#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     MONTHLY STATS                              #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 10/07/2013     #####
####                                                                #####
#########################################################################

# Skipout if day is unsorted
# filtrage sur pays a ajouter

$version = "3.18";
$verdate = "05/07/13";

$shift_factor = 0.3;

$calendarmonthjs = "monthcalendar.js";
$css_calendar = "calendar.css";

$scriptname = "cron-month.pl";

$status_script = 0;
$debug = 0;

# Todo : Graph req/access/host sur le domain
#$reqdommaxtot[$count_month] = $requete_dom;
# Check RSS is ok
# Mois en cours


####### script a lancer a 00 heures 01 minutes tous les 1er du mois #####
require "libw3perl.pl";

$listdailysites = "liste_daily_sites";
$listdailypages = "liste_daily_pages";
$listdailyscripts = "liste_daily_scripts";
$listdailytrafic = "liste_daily_trafic";
$listdailydir = "liste_daily_dir";
$listdailycountries = "liste_daily_country";
$listdailyfiletype = "liste_daily_filetype";
$listdailyusers = "liste_daily_users";
$listdailydestination = "liste_daily_dest";
$listdestination = "liste_destination".$htmlext;
$listdailyspam = "liste_daily_spam";

$listdailyrefer = "liste_daily_refer";
$listdailykeyword = "liste_daily_keyword";
$listdailyagent = "liste_daily_agent";


$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
#$pos = rindex($0,"-");
#$vtmp .= substr($0,$pos+1,length($0));
$vtmp .= $scriptname;
$vtmp =~ s/$plext//g;
#$rss_month = int($nb_rss_item/30)+1;

&MakeDirectories;

$linkpath_url = &Extract_WebUrlLink if ($linkpath_url eq '');

$starttime = time();

if ($opt_y eq '') {
    print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = "Monthly stats : $version\n";
    &output_log($msg);
    print "</DIV><P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}
print "<DIV ID=\"TOGGLE_$scriptname\" STYLE=\"display:inline\">\n" if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '');

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

# variable liee au serveur

$domreq = 0;
$reqtot = 0;
$totsize_day = 0;
$accesslues = 0;
$testday = 1; ### CHANGES
$testday = 0 if ($zipcut == 2);
$timesec = time;
$tabnamecsv = $tabnamemonth;
$tabnamecsv =~ s/$htmlext//;

($date,$datehour,$datemisc) = &get_time($timesec);

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print "Usage : \n";
      print "        -b                    : reset stats\n";
      print "        -c <file>             : load configuration file\n";
      print "        -d <nbdays>           : scan only nbdays previous day\n";
      print "        -g <";
      for ($i=0;$i<$#graphic;$i++) {
      print "$graphic[$i] ";
      } 
      print "$graphic[$#graphic]";
      print "> : graphic output (choose one)\n";
      print "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print "$lang[$i],";
      } 
      print "$lang[$#lang]";
      print ">            : language output (comma split)\n";          
      print "        -p <level>            : precision level (from 1 to 4)\n";
      print "        -x                    : show default value for flag options\n";
      print "        -v                    : version\n";
      print "        -z           : zip logfiles\n";      
      print "\n";
      exit;
}

if ($opt_v == 1) {
      print "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print "Default : \n";
      print "          -d            : $nbdays\n";
      print "          -c            : $configfile\n";
      print "          -g <graphic>  : $graphic[0]\n";
      print "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print "$lang[$i],";
      }
      print "$lang[$#lang]\n";      
      print "          -p <level>    : $precision\n";
      print "          -v            : $version\n";
      print "          -z            : ";
      &id($opt_z);         
      exit;
}

if ($opt_z ne '') {
$zip = $opt_z;
}

if ($opt_d ne '') {
$nbdays = $opt_d; 
}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !",1);
      }
}

$default_graph_idx = 1;
if ($opt_g ne '') {
  if ($opt_g eq "3d")  {
     $default_graph_idx = 1;
  }
  if ($opt_g eq "fill") {
      $default_graph_idx = 3;
  }
  if ($opt_g eq "line") {
      $default_graph_idx = 4;
  }
  if ($opt_g eq "bar") {
      $default_graph_idx = 2;
  }
}

@list_graph_option = ("1010","1000","0101","0100");
@list_graph_file1 = ("month_mac3d","month_macb","month_macf","month_macl");
@list_graph_file2 = ("month_req3d","month_reqb","month_reqf","month_reql");


# argument cmds line

if ($opt_p ne '') {
  $precision = $opt_p;
}

if ($opt_r ne '' || $opt_s ne '') {
    $opt_b = 1;
}


#################################################################
####          debut de l'initialisation                   #######
#################################################################

#$outfile1 = $path.$dirgraph.$dirsep."month_mac".$gifext;
$file1x = $path.$dirgraph.$dirsep."month_macx".$gifext;
$file1y = $path.$dirgraph.$dirsep."month_macy".$gifext;

#$linkoutfile1 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_mac".$gifext;
$linkfile1x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_macx".$gifext;
$linkfile1y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_macy".$gifext;

#$outfile2 = $path.$dirgraph.$dirsep."month_req".$gifext;
$file2x = $path.$dirgraph.$dirsep."month_reqx".$gifext;
$file2y = $path.$dirgraph.$dirsep."month_reqy".$gifext;

#$linkoutfile2 = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_req".$gifext;
$linkfile2x = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_reqx".$gifext;
$linkfile2y = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."month_reqy".$gifext;

&load_fileext;

&load_countries_map;

&load_url_map if ($titlename == 1);

&reload_city_map(1) if ($geoipcity == 1 && -f "$path$dirinc$dirsep$filecity");

&load_basic_stats;

#&load_reverse_adresse; # if ($opt_b == 1); # And init first time !!!!!!!!!

# Find last month

$line = 0;
$totsize_max = 0;
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);
while (<INFILE>) {
    chop;                                                                                                                      
    next if ($_ eq '');  
    $line++;
    next if ($line < 3);
    ($jour,$lastmonth,$lastyear,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize,$script,$pays,$nbfilejour) = split('\s+');
#    ($jour,$lastmonth,$lastyear) = split('\s+');
    $totsize_max += $totsize_day; # if ($totsize_day > $totsize_max);

 }
close(INFILE);

$tmp = $line-2;
if ($jour eq '' || $tmp < 31) {
    $msg = "Not enough data to compute monthly stats.\n";
    $msg .= "File $path$dirdata$dirsep$datafile is empty" if ($jour eq '');
    if ($tmp < 31 && $jour ne '') {
	$msg .= "Only $tmp day";
	$msg .= "s" if ($tmp > 1);
	$msg .= " found";
    } 
    $status_script = 2;
    &error_exit($msg,0);
}

if ($jour ne $month_of_year{$lastmonth}) {
    $lastmonth = $month_nb[$month_equiv{$lastmonth}-2];
}

$totsize_max = $totsize_max/$tmp;

$unit_div = 1;
$unit = "Data_unit_octet";
 if ($totsize_max > 1024) {
     $unit_div = 1024;
     $unit = "Kb";
 }
 if ($totsize_max > (1024*1024)) {
     $unit_div = 1024*1024;
     $unit = "Mb";
 }
 if ($totsize_max > (1024*1024*1024)) {
     $unit_div = 1024*1024*1024;
     $unit = "Gb";
 }
 if ($totsize_max > (1024*1024*1024*1024)) {
     $unit_div = 1024*1024*1024*1024;
     $unit = "Tb";
 }

$spam_on = 1 if ($mail_format == 1 && -f "$path$dirdata$dirsep$spam");

#################################################################
#####              computing monthly stats                 ######
#################################################################

open(OUT, ">$path$dircsv$dirsep$tabnamecsv$csvext");
print OUT "#\"Date\"";
print OUT ";\'Requests\"" if ($mail_format == 0 && $ftp_format == 0);
print OUT ";\"File\"" if ($ftp_format == 1);
print OUT ";\"Emails\"" if ($mail_format == 1);
print OUT ";\"Spam\"" if ($spam_on == 1);
if ($dhcp_format == 0) {
    print OUT ";\"Accesses\"" if ($mail_format == 0 && $ftp_format == 0);
    print OUT ";\"Documents\"" if ($mail_format == 0 && $cups_format == 0);
    print OUT ";\"Scripts\"" if ($mail_format == 0 && $cups_format == 0);
}
print OUT ";\"Hosts\";\"New_Hosts\"";
print OUT ";\"Countries\"";
print OUT ";\"Traffic\"" if ($notrafic == 0);
print OUT ";\"Domain Requests\"";
print OUT ";\"Domain_Hosts\"";
print OUT ";\"Domain Traffic\"" if ($notrafic == 0);
print OUT ";\"Hosts\"";
print OUT ";\"New_Hosts\"";
print OUT "\n";
close(OUT);

for ($nblang=0;$nblang<=$#lang;$nblang++) {

    $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
    $file_to_open = $tabmonth;
    open(TABMONTH,">$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
    &MonthHeader(*TABMONTH, eval($Lang{$lang[$nblang]}));
    close(TABMONTH);
}

$line_file = &line_file("$path$dirdata$dirsep$datafile");
$line_file_step = int($line_file/100);
$line_file_step = 1 if ($line_file_step == 0);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $line_file > 100) {
    print "<INPUT TYPE=\"hidden\" NAME=\"progressbar_step\" VALUE=\"1\">\n";
    $barfiletmp = "month";
    &InitProgressBar($barfiletmp,$scriptname,0);
    print "<BR>";
}

 if ($spam_on == 1) {
     open(SPAMFILE,"$path$dirdata$dirsep$spam");
     while (<SPAMFILE>) {
	 next if ($_ =~ /^#/);
	 ($jour,$month,$year,$m_tot,$m_dom,$spam_ext,$spam_loc) = split('\s+');
	 $spam_daily{"$jour$month$year"} = $spam_ext+$spam_loc;
     }
     close(SPAMFILE) 
 }

open(OUT, ">>$path$dircsv$dirsep$tabnamecsv$csvext");
open(INFILE, "$path$dirdata$dirsep$datafile") || &error_exit("Error, unable to open $path$dirdata$dirsep$datafile",1);

$line = 0;
$count_month = 0;
$lastmonth_found = 0;

BOUCLE_INI:
while (<INFILE>) {
    chop;
    next if ($_ eq '');     
    $line++;

     if ($line_file > 100) {
	 if (int($line/$line_file_step) == ($line/$line_file_step)) {
	     $line_percent = int(100*($line+1)/$line_file);
	     # Write status in a file called 'status.txt' => scriptname - $line_percent
	     open(FILESTATUS,">$path$incstatus$txtext");
	     print FILESTATUS "$scriptname\t$line_percent\t$status_script\n";
	     close(FILESTATUS);
	     if ($ENV{'REQUEST_METHOD'} eq "GET") {
		 print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
		 print "$barfiletmp.setPercentage('+1');\n";
		 print "</script>\n";
	     }
	 }
     }

     next if ($line < 3);

     $count++;

     ($jour,$month,$year,$m_tot,$m_new,$m_dom,$req_tot,$req_dom,$access_day,$totsize_day,$tothtmlsize,$domsize,$script,$pays_day,$nbfilejour_day,$users_day,$access_unique_day) = split('\s+');
     $spam_day = $spam_daily{"$jour$month$year"};

     if ($line == 3) {
       $start_date = $month." ".$year;
       $oldmonth = $month;
       $oldyear = $year;
     }

     $dirresume = $year."-".$month."-".$jour;
     $dirresume_jq = $jour."-".$month."-".$year;
     $dirresumefull = $year."-".$month;


    if ($opt_b eq '') {
	if ($month ne $previous_month && $bypass == 1) {
	    $bypass = 0;
	}
#	if ($bypass == 1) {
#	    next BOUCLE_INI;
#	}

	# If exists, bypass
	$tmpdate = "$year-$month";
	
	if (-d "$path$lang[0]$dirsep$dirdate$dirsep$tmpdate") {
	    $bypass = 1;
	    $previous_month = $month;
#	    next BOUCLE_INI;
	}
    }

    print "Reading $dirresume\n" if ($debug == 1);

     $maxmac = $m_tot if ($m_tot > $maxmac);
     $maxreq = $req_tot if ($req_tot > $maxreq);
     $maxacc = $access_day if ($access_day > $maxacc);
     $maxspam = $spam_day if ($spam_day > $maxspam);
     $maxsize = $totsize_day if ($totsize_day > $maxsize);
     $maxfile = $nbfile_day if ($nbfile_day > $maxfile);

     $oldmonth = $month;
     $oldyear = $year;

     $access_day2 = $access_day;
     $access_day2 = $access_unique_day if ($cups_format == 1);

#     print "$jour/$month/$year :  $month_of_year{$oldmonth} - $oldmonth - $jour\n";

    print "$month - $month_of_year{$month} - $jour\n" if ($debug == 1);

     if ($month_of_year{$month} != $jour) {
#     if ($month eq $oldmonth) {
##	 if ($bypass == 0) {
	 &LoadDailyData($dirresume,0) if ($bypass == 0);
	 &LoadDailyData($dirresume,2) if ($bypass == 1);

	 print "Loading $dirresume\n" if ($debug == 1);

#	 $machine_tot = $machine_tot + $m_tot;
#	 $machine_dom = $machine_dom + $m_dom;
	 $machine_new = $machine_new + $m_new;
	 $requete_tot = $requete_tot + $req_tot;
	 $access_tot = $access_tot + $access_day2;
	 $spam_tot = $spam_tot + $spam_day;
	 $requete_dom = $requete_dom + $req_dom;
	 $size_tot = $size_tot + $totsize_day;
	 $nbfilejour_tot = $nbfilejour_tot + $nbfilejour_day;
	 $script_tot = $script_tot + $script;
#	 $pays_tot = $pays_tot + $pays_day;
	 $domsize_tot = $domsize_tot + $domsize;

	 push(@req_value,$req_tot);
	 push(@acc_value,$access_day2) if ($mail_format == 0 && $dhcp_format == 0); 
	 push(@spam_value,$spam_day);
	 push(@doc_value,$nbfilejour_day);
	 push(@host_value,$m_tot);
	 push(@date_value,$dirresume);
	 push(@datejq_value,$dirresume_jq);
	 push(@traffic_value,$totsize_day);
	 $month_current++;
	 push(@month_table,"$dirresume|$req_tot|$access_day2|$m_tot|$totsize_day|$nbfilejour_tot|$spam_day");
##	 }
     } else {
	 
	 $lastmonth_found = 1 if ($month eq $lastmonth && $year == $lastyear);
	 $month_over = 1 if ($lastmonth_found == 1 && $jour == $month_of_year{$month});

#	 print "OVER : $month_over / LAST : $lastmonth_found ($month/$lastmonth/$year/$lastyear)\n";
##	 if ($bypass == 0) {
	 &LoadDailyData($dirresume,0) if ($bypass == 0);
	 &LoadDailyData($dirresume,2) if ($bypass == 1);

	 print "Loading last $dirresume\n" if ($debug == 1);

	 push(@month_table,"$dirresume|$req_tot|$access_day2|$m_tot|$totsize_day|$nbfilejour_tot|$spam_day");
	 push(@month_table,"$dirresume");
##	 }

#	 $machine_tot = $machine_tot + $m_tot;
#	 $machine_dom = $machine_dom + $m_dom;
	 $machine_new = $machine_new + $m_new;
	 $requete_tot = $requete_tot + $req_tot;
	 $access_tot = $access_tot + $access_day2;
	 $spam_tot = $spam_tot + $spam_day;
	 $requete_dom = $requete_dom + $req_dom;
	 $size_tot = $size_tot + $totsize_day;
	 $nbfilejour_tot = $nbfilejour_tot + $nbfilejour_day;
	 $script_tot = $script_tot + $script;
#	 $pays_tot = $pays_tot + $pays_day;
	 $domsize_tot = $domsize_tot + $domsize;

	 $reqmax = $requete_tot if ($requete_tot > $reqmax);

	 $dirresume_old = $dirresume;
	 $dirresume_jq_old = $dirresume_jq;
	 $tmpdate = "$oldyear $oldmonth";

	 if ($bypass == 0) {
	 $month_current++;
	 push(@req_value,$req_tot);
	 push(@acc_value,$access_day2) if ($mail_format == 0 && $dhcp_format == 0); 
	 push(@spam_value,$spam_day);
	 push(@doc_value,$nbfilejour_day);
	 push(@host_value,$m_tot);
	 push(@date_value,$dirresume);
	 push(@datejq_value,$dirresume_jq);
	 push(@traffic_value,$totsize_day);

	 $dirresumefull = "$path$lang[0]$dirsep$dirdate$dirsep$dirresumefull";
	 

	 ($val1,$val2) = split(/\s+/,$tmpdate);
	 $dirresume = $val1."-".$val2;
#	 ($val1,$val2,$val3) = split(/\s+/,$tmpdate);
#	 $dirresume = $val3."-".$val2;
	 $msg = "Month : $tmpdate\n";
	 &output_log($msg);
	 print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 

#	 $month_nb1 = $month_equiv{$oldmonth};
#	 $month_nb2 = $month_equiv{$month};

	 $reqtotjour = $requete_tot;
	 $accessjour = $access_tot;
	 $spamjour = $spam_tot;
	 $totsizejour = $size_tot;
	 $domreq = $requete_dom;
#	$serveruniquejour = $machine_tot;
	 $serveruniquejour = $mm_tot;
#	$locserverjour = $machine_dom;
	 $locserverjour = $mm_dom_tot;;
#	$scriptuniquejour = $script_day;
	 $newhost = $machine_new;
	 $nbfilejour = $nbfilejour_tot;
	 $script_day = $script_tot;
#	 $pays = $pays_tot;
	 $domsizejour = $domsize_tot;

	if ($mail_format == 0) {

	    for ($k=0;$k<=$nbzonefile;$k++) {
		$zoneextbis[$k] = $zoneextjour[$k];
	    }

	    for ($j=0;$j<=$nbzonefile;$j++) {
		$max = 0;
		$filetypejourmax[$j] = 0;
		for ($k=0;$k<=$nbzonefile;$k++) {
		    if ($zoneextbis[$k] > $max) {
			$max = $zoneextbis[$k];
			$filetypejourmax[$j] = $k;
		    }
		}
		$zoneextbis[$filetypejourmax[$j]] = 0;      
	    }
	}

	if ($ftp_format == 0 && $mail_format == 0) {

	    # OS

	    $unique_new_osday = $uniqueosday;
	    foreach $osday (keys(%nbreosday)) {
		$ok = 0;
		for ($j=0;$j<=$#os;$j++) {
		    if ($osday eq $os[$j]) {
			$tmp = $os[$j];
			$tmp1 = $translate_os{$tmp};
			$new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
			$ok = 1;
			$unique_new_osday-- if ($seen_serveur{"$tmp1 $oldjour"}++);
		    }
		}
		$new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	    }

	    # Browser

	    $unique_new_browserday = 0;

	    for ($l=1;$l<=$uniqueday;$l++) {	       
		for ($j=0;$j<=$#agent;$j++) {
		    if ($browserday[$l] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
			$bro_ver = $browserday[$l];
			$bro_ver =~ /(\d)+/;
			$bro_ver = int($1);
			$new_browserday{$tmp1} += $nbreday{$browserday[$l]};
			$browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
			$browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
			$browserday[$l] = '';
			$unique_new_browserday++ if (!($seen_serveur{"$tmp1 $oldjour"}++));
		    }
		}
		$new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
		$unique_new_browserday++ if ($browserday[$l] ne '');
	    }
	
	    for ($i=0;$i<$unique_new_browserday;$i++) {
		$maxi = 0;
		foreach $browser (keys(%new_browserday)) {
		    if ($new_browserday{$browser} > $maxi) {
			$maxi = $new_browserday{$browser};
			$bestbrowserday[$i] = $browser;
			$occurbrowserday[$i] = $new_browserday{$browser};                 
		    }
		}
		$new_browserday{$bestbrowserday[$i]} = 0;
	    }
	    
	    for ($i=0;$i<$unique_new_browser;$i++) {
		for ($j=0;$j<=$#agent;$j++) {
		    if ($bestbrowserday[$i] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
		    }
		}
		$bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	    }
	}
	 
	 
	 ($tmp1,$tmp2) = split(/ /,$tmpdate);
	 $tmp = $month_of_year{$oldmonth}-$month_current+1;
	 $first_date = $tmp." ".$tmp2." ".$tmp1;
#	 $first_date = $tmpdate;

	 for ($i=0;$i<=$#date_value;$i++) {
	     &LoadDailyData($date_value[$i],1);
	 }

	 print "Generate $dirresume\n" if ($debug == 1);

#	 $reqmax = $requete_tot if ($requete_tot > $reqmax);

#	 &BuildRequestsGraph($tmpdate,$month_of_year{$oldmonth},\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value);

	 if ($fly_set == 1) {
	     &BuildRequestsGraph($tmpdate,$dirgraph,$month_current,$first_date,\@date_value,\@req_value,\@acc_value,\@host_value,\@traffic_value,\@doc_value,\@spam_value);
	 }

	 if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
		# Trick to create empty file so daily menu will see existing files and build links
		if (keys(%nbredayref) != 0) {
		    &BuildEmptyReferResume($scriptname,0);
		}
		if ($uniqueosday != 0) {
		    &BuildEmptyAgentResume($scriptname,0);
		}
	     &BuildDailyReferResume($scriptname,$lastmonth_found,0) if (keys(%nbredayref) != 0);
	     &BuildDailyAgentResume($scriptname,$lastmonth_found,0) if ($uniqueosday != 0);
	 }
	 &BuildDailyResume($scriptname,$lastmonth_found,0);
	 &UpdatePageResumeMenu($scriptname,$lastmonth_found,0);

#	print "Build RSS\n";
	($unit_div,$unit) = &Return_Unit($size_tot,1);
	$tmp2 =  int($size_tot*100/$unit_div)/100;
	$tmp5 = "Requests : $requete_tot|";
	if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	    $tmp5 .= "Accesses" if ($cups_format == 0);
	    $tmp5 .= "Files" if ($cups_format == 1);
	    $tmp5 .= " : $access_tot|";
	}
	$tmp5 .= "Spam : $spam_tot|" if ($spam_on == 1);
	$tmp5 .= "Documents : $nbfilejour_tot|" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
	$tmp5 .= "Hosts : $mm_tot";
	$tmp5 .= "|Traffic : $tmp2 $unit" if ($notrafic == 0);

	 ($tmp1,$tmp2) = split(/\s+/,$tmpdate);
	 $tmp = $tmp1."-".$tmp2;
	 $tmp7 = $tmp2." ".$tmp1;

	$linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	$fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	&BuildRSS($filerss,$tmp5,$tmp7,$linkjour) if ($requete_tot != 0);

	 undef @req_value;
	 undef @acc_value;
	 undef @doc_value;
	 undef @host_value;
	 undef @date_value;
	 undef @datejq_value;
	 undef @traffic_value;
	 undef @spam_value;

	 $month_current = 0;

	 if ($mail_format == 0) {
	    undef @zoneextjour;
	    undef @filetypejourmax;
	    undef @listext;
	    undef %downloadjour;
	    undef %filetypejour;
	}

	 if ($ftp_format == 0 && $mail_format == 0) {

	    for ($i=0;$i<=$unique_new_browserday;$i++) {
		for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
		    $browser_versionday{$bestbrowserday[$i],$l} = '';
		}
	    }

	    undef %browser_versionday;
	    undef %browser_version_nbday;
	    undef %new_browserday;
	    undef %nbrebrowserday;
	    undef %nbreosday;
	    undef @browserday;
	    undef %new_osday;
	    undef @bestbrowserday;
	    undef @occurbrowserday;
	    undef %nbreday;
	    undef %idx_browser;

	    undef %refer_fullsite_occur_day;;
	    undef %idx_fullsite_day;
	    undef %refer_fullsite_page_day;
	    
	    undef %occur_fullsite_occur_day;
	    undef %idx_occur_day;
	    undef %occur_fullsite_page_day;

	    $unique_new_browserday = 0;
	    $nbagent = 0;

	    undef %nbredayref;
	    undef %nbrefullday;
	    undef %occurday;
	    undef %wday;
	    undef %fullstringday;
	    undef %keyshday;
	    undef @wordsday;

	}

	$uniquenbrefullday = 0;
	$uniqueurlday = 0;

	$countday = 0;
	$uniqueday = 0;

	if ($display_subitem > 0) {

	    foreach $tmp (keys(%min_data1)) {
		$tmp2b = "min_valdata".$tmp;
		undef @$tmp2b;
	    }

	    foreach $tmp (keys(%min_data2)) {
		$tmp2b = "min2_valdata".$tmp;
		undef @$tmp2b;
	    }

	    if ($inc_user == 1) {
		foreach $tmp (keys(%min_data3)) {
		    $tmp2b = "min3_valdata".$tmp;
		    undef @$tmp2b;
		}
	    }

	    if ($squid_format == 1 || $cups_format == 1) {
		foreach $tmp (keys(%min_data4)) {
		    $tmp2b = "min4_valdata".$tmp;
		    undef @$tmp2b;
		}
	    }
	}
	
	$count_nb_file = 0;
	undef @count_file;
	$min_count_file = 0;
	
	$count_nb_file2 = 0;
	undef @count_file2;
	$min_count_file2 = 0;
	
	$count_nb_file3 = 0;
	undef @count_file3;
	$min_count_file3 = 0;
	
	$count_nb_file4 = 0;
	undef @count_file4;
	$min_count_file4 = 0;
	
	undef %min_data1;
	undef %min_data2;
	undef %min_data3;
	undef %min_data4;

	undef %seen_server;
	undef %freqjourrac;
	undef %freqjourrachtml;
	undef %sizejourrachtml;
	undef %dailysizepage;
	undef %serverjour;
	 undef %pays_ip if ($reverse_geo == 1);
	undef %hostluesday;
	undef %serversizejour;
	undef %pagesluesday;
	undef %paysjour;
	undef %payshtmljour;
	undef %paysjourlist;
	undef %scriptday;
	undef %client_day_error;
	undef %client_day_refer;
#	undef %downloadjour;
#	undef %filetypejour;

	 undef %seen_page;
	 undef %nbpageday;
	 undef %dailypageserv;
	 undef %seen_host;
	 undef %nbhostpageday;
	 undef %dailyhostpage;
	 undef %nbdailyvisits;


	 undef %spam_daily_user_ext;
	 undef %spam_daily_user_ext_unique;
	 undef %spam_daily_user_loc;
	 undef %spam_daily_user_loc_unique;
	 undef %spam_daily_page;
	 undef %seen_spam;

	 undef %userday;
	 undef %user_adresseday;
	 undef %user_trafficday;
	 undef %user_accessday;
	 undef %seen_user;
	 $nb_userday = 0;

	 undef %nbusersday;
	 undef %dailylogindest;
	 undef %seen_users;
	 undef %dailyuserssizedest;
	 undef %nbdailyuser;

	if ($squid_format == 1 || $cups_format == 1 || $dhcp_format == 1) {
	    undef %dailydest;
	    undef %dailysizedest;
	    undef %nbhostday;
	    undef %dailyhostdest;
	    undef %dailyusersdest;
	    undef %seen_dest;
	    undef %dailyhostsizedest;
	    undef %nbdailydest;
	    $dailydest_unique = 0;
	}

	 $domsizejour = 0;
	 $script_day = 0;
	 $scriptuniquejour = 0;
	 $pageuniquejour = 0;
	 $tothtmlsizejour = 0;

	 } # bypass
#	 push(@listhost,$machine_tot);
	 push(@listhost,$mm_tot);
	 push(@listreq,$requete_tot);
	 push(@listacc,$access_tot);
	 push(@listscript,$script_tot);
	 push(@listsize,$size_tot);
	 $tmpdate = "01 $oldmonth $oldyear";
	 push(@listdate,$tmpdate);
	 push(@listspam,$spam_tot);


#	     $machmaxtot{$count_month} = $machine_tot;
	 $machmaxtot[$count_month] = $mm_tot;
	 $newmaxtot[$count_month] = $machine_new;
#	 $dommaxtot{$count_month} = $machine_dom;
	 $dommaxtot[$count_month] = $mm_dom_tot;
	     
	 #$machmax = $machine_tot if ($machine_tot > $machmax);
	 $machmax = $mm_tot if ($mm_tot > $machmax);
	 $maxtot = $size_tot if ($size_tot > $maxtot);

	 $reqmaxtot[$count_month] = $requete_tot;
	 $accessmaxtot[$count_month] = $access_tot if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0);
	 $spammaxtot[$count_month] = $spam_tot;
	 $docmaxtot[$count_month] = $nbfilejour_tot;
	 $reqdommaxtot[$count_month] = $requete_dom;
	 $sizemaxtot[$count_month] = $size_tot;
	 $scriptmaxtot[$count_month] = $script_tot;

#	 ($val1,$val2) = split(/\s+/,$tmpdate);
#	 $tmp = $val1."-".$val2;
	 ($val1,$val2,$val3) = split(/\s+/,$tmpdate);
	 $tmp = $val3."-".$val2;
	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	 $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;

	 $pays_tot = int($pays_tot/30);
	 $domsize_tot = int(10*$domsize_tot/$unit_div)/10;
	 $size_tot = int(10*$size_tot/$unit_div)/10;

	     for ($nblang=0;$nblang<=$#lang;$nblang++) {
		 $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
		 $taboldmonth = $oldyear."-".$oldmonth;

		 $graphline[$count_month] = $taboldmonth if ($nblang == 0);

		 open(TABMONTH,">>$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
		 print TABMONTH "<TR><TD CLASS=\"left\">";
		 print TABMONTH "<A HREF=\"$linkjour\">";
		 print TABMONTH "$oldyear $oldmonth ";
		 print TABMONTH "</A>";
		 print TABMONTH "</TD>";

		 print TABMONTH "<TD CLASS=\"right\">$requete_tot</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$access_tot</TD>\n" if ($mail_format == 0 && $ftp_format == 0 && $dhcp_format == 0);
		 print TABMONTH "<TD CLASS=\"right\">$spam_tot</TD>\n" if ($spam_on == 1);
		 if ($dhcp_format == 0) {
		     print TABMONTH "<TD CLASS=\"right\">$nbfilejour_tot</TD>\n" if ($mail_format == 0 && $cups_format == 0);
		     print TABMONTH "<TD CLASS=\"right\">$script_tot</TD>\n" if ($mail_format == 0 && $cups_format == 0);
		 }
#		 print TABMONTH "<TD CLASS=\"right\">$machine_tot</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$mm_tot</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$machine_new</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$paysuniquejour</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$size_tot</TD>\n" if ($notrafic == 0);
		 print TABMONTH "<TD CLASS=\"right\">$requete_dom</TD>\n";
#		 print TABMONTH "<TD CLASS=\"right\">$machine_dom</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$mm_dom_tot</TD>\n";
		 print TABMONTH "<TD CLASS=\"right\">$domsize_tot</TD>\n" if ($notrafic == 0);

#		 print TABMONTH "<TD CLASS=\"right\">$machine_tot</td>";
#		 print TABMONTH "<TD CLASS=\"right\">$machine_new</TD>";
#		 print TABMONTH "<TD CLASS=\"right\">$machine_dom</TD>";
#		 print TABMONTH "<TD CLASS=\"right\">$requete_tot</TD>";
#		 print TABMONTH "<TD CLASS=\"right\">$access_tot</TD>" if ($mail_format == 0 && $ftp_format == 0);
#		 print TABMONTH "<TD CLASS=\"right\">$requete_dom</TD>";
		 print TABMONTH "</TR>\n";
		 close(TABMONTH);
	     }


	 print OUT "\"$oldyear $oldmonth\"";
	 print OUT ";\"$requete_tot\"";
	 print OUT ";\"$access_tot\"" if ($mail_format == 0 && $ftp_format == 0 && $dhcp_format == 0);
	 print OUT ";\"$spam_tot\"" if ($spam_on == 1);
	 if ($dhcp_format == 0) {
	     print OUT ";\"$nbfilejour_tot\"" if ($mail_format == 0 && $cups_format == 0);
	     print OUT ";\"$script_tot\"" if ($mail_format == 0 && $cups_format == 0);
	 }
#	 print OUT ";\"$machine_tot\"";
	 print OUT ";\"$mm_tot\"";
	 print OUT ";\"$machine_new\"";
	 print OUT ";\"$paysuniquejour\"";
	 print OUT ";\"$size_tot\"" if ($notrafic == 0);
	 print OUT ";\"$requete_dom\"";
#	 print OUT ";\"$machine_dom\"";
	 print OUT ";\"$mm_dom_tot\"";
	 print OUT ";\"$domsize_tot\"" if ($notrafic == 0);
	 print OUT "\n";

#	 $machine_tot = 0;
	 $paysuniquejour = 0;
	 $mm_tot = 0;
	 $machine_new = 0;
#	 $machine_dom = 0;
	 $mm_dom_tot = 0;
	 $requete_tot = 0;
	 $access_tot = 0;
	 $spam_tot = 0;
	 $requete_dom = 0;
	 $size_tot = 0;
	 $script_tot = 0;
#	 $pays_tot = 0;
	 $nbfilejour_tot = 0;
	 $domsize_tot = 0;
	 $count_month++;
	 $date_last = $year."-".$oldmonth;

#	 if ($enable_pdf == 1) {
#	     if (-d "$path$lang[0]$dirsep$dirdate$dirsep$dirresume") {
#		 $filepdf = $path.$dirpdf.$dirsep.$date_last.$pdfext;
#		 &generate_pdf_cmd($date_last,$statnamemonth,$filepdf,0) if (!(-f $filepdf));
#	     }
#	 }

	$dirresume = $dirresume_old;
	$dirresume_jq = $dirresume_jq_old;

        }
}

close(INFILE);

#

$monthindex = $month_equiv{$month};

close(OUT);

        
# fermeture de la page HTML du tableau sur les mois

for ($nblang=0;$nblang<=$#lang;$nblang++) {
  $tabmonth = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$tabnamemonth;
  
  open(TABMONTH,">>$tabmonth") || &error_exit("Error, unable to open $tabmonth",1);
  &MonthFooter(*TABMONTH, eval($Lang{$lang[$nblang]}));
  close (TABMONTH);
}
#$count_month--;

#################################################################
#####           hosts and requests graphs                 #######
#################################################################


if ($precision > 2) {

#################################################################
# Fly

if ($fly_set == 1) {
    
    $map ='';
    $num = 0;
    $num2 = 0;
    $it = length($count_month)-1;
    $div = 10**$it;
    $factx = ($div*(int($count_month/$div)+1))/$grad;
    
    $factx = 1 if ($it == 0);
    
    $it = length($machmax)-1;
    $div = 10**$it;
    $facty = ($div*(int(($machmax+$perspec)/$div)+1))/$grad;
    
    $fymax = $ymax-2;


    ($unit_div,$unit) = &Return_Unit($maxtot,1);

    $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));
   
    # Compute USEMAP
    for ($i=0;$i<=($count_month+$bargraph);$i++) {

	if ($listdate[$num] ne '') {

#	    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
#	    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
	    $x1 = ($i+$linegraph+$tridim)*$xstep/$factx;
	    $x2 = ($i+1+$linegraph+$tridim)*$xstep/$factx;
      
	    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
	    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

	    ($tmp1,$tmp2,$tmp3) = split(/\s+/,$listdate[$num]);
#	    $tmp = $tmp1."-".$tmp2;
	    $tmp = $tmp3."-".$tmp2;
	    $tmp6 = $tmp2." ".$tmp1;
	    $tmp10 = $tmp1."_".$tmp2;
	    $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$menu;
	    $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$menu;
	    
	    $num++;
	    $num2 = $num-1;
	    if (-e $fulljour) {
		$list[$num2] = "$tmp";
	    }

	    $tmp2 =  int($sizemaxtot[$i]*100/$unit_div)/100;
	    $tmp5 = "Requests : $reqmaxtot[$i]|";
	    if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
		$tmp5 .= "Accesses" if ($cups_format == 0);
		$tmp5 .= "Files" if ($cups_format == 1);
		$tmp5 .= " : $accessmaxtot[$i]|";
	    }
	    $tmp5 .= "Spam : $spammaxtot[$i]|" if ($spam_on == 1);
	    $tmp5 .= "Documents : $docmaxtot[$i]|" if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0);
	    $tmp5 .= "Hosts : $machmaxtot[$i]";
	    $tmp5 .= "|Traffic : $tmp2 $unit" if ($notrafic == 0);

	    $wday = '';

	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnamemonth#$num\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp6','$tmp5','','$tabnamedays#$num',1,'','$popup_graph_width');ToggleSet('TOGGLE_$tmp10')\">\n" if (!(-e $fulljour) && $reqmaxtot[$i] != 0);
	    $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$tmp6','$tmp5','','$linkjour',1,'','$popup_graph_width');ToggleSet('TOGGLE_$tmp10')\">\n" if (-e $fulljour);
	    
#	    if ($i > ($count_month-$rss_month)) {
#		&BuildRSS($filerss,$tmp5,$tmp6,$linkjour) if ($reqmaxtot[$i] != 0);
#	    }
	}
    }
}

  if ($fly_set == 1) {

for ($i=0;$i<=$#list_graph_option;$i++) {
    ($bargraph,$linegraph,$tridim,$fillgraph) = split(//,$list_graph_option[$i]);
    $filegraph = $path.$dirgraph.$dirsep.$list_graph_file1[$i].$gifext;
    &GenerateWeeklyGraph1($filegraph,$vtmp,$bargraph,$linegraph,$tridim,$fillgraph);
}


    sub GenerateWeeklyGraph1 {
    local($file1,$vtmp,$bargraph,$linegraph,$tridim,$fillgraph) = @_;
    local($i);

    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ymax\n";
    print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
    for ($i=0;$i<=($count_month+$bargraph);$i++) {
#      $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
 #     $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
      $x1 = ($i+$linegraph+$tridim)*$xstep/$factx;
      $x2 = ($i+1+$linegraph+$tridim)*$xstep/$factx;
      
      $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
      $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
      
      $y2 = $ymax - ($ystep/$facty * $machmaxtot[$i]);

      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          $y1plus = $ymax - $perspec;
          
          print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $machmaxtot[$i+1]);
        print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
        
        if ($fillgraph == 1) {
	    $fx1 = ($x1+$x2)/2;
	    $fx1 = $x2 if ($fx1 < ($x1+1.5));
	    if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
		print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

		print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
		print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
	    }
        }
      }
      
      $x1 -= $factx*$shift_factor;
      $x2 -= $factx*$shift_factor;

      $y2 = $ymax - ($ystep/$facty * $newmaxtot[$i]);
#      $y2ppp = $ymax - ($ystep/$facty * $newmaxtot{$i-1});
      
      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#        print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          
          print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $newmaxtot[$i+1]);
        print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";

        if ($fillgraph == 1) {
	    $fx1 = ($x1+$x2)/2;
	    $fx1 = $x2 if ($fx1 < ($x1+1.5));
	    if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {		
		print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
		print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";

		print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
          }
        }
      }
      
      $x1 -= $factx*2*$shift_factor;
      $x2 -= $factx*2*$shift_factor;
      
      $y2 = $ymax - ($ystep/$facty * $dommaxtot[$i]);
      $y2ppp = $ymax - ($ystep/$facty * $dommaxtot[$i-1]);
      
      if ($bargraph == 1) {
        $x2 -= $perspec if ($tridim == 1);
        $x1 -= $perspec if ($tridim == 1);
        print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
        print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
#        print FLY "rect $x1,$y2,$x1,$y2ppp,0,0,0\n";
        if ($tridim == 1 && $y2 != $ymax) {
          
          $x1plus = $x1+$perspec;
          $x2plus = $x2+$perspec;
          $y2plus = $y2-$perspec;
          
          print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
          
          print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
          
        }
      }
      
      if ($linegraph == 1) {
        $y1 = $ymax - ($ystep/$facty * $dommaxtot[$i+1]);
        print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
        
        if ($fillgraph == 1) {
	    $fx1 = ($x1+$x2)/2;
	    $fx1 = $x2 if ($fx1 < ($x1+1.5));
	    if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
		print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";

		print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
		print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
	    }
        }
      }
      
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    &BuildFly("$tmpfly$vtmp",$file1);
  }

    ### image pour les abscisses
    
    $xlegend = "$count_month month";
    $xlegend .= "s" if ($count_month > 1);
    $xlegend .= " (starting $start_date)";
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xmax,$ydecal\n";
    print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
    $posx = (($xmax/2)-(length($xlegend)*7/2));
    print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
    for ($i=$xstep;$i<$xmax;$i+=$xstep) {
#      $val = ($monthindex -1 - $count_month) + ($i*$factx/$xstep);

      $val = ($monthindex  - $count_month) + ($i*$factx/$xstep);
      $val--;
      $val += 12 if ($val < 0);
      $val -= 12 if ($val > 11);
      # print "$val $monthindex $count_month\n";
      $posx = $i - 8;
      print FLY "line $i,0,$i,5,0,0,0\n";
      print FLY "string 0,0,0,$posx,10,small,$month_nb[$val-1]\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);

    &BuildFly("$tmpfly$vtmp",$file1x);    
    
    ### image pour les ordonnees
    
    open(FLY,">$tmpfly$vtmp");
    print FLY "new\n";
    print FLY "size $xdecal,$ymax\n";
    print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
    $posy = $ymax - (($ymax/2)-(length("Hosts")/2));
    print FLY "stringup 0,0,0,5,$posy,medium,Hosts\n";
    for ($i=$ystep;$i<$ymax;$i+=$ystep) {
      $valstep = int(($ymax - $i) * ($facty/$ystep));
      $pos = ($xdecal - length($valstep)*9);
      $posy = $i-5;
      print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
      print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
    }
    print FLY "transparent 200,200,200\n";
    close (FLY);
    
    &BuildFly("$tmpfly$vtmp",$file1y);    

  }
}


#####################  2 ieme GIF  #################################

print FOUT "<TD></TD>\n";

#################################################################
# Fly

if ($fly_set == 1) {
  $it = length($count_month)-1;
  $div = 10**$it;
  $factx = ($div*(int($count_month/$div)+1))/$grad;
  
  $factx = 1 if ($it == 0);
  
  $it = length($reqmax)-1;
  $div = 10**$it;
  $facty = ($div*(int(($reqmax+$perspec)/$div)+1))/$grad;
  
  $perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

  ### image pour les abscisses
  
  $xlegend = "$count_month month";
  $xlegend .= "s" if ($count_month > 1);
  $xlegend .= " (starting $start_date)";
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ydecal\n";
  print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
  $posx = (($xmax/2)-(length($xlegend)*7/2));
  print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
  for ($i=$xstep;$i<$xmax;$i+=$xstep) {
#    $val = ($monthindex - 1 - $count_month) + ($i*$factx/$xstep);
    $val = ($monthindex - $count_month) + ($i*$factx/$xstep);
    $val--;
    $val += 12 if ($val < 0);
    $val -= 12 if ($val > 11);
    $posx = $i - 8;
    print FLY "line $i,0,$i,5,0,0,0\n";
    print FLY "string 0,0,0,$posx,10,small,$month_nb[$val-1]\n";
  }
  print FLY "transparent 200,200,200\n";
  close (FLY);
  
  &BuildFly("$tmpfly$vtmp",$file2x);

#

  ### image pour les ordonnees
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xdecal,$ymax\n";
  print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
  $posy = $ymax - (($ymax/2)-(length("Requests")/2));
  print FLY "stringup 0,0,0,5,$posy,medium,Requests\n";
  
  for ($i=$ystep;$i<$ymax;$i+=$ystep) {
    $valstep = int(($ymax - $i) * ($facty/$ystep));
    $pos = ($xdecal - length($valstep)*9);
    $posy = $i-5;
    print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
    print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
  }

  print FLY "transparent 200,200,200\n";
  close (FLY);

  &BuildFly("$tmpfly$vtmp",$file2y);

###

for ($i=0;$i<=$#list_graph_option;$i++) {
    ($bargraph,$linegraph,$tridim,$fillgraph) = split(//,$list_graph_option[$i]);
    $filegraph = $path.$dirgraph.$dirsep.$list_graph_file2[$i].$gifext;
    &GenerateWeeklyGraph2($filegraph,$vtmp,$bargraph,$linegraph,$tridim,$fillgraph);
}

    sub GenerateWeeklyGraph2 {
    local($file2,$vtmp,$bargraph,$linegraph,$tridim,$fillgraph) = @_;
    local($i);
  
  open(FLY,">$tmpfly$vtmp");
  print FLY "new\n";
  print FLY "size $xmax,$ymax\n";
  print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
  for ($i=0;$i<=($count_month+$bargraph);$i++) {
#    $x1 = ($i-1+$linegraph+$tridim)*$xstep/$factx;
#    $x2 = ($i+$linegraph+$tridim)*$xstep/$factx;
    $x1 = ($i+$linegraph+$tridim)*$xstep/$factx;
    $x2 = ($i+1+$linegraph+$tridim)*$xstep/$factx;
    
    $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
    $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
    
    $y2 = $ymax - ($ystep/$facty * $reqmaxtot[$i]);
    
    if ($bargraph == 1) {
      $x2 = int($x2 - $perspec) if ($tridim == 1);
      $x1 = int($x1 - $perspec) if ($tridim == 1);
      print FLY "frect $x1,$y2,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {
        
        $x1plus = int($x1+$perspec);
        $x2plus = int($x2+$perspec);
        $y2plus = int($y2-$perspec);
        $y1plus = int($ymax - $perspec);
        
        print FLY "fpoly $red[0],$green[0],$blue[0],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        
        print FLY "fpoly $red[0],$green[0],$blue[0],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        
      }
    }
    
    if ($linegraph == 1) {
      $y1 = $ymax - ($ystep/$facty * $reqmaxtot[$i+1]);
      print FLY "line $x1,$y2,$x2,$y1,$red[0],$green[0],$blue[0]\n";
      
      if ($fillgraph == 1) {
	  $fx1 = ($x1+$x2)/2;
	  $fx1 = $x2 if ($fx1 < ($x1+1.5));
	  if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
	      print FLY "line $x1,$ymax,$x1,$y2,$red[0],$green[0],$blue[0]\n";
	      print FLY "line $x2,$ymax,$x2,$y1,$red[0],$green[0],$blue[0]\n";

	      print FLY "line $x1,$ymax,$x2,$ymax,$red[0],$green[0],$blue[0]\n";
	      print FLY "fill $fx1,$fymax,$red[0],$green[0],$blue[0]\n";
        }
      }
    }


	if ($spam_on == 1) {
	    $x1 -= $factx*$shift_factor;
	    $x2 -= $factx*$shift_factor;

	    $y2 = $ymax - ($ystep/$facty * $spammaxtot[$i]);
	    $y2db = $ymax - ($ystep/$facty * $spammaxtot[$i])+1;

	    if ($bargraph == 1) {
		$x2 -= $perspec if ($tridim == 1);
		$x1 -= $perspec if ($tridim == 1);
		print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
		
		if ($tridim == 1 && $y2 != $ymax) {
		    
		    $x1plus = $x1+$perspec;
		    $x2plus = $x2+$perspec;
		    $y2plus = $y2-$perspec;
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		    
		    print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		    print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		}
	    }
	    
	    if ($linegraph == 1) {
		$y1 = $ymax - ($ystep/$facty * $spammaxtot[$i+1]);
		$y1db = $ymax - ($ystep/$facty * $spammaxtot[$i+1])+1;
		print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
		print FLY "line $x1,$y2db,$x2,$y1db,$red[1],$green[1],$blue[1]\n";
		
		if ($fillgraph == 1) {
		    $fx1 = ($x1+$x2)/2;
		    $fx1 = $x2 if ($fx1 < ($x1+1.5));
		    if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
			print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
			print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
			
			print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
			print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
		    }
		}
	    }
	}


    if ($mail_format == 0 && $ftp_format == 0 && $dhcp_format == 0) {
	$x1 -= $factx*$shift_factor;
	$x2 -= $factx*$shift_factor;
    
	$y2 = $ymax - ($ystep/$facty * $accessmaxtot[$i]);
    
	if ($bargraph == 1) {
	    $x2 = int($x2 - $perspec) if ($tridim == 1);
	    $x1 = int($x1 - $perspec) if ($tridim == 1);
	    print FLY "frect $x1,$y2,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
	    print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
	    if ($tridim == 1 && $y2 != $ymax) {
		
		$x1plus = int($x1+$perspec);
		$x2plus = int($x2+$perspec);
		$y2plus = int($y2-$perspec);
		
		print FLY "fpoly $red[1],$green[1],$blue[1],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
		
		print FLY "fpoly $red[1],$green[1],$blue[1],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
		print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
	    }
	}
    
	if ($linegraph == 1) {
	    $y1 = $ymax - ($ystep/$facty * $accessmaxtot[$i+1]);
	    print FLY "line $x1,$y2,$x2,$y1,$red[1],$green[1],$blue[1]\n";
	    
	    if ($fillgraph == 1) {
		$fx1 = ($x1+$x2)/2;
		$fx1 = $x2 if ($fx1 < ($x1+1.5));
		if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
		    print FLY "line $x1,$ymax,$x1,$y2,$red[1],$green[1],$blue[1]\n";
		    print FLY "line $x2,$ymax,$x2,$y1,$red[1],$green[1],$blue[1]\n";
		    
		    print FLY "line $x1,$ymax,$x2,$ymax,$red[1],$green[1],$blue[1]\n";
		    print FLY "fill $fx1,$fymax,$red[1],$green[1],$blue[1]\n";
		}
	    }
	}
    }

    $x1 -= $factx*2*$shift_factor;
    $x2 -= $factx*2*$shift_factor;
    
    $y2 = $ymax - ($ystep/$facty * $reqdommaxtot[$i]);
    
    if ($bargraph == 1) {
      $x2 = int($x2 - $perspec) if ($tridim == 1);
      $x1 = int($x1 - $perspec) if ($tridim == 1);
      print FLY "frect $x1,$y2,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
      print FLY "rect $x1,$y2,$x2,$ymax,0,0,0\n";
      if ($tridim == 1 && $y2 != $ymax) {
        
        $x1plus = int($x1+$perspec);
        $x2plus = int($x2+$perspec);
        $y2plus = int($y2-$perspec);
        
        print FLY "fpoly $red[2],$green[2],$blue[2],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        
        print FLY "fpoly $red[2],$green[2],$blue[2],$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
        print FLY "poly 0,0,0,$x2,$ymax,$x2,$y2,$x2plus,$y2plus,$x2plus,$ymax\n";
      }
    }
    
    if ($linegraph == 1) {
      $y1 = $ymax - ($ystep/$facty * $reqdommaxtot[$i+1]);
      print FLY "line $x1,$y2,$x2,$y1,$red[2],$green[2],$blue[2]\n";
      
      if ($fillgraph == 1) {
	  $fx1 = ($x1+$x2)/2;
	  $fx1 = $x2 if ($fx1 < ($x1+1.5));
	  if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
	      print FLY "line $x1,$ymax,$x1,$y2,$red[2],$green[2],$blue[2]\n";
	      print FLY "line $x2,$ymax,$x2,$y1,$red[2],$green[2],$blue[2]\n";

	      print FLY "line $x1,$ymax,$x2,$ymax,$red[2],$green[2],$blue[2]\n";
	      print FLY "fill $fx1,$fymax,$red[2],$green[2],$blue[2]\n";
	  }
      }
    }
    
  }
  print FLY "transparent 200,200,200\n";
  close (FLY);
  
  &BuildFly("$tmpfly$vtmp",$file2);
    }
}

#############################################################################

#&load_basic_stats;

# At least two points are necessary to get lines or filled lines

#if (scalar(@listdate) < 2) {
#    @list_graph_name_jqplot = ("barchart");
#}

if ($count_month != 0) {
for ($nblang=0;$nblang<=$#lang;$nblang++) {

        $file_to_open = $path.$lang[$nblang].$dirsep.$dirdate.$dirsep.$statnamemonth;
        open(STATMONTH,">$file_to_open") || &error_exit("Error, unable to open $file_to_open",1);
        &MonthStats(*STATMONTH, eval($Lang{$lang[$nblang]}), $count_month);
	close(STATMONTH);
}
}

unlink("$tmpfly$vtmp");

#################################################################
#####              computing monthly stats                 ######
#################################################################

$yesterday = "$jour $month $year";
&update_homepage;

# PDF report

if ($enable_pdf == 1) {

    for ($i=0;$i<=$#month_table;$i++) {

      @val_tab = split(/\|/,$month_table[$i]);
      if ($#val_tab == 0) {
	  $end_month = 1;
      }
      if ($#val_tab != 0) {
	  if ($end_month == 1 || $i == 0) {
	      $end_month = 0;
	      ($tmp1,$tmp2a) = split(/-/,$val_tab[0]);

	      $dirresume = $tmp1."-".$tmp2a;
#	      print "II $dirresume\n";
	      if (-d "$path$lang[0]$dirsep$dirdate$dirsep$dirresume") {
		  $filepdf = $path.$dirpdf.$dirsep.$dirresume.$pdfext;
		  for ($k=0;$k<=$#homepages;$k++) {
		      $tmp = $k if ($homepages[$k] !~ /-/);
		  }
		  &generate_pdf_cmd($dirresume,$statnamemonth,$filepdf,0,eval($Lang{$lang[$tmp]})) if (!(-f $filepdf));
	      }
	  }
      }
    }
    &export_pdf(@list_cmd) 
}



if ($enable_email == 1 && $emailadr ne '' && $email_monthly == 1 && $month_over == 1 && ($email_html == 1 || $email_pdf == 1)) {

    $subject = "W3Perl Monthly Report - $year/$lastmonth";
    $from = "webmaster\@".$localdomainename;

    &export_html($date_last,eval($Lang{$lang[0]})) if ($email_html == 1);

    # MIME::Lite module

    &send_email($emailadr,$subject,$html,0,$filepdf);

    $msg = "Email monthly report sent to $emailadr";
    $msg .= " : $filepdf" if ($email_pdf == 1 && $enable_pdf == 1);
    $msg .= "\n";
    &output_log($msg);
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET"); 
}


# calculer le temps mis pour le calcul

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
$msg = "Computing took";
$msg .= " $hour h" if ($hour > 0);
$msg .= " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
&output_log($msg);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
    print "</DIV>";
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "ToggleMenu('TOGGLE_$scriptname');\n";
    print "</script>\n";
}

&UpdateCSSMenu('When','Months',$icon_months,"$dirdate$dirsepurl$filemonth",1,0);

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

&StatusCompleted($scriptname,$status_script);

open(FILE,">>$history");
#print FILE "cron-month\t$today\t$startrun\t$endrun\t$min:$sec\t$loglines\n";
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\n",$today,$startrun,$endrun,$hour,$min,$sec;
close(FILE);


########################################################################################
sub MonthHeader {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'About_months'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";
  
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  print FOUT "<H2> $L{'About_months'}</H2><P>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "<A HREF=\"..$dirsepurl..$dirsepurl$dircsv$dirsepurl$tabnamecsv$csvext\" TITLE=\"Export in CSV\"><IMG WIDTH=\"20\" HEIGHT=\"20\" SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_csv\" BORDER=0 ALT=\"CSV\"></A>" if (-f "$path$dircsv$dirsep$tabnamecsv$csvext");

#  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-autopage:$table_lines_aff table-stripeclass:alternate\" id=\"page\">\n";
  print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
  print FOUT "<thead>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH>&nbsp;</TH>\n";
  $tmp = 4;
  $tmp++ if ($notrafic == 0);
  $tmp++ if ($mail_format == 0 && $ftp_format == 0);
  $tmp += 2 if ($mail_format == 0 && $cups_format == 0);
  $tmp++ if ($spam_on == 1);
  $tmp -= 3 if ($dhcp_format == 1);
#  $tmp -= 2 if ($mail_format == 1);
  print FOUT "<TH COLSPAN=$tmp>&nbsp;</TH>\n";
  $tmp = 2;
  $tmp++ if ($notrafic == 0);
  print FOUT "<TH COLSPAN=$tmp>&nbsp;$L{'Domain'}&nbsp;</TH>\n";
  print FOUT "</TR>\n";
  print FOUT "<TR>\n";
  print FOUT "<TH class=\"table-sortable:date\">$L{'Date'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Files'}</TH>\n" if ($ftp_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Emails'}</TH>\n" if ($mail_format == 1);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Spam'}</TH>\n" if ($spam_on == 1);
  if ($dhcp_format == 0) {
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Accesses'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Documents'}</TH>\n" if ($mail_format == 0 && $cups_format == 0);
      print FOUT "<TH class=\"table-sortable:numeric\">$L{'Scripts'}</TH>\n" if ($mail_format == 0 && $cups_format == 0);
  }
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'New_Hosts'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Countries'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Traffic'} ($L{$unit})</TH>\n" if ($notrafic == 0);
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Traffic'} ($L{$unit})</TH>\n" if ($notrafic == 0);
  print FOUT "</TR>\n";

#  print FOUT "<TR>\n";
#  print FOUT "<TH class=\"table-sortable:date\">$L{'Date'}</TH>\n";
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Hosts'}</TH>\n";
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'New_Hosts'}</TH>\n";
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Domain_Hosts'}</TH>\n";
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Requests'}</th>\n" if ($ftp_format == 0 && $mail_format == 0);
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Files'}</TH>\n" if ($ftp_format == 1);
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Emails'}</TH>\n" if ($mail_format == 1);
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'Accesses'}</th>\n" if ($ftp_format == 0 && $mail_format == 0);
#  print FOUT "<TH class=\"table-sortable:numeric\">$L{'DomReq'}</th>\n";
#  print FOUT "</TR>\n";
  print FOUT "</thead>\n";

#  $tmp = int($line_file/(7*$table_lines_aff));
#  if ($tmp != ($line_file/(7*$table_lines_aff))) {
#      $tmp++;
#  }

  print FOUT "<tfoot>\n";
  print FOUT "<tr>\n";
  print FOUT "<TH>$L{'Date'}</TH>\n";
  print FOUT "<TH>$L{'Requests'}</TH>\n" if ($ftp_format == 0 && $mail_format == 0);
  print FOUT "<TH>$L{'Files'}</TH>\n" if ($ftp_format == 1);
  print FOUT "<TH>$L{'Emails'}</TH>\n" if ($mail_format == 1);
  print FOUT "<TH>$L{'Spam'}</TH>\n" if ($spam_on == 1);
  if ($dhcp_format == 0) {
      print FOUT "<TH>$L{'Accesses'}</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "<TH>$L{'Documents'}</TH>\n" if ($mail_format == 0 && $cups_format == 0);
      print FOUT "<TH>$L{'Scripts'}</TH>\n" if ($mail_format == 0 && $cups_format == 0);
  }
  print FOUT "<TH>$L{'Hosts'}</TH>\n";
  print FOUT "<TH>$L{'New_Hosts'}</TH>\n";
  print FOUT "<TH>$L{'Countries'}</TH>\n";
  print FOUT "<TH>$L{'Traffic'}</TH>\n" if ($notrafic == 0);
  print FOUT "<TH>$L{'Requests'}</TH>\n";
  print FOUT "<TH>$L{'Hosts'}</TH>\n";
  print FOUT "<TH>$L{'Traffic'}</TH>\n" if ($notrafic == 0);
  print FOUT "</tr>\n";

#  if ($tmp > 1) {
#  if ($mail_format == 0 && $ftp_format == 0) {
#      print FOUT "<td colspan=8>\n";
#  } else {
#      print FOUT "<td colspan=7>\n";
#  }
#  print FOUT "<a href=\"#\" onclick=\"pageexample('previous'); return false;\">&lt;&lt;&nbsp;$L{'Previous'}</a>\n";

#  for ($i=1;$i<=$tmp;$i++) {
#      $iminus = $i-1;
#      print FOUT "<a href=\"#\" id=\"page$i\" class=\"pagelink\" onclick=\"pageexample($iminus); return false;\">$i</a>\n";
#  }
#  print FOUT "<a href=\"#\" onclick=\"pageexample('next'); return false;\">$L{'Next'}&nbsp;&gt;&gt;</a>\n";
#  print FOUT "<a href=\"#\" onclick=\"pageexample('all'); return false;\">$L{'All'}&nbsp;&gt;&gt;</a>\n";
#  print FOUT "</td>\n";
#  print FOUT "</tr>\n";
#  }
  print FOUT "</tfoot>\n";
  print FOUT "<tbody>\n";
}

sub MonthFooter {
  local(*FOUT) = $_[0];
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "<P><HR><P>\n";
  print FOUT "</BODY></HTML>\n";
}

sub MonthStats {
  local(*FOUT,*L, $count_month) = @_;

  $unit = "Data_unit_octet";
  $unit_div = 1;
  if ($maxsize > 1024) {
      $unit_div = 1024;
      $unit = "Kb";
  }
  if ($maxsize > (1024*1024)) {
      $unit_div = 1024*1024;
      $unit = "Mb";
  }
  if ($maxsize > (1024*1024*1024)) {
      $unit_div = 1024*1024*1024;
      $unit = "Gb";
  }
  if ($maxsize > (1024*1024*1024*1024)) {
      $unit_div = 1024*1024*1024*1024;
      $unit = "Tb";
  }


#  if ($maxsize > (1024*1024*1024)) {
 #     $unitdata2 = $L{'Gb'};
#  } elsif ($maxsize > (1024*1024)) {
#      $unitdata2 = $L{'Mb'};
#  } elsif ($maxsize > 1024) {
#      $unitdata2 = $L{'Kb'};
#  }

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Stats_about_months'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$calendarmonthjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
  print FOUT "$curvy_bottom_jss\n";

  &add_jqplot_js(*FOUT,2);

  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
  print FOUT "var todaydate=new Date()\n";
  print FOUT "var curmonth=todaydate.getMonth()+1 //get current month (1-12)\n";
  print FOUT "var curyear=todaydate.getFullYear() //get current year\n";

  print FOUT "function ToggleGraph(obj,obj2,obj3,obj4) {\n";
  print FOUT "target = document.getElementById(obj);\n";
  print FOUT "target2 = document.getElementById(obj2);\n";
  print FOUT "target3 = document.getElementById(obj3);\n";
  print FOUT "target4 = document.getElementById(obj4);\n";
  print FOUT "target.style.display = \"inline\";\n";
  print FOUT "target2.style.display = \"none\";\n";
  print FOUT "target3.style.display = \"none\";\n";
  print FOUT "target4.style.display = \"none\";\n";
  print FOUT "}\n";

 print FOUT "function ToggleGraph2(id,obj,obj2,obj3) {\n";
 print FOUT "target = document.getElementById(obj);\n";
 print FOUT "target2 = document.getElementById(obj2);\n";
 print FOUT "target3 = document.getElementById(obj3);\n";
 print FOUT "target.style.display = \"inline\";\n";
 print FOUT "target2.style.display = \"none\";\n";
 print FOUT "target3.style.display = \"none\";\n";
 print FOUT "eval(id).replot();\n";
 print FOUT "}\n";

  print FOUT "function ToggleSet(obj) {\n";
  print FOUT "document.getElementById(obj).style.display = \"inline\";\n";
  print FOUT "var val = document.getElementById(\"DATA_LIST\").getElementsByTagName(\"div\");\n";
  print FOUT "for (var i=0; i < val.length; i++) {\n";
  print FOUT "if (val[i].getAttribute(\"id\") != obj) val[i].style.display = \"none\";\n";
  print FOUT "}\n";
  print FOUT "}\n";

  print FOUT "</SCRIPT>\n";

  &add_css_style(*FOUT,2);

  print FOUT "<link rel=\"stylesheet\" type=\"text/css\" href=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dircss$dirsepurl$css_calendar\">\n";
  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\"  LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "<FORM name=\"calendar_value\" ACTION=\"\">\n";
  for ($i=0;$i<=$#list;$i++) {
      print FOUT "<INPUT type=\"hidden\" name=\"calendar_val$i\" value=\"$list[$i]\">\n";
  }
  print FOUT "</FORM>\n";

  print FOUT "<DIV ID=\"calendarspace\">\n";
  print FOUT "<SCRIPT LANGUAGE=\"JavaScript\" type=\"text/javascript\">\n";
#  print FOUT "document.write(buildCal(curmonth ,curyear, \"main\", \"month\", \"daysofweek\", \"weeks\", 1,1,'index$htmlext','@list'));\n";
  print FOUT "document.write(buildCal(curmonth ,curyear, \"main\", \"month\", \"daysofweek\", \"weeks\", 1,1,'index$htmlext'));\n";
  print FOUT "</SCRIPT>\n";
  print FOUT "</DIV>\n";


  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";

  print FOUT "<TABLE>\n<TR>\n<TD ALIGN=CENTER>\n";
  print FOUT "<DIV CLASS=\"curly_title\">\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Stats'}))." ".uc(&noaccentinhtml($L{'about'}))." ".uc(&noaccentinhtml($L{'Months'}))."</H1>\n";
  print FOUT "</DIV>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";
  
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

  print FOUT "<A HREF=\"$oldyear2-$affmois$htmlext\">$L{'Month_of'}$affmois $oldyear2</A><br><br>\n" if ($precision > 2 && $oldyear2 ne '' && $affmois ne '');
  print FOUT "<A HREF=\"$tabnamemonth\">$L{'Table'} $L{'of_months'}</A><br><br>\n";

  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0>\n<TR>\n<TD VALIGN=TOP ALIGN=CENTER>\n";

  print FOUT "<A NAME=\"requete\"></A>\n";

  $chart_id = 0;
  $info = "info".$chart_id;
  undef @ref_tab;
  push(@ref_tab,\@reqmaxtot);
  push(@ref_tab,\@accessmaxtot);
  push(@ref_tab,\@spammaxtot);
  push(@ref_tab,\@machmaxtot);
  push(@ref_tab,\@docmaxtot);
  push(@ref_tab,\@scriptmaxtot);
  push(@ref_tab,\@sizemaxtot);

  @ref_tab_name = ('requests','accesses','spam','hosts','documents2','scripts','traffic');

  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,3,$unit_div,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);
  @graph_to_display = ($L{'Requests'},$L{'Accesses'},$L{'Spam'},$L{'Hosts'});

  undef @ref_tab;
  push(@ref_tab,\@reqmaxtot);
  push(@ref_tab,\@accessmaxtot);
  push(@ref_tab,\@spammaxtot);
  push(@ref_tab,\@machmaxtot);

  @serie_color = ('#ff5555', '#55ff55', '#55ff55','#5555ff', '#55ffff', '#ff55ff', '#ffff55','#aa0000', '#00aa00', '#0000aa', '#4ad5ac', '#c5d529','#9cb400','#EE9400','#bd8383');

  $xlegend = "$count_month month";
  $xlegend .= "s" if ($count_month > 1);
  $xlegend .= " (starting $start_date)";

  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,3,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,-2,"",$info,0,$xlegend,"",$xmax_jqplot,$menu);

  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

  if ($fly_set == 1)  {
      print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
      print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfile2y\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD>\n";
	  for ($i=0;$i<=$#list_graph_file2;$i++) {
	      print FOUT "<!-- begin_bypass_multigraph -->\n" if ($i != ($default_graph_idx-1));
	      $toggle_var = "TOGGLE_".$list_graph_file2[$i];
	      print FOUT "<DIV ID=\"$toggle_var\" STYLE=\"display:";
	      print FOUT "inline" if ($i == ($default_graph_idx-1));
	      print FOUT "none" if ($i != ($default_graph_idx-1));
	      print FOUT "\">\n";
	      print FOUT "<IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$list_graph_file2[$i]$gifext\" ALT=\"graph1\" USEMAP=\"#month2\" BORDER=0>\n";
	      print FOUT "</DIV>\n";
	      print FOUT "<!-- end_bypass_multigraph -->\n" if ($i != ($default_graph_idx-1));
	  }
	  print FOUT "</TD>\n";
	  print FOUT "<TD VALIGN=BOTTOM>\n";
      print FOUT "<!-- begin_bypass_multigraph -->\n";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1>\n";
	  for ($i=0;$i<=$#list_graph_file2;$i++) {
	      print FOUT "<TR><TD ALIGN=LEFT>";
	      print FOUT "<A HREF=\"javascript:ToggleGraph('";
	      print FOUT "TOGGLE_$list_graph_file2[$i]'";
	      for ($j=0;$j<=$#list_graph_file2;$j++) {
		  print FOUT ",'TOGGLE_$list_graph_file2[$j]'" if ($j != $i);
	      }
	      print FOUT ");\">";
#	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$dirress$dirsepurl$list_graph_name[$i]$gifext\" WIDTH=81 HEIGHT=36 BORDER=0 ALT=\"$list_graph_name[$i]\"></A>";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$list_graph_name[$i]$gifext\" WIDTH=20 HEIGHT=20 BORDER=0 ALT=\"$list_graph_name[$i]\"></A>";
	      print FOUT "</TD>\n";
	      print FOUT "</TR><TR>\n";
	      print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>";
	      print FOUT "<A HREF=\"javascript:ToggleGraph('";
	      print FOUT "TOGGLE_$list_graph_file2[$i]'";
	      for ($j=0;$j<=$#list_graph_file2;$j++) {
		  print FOUT ",'TOGGLE_$list_graph_file2[$j]'" if ($j != $i);
	      }
	      print FOUT ");\">$L{$list_graph_name[$i]}</A>\n";
	      print FOUT "</TD>";
	      print FOUT "</TR>";
	  }

	  print FOUT "</TABLE>\n";
      print FOUT "<!-- end_bypass_multigraph -->\n";	  
	  print FOUT "</TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";




#      print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfile2y\" ALT=\"ylabel\"></TD>\n";
#      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkfile2\" BORDER=0 USEMAP=\"#month2\" ALT=\"month_requests\"></TD>\n";
#      print FOUT "</TR><TR><TD></TD>\n";
      print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfile2x\" ALT=\"xlabel\"></TD>\n";
      print FOUT "<TD></TD>\n";
      print FOUT "</TR><TR><TD></TD>\n";
      print FOUT "<TD ALIGN=CENTER>\n";

      print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
      print FOUT "<TD ALIGN=LEFT>&nbsp;";
      print FOUT "$L{'Requests'}" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "$L{'Files'}" if ($ftp_format == 1);
      print FOUT "$L{'Emails'}" if ($mail_format == 1);
      print FOUT "</TD>\n";
      print FOUT "</TR>\n"; 

      if ($spam_on == 1) {
	  print FOUT "<TR>";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp;$L{'Spam'}</TD></TR>";
      }

      if ($mail_format == 0 && $ftp_format == 0 && $dhcp_format == 0) {
	  print FOUT "<TR>";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp;$L{'Accesses'}</TD>\n";
	  print FOUT "</TR>\n";
      }
      print FOUT "<TR>\n";                
      print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";

      print FOUT "<TD ALIGN=LEFT>&nbsp;";
      print FOUT "$L{'Requests'}" if ($mail_format == 0 && $ftp_format == 0);
      print FOUT "$L{'Files'}" if ($ftp_format == 1);
      print FOUT "$L{'Emails'}" if ($mail_format == 1);
      print FOUT " $L{'from_dom'} $localdomainename</TD>\n";      
      print FOUT "</TR></TABLE>\n";
      print FOUT "</TD><TD></TD>\n";
      print FOUT "</TR></TABLE></CENTER>\n";  
  }

  if ($precision > 2) {
      print FOUT "<A NAME=\"utilisateur\"></A>\n";

      $chart_id = ($chart_id+1)*scalar(@list_graph_name_jqplot);
      $info = "info".$chart_id;
      @graph_to_display = ($L{'Hosts'},$L{'New_Hosts'},$L{'Domain_Hosts'});

      undef @ref_tab;
      push(@ref_tab,\@machmaxtot);
      push(@ref_tab,\@newmaxtot);
      push(@ref_tab,\@dommaxtot);
      
      @serie_color = ('#ff5555', '#55ff55','#5555ff', '#55ffff', '#ff55ff', '#ffff55','#aa0000', '#00aa00', '#0000aa', '#4ad5ac', '#c5d529','#9cb400','#EE9400','#bd8383');
      $ylegend = "$L{'Hosts'}";
      
      &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,3,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,-3,"hosts",$info,0,$xlegend,$ylegend,$xmax_jqplot,$menu);

      &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

      if  ($fly_set == 1) {
	  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	  print FOUT "<TR>\n";
	  print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkfile1y\" ALT=\"y\"></TD>\n";
	  print FOUT "<TD>\n";
	  for ($i=0;$i<=$#list_graph_file1;$i++) {
	      print FOUT "<!-- begin_bypass_multigraph -->\n" if ($i != ($default_graph_idx-1));
	      $toggle_var = "TOGGLE_".$list_graph_file1[$i];
	      print FOUT "<DIV ID=\"$toggle_var\" STYLE=\"display:";
	      print FOUT "inline" if ($i == ($default_graph_idx-1));
	      print FOUT "none" if ($i != ($default_graph_idx-1));
	      print FOUT "\">\n";
	      print FOUT "<IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$list_graph_file1[$i]$gifext\" ALT=\"graph1\" USEMAP=\"#month1\" BORDER=0>\n";
	      print FOUT "</DIV>\n";
	      print FOUT "<!-- end_bypass_multigraph -->\n" if ($i != ($default_graph_idx-1));	  
	  }
	  print FOUT "</TD>\n";
	  print FOUT "<TD VALIGN=BOTTOM>";
	      print FOUT "<!-- begin_bypass_multigraph -->\n";
	  print FOUT "<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1>\n";
	  for ($i=0;$i<=$#list_graph_file1;$i++) {
	      print FOUT "<TR><TD ALIGN=LEFT>";
	      print FOUT "<A HREF=\"javascript:ToggleGraph('";
	      print FOUT "TOGGLE_$list_graph_file1[$i]'";
	      for ($j=0;$j<=$#list_graph_file1;$j++) {
		  print FOUT ",'TOGGLE_$list_graph_file1[$j]'" if ($j != $i);
	      }
	      print FOUT ");\">";
#	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$dirress$dirsepurl$list_graph_name[$i]$gifext\" WIDTH=81 HEIGHT=36 BORDER=0 ALT=\"$list_graph_name[$i]\"></A>";
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$list_graph_name[$i]$gifext\" WIDTH=20 HEIGHT=20 BORDER=0 ALT=\"$list_graph_name[$i]\"></A>";
	      print FOUT "</TD>\n";
	      print FOUT "</TR><TR>\n";
	      print FOUT "<TD ALIGN=CENTER VALIGN=BOTTOM>";
	      print FOUT "<A HREF=\"javascript:ToggleGraph('";
	      print FOUT "TOGGLE_$list_graph_file1[$i]'";
	      for ($j=0;$j<=$#list_graph_file1;$j++) {
		  print FOUT ",'TOGGLE_$list_graph_file1[$j]'" if ($j != $i);
	      }
	      print FOUT ");\">$L{$list_graph_name[$i]}</A>\n";
	      print FOUT "</TD>";
	      print FOUT "</TR>";
	  }

	  print FOUT "</TABLE>\n";
	      print FOUT "<!-- end_bypass_multigraph -->\n";	  
	  print FOUT "</TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkfile1x\" ALT=\"xlabel\"></TD>\n";
	  print FOUT "<TD></TD>\n";
	  print FOUT "</TR><TR><TD></TD>\n";
	  print FOUT "<TD ALIGN=CENTER>\n";
	  
	  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" ALT=\"$gcolor[0]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'Conn_Mach'}</TD>\n";
	  print FOUT "</TR><TR>\n";
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'New_Mach'}</TD>\n";
	  print FOUT "</TR><TR>\n";    
	  print FOUT "<TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\"></TD>\n";
	  print FOUT "<TD ALIGN=LEFT>&nbsp; $L{'Number_of'} $L{'Mach_Dom'} $localdomainename</TD>\n";
	  print FOUT "</TR></TABLE>\n";
	  print FOUT "</TD><TD></TD>\n";
	  print FOUT "</TR></TABLE></CENTER>\n";
      }
  }
  

  
  $map2 = $map;
  $map2 =~ s/\/\//\/$lang[$nblang]\//g;
  $map2 =~ s/Requests/$L{'Requests'}/g;
  $map2 =~ s/Accesses/$L{'Accesses'}/g;
  $map2 =~ s/Hosts/$L{'Hosts'}/g;
  $map2 =~ s/Traffic/$L{'Traffic'}/g;

  print FOUT "<MAP NAME=\"month1\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "<MAP NAME=\"month2\">\n";
  print FOUT "$map2\n";
  print FOUT "</MAP>\n";

  print FOUT "</TD>\n<TD VALIGN=TOP ALIGN=CENTER>\n";


  print FOUT "<DIV ID=\"DATA_LIST\">\n";

  $prev_data = '';

  for ($i=0;$i<=$#month_table;$i++) {
      @val_tab = split(/\|/,$month_table[$i]);
      if ($#val_tab == 0) {

	  print FOUT "</TABLE>\n";
	  print FOUT "</TD>\n";
	  print FOUT "<TH>&nbsp;</TH>\n";
	  print FOUT "</TR>";
	  print FOUT "<TR><TH COLSPAN=3>&nbsp;</TH></TR>";
	  print FOUT "</TABLE>\n";
	  print FOUT "</DIV>\n";
	  $end_month = 1;
      }
      if ($#val_tab != 0) {
	  if ($end_month == 1 || $i == 0) {
	      $end_month = 0;
	      ($tmp1,$tmp2a) = split(/-/,$val_tab[0]);
	      $tmp = $tmp1."_".$tmp2a;

	      $title_data = $tmp2a." ".$tmp1;

	      $tmp10 = $month_equiv{$tmp2a};
	      if ($tmp10 > 11) {
		  $tmp10 = 0;
		  $tmp1++;
	      }
	      $tmpb1 = $tmp1."_".$month_nb[$tmp10];
	      $tmpb10 = $tmp1."-".$month_nb[$tmp10];

	      ($tmp4,$tmp3) = split(/\s/,$prev_data);
	      $tmpb = $tmp3."_".$tmp4;

	      print FOUT "<DIV ID=\"TOGGLE_$tmp\" STYLE=\"display:inline\">\n" if ($i == 0);
	      print FOUT "<DIV ID=\"TOGGLE_$tmp\" STYLE=\"display:none\">\n" if ($i != 0);
	      print FOUT "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	      print FOUT "<TR>\n";


	      print FOUT "<TH ALIGN=CENTER COLSPAN=3>";
	      print FOUT "<A HREF=\"javascript:ToggleSet(\'TOGGLE_$tmpb\');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_flecheg\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"left_arrow\"></A>\n" if ($prev_data ne '');
	      print FOUT "&nbsp;";
	      print FOUT "$title_data\n";
	      print FOUT "&nbsp;";
	      print FOUT "<A HREF=\"javascript:ToggleSet(\'TOGGLE_$tmpb1\');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$homeicons$dirsepurl$icon_fleched\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\"></A>\n" if (-f "$path$lang[$nblang]$dirsepurl$dirdate$dirsep$tmpb10$dirsep$menu");
	      print FOUT "</TH>\n";

#	      print FOUT "<TH WIDTH=16>&nbsp;</TH>\n" if ($prev_data eq '');
#	      print FOUT "<TH><A HREF=\"javascript:ToggleSet(\'TOGGLE_$tmpb\');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$homeicons$dirsepurl$icon_flecheg\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"left_arrow\"></A></TH>\n" if ($prev_data ne '');

#	      print FOUT "<TH ALIGN=CENTER>$title_data</TH>\n";

#	      print FOUT "<TH WIDTH=16>&nbsp;</TH>\n" if (!(-f "$path$lang[$nblang]$dirsepurl$dirdate$dirsep$tmpb10$dirsep$menu"));
#	      print FOUT "<TH><A HREF=\"javascript:ToggleSet(\'TOGGLE_$tmpb1\');\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$homeicons$dirsepurl$icon_fleched\" WIDTH=\"16\" HEIGHT=\"16\" BORDER=0 ALT=\"right_arrow\"></A></TH>\n" if (-f "$path$lang[$nblang]$dirsepurl$dirdate$dirsep$tmpb10$dirsep$menu");

	      print FOUT "</TR><TR>\n";
	      print FOUT "<TH VALIGN=MIDDLE>&nbsp;</TH>";
	      print FOUT "<TD>\n";

#	      print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"A$tmp\">\n";
	      print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
	      print FOUT "<thead>\n";
	      print FOUT "<TR>\n";
	      print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Weekday'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Date'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Requests'}&nbsp;</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Files'}&nbsp;</TH>\n" if ($ftp_format == 1);
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Emails'}&nbsp;</TH>\n" if ($mail_format == 1);
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Spam'}&nbsp;</TH>\n" if ($spam_on == 1);
	      if ($dhcp_format == 0) {
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Accesses'}&nbsp;</TH>\n" if ($mail_format == 0 && $ftp_format == 0);
		  print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Documents'}&nbsp;</TH>\n" if ($mail_format == 0 && $cups_format == 0);
	      }
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Hosts'}&nbsp;</TH>\n";
	      print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Traffic'}&nbsp;($unit)&nbsp;</TH>\n" if ($notrafic == 0);
	      print FOUT "</TR>\n";
	      print FOUT "</thead>\n";
	      print FOUT "<tbody>\n";

	      $prev_data = $title_data;
	  }

	  ($tmp3,$tmp4,$tmp5) = split(/-/,$val_tab[0]);
	  $tmpaff = $tmp5." ".$tmp4." ".$tmp3;

	  $wday = $day_of_week[(localtime(&nbday("$tmpaff")*86400))[6]];
	  $classname = "left";
	  $classname = "weekend_left" if ($wday eq "Sun" || $wday eq "Sat");
	  $tmpaff =~ s/\s+/&nbsp;/g;
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"$classname\">$wday</TD>\n";
	  print FOUT "<TD CLASS=\"$classname\"><A HREF=\"$val_tab[0]$dirsepurl$menu\">$tmpaff</A></TD>\n";

	  $tmp = int(40*$val_tab[1]/$maxreq) if ($maxreq != 0);
	  $tmp = 1 if ($val_tab[1] == 0);
	  print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[0]\" HEIGHT=$square ALT=\"$gcolor[0]\">&nbsp;$val_tab[1]&nbsp;</TD>\n";

	  if ($spam_on == 1) {
	      $tmp = int(40*$val_tab[6]/$maxspam) if ($maxspam != 0);
	      $tmp = 1 if ($val_tab[6] == 0);
	      print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" HEIGHT=$square ALT=\"$gcolor[1]\">&nbsp;$val_tab[6]&nbsp;</TD>\n";
	  }

	  if ($ftp_format == 0 && $mail_format == 0 && $dhcp_format == 0) {
	      $tmp = int(40*$val_tab[2]/$maxacc) if ($maxacc != 0);
	      $tmp = 1 if ($val_tab[2] == 0);
	      print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" HEIGHT=$square ALT=\"$gcolor[1]\">&nbsp;$val_tab[2]&nbsp;</TD>\n";
	  }

	  if ($mail_format == 0 && $cups_format == 0 && $dhcp_format == 0) {
	      $tmp = int(40*$val_tab[5]/$maxfile) if ($maxfile != 0);
	      $tmp = 1 if ($val_tab[5] == 0);
	      print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[6]\" HEIGHT=$square ALT=\"$gcolor[5]\">&nbsp;$val_tab[5]&nbsp;</TD>\n";
	  }

	  $tmp = int(40*$val_tab[3]/$maxmac) if ($maxmac != 0);
	  $tmp = 1 if ($val_tab[3] == 0);
	  print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[4]\" HEIGHT=$square ALT=\"$gcolor[4]\">&nbsp;$val_tab[3]&nbsp;</TD>\n";

	  if ($notrafic == 0) {
	      $tmp2 = $val_tab[4];
	      $tmp2 = $tmp2/(1024*1024*1024) if ($maxsize > (1024*1024*1024));
	      $tmp2 = $tmp2/(1024*1024) if ($maxsize > (1024*1024) && $maxsize <= (1024*1024*1024));
	      $tmp2 = $tmp2/1024 if ($maxsize > 1024 && $maxsize <= (1024*1024));
	      $tmp = int(40*$val_tab[4]/$maxsize) if ($maxsize != 0);
	      $tmp = 1 if ($val_tab[4] == 0);
	      $tmp2 = int($tmp2*10)/10;
	      print FOUT "<TD CLASS=\"$classname\"><IMG WIDTH=$tmp SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[3]\" HEIGHT=$square ALT=\"$gcolor[3]\">&nbsp;$tmp2&nbsp;</TD>\n";
	  }
	  print FOUT "</TR>\n";
      }
  }
  print FOUT "</tbody>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</DIV>\n";
  print FOUT "</DIV>\n";

  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "</CENTER>\n";
  print FOUT "</BODY></HTML>\n";
  close FOUT;
}

