<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>W3Perl plugins</TITLE>
<link rel="stylesheet" media="all" type="text/css" href="../../resources/css/menu.css">
<link rel="stylesheet" media="screen" type="text/css" href="../../resources/css/docs.css">
<!-- insert_curly -->
</head>

<BODY TEXT="#000000" LINK="#0000C0" VLINK="#50508F">

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR>
<TD COLSPAN=2>
<!-- insert_css_menu -->
</TD>
</TR>
<TR>
<TD WIDTH=130 ALIGN=CENTER VALIGN=TOP BGCOLOR="#39FFFF"></TD>
<TD VALIGN=TOP ALIGN=CENTER>
<H1><FONT COLOR="#209090">Plugins</FONT></H1>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
To add new features, you could install several optional plug-in. Go to the <A HREF="http://www.w3perl.com/download/">download</A> page to get the package.
<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>
</BLOCKQUOTE>
</TD>
</TR>

<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Fly/Flydraw</DIV>
</TD>
<TD VALIGN=TOP BGCOLOR="#EEEEEE">
<BLOCKQUOTE>
<P>
<DIV STYLE="color:#FF0000"><B>DEPRECATED : W3Perl uses now Jqplot, a javascript library</B></DIV>
<P>
If you want the old way to generate graphics, you can still install
<A HREF="http://www.w3perl.com/download/">Fly</A> or <A HREF="http://packages.ubuntu.com/search?lang=en&amp;searchon=names&amp;keywords=flydraw">Flydraw</A>
(as the new javascript library does not produce any file).
<P>
<P>
<B>Installation</B> 
<BR>
<OL>
<LI>rpm -ivh fly-1.6.5-1mdk.i686.rpm
</OL>
or
<OL>
<LI> tar -zxvf fly-2.0.1.tar.gz</I>
<LI> cd fly-2.0.1</I>
<LI> ./configure; make ; sudo make install</I>
</OL>
<P>
Default location for the fly tool is /usr/local/bin

</BLOCKQUOTE>
</TD>
</TR>


<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Screensize</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
In order to get stats on user's screensize , you need to insert a
javascript tag in your most popular pages (usually homepage).
<P>
Insert these this line :<BR>
&lt;script language="javascript" type="text/javascript" src="/js/miscstats.js"&gt;&lt;/script&gt;
<!--
<BR>
&lt;img src="/js/miscstats.js" height=0 width=0 border=0&gt;
-->
<P>
You'll have to create a js directory in your server root and put the
misctstats.js script inside. 
<BR>
The location of the miscstats.js can be changed but you'll need to change also the link.
<P>
<B>Installation</B> 
<BR>
<OL>
<LI> Create a js directory inside your web server tree
<LI> Copy the javascript /w3perl/resources/miscstats.js in your js directory
<LI> Add the javascript tag in your most popular server pages
</OL>
<P>

</BLOCKQUOTE>
</TD>
</TR>

<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Heatmap</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
In order to get heatmap , you need to insert a
javascript in your most popular pages (usually homepage).
<P>
Insert this line :
<BR>
&lt;script language="javascript" type="text/javascript" src="/js/heatmap.js"&gt;&lt;/script&gt;
<P>
The location of the heatmap.js can be changed but you'll need to change also the link.
<P>
The script will build new logfiles every day in the /log/ subdirectory
found in w3perl install directory.
<BR>
PHP should be enabled.
<P>
<P>
<B>Installation</B> 
<BR>
<OL>
<LI> Create a js directory inside your web server tree
<LI> Copy the javascript /w3perl/resources/heatmap.js in your js directory
<LI> Add the javascript tag in your most popular server pages
</OL>
<P>
</BLOCKQUOTE>
</TD>
</TR>



<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Geo::IPfree</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
The first one is the Geo::IPfree perl module which allow to map IP
to country code, allowing to get country stats with IP logfiles.
It can be used as an alternative to reverse dns as the perl module
use a local database to map IP to country code.
Making DNS queries can be very long, but this is the only way to 
resolve IP to hostname, GeoIPfree doesn't do the same job, IP are not
translated to hostname. Geo::IPfree doesn't work (yet) with ipv6
addresses (2012/06)
<P>
<B>Installation from source </B> 
<BR>
<OL>
<LI> Get the perl module from <A HREF="http://search.cpan.org/~bricas/Geo-IPfree-1.130450/">http://search.cpan.org/~bricas/Geo-IPfree-1.130450/</A>
<LI> Download Geo-IPfree-1.130450.tar.gz  (as 02/2013)
<LI> perl Makefile.PL
<LI> make
<LI> make test
<LI> make install
</OL>
<P>
<P>
<B> - Installation from CPAN</B> 
<P>
- Unix
<P>
<OL>
<LI> perl -MCPAN -e shell
<LI> At the prompt 'cpan>' type 'install Geo::IPfree'
</OL

<P>
- Windows
<P>
<OL> 
<LI> Go to your Perl installation path (usually C:\Perl)
<LI> Type 'ppm'
<LI> At the prompt 'PPM>' type 'install Geo::IPfree'
</OL>

Download the latest ipscountry.dat available, put it within your perl module (/usr/lib/perl5/site_perl/5.8.8/Geo/ in my case).

<P>
<B> - Installation from package</B> 
<P>

This Perl module is already included in most distribution. Search
for Perl-Geo-IP and Perl-Geo-Ipfree

<P>
</BLOCKQUOTE>
</TD>
</TR>

<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Geo::IP</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
<B>Perl module socket6.pm is required for Perl < 5.14 if your logfile contains ipv6 addresses</B>
<P>
Geo::IP perl module is an alternative to Geo::IPfree which also allow to map IP
to country code, allowing to get country stats with IP logfiles.
It can be used as an alternative to reverse dns as the perl module
use a local database to map IP to country code.
(update are freely available on the maxmind website).
Making DNS queries can be very long, but this is the only way to 
resolve IP to hostname, GeoIP doesn't do the same job, IP are not
translated to hostname.
<P>
<B>Step 1 - Installation : GeoIP Library</B> 
<BR>
<OL>
<LI> Get the library from <A HREF="http://www.maxmind.com/download/geoip/api/c/GeoIP-latest.tar.gz">http://www.maxmind.com/download/geoip/api/c/GeoIP-latest.tar.gz</A>
<LI> download GeoIP.tar.gz
<LI> ./configure
<LI> make
<LI> make check
<LI> make install
</OL>
<P>
if user's install, use ./configure --prefix /home/me/GeoIP instead of ./configure (where /home/me/GeoIP is the location where GeoIP will be installed).
<P>

Then if you want to map IP with country code, you'll need the Geo::IP module :
<P>
<B>Step 2 - Installation : Geo::IP module</B> 
<BR>
<OL>
<LI> Get the perl module from <A HREF="https://metacpan.org/release/Geo-IP/">https://metacpan.org/release/Geo-IP/</A>
<LI> Download Geo-IP-1.41.tar.gz  (as 02/2013)
<LI> perl Makefile.PL
<LI> make
<LI> make test
<LI> make install
</OL>
<P>
if user's install, use perl Makefile.PL LIBS='-L/home/me/GeoIP/lib' INC='-I/home/me/GeoIP/include' PREFIX=/home/me/GeoIP (where /home/me/GeoIP is the location where GeoIP have been installed).
<P>
<B>Step 3 - Database</B> 
<P>
Download the latest <A HREF="http://geolite.maxmind.com/download/geoip/database/GeoLiteCountry/GeoIP.dat.gz">GeoIP.dat.gz</A>, uncompress the file and move it over
your previous version.
<BR>
Get also the
latest <A HREF="http://geolite.maxmind.com/download/geoip/database/GeoIPv6.dat.gz">GeoIPv6.dat.gz</A>
if your logfile contains ipv6 addresses.
<P>
In W3Perl configuration file, $geoipv6_file should pointed to your GeoIPv6.dat file 
<P>
</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">GeoLiteCity</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>

To get cities stats, you can use the free GeoLiteCity database from
maxmind which require the GeoIP library (see Step 1 from Geo::IP).
<P>
<B>Step 1 - Installation : GeoIP Library</B> 
<P>
You need first to install the GeoIP library. See the Geo::IP installation and follow only the first step
<P>
<B>Step 2 - Installation : GeoLiteCity database</B> 
<P>
<OL>
<LI> Download the database file from <A HREF="http://geolite.maxmind.com/download/geoip/database/GeoLiteCity.dat.gz">GeoLiteCity.dat.gz</A>
<LI> Uncompress the file and put it in /home/me/GeoIP/share/GeoIP/ if you have installed the package as a user.
</OL>
<P>
In W3Perl configuration file, $geoipcity_file should pointed to your GeoLiteCity.dat file 
(/home/me/GeoIP/share/GeoIP/GeoLiteCity.dat for a user's install).

<P>
</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">PDF&nbsp;report</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>

<P>
Stats reports can be exported in PDF thanks to the <A HREF="http://www.htmldoc.org/">htmldoc program</A>
<BR>
You can download the package <A HREF="http://www.w3perl.com/download/">here</A>

<P>
</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">Mail&nbsp;report</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
In order to send stats report via email, you'll need to install
the perl MIME::Lite module (and also Email::Date::Format which is required by the module).
<P>
<B> - Installation from source</B> 
<BR>
<OL>
<LI> Get the perl module from <A HREF="http://search.cpan.org/CPAN/authors/id/R/RJ/RJBS/MIME-Lite-3.029.tar.gz">MIME::Lite</A>
<LI> Download MIME-Lite-3.029.tar.gz (as 08/2012)
<LI> perl Makefile.PL
<LI> make
<LI> make install
</OL>
<P>
if user's install, use perl Makefile.PL LIBS='-L/home/me/lib' INC='-I/home/me/include' PREFIX=/home/me/MIMELite (where /home/me/MIMELite is the location where MIME::Lite will be installed).
<P>
There is a faster way to install the package using CPAN :
<P>
<B> - Installation from CPAN</B> 
<P>
- Unix
<P>
<OL>
<LI> perl -MCPAN -e shell
<LI> At the prompt 'cpan>' type 'install MIME::Lite'
</OL

<P>
- Windows
<P>
<OL> 
<LI> Go to your Perl installation path (usually C:\Perl)
<LI> Type 'ppm'
<LI> At the prompt 'PPM>' type 'install MIME::Lite'
</OL>


</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<div class="margintable_small">SPIP</DIV>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>

At last, if you want W3Perl to extract data from your SPIP database,
the perl DBI module should be installed.
<P>
Proceed as the MIME::Lite perl module but replace MIME::Lite with DBI.
<BR>
Once the DBI module installed, you need to install the database connector.
(DBD-mysql for a mysql database).

</BLOCKQUOTE>

<HR ALIGN=CENTER WIDTH="30%">
<P>
<BLOCKQUOTE>
See the <A HREF="faq.html">FAQ</A> and <A HREF="bugs.html">bug</A> report if something's wrong.
<BR>
If you have any trouble when installing the package, send me an email about
what's wrong. Try to be as much precise as you can.<BR>
</BLOCKQUOTE>
</TD>
</TR>
</TABLE>
</body>
</html>
