<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>W3Perl - Scripts description - Master script</TITLE>
<link rel="stylesheet" media="all" type="text/css" href="../../resources/css/menu.css">
<link rel="stylesheet" media="screen" type="text/css" href="../../resources/css/docs.css">
<!-- insert_curly -->
</head>

<BODY  TEXT="#000000" LINK="#0000C0" VLINK="#50508F">

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR>
<TD COLSPAN=2>
<!-- insert_css_menu -->
</TD>
</TR>
<TR>
<TD WIDTH=130 ALIGN=CENTER VALIGN=TOP BGCOLOR="#39FFFF"></TD>
<TD VALIGN=TOP ALIGN=CENTER>
<H1><FONT COLOR="#209090">Scripts description</FONT></H1>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP BGCOLOR="#39FFFF">

</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
Cron-w3perl is the master script which start all the others scripts in
the right order.
If your provider allow only one entry in your crontab, this is the
script to add !
<BR>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>
<table border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-w3perl.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
It compute all stats, lannching the different w3perl scripts.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once a day in incremental mode.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
Depending on your logfile size and your configuration file, 
it can take from a few minutes to several hours.<br>
If your logfiles are really huge, I suggest you first to test reports using a small logfile.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How it works
</td>
<td BGCOLOR="#F5F5F5">
It starts the different scripts according to the time schedule you
have defined. Can be run from the web interface.
</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th align=left>-c &lt;file&gt;</th><td>load configuration file</td></tr><tr>
<th align=left>-a</th><td>start from scratch</td></tr><tr>
<th align=left>-d &lt;nbdays&gt;</th><td>number of days to scan</td></tr><tr>
<th align=left>-r &lt;date&gt;</th><td>ending date</td></tr><tr>
<th align=left>-s &lt;date&gt;</th><td>starting date</td></tr><tr>
<th align=left>-e</th><td>incremental run for all scripts</td></tr><tr>
<th align=left>-x</th><td>show default value</td></tr><tr>
<th align=left>-v</th><td>version</td></tr>
</table>

</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
Can now be run from Windows also
</td>
</tr>
</table>
<P>
Example :
<BR>

<TABLE BORDER=0 CELLPADDING=3>
<TR>
<TH BGCOLOR="#FFCC99"><FONT SIZE=-1>Action</FONT></TH>

<TH BGCOLOR="#FFEECC"><FONT SIZE=-1>Command</FONT></TH>
<TH BGCOLOR="#ECECEC"><FONT SIZE=-1>Comment</FONT></TH>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Init your stats from the first logfile found</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -a</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">Use the default config.pl file</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Init your stats from the first logfile found</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl -a</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">Use a dedicated config file</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Init your stats starting 10 days ago only</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl -a -d 10</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">-d  number of days</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Init your stats starting on March 14th 2011</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl -a -s 14/Mar/2011</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">-s starting date</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Init your stats between January 10th 2011 and March 17th 2011</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl -a -s 10/Jan/2011 -r 17/Mar/2011</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">-r ending date</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Update everything</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl -e</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">Update from your last run</TD>
</TR>
<TR>
<TD BGCOLOR="#FFCC99">Update current stats</TD>
<TD ALIGN=LEFT BGCOLOR="#FFEECC">cron-w3perl.pl -c config-mywebsite.pl</TD>
<TD ALIGN=RIGHT BGCOLOR="#ECECEC">Real-time and hourly reports</TD>
</TR>
</TABLE>
<P>
Initialisation (-a) will delete your previous reports (except cache files as IP reversedns).
<BR>
Update (-e) will scan at maximum for the last 14 days (default). Can be changed in config file.
</BLOCKQUOTE>

</TD>
</TR>
</TABLE>
</body>
</html>
