<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>W3Perl - Scripts description - Time</TITLE>
<link rel="stylesheet" media="all" type="text/css" href="../../resources/css/menu.css">
<link rel="stylesheet" media="screen" type="text/css" href="../../resources/css/docs.css">
<!-- insert_curly -->
</head>

<BODY TEXT="#000000" LINK="#0000C0" VLINK="#50508F">

<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
<TR>
<TD COLSPAN=2>
<!-- insert_css_menu -->
</TD>
</TR>
<TR>
<TD WIDTH=130 ALIGN=CENTER VALIGN=TOP BGCOLOR="#39FFFF"></TD>
<TD VALIGN=TOP ALIGN=CENTER>
<H1><FONT COLOR="#209090">Scripts description</FONT></H1>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP BGCOLOR="#39FFFF">

</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
<UL>

<LI> Time structures : real time, hour, day, week and month
<UL>
<LI><A HREF="#hour">cron-hour.pl</A>
<LI><A HREF="#jour">cron-day.pl</A>
<LI><A HREF="#semaines">cron-week.pl</A>
<LI><A HREF="#mois">cron-month.pl</A>
<LI><A HREF="#annee">cron-year.pl</A>
</UL>

</UL>
<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="hour"></A>
<table border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-hour.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Hourly stats<br>
It compute stats for each hours of the current day,
by scanning the logfile on the current day.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once every hour.<br>
If you forget to run it one hour, it won't loose any data as
cron-hour.pl compute the hourly stats from the beginning of
the current day. So you can run cron-hour once a day (at midnight) if
your CPU is low.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
A few seconds.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan the logfile for the current date and compute values
for each hours from the beginning of the current day.
It will also save the hourly stats at midnight, the files can
be viewed in the table of daily stats.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-a</th><td> scan all the logfile to produce average hourly stats</td>
</tr><tr>
<th>-c &lt;file&gt;</th><td>load configuration file</td>
</tr><tr>
<th>-i &lt;file&gt;</th><td> input logfile</td>
</tr><tr>
<th>-o &lt;file&gt;</th><td> output logfile</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td>language output</td>
</tr><tr>
<th>-j &lt;dd/Mmm/yyyy&gt;</th><td> scan only a specific day</td>
</tr><tr>
<th>-r &lt;string&gt;</th><td> scan only this matching string</td>
</tr><tr>
<th>-p &lt;level&gt;</th><td> precision level</td>
</tr><tr>
<th>-t &lt;topten&gt;</th><td> display only toplist files</td>
</tr><tr>
<th>-v</th><td> show default value </td>
</tr><tr>
<th>-v</th><td> display version </td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
Produced a stats of the day, you can see them in the text version of the
daily stats. Will not save over than one year daily files. The -a option
will show you the average hourly hits over the full logfile (these job is
done by cron-session).
</td>
</tr>
</table>


<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="jour"></A>
<table border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-day.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Daily stats<br>
It compute text and graphics stats for each day,
by scanning files produced by cron-pages or cron-inc.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once every day.<br>
No data lost if you forget to run it one day.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
A few seconds.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan differents files produced by cron-pages or cron-inc
, extract some values and compute the graphs and table data.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-c &lt;file&gt;</th><td>load configuration file</td>
</tr><tr>
<th>-d &lt;number&gt;</th><td> number of days </td>
</tr><tr>
<th>-g &lt;graphic&gt;</th><td> use different graphic option</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td>language output</td>
</tr><tr>
<th>-p &lt;level&gt;</th><td> precision level</td>
</tr><tr>
<th>-v</th><td> display version</td>
</tr><tr>
<th>-x</th><td> show default values</td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
You could look for the last previous days stats in the text option.
The hourly stats script save its daily file at the end of the day
and cron-day.pl add the link in its table data.
</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="semaines"></A>
<table border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-week.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Weekly stats<br>
It compute stats for each week
by scanning files produced by cron-pages or cron-inc.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once every week.<br>
No data lost if you forget to run it one week.<BR>
You will have to wait two weeks to see the graphs (need two
points to draw a graph !).
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
A few seconds.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan differents files produced by cron-pages or cron-inc
, extract some values and compute the graphs and table data.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<!-- <th>-w &lt;number&gt;</th><td> number of weeks </td>
</tr><tr> -->
<th>-c &lt;file&gt;</th><td>load configuration file</td>
</tr><tr>
<th>-g &lt;graphic&gt;</th><td> use different graphic option</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td>language output</td>
</tr><tr>
<th>-p &lt;level&gt;</th><td> precision level</td>
</tr><tr>
<th>-v</th><td> display version</td>
</tr><tr>
<th>-x</th><td> show default values</td>
</tr></table>

</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
Cron-week compute a graph for the directory stats.<BR>
It will also compute graphs for each directories you have choosen
in the configuration files.
</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="mois"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-month.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Monthly stats<br>
It compute stats for each month by reading saved data from main script
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once every month.<br>
You will have to wait two months to see the graphs (need two
points to draw a graph !).
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
Few minutes.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It read saved data from the main script
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-c &lt;file&gt;</th><td>load configuration file</td>
</tr><tr>
<th>-g &lt;graphic&gt;</th><td> use different graphic option</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td>language output</td>
</tr><tr>
<th>-p &lt;level&gt;</th><td> precision level</td>
</tr><tr>
<th>-v</th><td> display version</td>
</tr><tr>
<th>-x</th><td> show default values</td>
</tr><tr>
<th>-z</th><td> use compressed logfiles</td>
</tr></table>

</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="annee"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-year.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Yearly stats<br>
It compute stats for each year
by scanning the log file.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
Once every few weeks.<br>
Will show the current year also.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
Few seconds.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It read saved data from the main script
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-c &lt;file&gt;</th><td>load configuration file</td>
</tr><tr>
<th>-g &lt;graphic&gt;</th><td> use different graphic option</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td>language output</td>
</tr><tr>
<th>-p &lt;level&gt;</th><td> precision level</td>
</tr><tr>
<th>-v</th><td> display version</td>
</tr><tr>
<th>-x</th><td> show default values</td>
</tr><tr>
<th>-z</th><td> use compressed logfiles</td>
</tr></table>

</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">

</td>
</tr>
</table>
</BLOCKQUOTE>
</TD>
</TR>
</TABLE>
</body>
</html>
