#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    domisse@w3perl.com                   version 02/05/2003     #####
####                                                                #####
#########################################################################

# Look for YYY string for new or updated strings

%LangJP = (
"No_enough_data_to_display_graph", "Not enough data to display graph",
"Emails_sent", "Emails sent",
"emails_sent", "emails sent",
"Histogram", "Histogram",
"Mac_address", "Mac address",
"Days_between_same_session", "Days between multiple session",
"Daily_visits", "Daily visits",
"Different_accesses", "Different accesses",
"Unique", "Unique",
"Spam", "Spam",
"spam", "spam",
"Flag", "Flag",
"Spam_rank", "Spam rank",
"documents" , "ドキュメント",
"graph3d", "3D bar",
"graphlinefill","Filled lines",
"graphline", "Lines",
"barchart", "Barchart",
"Sort", "Sort",
"Alphabetically", "Alphabetically",
"By_size", "By size",
"All", "All",
"Next", "Next",
"Previous", "Previous",
"Last", "Last",
"Weekday", "Weekday",
"Select_an_interval", "Select an interval",
"When", "When",
"Resources", "Resources",
"Optional", "Optional",
"Last_update", "Last update",
"Admin", "Admin",
"Tag", "Tag",
"No_index", "No index",
"Only_users", "Only users",
"Only_cities", "Only cities",
"Cities", "Cities",
"Region_name", "Region name",
"Heatmap", "Heatmap",
"Click", "Click",
"Most_heavy_files", "Largest files",
"Selected_pages", "Selected pages",
"robots", "robots",
"Years", "Years",
"About_years", "About years",
"of_years", "of years",
"Incoming_bandwidth", "Incoming bandwidth",
"Outgoing_bandwidth", "Outgoing bandwidth",
"RSS", "RSS",
"Click_here", "Click here to view more informations",
"URL_mapping", "URL mapping",
"Enabled", "Enabled",
"Disabled", "Disabled",
"Processing", "Processing",
"No_item_found", "No item found",
"Title", "Title",
"URL", "URL",
"Threshold", "Threshold",
"Search", "Search",
"Search_on", "Search on",
"General_ranking", "General ranking",
"Emails", "Emails",
"emails", "emails",
"Only_emails", "Only emails",
"Full_list", "Full list",
"Miscellaneous", "Miscellaneous",
"Screensize", "Screensize",
"Color_depth", "Color depth",
"Java_plugin", "Java plugin",
"Protected_files", "Protected files",
"Parameter","Parameter",
"Exit_occurence", "Exit occurence",
"Entry_occurence", "Entry occurence",
"Unauthorized", "Unauthorized",
"ReferSpam_excluding", "Spammer excluded",
"Cached_files", "Cached files",
"Cached_trafic", "Cached trafic",
"Downloaded_files", "Downloaded files",
"Downloaded_trafic", "Downloaded trafic",
"milliseconds", "ms",
"Stats_about_destinations", "Statistiques about destinations",
"Sorted_destination_servers", "Sorted destination servers",
"Destination", "Destination",
"Incoming_requests_by_status", "Incoming requests by status",
"Outgoing_requests_by_status", "Outgoing requests by status",
"Outgoing_requests_by_destination", "Outgoing requests by destination",
"Average_elapsed_time", "Average elapsed time",
"Proxy", "プロキシ",
"Stats_over", "Stats over",
"updated_every", "updated every",
"with_an_integration_time_of", "with an integration time of",
"Real_time","Real time",
"Abort","Abort",
"Status_code","Status code",
"Size","Size",
"Download_not_completed","Download not completed",
"Outgoing_traffic", "Outgoing traffic",
"Incoming_traffic", "Incoming traffic",
"Virus", "Virus",
"virus", "virus",
"internal_pages", "YYYinternal pages",
"Internal_pages", "YYYInternal pages",
"Accesses_only", "YYYAccesses only",
"accesses", "YYYaccesses",
"Gb", "Gb",
"Tb", "Tb",
"most_successful_bookmark", "YYYmost successful bookmark",
"Bookmarked_page", "YYYBookmarked page",
"Difference", "YYYDifference",
"Minimum", "YYYMin",
"Maximum", "YYYMax",
"Only_files", "YYYOnly files",
"Filetype", "YYYFiletype",
"28800_modem", "28800 モデム ，",
"A_description" , "詳細",
"About_months" , "月毎のテ−ブル", 
"About_weeks" , "週毎のテ−ブル", 
"Absolute_links", "Absolute links",
"Accesses" , "アクセス",
"Acces_not_taken_into_account", "解析対象にしないアクセス",
"All_html_pages_requests", "HTMLペ−ジの総リクエスト",
"All_images_requests", "画像の総リクエスト",
"All_requests" , "全てのリクエスト",
"All_sites" , "全てのサイト",
"At", "",
"Average_CPU", "YYYTemps moyen CPU",
"Average", "平均",
"Average_is_black", "黒線は平均です",
"Average_on_hours_and_days", "曜日、時間の平均",
"Average_pages_by_session", "一回のセッションで読まれたペ−ジ数の平均",
"Average_session_time", "一回のセッションにかかる時間の平均",
"Average_reading_time_per_page", "YYYAverage reading time",
"Back", "戻る",
"Background", "背景",
"Bad_links", "Bad links",
"Blue_line_is_average", "青線は平均です",
"Browser" , "ブラウザ",
"Browsers" , "ブラウザ",
"Browsers_used" , "使用されたブラウザ",
"CPU", "YYYTemps de calcul",
"Cgi-bin", "Cgi-bin",
"Conn_Mach" , "アクセスしてきたマシン数", 
"Connection_time", "接続時間",
"Correct_size_taken_from_image", "画像から得られる正しいサイズ",
"Countries", "国", 
"Data", "デ−タ",
"Data_traffic_by_weeks" , "週間のデ−タトラフィック",
"Data_unit_Kb" , "キロバイト",
"Data_unit_Mb" , "メガバイト",
"Data_unit_octet" , "バイト",
"Date" , "日",
"Days", "日間", 
"Decrease_over_the_previous_day","Decrease over the previous day",
"Directories" , "ディレクトリ",
"Directories_graphs" , "グラフ：ディレクトリ",
"Docs" , "ドキュメント",
"Documents" , "ドキュメント",
"DomReq" , "自ドメインからのリクエスト", 
"Domain", "ドメイン",
"Domain_Hosts" , "自ドメイン内のホスト",
"Download", "YYYDownload",
"Downloading_time", "ダウンロ−ド時間",
"Errors" , "エラ−",
"Error", "エラ−",
"Evolution_of", "解析結果：",
"Files", "ファイル",
"Forbidden", "応答不能",
"Found_in", "Found in",
"Frames", "YYYFrames",
"Frames_excluding", "YYYFrames excluding",
"Global_access", "全アクセス",
"Graphic" , "グラフ",
"Graphs_for" , "グラフ：",
"Graphs_for_dir" , "グラフ：ディレクトリ",
"HTML_files", "HTMLファイル",
"Histogram_about_average_request", "グラフ：リクエスト数の平均",
"Histogram_sessions", "グラフ：セッション数",
"Hosts", "ホスト",
"Hosts_excluding", "アクセス拒否されたホスト",
"Hosts_from" , "ホスト：",
"Hour" , "時間", 
"Hours" , "時間", 
"Image", "画像", 
"Images", "画像",
"Images_histogram", "グラフ：画像",
"Images_never_used", "一度も使われていない画像",
"Increase_over_the_previous_day", "Increase over the previous day",
"Index", "インデックス",
"Index_pages", "XXX",
"Inside" , "内部ドメインからのアクセス",
"Kb" , "Kb", 
"Kbytes" , "キロバイト", 
"Keywords", "キ−ワ−ド",
"Language" , "日本語",
"Last_occurence" , "最終アクセス日",
"Last_try", "最終トライ日",
"Legend_in_bracket", "Legend in brackets",
"Level", "レベル",
"Lines_processed", "YYYLignes trait&eacute;es",
"Link", "リンク",
"Links", "リンク", 
"Links_histogram", "グラフ：リンク",
"ListOf" , "",
"ListOfSites" , "サイトリスト",
"List_of_unresolved_hosts", "(不明)",
"List_of", "リスト：",
"Login", "YYYLogin",
"Longest_external_session", "外部ドメインからの最長セッション時間",
"Longest_local_session", "自ドメインからの最長セッション時間",
"Longest_session", "最長セッション時間",
"Mach_Dom" , " 自ドメイン内のマシン：", 
"Mb" , "Mb",
"Mbytes" , "メガバイト",
"Method", "YYYMethod",
"Mhosts" , "ホスト", 
"Misc", "YYYMisc",
"MonthByMonth" , "月毎", 
"Month_of" , "", 
"Month" , "月間", 
"Months" , "月間", 
"More_Precise" , "",
"MostSuccesf" , "(アクセス成功のみ)",
"Multiple_sessions", "セッション数",
"New_country", "YYYNew countries",
"New_HTML_files", "新しいHTLMファイル",
"New_Hosts" , "初めてアクセスしてきたホスト",
"New_Mach" , "初めてアクセスしてきたマシン", 
"Newest_pages", "一番新しいペ−ジ",
"Newest_pages_histogram", "グラフ：一番新しいペ−ジ",
"News" , "最新情報",
"NoReq" , "リクエスト数",
"No_Ttl_Req_Mnth" , "月毎のリクエスト総数",
"No_Ttl_Req_Week" , "週毎のリクエスト総数",
"No_login", "YYYNo login accesses",
"No_modification", "変更なし",
"No_request", "リクエストなし",
"No_robot_session", "ロボットによるセッションなし",
"No_title", "タイトルなし",
"Not_found", "該当するページがない",
"Number" , "",
"Number_of" , "", 
"Number_of_HTML_files", "HTMLファイルの数",
"Number_of_different_sites" , "サイト数(重複分は除く)",
"Number_of_different_resolved_countries" , "YYY国の数(重複分は除く)",
"Number_of_different_pages_used" , "ペ−ジ数(重複分は除く)",
"Number_of_pages_read", "読まれたペ−ジの数",
"Number_of_req_by_weeks" , "週間リクエスト数",
"Number_of_requests", "リクエスト数",
"Number_of_visits", "訪問数",
"OS" , "OS",
"OS_used1" , "",
"OS_used2" , "OS",
"Occurence" , "アクセス数",
"On", "", 
"Only_directories", "ディレクトリ…",
"Only_first", "最初のもののみ",
"Only_hosts", "ホストのみ",
"Only_pages", "ペ−ジのみ",
"Only_scripts", "YYYOnly scripts",
"Only_time_session_upper", "最低セッション時間：",
"Others" , "その他",
"Outside" , "外部ドメインからのアクセス",
"Page", "ペ−ジ", 
"Pages_excluding", "アクセスを禁止されたページ", 
"Page_reading_time_histogram", "グラフ：HTLMペ−ジ読み込み時間",
"Pages", "ペ−ジ", 
"Pages_never_used", "一度も使用されていないペ−ジ",
"Percentage" , "割合",
"Reading_time", "読み込み時間",
"Reading_time_sessions", "セッション数：読み込み時間-",
"Redirect", "接続先変更",
"References_for" , "参照：",
"Referer" , "参照",
"Referer_about" , "参照：",
"Referer_on" , "参照：",
"Referer_pages2" , "参照ペ−ジ",
"Request" , "リクエスト", 
"Requests" , "リクエスト", 
"Robots_excluding", "YYYRobots excluding",
"Robot_name", "ロボット名",
"Robot_session_exclude", "(以下はロボットによるセッションをカウントしていません)",
"Same_over_the_previous_day", "Same over the previous day",
"Same_title", "同じタイトル",
"Scripts", "YYYScripts",
"Search_engine", "サーチエンジン",
"Send_me_an", "私にメールをください",
"entry_pages" , "YYYentry pages",
"exit_pages" , "YYYexit pages",
"Entry_pages" , "YYYEntry pages",
"Exit_pages" , "YYYExit pages",
"Server_tree", "サ−バツリ−",
"Session", "セッション",
"Session_cut1", "一回のセッションが日をまたがった場合、一日目のセッションとみなされます",
"Session_cut2", "一回のセッションが24時間以上に及んだ場合、そのセッションは不正とみなされます",
"Session_length", "セッション時間",
"Sessions" , "セッション",
"Sessions_from", "セッション…",
"Sorted_countries_list", "国名リスト(アルファベット順)",
"Sorted_virtual_server_list", "YYYSorted virtual server list",
"Speed", "YYYVitesse",
"Stats_about_CPU", "YYYStatistiques sur les temps de calculs",
"Stats" , "解析結果：", 
"Stats_aboutMnth" , "解析結果：",
"Stats_about_HTML_files", "解析結果：HTMLファイル",
"Stats_about_files_weight", "解析結果：ファイルのウェイト",
"Stats_about_alt", "解析結果：ALT",
"Stats_about_errors" , "解析結果：エラ−", 
"Stats_about_host" , "解析結果：ホスト", 
"Stats_about_hosts", "解析結果：ホスト",
"Stats_about_images", "解析結果：画像",
"Stats_about_internal_links", "YYY解析結果：リンク",
"Stats_about_login", "YYYStatistics about login",
"Stats_about_months" , "解析結果：月毎", 
"Stats_about_robots_sessions", "解析結果：ロボットによるセッション",
"Stats_about_session_length", "解析結果：セッションの長さ",
"Stats_about_sessions", "解析結果：セッション",
"Stats_about_visits", "解析結果：訪問数",
"Stats_about_virtual_servers", "YYYStatistiques about virtual servers",
"Stats_about_weeks" , "解析結果：週毎", 
"Stats_about_width", "解析結果：WIDTH と HEIGHT",
"Stats_aboutlastdays1" , "過去",
"Stats_aboutlastdays2" , "日毎",
"String", "文字列",
"Successful_pages" , "アクセスできたページ",
"Summary", "YYYSummary",
"Symbolic_links", "シンボリックリンク",
"Tab_about_lastdays1" , "日毎のテーブル…過去",
"Tab_about_lastdays2" , "日間",
"Table" , "テーブル", 
"Text" , "テキスト",
"Textual_version" , "テキスト",
"The_Top", "上位",
"Time", "時間",
"Total", "総数",
"Total_HTML_access", "HTMLアクセスの総数",
"Total_data_sent" , "送信されたデ−タの総数",
"Total_number_of_directories", "ディレクトリの総数",
"Total_number_of_html_files", "HTMLファイルの総数",
"Total_number_of_images", "画像の総数",
"Total_number_of_images_in_files", "HTMLファイルの中の画像の総数",
"Total_number_of_links", "リンクの総数",
"Total_number_of_requests" , "リクエストの総数",
"Total_number_of_robot_session", "ロボットセッションの総数",
"Total_number_of_scripts", "YYYTotal number of scripts",
"Total_number_sessions", "セッションの総数",
"Total_traffic" , "トラフィックの総数",
"Traffic" , "トラフィック", 
"Traffic_about" , "トラフィック：",
"Traffic_statistics" , "トラフィック",
"Tree", "ツリー",
"Useless_pages", "使用できないペ−ジ",
"Users" , "ユ−ザ",
"Virtual_servers", "YYYVirtual servers",
"You_should_add", "You should add",
"Web_size", "Webサイズ",
"Week" , "週間", 
"Weeks" , "週間", 
"Weight_HTML_files_histogram", "グラフ：HTLMファイルのWEIGHT",
"Weight_of_files", "ペ−ジのWEIGHT",
"With" , "", 
"about" , "", 
"about_hours_and_days", "(時間毎、日毎)",
"absolute_links", "absolute links",
"added_pages", "　そうすれば、ご希望のぺ−ジを下のリストにのせます。",
"all_sites", "全てのサイト",
"among" , "総数：", 
"and", "と",
"are_shown", "",
"average_HTML_accesses", "HTLMアクセスの平均",
"bad_links", "bad links",
"by", "／",
"by_day", "(/日)",
"by_hour", "(/時間)",
"bytes" , "バイト",
"chronological_order", "時間順", 
"coming_from", "",
"computed_with", "バージョン：",
"connecting_to", "…アクセス",
"connecting_to_the_server", "",
"countries", "国",
"daily" , "日間",
"data_sent_for_dir" , "ディレクトリに送信されたデ−タ",
"day" , "日",
"days", "日間",
"description", "詳細",
"different_images", "その他の画像",
"different_references_found", "different references found",
"directories" , "ディレクトリ",
"directory" , "ディレクトリ",
"domain", "ドメイン",
"engine_keywords_used", "最もよく使用されたキ−ワ−ド",
"exceeding", "最低：",
"excluding", "YYYexcluding",
"external" , "外部ドメイン",
"files", "files",
"files_stored_locally_CD-ROM", "もし、あなたのファイルが近くで保管されている場合、又はCD-ROMにある場合",
"for_today" , "(本日分)",
"from", "",
"from_dom" , "ドメイン：", 
"from domain", "ドメイン：",
"from_outside", "外部ドメイン",
"global", "YYYglobal",
"hTML_pages", "HTMLペ−ジ",
"have", "",
"host", "ホスト",
"hosts","ホスト",
"hour" , "時", 
"hours" , "時間", 
"images", "画像",
"images_found_on_server", "サ−バ上の画像",
"in", "",
"in_this_directory", "(このディレクトリのみ)",
"in_whole_directory", "(全ディレクトリ)",
"internal", "YYYinternal",
"less_than", "",
"links", "リンク", 
"local", "自ドメイン内",
"maximum", "最大",
"minimum", "最大表示数",
"minutes", "分",
"minute", "YYY分",
"modified_less_than", "modified less than",
"monthly", "月毎",
"more_than" , "",
"most_common_errors" , "の最も多かったエラ−",
"most_graphic_pages", "最もグラフィックなペ−ジ",
"most_linky_pages", "最もリンクの多いペ−ジ",
"most_succf_browsers_vtime1" , "エラー解析：",
"most_succf_browsers_vtime2" , "の、(成功した)アクセスが多かったブラウザ",
"most_succf_browsers1" , "",
"most_succf_browsers2" , "の、(成功した)アクセスの多かったブラウザ",
"most_weighty_pages", "最も大量のペ−ジ",
"no_reference_found", "参照なし",
"not_defined", "不明",
"not_included", "含まれていない",
"of_different_hosts" , "ホスト数(重複分は除く)",
"of_months" , "(月毎)",  
"on", "",
"only_reading_time_below", "最大読み込み時間：",
"only_session_more_than", "最小セッション時間",
"optdirsize1" , "(全てののHTLMペ−ジ)",
"optdirsize2" , "(外部ドメインのHTLMペ−ジ)",
"optdirsize3" , "(自ドメインのHTLMペ−ジ)",
"optdirsize4" , "(全てのリクエスト)",
"optdirsize5" , "(外部ドメインからの総リクエスト)",
"optdirsize6" , "(自ドメインからの総リクエスト)",
"page", "ペ−ジ",
"pages" , "ペ−ジ",
"pages_found_on_server", "サ−バ上で見つかったぺ−ジ",
"percentage" , "パーセント", 
"read_by", "…",
"referer_pages1" , "参照ペ−ジ",
"request" , "リクエスト", 
"requests" , "リクエスト", 
"resolved_countries", "(DNS での逆引き可能なもの)",
"scripts", "YYYscripts",
"search_engine", "サ−チエンジン",
"seconds", "秒",
"session", "セッション",
"sessions", "セッション",
"since", "",
"sites", "サイト",
"symbolic_links", "シンボリックリンク",
"text_only", "テキストのみ",
"the" , "", 
"there_are", "",
"times" , "回",
"to", "",
"today", "本日",
"top" , "",
"top_external_sites" , "の外部ドメインのサイト",
"top_local_sites" , "の自ドメインのサイト",
"total" , "総数",
"total_data_sent_for" , "total data sent for",
"total_for" , "",
"traffic_in" , "トラフィック　単位：",
"unknown", "(不明)",
"unresolved", "(DNS での逆引き不可能)",
"used", "(アクセスのあったもの)",
"used2", "(アクセスのあったもの)",
"visitors", "訪問者",
"weekly", "週間",
"weight", "ウェイト",
"weighting", "ウェイト",
"with_at_least", "最小：",
"with_less_than", "最小リクエスト数：",
"with_most_accesses", "(最もアクセスのあったもの)",
"with_the_same_title", "(同じタイトル)",
"without", "次を除く：",
"without_title", "タイトルのないもの",
"wrong", "wrong"
 );
