#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    domisse@w3perl.com                   version 10/01/2009     #####
####                                                                #####
#########################################################################

# Look for YYY string for new or updated strings

%LangSP = (
"No_enough_data_to_display_graph", "Not enough data to display graph",
"Emails_sent", "Emails sent",
"emails_sent", "emails sent",
"Histogram", "Histogram",
"Mac_address", "Mac address",
"Days_between_same_session", "Days between multiple session",
"Daily_visits", "Daily visits",
"Different_accesses", "Different accesses",
"Unique", "Unique",
"Spam", "Spam",
"spam", "spam",
"Flag", "Flag",
"Spam_rank", "Spam rank",
"documents" , "documentos",
"graph3d", "3D bar",
"graphlinefill", "Filled lines",
"graphline", "Lines",
"barchart", "Barchart",
"Sort", "Sort",
"Alphabetically", "Alphabetically",
"By_size", "By size",
"All", "Todos",
"Next", "Siguiente",
"Previous", "Anterior",
"Last", "&Uacute;ltimo",
"Weekday", "D&iacute; de la semana",
"Select_an_interval", "Escoge un intervalo",
"When", "Cu&aacute;ndo",
"Resources", "Recursos",
"Optional", "Opcional",
"Last_update", "&Uacute;ltima actualizaci&oacute;n",
"Admin", "Admin",
"Tag", "Etiqueta",
"No_index", "Sin &iacute;ndice",
"Only_users", "Solo usuarios",
"Only_cities", "Solo ciudades",
"Cities", "Ciudades",
"Region_name", "Nombre de la regi&oacute;n",
"Heatmap", "Mapa de calor",
"Click", "Click",
"Most_heavy_files", "Ficheros m&aacute;s pesados",
"Selected_pages", "P&aacute;ginas seleccionadas",
"robots", "robots",
"Years", "A&ntilde;os",
"About_years", "A cerca de a&ntilde;os",
"of_years", "de a&ntilde;os",
"Incoming_bandwidth", "Ancho de banda de entrada",
"Outgoing_bandwidth", "Ancho de banda de salida",
"RSS", "RSS",
"Click_here", "Haz click aqu&iacute; para ver m&aacute;s informaci&oacute;n",
"URL_mapping", "Mapeo de URL",
"Enabled", "Habilitado",
"Disabled", "Deshabilitado",
"Processing", "Procesando",
"No_item_found", "No se ha encontrado ning&uacute;n elemento",
"Title", "T&iacute;tulo",
"URL", "URL",
"Threshold", "Umbral",
"Search", "B&uacute;squeda",
"Search_on", "Buscar en",
"General_ranking", "Posicionamiento general",
"Emails", "Correos",
"emails", "correos",
"Only_emails", "Solo correos",
"Full_list", "Lista completa",
"Miscellaneous", "Miscel&aacute;nea",
"Screensize", "Tama&ntilde;o de pantalla",
"Color_depth", "Profundidad de color",
"Java_plugin", "Plugin de java",
"Protected_files", "Ficheros protegidos",
"Parameter","Par&aacute;metro",
"Exit_occurence", "Ocurrencia de salida",
"Entry_occurence", "Ocurrencia de entrada",
"Unauthorized", "No autorizado",
"ReferSpam_excluding", "Excluyendo referencias no deseadas",
"Cached_files", "Ficheros atrapados",
"Cached_trafic", "Tr&aacute;fico atrapado",
"Downloaded_files", "Ficheros descargados",
"Downloaded_trafic", "Tr&aacute;fico descargado",
"milliseconds", "mili segundos",
"Stats_about_destinations", "Estad&iacute;sticas sobre destinos",
"Sorted_destination_servers", "Servidores de destino ordenados",
"Destination", "Destino",
"Incoming_requests_by_status", "Peticiones de entrada por estado",
"Outgoing_requests_by_status", "Peticiones de salida por estado",
"Outgoing_requests_by_destination", "Peticiones de salida por destino",
"Average_elapsed_time", "Tiempo promedio trasncurrido",
"Proxy", "Proxy",
"Stats_over", "Estad&iacute;sticas sobre",
"updated_every", "actualizado cada",
"with_an_integration_time_of", "con un tiempo de integraci&oacute;n de",
"Real_time","Tiempo real",
"Abort","Abortar",
"Status_code","C&oacute;digo de estado",
"Size","Taman&tilde;o",
"Download_not_completed","Descarga no completada",
"Outgoing_traffic", "Tr&aacute;fico de salida",
"Incoming_traffic", "Tr&aacute;fico de entrada",
"Virus", "Virus",
"virus", "virus",
"internal_pages", "p&aacute;ginas internas",
"Internal_pages", "P&aacute;ginas internas",
"Accesses_only", "Solo accesos",
"accesses", "Accesos",
"Gb", "Gb",
"Tb", "Tb",
"most_successful_bookmark", "Marcador con mayor &eacute;xito",
"Bookmarked_page", "P&aacute;gina con marcador",
"Difference", "Diferencia",
"Minimum", "M&iacute;nimo",
"Maximum", "M&aacute;ximo",
"Only_files", "Solo ficheros",
"Filetype", "Tipo de fichero",
"28800_modem", "modem 28800",
"A_description" , "Una descripci&ograve;n",
"About_months" , "A cerca de meses", 
"About_weeks" , "A cerca de semanas", 
"Absolute_links", "Enlaces absolutos",
"Acces_not_taken_into_account", "Accesos no considerados",
"Accesses" , "Accesos", 
"All_html_pages_requests", "Todas las peticiones de p&aacute;ginas",
"All_images_requests", "Todas las peticiones a imagenes",
"All_requests" , "Todas las peticiones",
"All_sites" , "Todos los sitios",
"At", "En",
"Average_CPU", "Promedio CPU",
"Average", "Promedio",
"Average_is_black", "La media esta en negro",
"Average_on_hours_and_days", "Media de horas y dias",
"Average_pages_by_session", "Promedio de p&aacute;ginas leidas por sesi&oacute;n",
"Average_session_time", "Tiempo promedio por sesi&oacute;n",
"Average_reading_time_per_page", "Tiempo promedio de lectura por pagina",
"Back", "Atr&aacute;s",
"Background", "Trasfondo",
"Bad_links", "Enlaces err&oacute;neos",
"Blue_line_is_average", "La l&iacute;nea azul es el promedio",
"Browser" , "Navegador",
"Browsers" , "Navegadores",
"Browsers_used" , "Navegadores utilizados",
"CPU", "CPU",
"Cgi-bin", "Cgi-bin",
"Conn_Mach" , "m&aacute;quinas coordinadas", 
"Connection_time", "Tiempo de conexi&oacute;n",
"Correct_size_taken_from_image", "Tama&ntilde;o correcto capturado de la imagen",
"Countries", "Pa&iacute;ses", 
"Data", "Dato",
"Data_traffic_by_weeks" , "Tr&aacute;fico de datos por semanas",
"Data_unit_octet" , "bytes",
"Data_unit_Kb" , "Kilobytes",
"Data_unit_Mb" , "Megabytes",
"Date" , "Fecha",
"Days", "D&iacute;as", 
"Decrease_over_the_previous_day","Disminuci&oacute;n respect al d&iacute;a anterior",
"Directories" , "Directorios",
"Directories_graphs" , "Gr&acute;ficos de Directorios",
"Docs" , "Documentos",
"Documents" , "Documentos",
"DomReq" , "Peticiones de dominio", 
"Domain", "Dominio",
"Domain_Hosts" , "Hosts de Dominios",
"Download", "Descarga",
"Downloading_time", "Tiempo de descarga",
"Error", "Error",
"Errors" , "Errores",
"Evolution_of", "Evoluci&oacute;n de",
"Files", "Fichero",
"Forbidden", "Prohibido",
"Found_in", "Encontrado en",
"Frames", "Enmarcados",
"Frames_excluding", "Excluyendo enmarcados",
"Global_access", "Accesos Globales",
"Graphic" , "Gr&aacute;fico",
"Graphs_for" , "Gr&aacute;ficos para",
"Graphs_for_dir" , "Gr&aacute;ficos para directorio",
"HTML_files", "Archivos HMTL",
"Histogram_about_average_request", "Histograma del promedio de solicitudes",
"Histogram_sessions", "Histograma de sesiones",
"Hosts", "Hospedantes",
"Hosts_excluding", "Hospedantes excluidos",
"Hosts_from" , "Hospedantes de",
"Hour" , "Hora", 
"Hours" , "Horas", 
"Image", "Imagen",
"Images", "Im&aacute;genes", 
"Images_histogram", "Histograma de imagenes",
"Images_never_used", "Imagenes nunca utilizadas",
"Increase_over_the_previous_day", "Incremento sobre el dia anterior",
"Index", "&Iacute;ndice",
"Index_pages", "P&aacute;ginas &Iacute;ndice",
"Inside" , "Dentro",
"Kb" , "Kb", 
"Kbytes" , "Kilobytes", 
"Keywords", "Palabra Clave",
"Language" , "Idioma",
"Last_occurence" , "Ultima ocurrencia",
"Last_try", "Ultimo intento",
"Legend_in_bracket", "Leyenda entre par&eacute;ntesis",
"Level", "Nivel",
"Lines_processed", "Lineas Procesadas",
"Link", "Link",
"Links", "Links",
"Links_histogram", "Histograma de enlaces",
"ListOf" , "Lista de",
"ListOfSites" , "Lista de sitios web",
"List_of", "Lista de",
"List_of_unresolved_hosts", "Lista de hospederos sin reolver",
"Login", "Login", 
"Longest_external_session", "Sesi&oacute;n externa m&aacute;s larga",
"Longest_local_session", "Sesi&oacute;n local m&aacute;s larga",
"Longest_session", "Sesi&oacute;n m&aacute;s larga",
"Mach_Dom" , " maquinas del dominio", 
"Mb" , "Mb",
"Mbytes" , "Megabytes",
"Mhosts" , "hosts",
"Misc", "Misc",
"Method", "Metodo",
"MonthByMonth" , "mes a mes", 
"Month_of" , "Mes del",
"Month", "Mes",
"Months" , "Meses", 
"More_Precise" , "m&aacute;s preciso",
"MostSuccesf" , "el m&aacute;s accedido",
"Multiple_sessions", "Sesiones mÃ&uacute;ltiples",
"New_country", "Nuevos Pa&iacute;ses",
"New_HTML_files", "Nuevo fichero HTML",
"New_Hosts" , "Nuevos hospederos",
"New_Mach" , "maquinas nuevas", 
"Newest_pages", "P&aacute;ginas m&aacute;s nuevas",
"Newest_pages_histogram", "Histograma de p&aacute;ginas m&aacute;s nuevas",
"News" , "Noticias",
"NoReq" , "de peticiones",
"No_Ttl_Req_Mnth" , "n&uacute;mero total de peticiones por mes",
"No_Ttl_Req_Week" , "n&uacute;mero total de peticiones por semana",
"No_login", "Accesos sin Login",
"No_modification", "Sin modificacion",
"No_request", "Ninguna petici&oacute;n ha sido hecha",
"No_robot_session", "No hay sesiones de robots",
"No_title", "Sin t&iacute;tulo",
"Not_found", "No encontrado",
"Number" , "N&uacute;mero",
"Number_of" , "n&uacute;mero de", 
"Number_of_HTML_files", "N&uacute;mero de ficheros HTML",
"Number_of_different_resolved_countries" , "N&uacute;mero de pa&iacute;ses resueltos",
"Number_of_different_pages_used" , "N&uacute;mero de p&aacute;ginas utilizadas",
"Number_of_different_sites" , "N&uacute;mero de sitios",
"Number_of_pages_read", "N&uacute;mero de p&aacute;ginas leidas",
"Number_of_req_by_weeks" , "N&uacute;mero de solicitudes por semana",
"Number_of_requests", "N&uacute;mero de solicitudes",
"Number_of_visits", "N&uacute;mero de visitas",
"OS" , "Sistema Operativo",
"OS_used1" , "Sistema Operativo utilizado",
"OS_used2" , "Sistema Operativo utilizado",
"Occurence" , "Ocurrencia",
"On", "Sobre", 
"Only_directories", "Solo directorios",
"Only_first", "Solo el primero",
"Only_hosts", "Solo los hospederos",
"Only_pages", "Solo p&aacute;ginas",
"Only_scripts", "Solo scripts",
"Only_time_session_upper", "Solo sesiones con tiempo mayor que",
"Others" , "Otros",
"Outside" , "De afuera",
"Page", "P&aacute;gina",
"Page_reading_time_histogram", "Histograma del tiempo de lectura de p&aacute;ginas",
"Pages", "P&aacute;ginas",
"Pages_excluding", "P&aacute;ginas excluidas", 
"Pages_never_used", "P&aacute;ginas nunca visitadas", 
"Percentage" , "Porcentaje", 
"Reading_time", "Tiempo de lectura",
"Reading_time_sessions", "Sesiones con tiempo de lectura",
"Redirect", "Redirecci&oacute;n",
"References_for" , "Referencias para",
"Referer" , "Referir",
"Referer_about" , "Referir a cerca de",
"Referer_on" , "Referido a",
"Referer_pages2" , "P&aacute;ginas Referidas",
"Request" , "Petici&oacute;n", 
"Requests" , "Peticiones", 
"Robots_excluding", "Robots excluidos",
"Robot_name", "Nombre del Robot",
"Robot_session_exclude", "Sesi&acute;on de Robot excluida",
"Same_over_the_previous_day", "Lo mismo que el d&iacute;a anterior",
"Same_title", "El mismo t&iacute;tulo",
"Scripts", "Scripts",
"Search_engine", "Motor de b&uacute;squeda",
"Send_me_an", "Env&iacute;ame un/a",
"entry_pages" , "p&aacute;ginas de entrada",
"exit_pages" , "p&aacute;ginas de salida",
"Entry_pages" , "P&aacute;ginas de entrada",
"Exit_pages" , "P&aacute;ginas de salida",
"Server_tree", "&Aacute;rbol servidor",
"Session", "Sesi&oacute;n",
"Session_cut1", "Si una sesi&oacute;n es m&aacute;s larga de un dia, sera contada en el primer dia",
"Session_cut2", "Puede haber habido inexactitud si alguna sesi&oacute;n todavia esta corriendo hoy",
"Session_length", "Duraci&oacute;n de la sesi&oacute;n",
"Sessions" , "Sesiones",
"Sessions_from", "Sesiones de",
"Sorted_countries_list", "Lista ordenada de pa&iacute;ses",
"Sorted_virtual_server_list", "Lista ordenada de servidores virtuales",
"Speed", "Velocidad",
"Stats_about_CPU", "Estad&iacute;sticas sobre la CPU",
"Stats" , "Estad&iacute;sticas", 
"Stats_aboutMnth" , "Estad&iacute;sticas del mes",
"Stats_about_HTML_files", "Estad&iacute;sticas a cerca de archivos HTML",
"Stats_about_files_weight", "Estad&iacute;sticas a cerca del tama&ntilde;o de los archivos",
"Stats_about_alt", "Estad&iacute;sticas sobre ALT",
"Stats_about_errors" , "Estad&iacute;sticas de errores", 
"Stats_about_host" , "Estad&iacute;sticas sobre hospederos", 
"Stats_about_hosts", "Estad&iacute;sticas sobre hospedros",
"Stats_about_images", "Estad&iacute;sticas sobre im&aacute;genes",
"Stats_about_internal_links", "Estad&iacute;sticas sobre los enlaces internos",
"Stats_about_login", "Estad&iacute;sticas a cerca del acceso",
"Stats_about_months" , "Estad&iacute;sticas sobre los meses", 
"Stats_about_robots_sessions", "Estad&iacute;sticas sobre las sesiones robot",
"Stats_about_session_length", "Estad&iacute;sticas a cerca de la duraci&oacute;n de la sesi&oacute;n",
"Stats_about_sessions", "Estad&iacute;sticas sobre sesiones",
"Stats_about_visits", "Estad&iacute;sticas sobre visitas",
"Stats_about_virtual_servers", "Estad&iacute;sticas sobre servidores virtuales",
"Stats_about_weeks" , "Estad&iacute;sticas sobre las semanas", 
"Stats_about_width", "Estad&iacute;sticas sobre tama&ntilde;o",
"Stats_aboutlastdays1" , "Estad&iacute;sticas sobre los &uacute;ltimos",
"Stats_aboutlastdays2" , "d&iacute;as",
"String", "Cadena",
"Successful_pages" , "P&aacute;ginas accedidas",
"Summary", "Sumario",
"Symbolic_links", "Enlaces simb&oacute;licos",
"Tab_about_lastdays1" , "Tabla a cerca de &uacute;ltimo",
"Tab_about_lastdays2" , "d&iacute;as",
"Table" , "Tabla", 
"Text" , "Texto",
"Textual_version" , "Versi&oacute;n de texto",
"The_Top", "El mejor",
"Time", "Tiempo",
"Total", "Total",
"Total_HTML_access", "N&uacute;mero total de accesos HTMLTotal HTML visitadas",
"Total_data_sent" , "Total datos enviados",
"Total_number_of_directories", "N&uacute;mero total de directorios",
"Total_number_of_html_files", "N&uacute;mero total de ficheros HTML",
"Total_number_of_images", "N&uacute;mero total de im&aacute;genes",
"Total_number_of_images_in_files", "N&uacute;mero total de imagenes en archivos",
"Total_number_of_links", "N&uacute;mero total de enlaces",
"Total_number_of_requests" , "N&uacute;mero total de peticiones",
"Total_number_of_scripts", "N&uacute;mero total de scripts",
"Total_number_of_robot_session", "N&uacute;mero total de sesiones de robot",
"Total_number_sessions", "N&uacute;mero total de sesiones",
"Total_traffic" , "Tr&aacute;fico total",
"Traffic" , "Tr&aacute;fico", 
"Traffic_about" , "A cerca del tr&aacute;fico",
"Traffic_statistics" , "Estad&iacute;sticas sobre el tr&aacute;fico",
"Tree", "Arbol",
"Useless_pages", "P&aacute;ginas sin uso",
"Users" , "Usuarios",
"Virtual_servers", "Servidores Virtuales",
"You_should_add", "Debe anadir",
"Web_size", "Tama&ntilde;o de la Web",
"Week", "Semana", 
"Weeks" , "Semanas", 
"Weight_HTML_files_histogram", "Histograma del espacio que ocupan los archivos HTML",
"Weight_of_files", "Especio ocupados por los archivos",
"With" , "con", 
"about" , "a cerca de", 
"about_hours_and_days", "A cerca de horas y d&iacute;as",
"absolute_links", "Enlaces absolutos",
"added_pages", "P&acute;ginas adicionadas",
"all_sites", "Todos los sitios web",
"among" , "entre", 
"and", "y",
"are_shown", "se muestran",
"average_HTML_accesses", "Promedio de HTML visitadas",
"bad_links", "enlaces err&oacute;neos",
"by", "por",
"by_day", "por dia",
"by_hour", "por hora",
"bytes" , "bytes", 
"chronological_order", "orden cronol&oacute;gico",
"coming_from", "viniendo de",
"computed_with", "computado con ",
"connecting_to", "conectando a",
"connecting_to_the_server", "conectando al servidor",
"countries", "pa&iacute;ses",
"daily" , "diario",
"data_sent_for_dir" , "datos enviados para el directorio",
"day" , "dia", 
"days", "dias",
"description", "descripci&oacute;n",
"different_images", "im&aacute;genes diferentes",
"different_references_found", "Distintas referencias encontradas", 
"directories" , "directorios",
"directory" , "directorio",
"domain", "dominio",
"engine_keywords_used", "mecanismo de palabras clave utilizado",
"exceeding", "excediendo",
"excluding", "excluyendo",
"external" , "externo",
"files", "archivos",
"files_stored_locally_CD-ROM", "archivos guardados localmente en un Disco Compacto (CD)",
"for_today" , "para hoy",
"from", "de",
"from_dom" , "del dominio", 
"from domain", "del dominio",
"from_outside", "de afuera",
"global", "global",
"hTML_pages", "p&aacute;ginas HTML",
"have", "tiene",
"hour" , "hora", 
"hours" , "horas", 
"host", "hospedero",
"hosts", "hospederos",
"images", "im&aacute;genes",
"images_found_on_server", "im&acute;agenes encontradas en el servidor",  
"in", "en",
"in_this_directory", "en este directorio",
"in_whole_directory", "en todo el directorio",
"internal", "interno",
"less_than", "menos de",
"links", "enlaces", 
"local", "local",
"maximum", "m&aacute;ximo",
"minimum", "m&iacute;nimo",
"minutes", "minutos",
"minute", "minuto",
"modified_less_than", "modificado hace menos de",
"monthly", "mensualmente",
"more_than" , "m&aacute;s de",
"most_common_errors" , "errores m&aacute;s comunes",
"most_graphic_pages", "p&aacute;ginas con m&aacute;s graficos",
"most_linky_pages", "p&aacute;ginas con los m&aacute;s ",
"most_succf_browsers_vtime1" , "Navegadores m&aacute;s usados",
"most_succf_browsers_vtime2" , "",
"most_succf_browsers1" , "navegadores m&aacute;s usados",
"most_succf_browsers2" , "",
"most_weighty_pages", "p&aacute;ginas m&aacute;s grandes",
"no_reference_found", "no se encontr&oacute; referencia",
"not_defined", "no definido",
"not_included", "no est&acute; incluido",
"of_different_hosts" , "de diferentes hospederos",
"of_months" , "de meses", 
"on", "sobre",
"only_reading_time_below", "solo tiempo de lectura menor de",
"only_session_more_than", "solo sesiones con m&aacute;s de",
"optdirsize1" , "(p&aacute;ginas HTML externas y de dominios)",
"optdirsize2" , "(p&aacute;ginas externas HTML)",
"optdirsize3" , "(p&aacute;ginas HTML de dominios)",
"optdirsize4" , "(todas las peticiones externas y de dominios)",
"optdirsize5" , "(todas las peticiones externas)",
"optdirsize6" , "(todas las peticiones de dominios)",
"pages_found_on_server", "p&aacute;ginas encontradas en el servidor", 
"page", "p&aacute;gina",
"pages" , "p&aacute;ginas", 
"percentage" , "porcentaje",
"read_by", "le&iacute;do por",
"referer_pages1" , "p&aacute;ginas referidas",
"request" , "solicitud", 
"requests" , "solicitudes", 
"resolved_countries", "pa&iacute;ses resueltos",
"scripts", "scripts",
"search_engine", "motor de b&uacute;squeda",
"seconds", "segundos",
"session", "sesi&oacute;n",
"sessions", "sesiones",
"since", "desde",
"sitios web", "sitios web",
"symbolic_links", "enlaces simb&oacute;licos",
"text_only", "solo texto",
"the" , "el", 
"There_are", "Hay",
"times" , "veces",
"to", "a",
"today", "hoy",
"top" , "m&aacute;ximo",
"top_external_sites" , "sitios externos m&aacute;ximos",
"top_local_sites" , "sitios locales m&aacute;ximos",
"total" , "total",
"total_data_sent_for" , "total datos enviados para",
"total_for" , "total para",
"traffic_in" , "tr&aacute;fico en",
"unknown", "desconocido",
"unresolved", "sin resolver",
"used", "usado en el servidor",
"used2", "usado en el servidor",
"visitors", "visitantes",
"weekly", "semanal",
"weight", "espacio ocupado",
"weighting", "midiendo el espacio ocupado",
"with_at_least", "con al menos",
"with_less_than", "con menos de",
"with_most_accesses", "con m&aacute;s accesos",
"with_the_same_title", "con el mismo t&iacute;tulo",
"without", "sin",
"without_title", "sin t&iacute;tulo",
"wrong", "mal"
 );
