#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                  INIT LIBRAIRY CONFIG STATS                    #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 24/06/2013     #####
####                                                                #####
#########################################################################

#############################################################################
# Change this two values according to your system

$cgipath = "/srv/www/cgi-bin/w3perl";

$w3perlpath = "/srv/w3perl"; # The W3Perl Path : where the resources are located

$tildealias = "public_html";

#############################################################################
# Do not change anyhting below this line
# Constant, change if different on your server

$gifext = ".gif";
$dirsepurl = "/";
$pathserver = substr($w3perlpath,0,rindex($w3perlpath,'/',(length($w3perlpath)-2))+1);
$pathserver2 = substr($w3perlpath,0,rindex($w3perlpath,'/',(length($w3perlpath)-2)));

# Lire logfiledir from Config.txt ????
# lire CGISERVER => $GZIP/$FLY/$WGET
# Gestion InstallPath_URL si install ailleurs que /w3perl/ -> /aaa/w3perl/ (NT) (lire Config.txt).

# Perl path

open(ME,$0);
$perlpath = <ME>;
$perlpath =~ s/^#\!\s*(.*)\n$/$1/;
close (ME);

#require "ctime.pl";
use POSIX;

$cgipath2 = $cgipath;
$cgipath2 =~ s/w3perl$//;

# Fly pour Windows
$car = substr($cgipath,1,1);
$nt = 1 if ($car eq ':');

$pos = rindex($cgipath,$dirsepurl);
$tmp = substr($cgipath,0,$pos+1);
$flypath = $tmp."fly";
$flypath .= ".exe" if ($nt == 1);
 
# tags

$pos = length($w3perlpath)-1;
while ($pos >= 0) {
$dirsep = substr($w3perlpath,$pos,1);
last if ($dirsep !~ /[\.\w\s\d-_]/i);
#print "POS : $pos - $dirsep\n";
$pos--;
}
$dirsep = "/" if ($pos == -1);

$pos = rindex(lc($cgipath),"cgi");
$cgiurl = substr($cgipath,$pos-1,length($cgipath));
$bkg = substr($cgipath,$pos-1,1);

if ($bkg ne $dirsep) {
$tmp = substr($cgipath,0,$pos-1);
$pos2 = rindex($tmp,$dirsep);
$cgiurl = substr($cgipath,$pos2,length($cgipath));
}

$macos = 0;
if ($cgiurl =~ /CGI-Executables/i) {
    $cgiurl =~ s/CGI-Executables/cgi-bin/i;
    $macos_log = "access_log";
    $macos_errorlog = "error_log";
    $macos_wgetbin = "/usr/bin/curl -O ";
    $macos_fileroot = "/private/var/log/apache2/";
    $macos = 1;
}


$abyss_fileroot = "C:/Program Files/Abyss Web Server/log";
$iis_fileroot = "C:/Windows/System32/LogFiles/W3SVC1";

%month_equiv = ( 'Jan','01',
                 'Feb','02',
                 'Mar','03',
                 'Apr','04',
                 'May','05',
                 'Jun','06',
                 'Jul','07',
                 'Aug','08',
                 'Sep','09',
                 'Oct','10',
                 'Nov','11',
                 'Dec','12');

$tmp = $w3perlpath;
$w3perlpath .= $dirsep if ($w3perlpath ne '');
$htmlext = ".html" if  ($dirsep ne "."); # All except RiscOS
$htmlext = "/html" if  ($dirsep eq "."); # RiscOS
$plext = ".pl" if  ($dirsep ne "."); # All except RiscOS
$plext = "/pl" if  ($dirsep eq "."); # RiscOS
$txtext = ".txt";

#$dirsep = chop($tmp);
$pathsetup = $w3perlpath."admin".$dirsep."config".$dirsep;
$basefilename = $pathsetup."step";
$selected = " SELECTED";
$w3perlpathres = $w3perlpath."resources".$dirsep."admin"; # w3perl resources path
$dirress = "resources";
$dirdata = "data";
$diradmin = "admin";
$dirconfig = "config";
$dirhelp = "help";
$dircss = "css";
$dirjs = "js";
$w3perlcss = "w3perl.css";
$docscss = "docs.css";
$tablejs = "table.js";
$sorttablejs = "sorttable.js";
$checkjs = "check_configfile_exist.js";
$helpjs = "help.js";
$varforms = $w3perlpath.$dirress.$dirsep.$diradmin.$dirsep."var-forms";
$zipcut = 0;
$default_package_index = "index.html";
#$dirw3perl = "w3perl";

# constants
$locconf = "locconf";
$w3perlloc = $w3perlpathres.$dirsep.$locconf;
#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
$year = $a if ($year eq '');
$day = "0".$day if (length($day) == 1);
$countmonth = $month_equiv{$month};
($hour,$minute,$second) = split(/:/,$hourdate);
$date = $day."/".$month."/".$year;
$changedate = "$year$countmonth$day";

# background
$bkg = $w3perlpath;

#############################################

if ($w3perlpath ne '') {
    if ($bkg =~ /\/(\w+)\/$tildealias/ && $tildealias ne '') {
	$tmp2 = $1;
	$bkg =~ s/.*\/$tildealias/\/~$tmp2/;
    } else {

	# Try to guess if not installed in the web server first level

	$tmp1 = "/htdocs/";
	if (index($tmp,$tmp1) != -1) {
	    $tmp2 = substr($tmp,0,index($tmp,$tmp1)+length($tmp1));
	    $bkg =~ s/$tmp2/$dirsepurl/;
	}

	$tmp1 = "/html/";
	if (index($tmp,$tmp1) != -1) {
	    $tmp2 = substr($tmp,0,index($tmp,$tmp1)+length($tmp1));
	    $bkg =~ s/$tmp2/$dirsepurl/;
	}

	$tmp1 = "/www/";
	if (index($tmp,$tmp1) != -1) {
	    $tmp2 = substr($tmp,0,index($tmp,$tmp1)+length($tmp1));
	    $bkg =~ s/$tmp2/$dirsepurl/;
	}

	if ($bkg eq $w3perlpath) {
	    $pos = rindex($tmp,$dirsep);
	    $bkg = substr($tmp,$pos,length($bkg));
	    $bkg .= $dirsep;
	}
    }
} else {
    $bkg = $cgipath;
}

$loadconf = "locconf";

if ($w3perlpath !~ /$tildealias/) {
    while (!(-d "$pathserver2$bkg$dirress") && $bkg ne $dirsepurl) {
	$bkg = substr($bkg,index($bkg,$dirsep,1),length($bkg));
    }

}

$bkg = "/w3perl/" if ($nt == 1);

#$helpurl = $bkg.$diradmin.$dirsep.$dirhelp;
$helpurl = $bkg.$dirress.$dirsep.$dirhelp.$dirsep.$diradmin;
$w3perlurl = $bkg.$dirress;
$cssurl = $bkg.$dirress.$dirsep.$dircss.$dirsep.$docscss;
#$js_sortable = $bkg.$dirress.$dirsep.$dirjs.$dirsep.$sorttablejs;
$css_w3perl_url = $bkg.$dirress.$dirsep.$dircss.$dirsep.$w3perlcss;
$jsurl = $bkg.$dirress.$dirsep.$dirjs.$dirsep.$tablejs;
$js_sort_url = $bkg.$dirress.$dirsep.$dirjs.$dirsep.$sorttablejs;
$jscheck = $bkg.$dirress.$dirsep.$dirjs.$dirsep.$checkjs;
$jshelp = $bkg.$dirress.$dirsep.$dirjs.$dirsep.$helpjs;
$loadconf_url = $bkg.$dirress.$dirsep.$diradmin.$dirsep.$loadconf;

$bkgline = $bkg."docs".$dirsepurl."img".$dirsepurl."line".$gifext;
$bkgback = $bkg."docs".$dirsepurl."img".$dirsepurl."back".$gifext;
$bkglink = $bkg.$diradmin.$dirsepurl."index.html";
$bkg = $bkg."docs".$dirsepurl."img".$dirsepurl."bg".$gifext;


########################################################################

sub error {
	local($msg) = @_;
	local ($file);

	$file = $pathsetup."error_admin.html";
	open(FILE,"$file");
	while (<FILE>) {
	    s/<!-- CSS -->/$cssurl/;
	    s/<!-- BG -->/$bkg/;
	    s/<!-- LINE -->/$bkgline/;
	    s/<!-- REFER_ADMIN_PAGE -->/$ENV{'HTTP_REFERER'}/;
	    s/<!-- insert_msg -->/$msg/;
	    print;
	}
	close(FILE);
	exit;
}


sub loadvar {
  local($file) = @_;
  local($tmp1,$tmp2,$number);
  
        &error_open_admin($file) if (!(-r $file));
	open(FILE,$file) || die "Can't open $file\n";
	while(<FILE>) {
	next if (/^#/);
	chop;
	$number = ($tmp1,$tmp2,$tmp3) = split(/\t/);

#	if ($tmp3 eq '') {
#	$type = $tmp1;
#	push(@tab,$type);
#	}

	if ($number == 1) {
#	    chop($tmp1);
	    $type = $tmp1;
	    push(@tab,$type);	
	}

	if ($number == 2) {
#	    chop($tmp2);
	    $nbvalueforms{$type}++;
	    $valueforms1{$type,$nbvalueforms{$type}} = $tmp1;
	    $valueforms2{$type,$nbvalueforms{$type}} = $tmp2;
	}
		
	if ($number == 3) {
#	    chop($tmp3);
	    $valueforms{$tmp1} = $tmp2;
	}
	
	}
	close(FILE);
}

#######################################################################
	
sub option {
	local($line,$out,$action) = @_;
	local($i,$field);

	#	
	### SELECT
	#

	$online_demo = 0;
	$online_demo = 1 if ($ENV{'HTTP_REFERER'} =~ /^$w3perlwebsite/);

	if ($line =~ /<DIV ID="(\w+)"\s+STYLE="(\w+):(\w+)"/ && $out == 0 && $line !~ /HIDDEN/i) {
	    $field = $1;
	    $field2 = $field;
#	    $field2 = substr($field2,8,length($field));
	    $field2 =~ s/TOGGLE_//i;
	    if ($action eq "MODIFY" || $action eq "TEMPLATE") {
		print "<DIV ID=\"$field\" STYLE=\"display:inline\">\n" if ($oldvalue{$field2} == 1); # Yes
		print "<DIV ID=\"$field\" STYLE=\"display:none\">\n" if ($oldvalue{$field2} == 0); # No
	    }
	    if ($action eq "BUILD") {
		print "<DIV ID=\"$field\" STYLE=\"display:inline\">\n" if ($valueforms{$field2} == 1); # Yes
		print "<DIV ID=\"$field\" STYLE=\"display:none\">\n" if ($valueforms{$field2} == 0); # No
	    }

	    return 1;
	}

	if ($line =~ /<SELECT NAME="(\w+)"/ && $out == 0 && $line !~ /HIDDEN/i) {
	    # la valeur par defaut est la premiere ligne de var-forms
	    print "$_";
	    $skip = 0;
	    # IIS
#	    if ($FORM{'server_used'} == 4 && $FORM{'logfile_type'} == 1 && $FORM{'type_serveur'} == 1) {
#	    if ($FORM{'server_used'} < 4 && $FORM{'type_serveur'} == 0) {
	    if ($FORM{'server_used'} == 0 && $FORM{'type_serveur'} == 0) {
		if ($1 eq "logfile") {
		    for ($j=1;$j<=4;$j++) {
			print "<OPTION VALUE=\"$valueforms2{$1,$j}\"";
			print " SELECTED" if ($valueforms2{$1,$j} eq $oldvalue{$1});
			print ">$valueforms1{$1,$j}";
		    }
#		    print "<OPTION VALUE=\"$valueforms2{$1,2}\">$valueforms1{$1,2}";
#		    print "<OPTION VALUE=\"$valueforms2{$1,3}\">$valueforms1{$1,3}";
#		    print "<OPTION VALUE=\"$valueforms2{$1,4}\">$valueforms1{$1,4}";
		}
		$skip = 1 if ($1 eq "logfile")
	    }
	    # IIS
	    if ($FORM{'server_used'} == 4 && $FORM{'type_serveur'} == 1) {
		if ($1 eq "logfile") {
		    for ($j=5;$j<=6;$j++) {
			print "<OPTION VALUE=\"$valueforms2{$1,$j}\"";
			print " SELECTED" if ($valueforms2{$1,$j} eq $oldvalue{$1});
			print ">$valueforms1{$1,$j}";
		    }
#		    print "<OPTION VALUE=\"$valueforms2{$1,6}\" SELECTED>$valueforms1{$1,6}";
#		    print "<OPTION VALUE=\"$valueforms2{$1,5}\">$valueforms1{$1,5}";
		    print "<OPTION VALUE=\"$valueforms2{$1,1}\"";
		    print " SELECTED" if ($valueforms2{$1,1} eq $oldvalue{$1});
		    print ">$valueforms1{$1,1}";
		}

		$skip = 1 if ($1 eq "logfile")
	    }
	    # Webstar
	    if ($FORM{'server_used'} == 3) {
		if ($1 eq "logfile") {
		    print "<OPTION VALUE=\"$valueforms2{$1,1}\"";
		    print " SELECTED" if ($valueforms2{$1,1} eq $oldvalue{$1});
		    print ">$valueforms1{$1,1}";
		    print "<OPTION VALUE=\"$valueforms2{$1,19}\"";
		    print " SELECTED" if ($valueforms2{$1,19} eq $oldvalue{$1});
		    print ">$valueforms1{$1,19}";
		}

		$skip = 1 if ($1 eq "logfile")
	    }
	    if ($FORM{'server_used'} == 20) {
		if ($1 eq "logfile") {
		    print "<OPTION VALUE=\"$valueforms2{$1,17}\"";
		    print " SELECTED" if ($valueforms2{$1,17} eq $oldvalue{$1});
		    print ">$valueforms1{$1,17}";
		}
		$skip = 1 if ($1 eq "logfile")
	    }

	    # Dhcp
	    if ($FORM{'server_used'} == 16) {
		print "<OPTION VALUE=\"$valueforms2{$1,18}\" SELECTED>$valueforms1{$1,18}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    # Dhcp-ISC
	    if ($FORM{'server_used'} == 17) {
		print "<OPTION VALUE=\"$valueforms2{$1,21}\" SELECTED>$valueforms1{$1,21}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    # RealServer
	    if ($FORM{'server_used'} == 6) {
		print "<OPTION VALUE=\"$valueforms2{$1,14}\" SELECTED>$valueforms1{$1,14}" if ($1 eq "extension");
		print "<OPTION VALUE=\"$valueforms2{$1,15}\">$valueforms1{$1,15}" if ($1 eq "extension");
		print "<OPTION VALUE=\"$valueforms2{$1,16}\">$valueforms1{$1,16}" if ($1 eq "extension");
		print "<OPTION VALUE=\"$valueforms2{$1,7}\" SELECTED>$valueforms1{$1,7}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "extension" || $1 eq "logfile")
	    }
	    # SFTP
	    if ($FORM{'server_used'} == 15 && $FORM{'type_serveur'} == 0) {
		print "<OPTION VALUE=\"$valueforms2{$1,20}\" SELECTED>$valueforms1{$1,20}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    # FTP
	    if ($FORM{'server_used'} == 7 && $FORM{'type_serveur'} == 0) {
		print "<OPTION VALUE=\"$valueforms2{$1,8}\" SELECTED>$valueforms1{$1,8}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    if ($FORM{'server_used'} == 14 && $FORM{'type_serveur'} == 1) {
		print "<OPTION VALUE=\"$valueforms2{$1,15}\" SELECTED>$valueforms1{$1,15}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    # Squid
	    if ($FORM{'server_used'} == 8) {
		if ($1 eq "logfile") {
		    for ($j=9;$j<=10;$j++) {
			print "<OPTION VALUE=\"$valueforms2{$1,$j}\"";
			print " SELECTED" if ($valueforms2{$1,$j} eq $oldvalue{$1});
			print ">$valueforms1{$1,$j}";
		    }
		    print "<OPTION VALUE=\"$valueforms2{$1,16}\"";
		    print " SELECTED" if ($valueforms2{$1,16} eq $oldvalue{$1});
		    print ">$valueforms1{$1,16}";
#		    print "<OPTION VALUE=\"$valueforms2{$1,9}\" SELECTED>$valueforms1{$1,9}";
#		    print "<OPTION VALUE=\"$valueforms2{$1,10}\">$valueforms1{$1,10}";
		}
		$skip = 1 if ($1 eq "logfile")
	    }
	    # Mail
	    if ($FORM{'server_used'} == 9) { # sendmail
		print "<OPTION VALUE=\"$valueforms2{$1,11}\" SELECTED>$valueforms1{$1,11}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    if ($FORM{'server_used'} == 10) { # postfix
		print "<OPTION VALUE=\"$valueforms2{$1,12}\" SELECTED>$valueforms1{$1,12}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    if ($FORM{'server_used'} == 11) { # exim
		print "<OPTION VALUE=\"$valueforms2{$1,13}\" SELECTED>$valueforms1{$1,13}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    if ($FORM{'server_used'} == 12) { # mdaemon
		print "<OPTION VALUE=\"$valueforms2{$1,14}\" SELECTED>$valueforms1{$1,14}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
	    # Abyss
	    if ($FORM{'server_used'} == 13) {
		print "<OPTION VALUE=\"$valueforms2{$1,2}\" SELECTED>$valueforms1{$1,2}" if ($1 eq "logfile");
		$skip = 1 if ($1 eq "logfile")
	    }
#	    print "UU $skip - $1 - $nbvalueforms{$1} - $oldvalue{$1}\n";
	    if ($skip == 0) {
		for ($i=1;$i<=$nbvalueforms{$1};$i++) {
		    print "<OPTION VALUE=\"$valueforms2{$1,$i}\"";
		    print " SELECTED" if ($valueforms2{$1,$i} eq $oldvalue{$1});
		    print ">$valueforms1{$1,$i}\n";
		}
	    }
	    return 1;
	}
	
	#
	### INPUT 
	#
		
	if ($line =~ /<INPUT NAME="(\w+)"/ && $out == 0 && $line !~ /HIDDEN/i) {
	$field = $1;
	
	### RADIO
	
	if ($line =~ /("radio").*(VALUE=")([\-\.0-9a-zA-Z]+)(")/i) {

#	    if ($action eq "MODIFY") {
	    if ($action eq "MODIFY" || $action eq "TEMPLATE") {
		print "$`$1 $2$3$4 CHECKED$'" if ($3 eq $oldvalue{$field}); 
		print "$`$1 $2$3$4$'" if ($3 ne $oldvalue{$field});
	    }
	    if ($action eq "BUILD") {
		# on lit la valeur par defaut qui doit etre selectionne
		# dans var-forms (la deuxieme valeur ne sert a rien excepte
		# pour le format de lecture
		if ($FORM{'server_used'} == 7 || $FORM{'server_used'} == 8) {
		    $valueforms{'titlename'} = 0;
		}
		if ($FORM{'server_used'} == 9 || $FORM{'server_used'} == 10 || $FORM{'server_used'} == 11 || $FORM{'server_used'} == 12) {
		    $valueforms{'titlename'} = 0;
		    $valueforms{'locallog'} = 1;
		}
		print "$`$1 $2$3$4 CHECKED$'" if ($3 eq $valueforms{$field});
		print "$`$1 $2$3$4$'" if ($3 ne $valueforms{$field});
#		print "$3 - $field - $valueforms{$field}\n";
	    }			
	}

	### TEXT

	$line =~ s/ SIZE="?(\d+)"?//i;
	$varsize = $1;

	if ($line =~ /("text").*(VALUE=")(")/i) {
	    
	    $size = "";

#	    if ($action eq "MODIFY") {
	    if ($action eq "MODIFY" || $action eq "TEMPLATE") {
		$size1 = length($oldvalue{$field});
		$size = "SIZE=\"$size1\"" if ($size1 != 0);
		if  ($field eq "pathinit") {
		    print "$`$1 $2$w3perlpath$3 $size$'" if ($online_demo == 0);
		    print "$`$1 $2$3 $size$'" if ($online_demo == 1);
		} else {
		    print "$`$1 $2$oldvalue{$field}$3 $size$'";
		}
	    }
	    
	    if ($action eq "BUILD") {
		if ($field eq "struct_compressed_logfile") {
		    $size1 = 40;
		} elsif ($field eq "pathinit") {
		    $size1 = length($w3perlpath);
		} elsif ($field eq "cgipath") {
		    $size1 = length($cgipath2);
		} elsif ($field eq "localserver") {
		    $size1 = length($referer);
		} elsif ($field eq "FLY") {
		    $size1 = length($flypath);
		} elsif ($field eq "prefixlog") {
		    $size1 = 2 if ($FORM{'server_used'} == 4);
		} else {
		    $size1 = length($valueforms{$field});
		}

#		$size1++;
		$size1 += 10 if ($field eq "configfile");

		if ($size1 != 0 && $field ne "tri") {
		    $size = "SIZE=\"$size1\"";
		} else {
		    $size = "SIZE=\"$varsize\"";
		}
#		$size = "SIZE=\"10\"" if ($size1 != 0);

#		if ($ENV{'HTTP_REFERER'} !~ /^$w3perlwebsite/) {
		if ($field eq "fileroot" && $FORM{'server_used'} == 4) {
		    print "$`$1 $2$iis_fileroot$3 $size$'";
		} elsif ($field eq "fileroot" && $FORM{'server_used'} == 12) {
		    print "$`$1 $2$abyss_fileroot$3 $size$'";
		} elsif ($field eq "fileroot" && $FORM{'server_used'} == 0 && $macos == 1) {
		    print "$`$1 $2$macos_fileroot$3 $size$'";
		} elsif ($field eq "struct_compressed_logfile" && $FORM{'server_used'} == 4) {
		    print "$`$1 $2%prefixlog%smallyear%month%day.log$3 $size$'";
		} elsif ($field eq "struct_compressed_logfile" && $FORM{'server_used'} == 12) {
		    print "$`$1 $2%prefixlog-%year%month%day.log$3 $size$'";
		} elsif ($field eq "struct_compressed_logfile" && $FORM{'server_used'} == 20) {
		    print "$`$1 $2%prefixlog.%rotate$3 $size$'";
		} elsif ($field eq "struct_compressed_logfile" && $FORM{'server_used'} == 0 && $macos == 0) {
		    print "$`$1 $2%prefixlog.%rotate$3 $size$'";
		} elsif  ($field eq "pathinit") {
		    print "$`$1 $2$w3perlpath$3 $size$'" if ($online_demo == 0);
		    print "$`$1 $2$3 $size$'" if ($online_demo == 1);
		} elsif ($field eq "cgipath") {
		    print "$`$1 $2$cgipath2$3 $size$'" if ($online_demo == 0);
		    print "$`$1 $2$3 $size$'" if ($online_demo == 1);
		} elsif ($field eq "pathserver") {
		    print "$`$1 $2$pathserver$3 $size$'" if ($online_demo == 0);
		    print "$`$1 $2$3 $size$'" if ($online_demo == 1);
		} elsif ($field eq "localserver") {
		    print "$`$1 $2$referer$3 $size$'";
		} elsif ($field eq "FLY") {
		    print "$`$1 $2$flypath$3 $size$'" if ($online_demo == 0);
		    print "$`$1 $2$3 $size$'" if ($online_demo == 1);
		} elsif ($field eq "wget_bin") {
		    if ($FORM{'server_used'} == 0 && $macos == 1) {
			print "$`$1 $2$macos_wgetbin$3 $size$'";
		    }		    
		} elsif ($field eq "errorlog") {
		    if ($FORM{'server_used'} == 0 && $macos == 1) {
			print "$`$1 $2$macos_errorlog$3 $size$'";
		    } else {
			print "$`$1 $2$3 $size$'";
		    }
		} elsif ($field eq "prefixlog") {
		    if ($FORM{'server_used'} == 7) {
			print "$`$1 $2xferlog$3 $size$'";
		    } elsif ($FORM{'server_used'} == 0 && $macos == 1) {
			print "$`$1 $2$macos_log$3 $size$'";			
		    } elsif ($FORM{'server_used'} == 9) {
			print "$`$1 $2maillog$3 $size$'";
		    } elsif ($FORM{'server_used'} == 10) {
			print "$`$1 $2mail.log$3 $size$'";
		    } elsif ($FORM{'server_used'} == 11) {
			print "$`$1 $2mainlog$3 $size$'";
		    } elsif ($FORM{'server_used'} == 12) {
			print "$`$1 $2Mdaemon$3 $size$'";
		    } elsif ($FORM{'server_used'} == 4) {
			print "$`$1 $2in$3 $size$'" if ($FORM{'logfile'} eq "IIS");
			print "$`$1 $2ex$3 $size$'" if ($FORM{'logfile'} eq "W3C");
			print "$`$1 $2nc$3 $size$'" if ($FORM{'logfile'} eq "CLF");
		    } else {
			print "$`$1 $2$3 $size$'";
		    }
		} else {
		    print "$`$1 $2$valueforms{$field}$3 $size$'";
		}
#		}
	    }
		
#	    if ($action eq "BUILD" && $field eq "pathinit") {

#		$size = "SIZE=\"$size1\"" if ($size1 != 0);

#	    }
	}

	### CHECKBOX
					
	if ($line =~ /("checkbox").*(VALUE=")([0-9]+)(")/i) {
#	    if ($action eq "MODIFY") {
	    if ($action eq "MODIFY" || $action eq "TEMPLATE") {
		print "$`$1 $2$3$4 CHECKED$'" if ($3 eq $oldvalue{$field}); 
		print "$`$1 $2$3$4$'" if ($3 ne $oldvalue{$field}); 			
	    }
	    
	    if ($action eq "BUILD") {
		# on lit la valeur par defaut (1 = CHECKED)
		# dans var-forms (la deuxieme valeur ne sert a rien excepte
		# pour le format de lecture
		$skip = 0;
		if ($FORM{'server_used'} == 7) {
		    print "$`$1 $2$3$4 CHECKED$'" if ($field eq "inc_download_aborted");
		    print "$`$1 $2$3$4 CHECKED$'" if ($field eq "session_login");
		    $skip = 1 if ($field eq "inc_download_aborted" || $field eq "session_login")
		}
		if ($skip == 0) {
		    print "$`$1 $2$3$4 CHECKED$'" if ($3 eq $valueforms{$field});
		    print "$`$1 $2$3$4$'" if ($3 ne $valueforms{$field});				
		}

	    }				
	}			
#			print "<!-- $field - $1 - $2 - $3 - $oldvalue{$field} -->\n";
	return 1;
	}
	
	return $out;
    }

#######################################################################

sub load {
  local($file) = @_;
  local($tmp1,$tmp2);
  
        &error_open_admin($file) if (!(-r $file));
	open(FILE,$file) || die "Can't open $file\n";
	while(<FILE>) {
	chop if ($_ =~ /\r\n$/);
	chop;
	($tmp1,$tmp2) = split(/\t/);
	$oldvalue{$tmp1} = $tmp2;
	}
	close(FILE);
}

sub securecgi {
  local($file) = @_;
  local($tmp1,$tmp2);

  print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n";
  print "<HTML><HEAD>\n";
  print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
  print "<TITLE>Installation forbidden access</TITLE>";
  print "<link rel=\"stylesheet\" media=\"screen\" type=\"text/css\" href=\"$cssurl\">\n";
  print "</HEAD>\n";
  print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
  print "<P><BR><CENTER><H3>";
  print "Forbidden access\n";
  print "</H3></CENTER><BR>";
  print "<P><BLOCKQUOTE><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print "You should run scripts from the interface administration\n";
  print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print " This is to avoid unsolicited access to your stats\n";
  print "</BLOCKQUOTE>" if ($ENV{'REQUEST_METHOD'} eq "GET");
  print "</BODY></HTML>\n" if ($ENV{'REQUEST_METHOD'} eq "GET");
  exit;

}

##################
# Errors report  #
##################

sub error_open_admin {
    local($file) = @_;

    print "<P><CENTER><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "POST");
    print "Unable to open $file : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "POST");
    print " ==> check read permission\n";
    print "</DIR></CENTER>" if ($ENV{'REQUEST_METHOD'} eq "POST");
    exit;
}


sub error_write {
    local($file) = @_;
    local($tmp,$pos);

    $pos = rindex($file,$dirsepurl);
    $tmp = substr($file,0,$pos+1);

    print "<P><CENTER><BLOCKQUOTE><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "POST");
    print "Unable to write $file : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "POST");
    print " ==> check write permission\n";
    if (-d $file) {
	print "<P>" if ($ENV{'REQUEST_METHOD'} eq "POST");
	print "Make sure your web server can write in with 'chmod 777 $tmp'" if ($ENV{'REQUEST_METHOD'} eq "POST");
    }
    print "</BLOCKQUOTE></CENTER>" if ($ENV{'REQUEST_METHOD'} eq "POST");
    exit;
}


sub error_write_cfg {
    local($file) = @_;

    print "<P><BLOCKQUOTE><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Unable to write $file : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print " ==> a file with the same name already exist\n";
    print "</BLOCKQUOTE>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit;
}
