#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                  DELETE CONFIGURATION FILES                    #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 12/05/2011     #####
####                                                                #####
#########################################################################

require "init.pl";

# Print out a content-type for HTTP/1.0 compatibility
print "Content-type: text/html\n\n";

&securecgi if ($ENV{'HTTP_REFERER'} !~ /$cgiurl/);

# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

    # Stop people from using subshells to execute commands
    # Not a big deal when using sendmail, but very important
    # when using UCB mail (aka mailx).
    # $value =~ s/~!/ ~!/g; 

    # Uncomment for debugging purposes
#    print "Setting $name to $value<P>";
	
    $FORM{$name} = $value;
}


$filename = $pathsetup."confirm".$htmlext; 

if ($FORM{'confirm'} eq "yes") {

$file = $FORM{'configfile'}; 

$pos = rindex($file,$dirsep);
#$tmp1 = substr($file,0,$pos);
$tmp2 = substr($file,$pos+1,length($file));

#$tmp2 =~ s/\..*//;
$tmp2 =~ s/$plext//;

$file = $w3perlpath.$dirconfig.$dirsep.$file;
#$file2 = $tmp1.$dirsep.$dirdata.$dirsep.$tmp2;
$file2 = $w3perlpathres.$dirsep.$tmp2;

$succeed1 = unlink($file);
$succeed2 = unlink($file2);

#$msg = "";

if ($succeed1 == 1 && $succeed2 == 1) {
    $msg = "<I>";
    $msg .= "- $file";
    $msg .= "<BR>";
    $msg .= "- $file2";
    $msg .= "</I>\n";
    $msg .= " <P>have been deleted.<P>";

#$w3perlloc = $w3perlpathres.$dirsep.$locconf;

    open(CONFLOC,"$w3perlloc") || die "can't open $w3perlloc\n";
    @lines = (<CONFLOC>);
    close(CONFLOC);

#    $msg .= "B - $#lines - ";
    open(CONFLOC,">$w3perlloc");
    for ($i=0;$i<=$#lines;$i++) {
	chop($lines[$i]);
	($tmpfile,$ver,$tmp3,$tmp4,$tmp5,$tmp6) = split(/\t/,$lines[$i]);
	print CONFLOC "$tmpfile\t$ver\t$tmp3\t$tmp4\t$tmp5\t$tmp6\n" if ($tmpfile ne $file);
#	$aa .= "$file = $tmpfile - $ver - $tmp3\n<BR>";
#	print CONFLOC "$lines[$i]\t$ver"; #if ($lines[$i] ne $file);
#	$msg .= "$i - $lines[$i]\t$ver<BR>"; #if ($lines[$i] ne $file);

    }
    close(CONFLOC);

} else {
    $msg = "<I>";
    $msg .= "- $file" if ($succeed1 == 0);
    $msg .= "<BR>";
    $msg .= "- $file2" if ($succeed2 == 0);
    $msg .= "</I> <P><FONT COLOR=\"#FF0000\">can't be deleted</FONT><P>"; 
}

$file = $pathsetup."deleted.html";
open(FILE,"$file");
while (<FILE>) {
    s/<!-- BG -->/$bkg/;
    s/<!-- CSS -->/$cssurl/;
    s/<!-- LINE -->/$bkgline/;
    s/<!-- bkglink -->/$bkglink/;
    s/<!-- bkgback -->/$bkgback/;
    s/<!-- REFER_ADMIN_PAGE -->/$FORM{'referer_page'}/;
    s/<!-- insert_msg -->/$msg/;
    print;
}
close(FILE);


} else {

open(FILE,$filename);
while (<FILE>) {
s/<!-- BG -->/$bkg/;
s/<!-- cgiurl -->/$cgiurl/;
s/<!-- CSS -->/$cssurl/;
s/<!-- LINE -->/$bkgline/;
s/<!-- HIDDEN -->/yes/;
s/<!-- REFER_ADMIN_PAGE -->/$FORM{'referer_page'}/;
s/<!-- DISPLAY -->/$FORM{'configfile'}/;
#s/<!-- HIDDEN2 -->/<INPUT NAME=configfile TYPE=hidden VALUE=\"$FORM{'configfile'}\">/;
s/<!-- HIDDEN2 -->/<INPUT NAME=configfile TYPE=hidden VALUE=\"$FORM{'configfile'}\">\n<INPUT NAME=\"referer_page\" TYPE=hidden VALUE=\"$FORM{'referer_page'}\">/;
print;
}
close (FILE);
}


