#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                     ERROR STATS                                #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 06/06/2013     #####
####                                                                #####
#########################################################################

$version = "3.18";
$verdate = "06/06/13";

### Things to improve :
### verifier que le jour suivant est bien +1 (pas de trou)

$scriptname = "cron-error.pl";

######### Recuperer $jour_of_year_end depuis la derniere ligne de datafile ?

### To launch just after midnight
require "libw3perl.pl";

if ($type_serveur == 7 || $ftp_format == 1 || $squid_format == 1) {
    &error_exit("No error stats can be done for FTP/Mail or Squid logfile",1);
}

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
#$pos = rindex($0,"-");
#$vtmp .= substr($0,$pos+1,length($0));
$vtmp .= $scriptname;
$vtmp =~ s/$plext//g;

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";
$status_script = 0;

if ($opt_y eq '') {
    print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = "Error stats : $version\n";
    &output_log($msg);
    print "</DIV><P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}
print "<DIV ID=\"TOGGLE_$scriptname\" STYLE=\"display:inline\">\n" if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '');

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

#if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
if ($struct_compressed_logfile =~ /\%hour/) {
    $real_deb = 1;
#    $re_index = 0;
}


#################################################################
####          debut de l'initialisation                   #######
#################################################################

$starttime = time();

# variables

&error_exit("No file specified in your configuration file",0) if ($errorlog eq '');

$file = $fileroot.$errorlog;

if ($type_serveur == 1) {

    if (-f $file) {
	$type_serveur = 0;
    }

    if (!(-f $file)) {
	$file = $fileroot.$errorlog;
    }
}

$divers = 0;
$ncsa = 0;
$cern = 0;
#$scan = 1;
#$scan = 1 if ($opt_b eq '');
$count_day = 0;
$diversday = 0;
$ref = 0;
$addit = 0;
$prefixlog = $errorlog;

### afficher la liste des refer (cern) pour chaque page avec file not found ?

#if ($zipcut == 3 || ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/)) {
if ($zipcut == 3 || $struct_compressed_logfile =~ /\%hour/) {
    $filetmpzip = &find_last_log($fileroot,$errorlog);
    $first_logfile = &find_first_log($fileroot,$errorlog);

    if ($zipcut == 3) {
	if ($filetmpzip == -1 || $first_logfile == -1) {
	    if (!(-f "$fileroot$errorlog")) {
		$status_script = 2;
		&error_exit("No error file found in $fileroot",0);
	    } else {
		$zip = 0;
		$zipcut = 0;
	    }
	} else {
	    $rotate_inc = &find_index_way($filetmpzip,$first_logfile) if ($filetmpzip != -1 && $first_logfile != 1);
	}

	$rotate = $max_rotate_index if ($rotate_inc == -1);

	$zip = 0 if ($zipcut == 3 && $max_rotate_index == 1 && -f $first_logfile);

	if ($zipcut == 3 && $rotate !~ /^\d+$/) {
	    $msg = "Found a logfile I don't understand : $error_log$rotate.\nIndex should be a number (found the string '$rotate').\n";
	    $msg .= "Check the compression tool (\$zipext = \"$zipext\" and \$GZIP = \"$GZIP\")\n" if ($zip == 1 && $rotate !~ /$zipext$/);
	    &error_exit($msg,1);
	}
    }
#    print "LAST : $filetmpzip\n";
#    print "DEB : $first_logfile\n";
}

#$yesterday = &yesterday_date($day,$countmonth,$year);
#$timesec = time;
#&get_time($timesec);

if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
if ($zipcut == 2 || $zipcut == 1) {
$monthtmp = $month;
#$filetmpzip = $fileroot;
$month = $month_equiv{$month};
#$month++ if ($zipcut == 1);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
$lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day if ($zipcut == 2);
$datetmpzip = $year.$month if ($zipcut == 1);
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filetmpzip = &Get_LogfileName($fileroot);
   $filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;
}
}

#$firstjour = &find_first_date($errorlog) if ($opt_s ne '');

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
#      print STDOUT "        -r <tildealias>       : substitue ~ by the path alias\n";
      print STDOUT "        -b                    : reset stats\n";
      print STDOUT "        -c <file>             : load configuration file\n";
      print STDOUT "        -i <file>             : input logfile\n";
      print STDOUT "        -d <nbdays>           : number of days to scan\n"; 
      print STDOUT "        -j <dd/Mmm/yyyy>      : stats on dd/Mmm/yyyy\n";
      print STDOUT "        -g <nograph ";
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";            
      print STDOUT "        -f                    : 'file does not exist', HTML files only\n";
      print STDOUT "        -q <tri>              : 'file does not exist', matching string only\n";
      print STDOUT "        -k                    : 'file does not exist', show referer page\n";
      print STDOUT "        -o <seuil>            : display pages with at least seuil errors\n";
      print STDOUT "        -s <date>             : starting date (dd/Mmm/yyyy)\n";
      print STDOUT "        -r <date>             : ending date (dd/Mmm/yyyy)\n";
      print STDOUT "        -t <toplist>          : display only toplist most found errors\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n";
#      print STDOUT "        -z                    : zip logfiles\n";       
      print STDOUT "\n";
      exit;
}

if ($opt_v == 1) {
      print "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -b               : ";
      &id($opt_b);      
      print STDOUT "          -g <graphic>     : $graphic[0]\n";
      print STDOUT "          -l <language>    : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";      
      print STDOUT "          -i <file>        : $file\n";
      print STDOUT "          -d <nbdays>      : $nbdays\n"; 
      print STDOUT "          -j <dd/Mmm/yyyy> : <none>\n";
      print STDOUT "          -f               : No\n";
      print STDOUT "          -q <tri>         : $tri\n";
      print STDOUT "          -k               : ";
      &id($ref);
      print STDOUT "          -o <threshold>   : $seuilpage\n";
      print STDOUT "          -s <date>        : $firstjour\n";
      print STDOUT "          -r <date>        : $yesterday\n";
      print STDOUT "          -t <toplist>     : $topten\n";
      print STDOUT "          -v               : $version\n";
#      print STDOUT "          -z               : ";
 #     &id($opt_z);           
      exit;
}

#if ($opt_z ne '') {
#$zip = $opt_z;
#}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !",1);
      }
}


if ($opt_g ne '') {
  if ($opt_g eq "nograph")  {
      $nograph = 1;
  }
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}


if ($opt_k == 1) {
    $cref = 1;
    $ref = 1;
}



if ($opt_o ne '') {
    $seuilpage = $opt_o;
}


if ($opt_s) {
    if ($opt_s !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid starting date format (valid format is for example 02/May/1995)\n";
	&error_exit($msg);
    } else {
	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$day = $1;
	$lettermonth = $2;
	$month = $month_equiv{$lettermonth};
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	if ($month < 1 || $month > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	$year = $3;
	$fyear = $3;
	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date \n";
	    &error_exit($msg);
	}


	$smallyear = $year - int($year/100)*100;       
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	$file = &Get_LogfileName($fileroot);
	$filezip = $file.$zipext if ($zip == 1);

	$startday = $opt_s;
	$nbstartday = &nbday($opt_s);

	if ($nbstartday > $ydaytoday) {
	    print "Error ! This date belongs to the futur !\n";
	    &error_exit($msg);
	}

	# En attendant la gestion de $firstjour
	if ($firstjour ne '') {
	    if ($nbstartday < &nbday($firstjour)) {
		$msg = "Error ! Logfile is beginning later !\nI will compute from $firstjour instead\n";
		&output_log($msg);
		$startday = $firstjour;

		($day,$lettermonth,$year) = split(/\//,$firstjour);
		$month = $month_equiv{$lettermonth};
		$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
		
		$smallyear = $year - int($year/100)*100;              
		$smallyear = "0".$smallyear if (length($smallyear) == 1);
		$file = &Get_LogfileName($fileroot);
		$filezip = $file.$zipext if ($zip == 1);
	    }
	} else {
	    if (!(-f $file) && !(-f $filezip)) {
		$msg = "Starting file $file does not exist\n";
		&error_exit($msg);
	    }
	}
    }

    if ($zipcut == 3) {
	$file = &find_index_log($fileroot,$errorlog,$startday);
#	print "$file - $errorlog - $startday\n";
	$filezip = $file.$zipext if ($zip == 1);
    }

}

$stopday = $today;

if ($opt_r) {

    if ($opt_r !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid ending date format (valid format is  for example 02/May/1995)\n";
	&error_exit($msg);
    } else {

	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$tmp = $month_equiv{$2};
	$tmp = "0".$tmp if (length($tmp) == 1);
	if ($tmp < 1 || $tmp > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date !\n";
	    &error_exit($msg);
	}

	$stopday = $opt_r;
	$nbstopday = &nbday($opt_r);

	if ($nbstopday > $ydaytoday) {
	    $msg = "Error ! Cannot compute futur !\nI will compute till $yesterday instead\n" ;
	    &output_log($msg);
	    $stopday = $yesterday;
	    $stopday =~ s/ /\//g;
	}
    }

    if ($zipcut == 3) {
	$tmp = $rotate;
	$filetmpzip = &find_index_log($fileroot,$errorlog,$stopday);
	$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
	$rotate = $tmp;
    }

}


if ($opt_s && $opt_r) {
    if ($nbstopday < $nbstartday) {
	$msg = "Ending date should be later than the starting date !\n";
	&error_exit($msg);
    }
}






if ($opt_t ne '') {
$topten = $opt_t;
}

if ($opt_j ne '')
     {
       if ($opt_j =~  /(\d\d)\/([JFMASOND][aepuco][nbrylgptvc])\/(\d\d\d\d)/) {
       $day = $1 ;
       $month = $2 ;
       $year = $3 ;
       $dayscan = "$1"." "."$2"." "."$3";
} else {
 $msg = "Error : date should be in dd/Mmm/yyyy format\n";
 $msg .= "        dd is the day number\n";
 $msg .= "        Mmm is the abbreviated month name with first letter upper\n";
 $msg .= "        yyyy is the year number\n";
 &error_exit($msg,1);
}
}

if ($opt_d ne '') {
    $nbdays = $opt_d;
}

$nbdayscf = $nbdays;

if ($opt_i ne '') {
$file = $opt_i;
$errorlog = $opt_i;
$errorlog =~ s/$fileroot//;
}

if ($opt_q ne '') {
$tri = $opt_q;
}

$pos = index($tri,'~');

if ($pos >= 0) {
$tri =~ s/~//;
$tri = $tri."/" if (rindex($tri,'/',length($tri))+1 != length($tri));
$tri = $tri.$tildealias."/";
}

$errorgraph = $path.$dirgraph.$dirsep."error".$gifext;
$errorgraphx = $path.$dirgraph.$dirsep."errorx".$gifext;
$errorgraphy = $path.$dirgraph.$dirsep."errory".$gifext;

$linkerrorgraph = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."error".$gifext;
$linkerrorgraphx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."errorx".$gifext;
$linkerrorgraphy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."errory".$gifext;

$others = "others".$gifext;

&MakeDirectories;

$linkpath_url = &Extract_WebUrlLink if ($linkpath_url eq '');

$nbline = 0;

#################################################################
####                   date de ce jour                    #######
#################################################################

### today date

$jour_of_year_end = &nbday($today);

### date il y a $nbdays jours

#if ($nbdays != 0) {
if ($opt_d ne '') {
    $jour = $pasttoday;
    $opt_b = 1;

    if ($nbdays != 0) {
	$pasttoday = &date_intervalle($today,-$nbdays);
	($pastday,$pastmonth,$pastyear) = split(/ /,$pasttoday);
	$pastmonthnb = $month_equiv{$pastmonth};   
	$pastjour_of_year = &nbday($pasttoday);
    }
#    $pasttoday = &date_intervalle($today,-$nbdays);

#    print "UU $today - $nbdays - $pastmonthnb - $pasttoday\n";

}

#print "TOTO\n";

#if (($pastyear%4 == 0 && $pastyear%100 != 0) || $pastyear%400 == 0) {
#$pastbisextil = 1;
#}


#$jour_of_year_end +=365 if ($pastjour_of_year > $jour_of_year_end || $pastyear != $year);
#$addit = 365 if ($pastjour_of_year > $jour_of_year_end || $pastyear != $year);
#$jour_of_year_end++ if ($pastjour_of_year > $jour_of_year_end || $pastyear != $year && $pastbisextil == 1);

#print "Aujourd'hui nous sommes le $today ($jour_of_year_end)\n";
#print "il y a $nbdays jours , nous etions le $pasttoday ($pastjour_of_year)\n";


#################################################################
#######        chargement des anciennes valeurs      ############
#################################################################

$opt_b = 1 if (!(-f "$path$dirinc$dirsep$incerror"));
$opt_b = 1 if ($opt_d ne '');

if ($opt_b == 1) {
    unlink("$path$dirinc$dirsep$incerror") if (-f "$path$dirinc$dirsep$incerror");
    unlink("$path$dirinc$dirsep$incerrpage") if (-f "$path$dirinc$dirsep$incerrpage");
    unlink("$path$dirinc$dirsep$dayerror") if (-f "$path$dirinc$dirsep$dayerror");
}

if ($opt_b != 1) {

if (-f "$path$dirinc$dirsep$incerror") {

$msg = "Loading incremental data ...\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

open(OUT,"$path$dirinc$dirsep$incerror") || &error_exit("Error, unable to open $path$dirinc$dirsep$incerror",1);
$a = (<OUT>);
($nbline,$sizeold,$divers,$diversday,$firstday,$oldjour) = split(/\t/,$a);
chop($oldjour);
$yesterday = $oldjour;
while (<OUT>) {
chop;
($err,$nb) = split(/\t/);
$error{$err} = $nb;
#print "$err - $error{$err}\n";
$toterror += $nb;
$unique++ if ($error{$err} != 0);
}
close(OUT);    

$toterror += $divers;
$jour_of_year = &nbday($firstday);

#   $jour_of_year = (365 - $jour_of_year) if ($jour_of_year > $jour_of_year_end || $pastyear != $year);
$jour_of_year_first = $jour_of_year; 

open(OUT,"$path$dirinc$dirsep$incerrpage") || &error_exit("Error, unable to open $path$dirinc$dirsep$incerrpage",1);
while (<OUT>) {
chop;
($page,$nb,$nbdate,$fullsite) = split(/\t/);
$notexistpage{$page} = $nb;
$notexistdate{$page} = $nbdate;
$notexistrefer{$page} = $fullsite;
}
close (OUT);

open(OUT,"$path$dirinc$dirsep$dayerror") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayerror",1);
$a = (<OUT>);
while (<OUT>) {
    (@err) = split;
    for ($i=0;$i<=$#err;$i++) {
#	$evolerror{$count_day,$i} = $err[$i];
	$evolerror[$count_day][$i] = $err[$i];
    }
    $count_day++;
}
close (OUT);

$count_day-- if ($count_day > 0);

for ($i=0;$i<$#err;$i++) {
      $errorday{$stringerror[$i]} = $err[$i];
      }
      
}
}

$jour = $oldjour;
$yeartmp = $year;

#################################################################
###                     gzip log file                         ###
#################################################################

$nb_error = 0;

if ((($zip == 1 || $zip == 0) && $zipcut != 0) && (($opt_b == 1) || ($nbline == 0)) && $opt_i eq '') {

    $month = $monthindex;
    $monthprev = $month-1;
    $year = $fyear;

   # detection du premier mois de log zipe

    while ($out == 0) {
	$tmp++;
	if ($zipcut == 2) {
    $day++;
$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
if ($day > $month_of_year{$month_nb[$monthprev]}) {
    $month++;
    $monthprev++;
    $day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
    $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
}
}
       $month++ if ($zipcut == 1);
       $monthprev++ if ($zipcut == 1);       
       $year++ if ($month == 13);
       $month = "1" if ($month == 13);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
       $monthprev = 0 if ($month == 1);
       $lettermonth = $month_nb[$monthprev];   
       if ((($year ==  $fullyear && $month > $monthindex) || ($year > $fullyear)) && $zipcut != 0) {
            $msg = "No gziped files found !\n" if ($zip == 1);
            $msg = "No log files found !\n" if ($zip == 0);
#            print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
            $out = 1;
            $status_script = 2;
#            &error_exit($msg,3);
       }

       $smallyear = $year - int($year/100)*100;       
       $smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallmonth = $month;
$file = &Get_LogfileName($fileroot);
#       $real_deb = 1 if ($file eq $filetmpzip);

     	$out = 1 if (-e $file && !(-z $file) && $real_deb == 0 && $zip == 0);
        $out = 1 if ($file eq $first_logfile && !(-z $first_logfile) && $real_deb == 1 && $zip == 0);
       $filezip = $file.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && !(-z $filezip) && $zip == 1);
	if ($zipcut == 3 && $filetmpzip eq $file && $rotate == 0) {
	    $out = 1;
	    $zip = 0;
	    $filezip = $file;
	}
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No error logfile found\n";
	    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
            $status_script = 2;
            $out = 1;
#	    &error_exit($msg,3);
	}

}


if ($out == 1 && (!(-f $file))) {
    $file = $fileroot.$prefixlog;
#    $file = $fileroot.$errorlog;
    $msg .= "If no error files are produced, disable running this script using \$actif_error = 0;\n" if (!(-f $file));
    &error_exit("If no error files are produced, disable running this script using \$actif_error = 0;\n",0) if (!(-f $file));
if ($zipcut != 3) {
    $zipcut = 0;
$zip = 0;
}
}
   $lastfile = $file;
   $lastfilezip = $filezip;
   $stop = 0;
   $yeartmp = $year;
   
}


#################################################################

if ($zipcut != 0 && $opt_b != 1 && $opt_i eq '') {
    if (!(-f $file)) {
	($day,$month2,$year) = split(' ',$oldjour);
$month = $month_equiv{$month2};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
        $lettermonth = $month2;    
#        $file = $fileroot;
        $smallyear = $year - int($year/100)*100;
        $smallyear = "0".$smallyear unless (length($smallyear) == 2);
$smallday = $day;
$smallmonth = $month;
$file = &Get_LogfileName($fileroot);
#       $real_deb = 1 if ($file eq $filetmpzip);
	$filezip = $file.$zipext if (!(-f $file) && $zip == 1);	        
	}   
}      

$file = $fileroot.$errorlog if (!(-f $filezip) && !(-f $file));

#################################################################
###               CERN or NCSA error logfile ?                ###
#################################################################

if (-z $file) {
    $status_script = 2;
    &error_exit("Your file $file is empty !",0);
}

if ($type_serveur != 1) {
    
    &error_open($file,0) if (!(-f $file) || !(-r $file));
open(INFILE, $file) || &error_exit("Error, unable to open $file",3);

($date,$failed) = split(/]/,<INFILE>);
chop($date) if ($failed eq '');
($date,$failed) = split(/]/,<INFILE>) if ($date eq '');
$date =~ s/\[//;

$real = 1 if ($failed eq '' && $date =~ /^\*\*\*/);
$ncsa = 1 if ($date =~ m/^(\w+) (\w+)(\s+)(\d+) ([0-9:])+ (\d+)/);
$ncsa = 1 if ($date =~ m/^(.+): (\w+) (\w+)(\s+)(\d+) ([0-9:])+ (\d+)/);
$falsebegin = 1 if ($date =~ m/^(.+): (\w+) (\w+)(\s+)(\d+) ([0-9:])+ (\d+)/);

if ($ncsa == 0 && $cern == 0 && $real == 0) {
    $msg = "Assuming NCSA format\n";
    &output_log($msg);
    $ncsa = 1;
}
 
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
$msg = "Seems to be a ";
$msg .= "NCSA" if ($ncsa == 1);
$msg .= "RealAudio" if ($real == 1);
$msg .= " error logfile.\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
close(INFILE);
}

if ($ncsa == 1) {
  @stringerror = ('File does not exist','socket error: accept failed','SIGHUP received','shutting down','directory as script','script not found or unable to stat','malformed header from script','timed out','password mismatch','send aborted','No file matching','file permissions deny','connection reset by peer','Directory index forbidden by rule','Premature end of script headers','unable to include','ModSecurity','PHP Notice','End of file found','Error reading from remote server','No route to host','Attempt to serve directory','No such file or directory','HTTP request parsing','Invalid path','no handler','Disconnecting source due to socket timeout','unable to open file');
  $cref = 1;
}

if ($type_serveur == 1) {
  @stringerror = ('404','403');
  for ($i=0;$i<=($#stringerror);$i++) {
	$stringerror[$i] .= ";$localhost_protocol://$localserver";
  }
}

for ($i=0;$i<=($#stringerror);$i++) {
    $errorday{$stringerror[$i]} = 0;
}

$size = -s $file;
if ($size == 0 && -f $file) {
    $status_script = 2;
    &error_exit("Your logfile is empty !",1);
}
if ($size < 0) {
    $msg = "Problem with logfile size\n";
    $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
    $msg .= "or split your logfile under the 2 Gb limit\n";
    &error_exit($msg,1);
}

&load_reverse_dns if (($reverse_dns == 1) && -f "$path$dirdata$dirsep$ip_table");

#################################################################
###                 scanning the log file                     ###
#################################################################

if ($reverse_dns == 1) {
    $msg = "*** Warning *** Reverse dns is on ... it will slow down !\n";
    &output_log($msg);
}
if ($geoip_free == 1) {
    $msg = "*** Warning *** Geo::IPfree doesn't work with ipv6 addresses, use rather Geo::IP if needed\n";
    &output_log($msg);
}

print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET" && $reverse_dns == 1);


($ds1,$ds2,$ds3) = split('/',$startday);
($de1,$de2,$de3) = split('/',$stopday);
$mds2 = $month_equiv{$ds2};
$mde2 = $month_equiv{$de2};

$file = $first_logfile if ($zipcut == 3 && $opt_b ne '');
$file = &find_index_log($fileroot,$errorlog,$startday) if ($opt_s ne '');

if ($opt_d ne '' && $zipcut == 3) {
    $file = &find_index_log($fileroot,$prefixlog,$pasttoday);
    $filezip = $file.$zipext if ($zip == 1);
    if (!(-f $file) && !(-f $filezip)) {
	$file = $fileroot.$errorlog;
    }
}


if ($size < $sizeold) {
$nbline = 0;
$msg = "Your logfile $file have been cut\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#&flush(STDOUT);
#$|=1;


while ($stop == 0) {

    if (-f $file || -f $filezip) {
	$msg = "Scanning $file file...\n";
	&output_log($msg);
    }

if ($mode_lb == 0) {
if (($zip == 1) && (-f $filezip) && ((($file ne $filezip) && ($nbline == 0 || $opt_b == 0)) || ($zipcut == 2))) {
#if (($zip == 1) && ($file ne $filezip) && ($nbline == 0)) {
	if ($zipcut != 3) {
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    &error_open($filezip) if (!(-r $filezip));
	    $line_file = &line_file($filezip);
	    open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",3);
	} else {
	    # Apache rotate, trying uncompressed file
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    if (-r $filezip) {
		$line_file = &line_file($filezip);
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",3);
	    } else {
#		&retrieve_external_logfile($fileroot,$remote_host_log,$file) if ($retrieve_external_log == 1);
		&error_open($file) if (!(-r $file));
		$line_file = &line_file($file);
		open(INFILE,$file) || &error_exit("Error, unable to open $file",3);
	    }
	}
#	&error_open($filezip) if (!(-r $filezip));
#       open(INFILE, "$GZIP $filezip |") || die "Error, unable to open $filezip\n";
    } else {
#    &retrieve_external_logfile($fileroot,$remote_host_log,$file) if ($retrieve_external_log == 1);
    &error_open($file) if (!(-r $file));
    $line_file = &line_file($file);
    open(INFILE,$file) || &error_exit("Error, unable to open $file",1);
}
} else {
	    $log_loadbalancing = "";
	    for ($load_iter=0;$load_iter<=$#fileroot;$load_iter++) {
		$file_lb = $file;
		$file_lb .= $zipext if ($zip == 1 && -f $filezip);
		$file_lb =~ s/$fileroot//;
		$log_loadbalancing .= "$fileroot[$load_iter]$file_lb ";
	    }
	    chop($log_loadbalancing);
#	    print "DEBUG $logresolvemerge_bin $log_loadbalancing\n";
	    open(INFILE,"$logresolvemerge_bin $log_loadbalancing |");
    }

$line_bar_file = 100 if ($reverse_dns == 0);
$line_bar_file = 1000 if ($reverse_dns == 1);
$line_file_step = int(($line_file/$line_bar_file)+.5);

#print "TOTO $line_file - $line_file_step\n<BR>";

if ($ENV{'REQUEST_METHOD'} eq "GET" && $line_file > $line_bar_file) {
#    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $barfiletmp = $file;
    $barfiletmp =~ s/$fileroot//;
    $barfiletmp =~ s/\.//g;
    &InitProgressBar($barfiletmp,$scriptname,$reverse_dns);
}

$line = 0;
$nbline = 0 if ($opt_b ne '');

BOUCLE:
while (<INFILE>) {

$line++;

if ($line_file > $line_bar_file) {
    if (int($line/$line_file_step) == ($line/$line_file_step)) {
	$line_percent = int(100*($line+1)/$line_file);
	open(FILESTATUS,">$path$incstatus$txtext");
	print FILESTATUS "$scriptname\t$line_percent\t$status_script\n";
	close(FILESTATUS);
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
#	    $toto = $line/$line_file_step;
	    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
	    print "$barfiletmp.setPercentage('+1');\n" if ($reverse_dns == 0);
	    print "$barfiletmp.setPercentage('+0.1');\n" if ($reverse_dns == 1);
	    print "</script>\n";
	}
    }
}

next if ($_ !~ /(\w+)/);
next BOUCLE if (-f "$path$dirinc$dirsep$incerror" && $line <= $nbline);

# Unix
#if ($type_serveur != 1) {

$linetoscan = $_;

($date,$failed,$cer1,$page)=split(/] /,$linetoscan);
next BOUCLE if ($page =~ /$miscstats_string/);
if ($real == 1) {
    ($date,$failed) = split(/\`/,$date);
    ($date) = split(/ /,$date);
    $date =~ s/\*//g;
    ($page,$failed) = split(/\'/,$failed);
    $failed =~ s/^\s//;
    $failed =~ s/\((.*)\)/$1/;
}

if ($falsebegin == 1) {
    ($a,$date) = split(/ \[/,$date);
    $date = "[".$date;
}

$failed = $failed."] ".$cer1 if ($ncsa == 1 && $cer1 ne '');
$failed .= "] ".$page if ($ncsa == 1 && $page ne '');


chop($failed);

#$cernok = 0 if ($cern == 1);
#$cernok = 1 if ($date =~ m/^\[(\w+) (\w+) (\d)/ || $date =~ m/^\[(\d+)\/(\w+)\/(\d+)/);
#next if ($cernok != 1 && $cern == 1);

next if ($date !~ /\[/ && $real == 0);
$date =~ s/\[//;
#print STDERR "$date\n";
#($jow,$month2,$day2,$hour,$year2,$year3) = split(/ +/,$date) if ($ncsa == 1);


$year2 = $year3 if ($ncsa == 1 && $year2 !~ /\d\d\d\d/);
$year2 = substr($year2,0,4);
($jow,$month2,$day2,$hour,$year2) = split(/ +/,$date) if ($ncsa == 1);
($day2,$month2,$year,$hour) = split(/[\/:]/,$date) if ($cern == 1);

if ($day2 !~ /^\d/ || $month2 !~ /\w+/ || $year2 !~ /\d+/) {
    ($date) = split(/\s+/,$date);
    ($year2,$month2,$day2) = split(/-/,$date);
}

#
if ($real == 1) {
    ($day2,$month2,$smallyear) = split(/-/,$date);
    $year2 = $smallyear2_today.$smallyear if ($smallyear <= $smallyear_today);
    $year2 = ($smallyear2_today-1).$smallyear if ($smallyear > $smallyear_today);
}


$month2 = $month_nb[$month2-1] if ($month2 =~ /\d/);
$day2 = "0".$day2 if (length($day2) == 1 && $struct_compressed_logfile !~ /\%smallday/);
$jour = $day2." ".$month2." ".$year2 if ($day2 =~ /^\d+/ && $month2 =~ /\w+/ && $year2 =~ /\d+/);
$yesterday = $day2." ".$month2." ".$year2;
#print "$date - $yesterday - $jour\n";
#next if ($jour !~ m/^((\d+) (\w+) (\d+))/);
#print "TT $date | $day2 - $month2 - $year2\n";
#if ($firstday2 eq '') {
#   $firstday2 = $jour;

#   $jour_of_year = &nbday($firstday2);
#   $jour_of_year_first = $jour_of_year; 
#   $oldjour = $firstday2;
#}

#print "A - $jour - $yesterday\n";

  if ($opt_s ne '' || $opt_r ne '') {
	($fa) = split(':',$jour);
	($fa1,$fa2,$fa3) = split(' ',$fa);
	$stop = 1 if ($fa3 > $de3);
	next if ($fa3 < $ds3 || $fa3 > $de3);
	$mequiv = $month_equiv{$fa2};
	$stop = 1 if ($fa3 == $de3 && $mequiv > $mde2);
	next if (($fa3 == $ds3 && $mequiv < $mds2) || ($fa3 == $de3 && $mequiv > $mde2));
	$stop = 1 if ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1);
	next if (($fa3 == $ds3 && $mequiv == $mds2 && $fa1 < $ds1) || ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1));

    }

    if ($opt_d ne '') {
	($fa) = split(':',$jour);
	($fa1,$fa2,$fa3) = split(' ',$fa);
	next if ($fa3 < $pastyear);
	$mequiv = $month_equiv{$fa2};
	next if ($fa3 == $pastyear && $mequiv < $pastmonthnb);
	next if ($fa3 == $pastyear && $mequiv == $pastmonthnb && $fa1 < $pastday);
    }


next BOUCLE if ($jour ne $dayscan && $opt_j ne '');

#print "B $jour\n";
$jour_of_year = &nbday($jour);

#    print "A $date - $jour_of_year - $pastjour_of_year - $scan\n";

#if ($scan == 1) {
if (($jour_of_year > $pastjour_of_year && $opt_b eq '') || $opt_b ne '') {
#if ($jour_of_year >= $pastjour_of_year) {
ERROR :

for ($i=0;$i<=($#stringerror);$i++) {

#    print "C $date - $jour_of_year - $pastjour_of_year - $failed\n";

   if ($failed =~ m/$stringerror[$i]/i) {
      $divers--;
      $diversday--;

#    print "AP $i - $stringerror[$i] - $failed\n";

      if ($stringerror[$i] eq "Invalid path") {
         $notexistpage{$page}++;
         $notexistdate{$page} = $jour;
         $error{$stringerror[$i]}++;
         $errorday{$stringerror[$i]}++;
         $unique++ if ($error{$stringerror[$i]} == 1);
         last ERROR;
      }

      if ($stringerror[$i] eq "No such file or directory") {
	  # Bug report (Netscape server)
	  # Thanks to Laurinda Chamberlin <lchamber@fcpa.fujitsu.com>
	  if ($failed =~ /\( (\d+)\)/) {
	      ($a,$b,$c,$fullsite,$d,$e,$f,$g,$h,$page) = split(/ /,$failed);
	  } elsif ($failed =~ /\((\d+)\)/) {
	      ($a,$b,$c,$fullsite,$d,$e,$f,$g,$page) = split(/ /,$failed);
	  } else {
	      ($a,$b,$c,$fullsite,$d,$e,$f,$page) = split(/ /,$failed);
	  }
	 chop($page);
	  if ($fullsite !~ /http/) {
	      ($tmp,$page) = split(/"/,$failed);
	  }
#	  print "A - $date - $page - $count_day\n";

         last ERROR if ($page !~ /\.(s)?htm(l)?/i && $opt_f == 1);
         last ERROR if ($page !~ /$tri/oi); 

         $notexistpage{$page}++;
         $notexistdate{$page} = $jour;
	  if ($reverse_dns == 1 && ($fullsite =~ /[0-9]+$/ || $fullsite =~ /:/)) {
	      $notexistrefer{$page} = &reversedns($fullsite);
	  } else {
	      $notexistrefer{$page} = $fullsite;
	  }
         $error{$stringerror[$i]}++;
         $errorday{$stringerror[$i]}++;
         $unique++ if ($error{$stringerror[$i]} == 1);
         last ERROR;
      }


      if ($stringerror[$i] eq "File does not exist" || $stringerror[$i] eq "No file matching") {
	  $failed =~ tr/[A-Z]/[a-z]/;
         ($part1,$fullsite) = split(/ f[rom ]/,$failed);
         ($a,$b,$page,$d,@endlast) = split(/ /,$part1);

         $page = $d if ($a eq "httpd:");
         $fullsite = $page if ($a eq "[error]" && $fullsite eq '');
	  if ($a eq "[error]") {
	      $fullsite =~ s/\]//g;
	      $page = $endlast[$#endlast];
	      ($page) = split(/\s+/,$page);
	  }
         chop($page) if ($a eq "[error]" && $page =~ /\n/);
         $cref = 1 if ($a eq "[error]" && $fullsite ne '');
#         last ERROR if (substr($page,rindex($page,$carext)) !~ /$extension/i && $opt_f == 1);
	  if ($opt_f == 1) {
	      $fileext = &Extract_Filetype($page);
	      $fileext =~ s/\.//;
	      last ERROR if (($fileext ne "Unknown") && ($extension ne '' && $page !~ /$extension/i));
##	      last ERROR if ((($nohtmlext == 1 && $page =~ /[$carext]/) || ($extension ne '' && $page !~ /$extension/i)));
	  }
#	  print "OO - $date - $page - $fullsite\n";
         last ERROR if ($page !~ /$tri/oi); 
#            if (($extension eq '' && $page !~ /[$carext]/) || ($extension ne '' && $page =~ /$extension/i) || ($page =~ /\?/ && $spip == 1) || $mail_format == 1) {
         $notexistpage{$page}++;
         $notexistdate{$page} = $jour;
         ($a,$fullsite) = split(/[ ,]/,$fullsite) if ($a ne "[error]");
	 if ($cref == 1 && ($fullsite =~ /[0-9]+$/ || $fullsite =~ /:/)) {
#	     if ($reverse_dns == 1 && $fullsite =~ /[0-9]+$/) {
	     if ($reverse_dns == 1) {
		 $notexistrefer{$page} = &reversedns($fullsite);
	     } else {
		 $notexistrefer{$page} = $fullsite;
	     }
	 }
#	  print "A55 - $date - $page - $count_day\n";
         $error{$stringerror[$i]}++;
         $errorday{$stringerror[$i]}++;
         $unique++ if ($error{$stringerror[$i]} == 1);
         last ERROR;
      }

      if ($stringerror[$i] eq "host:" && index($failed,"] /") != -1) {
         ($a,$host,$c,$fullsite,$page) = split(/ /,$failed);
         $fullsite = "&nbsp;" if ($page eq '');
         $page = $c if ($page eq '');
         last ERROR if (substr($page,rindex($page,$carext)) !~ /$extension/i && $opt_f == 1);
         last ERROR if ($page !~ /$tri/oi);
         $notexistpage{$page}++;
         $notexistdate{$page} = $jour;
	 if ($reverse_dns == 1 && ($fullsite =~ /[0-9]+$/ || $fullsite =~ /:/)) {
	     $notexistrefer{$page} = &reversedns($fullsite);
	 } else {
	     $notexistrefer{$page} = $fullsite;
	 }
         $error{$stringerror[$i]}++;
         $errorday{$stringerror[$i]}++;
         $unique++ if ($error{$stringerror[$i]} == 1);
         last ERROR;
      }

      $error{$stringerror[$i]}++;
      $errorday{$stringerror[$i]}++;
      $unique++ if ($error{$stringerror[$i]} == 1);

      last ERROR;
   }
}

$divers++;
$diversday++;
$toterror++;
#
#print "OO $firstday - $jour\n";

if ($firstday eq '') {
   $firstday = $jour;
   $jour_of_year = &nbday($firstday);
   $jour_of_year_first = $jour_of_year; 
   $oldjour = $firstday;
   push(@listdate,$jour);
}

if ($jour ne $oldjour && $opt_j eq '') {

    ($var1,$var2,$var3) = split(' ',$jour);
    ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);

    push(@listdate,$jour);

    $skipout = 0;
    
    if ($var3 < $oldvar3) {
	unless ($seen_problem_date{$jour}++) {
	    $msg = "1 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	    &output_log($msg);
	    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	}
	$skipout = 1;
	$jour = $oldjour;
	next BOUCLE;
    }
    
    if (($oldvar3 == $var3) && ($month_equiv{$var2} < $month_equiv{$oldvar2}) && $skipout == 0) {
	unless ($seen_problem_date{$jour}++) {
	    $msg = "2 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	    &output_log($msg);
	    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	}
	$skipout = 1;
	$jour = $oldjour;
	next BOUCLE;
    }

#    if (($var2 eq $oldvar2) && ($var1 < $oldvar1) && $skipout == 0) {
    if (($oldvar3 == $var3) && ($month_equiv{$var2} == $month_equiv{$oldvar2})  && ($var1 < $oldvar1) && $skipout == 0) {
	unless ($seen_problem_date{$jour}++) {
	    $msg = "3 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
	    &output_log($msg);
	    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	}
	$skipout = 1;
	$jour = $oldjour;
	next BOUCLE;
    }

    for ($i=0;$i<=($#stringerror);$i++) {
#	$evolerror{$count_day,$i} += $errorday{$stringerror[$i]};
	$evolerror[$count_day][$i] += $errorday{$stringerror[$i]};
	$errorday{$stringerror[$i]} = 0;
    }
#    $evolerror{$count_day,$i} += $diversday;
    $evolerror[$count_day][$i] += $diversday;
    $diversday = 0;
    
    if ($skipout == 0) {
	$yday = &nbday($jour);
	$ydayold = &nbday($oldjour);

	$diff = $yday - $ydayold;
##	$diff += $ydayold if ($diff < 0);
	$diff++ if ($yday == 0);

	$count_day += $diff; # if ($scan == 1);

	$jour_of_year += $diff;
	
	if ($jour_of_year < $pastjour_of_year) {
	    $oldjour = $jour;
#	    $scan = 0;
	    next BOUCLE;
	}

#	$scan = 1;
	$oldjour = $jour;
    }
}

}
#}

# End Unix
#}


}

close (INFILE);

# mois gzip suivant

#$numbermoisgzip++;
#$stop = 1 if (($zip != 1 && $zipcut == 0) || (($zip == 1 || $zipcut == 2) && $file eq $filezip));
$stop = 1 if (($zip == 0 && $zipcut == 0) || (($zip == 1 || $zipcut == 2) && $filezip eq $file && $file eq $errorlog) || $opt_i ne '');
$stop = 1 if ($file eq "$fileroot$errorlog");
$stop = 1 if (($zipcut == 2 || $zipcut == 1) && $zip == 0 && $file eq "$fileroot$errorlog");
$stop = 1 if ($rotate < 0 && $rotate_inc == -1 && $zipcut == 3);
$stop = 1 if ($rotate > $min_rotate_index && $rotate_inc == 1 && $zipcut == 3);
$stop = 0 if ($zipcut == 3 && $max_rotate_index == 1 && $rotate == 1 && (-f "$fileroot$errorlog"));

if (($zip == 1 || $zipcut != 0) && $stop == 0) {

    $nbline = 0;
#$year = $yeartmp;

    &nextlog;

    if ($rotate == -1 && $zipcut == 3) {
	$filezip = $fileroot.$errorlog;
	$file = $fileroot.$errorlog;
    }

if ($zip == 0) {
    if ($zipcut == 2) {
	if ($real_deb == 0) {
	    &nextlog while (!(-f $file) && $datezip lt $datetmpzip);
	}
	if ($real_deb == 1) {		
	    while ($abort == 1 && $datezip lt $datetmpzip) {
		&nextlog;
	    }
	}
	if ($file eq $filetmpzip) {
	    $filezip = $fileroot.$prefixlog;
	    $file = $fileroot.$prefixlog;
	    $stop = 1 if (!(-f $file));
	}
    }

    if ($zipcut == 1) {    
	$file = $fileroot.$errorlog if (!(-f $file));
    }

if ($zipcut == 3) {
    &nextlog while ((!(-f $file)) && (($rotate >= 0 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate < $min_rotate_index)));
    $stop = 1 if (!(-f "$fileroot$errorlog") && $rotate == -1 && $rotate == -1);
    $stop = 1 if (!(-f "$fileroot$errorlog") && $rotate_inc == 1 && $rotate > $min_rotate_index);
	}
}

if ($zip == 1) {
    if (-e $filezip) {
    } else {
	if ($zipcut == 2) {
#	    &nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
	    &nextlog while ((!(-f $filezip) && !(-f $file)) && $datezip lt $datetmpzip);
	    # Found an uncompressed logfile with daily zip logfiles
	    if (-f $file && $file !~ /$zipext$/) {
		$filezip = $file;
	    } 
	    $stop = 1 if ($filezip eq $filetmpzip);
	    } elsif ($zipcut == 3) {
		&nextlog while ((!(-f $filezip) && (!(-f $file))) && (($rotate >= 0 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate < $min_rotate_index)));
		$stop = 1 if ($filezip eq $filetmpzip);		
		$stop = 1 if (!(-f "$fileroot$errorlog") && $rotate_inc == -1 && $rotate == -1);
		$stop = 1 if (!(-f "$fileroot$errorlog") && $rotate_inc == 1 && $rotate > $min_rotate_index);
	    } elsif ($zipcut == 1) {
		&nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
		if ($filezip eq $filetmpzip) {
                    $month--;
                    $file = &Get_LogfileName($fileroot);
                    $filezip = $file;
                    if (!(-f $file)) {
#                        $filezip = $fileroot.$prefixlog;
#                        $file = $fileroot.$prefixlog;
                        $filezip = $fileroot.$errorlog;
                        $file = $fileroot.$errorlog;
                        $stop = 1 if (!(-f $file));
                    }
		}
	    } else {
		$filezip = $fileroot.$errorlog;
		$file = $fileroot.$errorlog;
		$stop = 1 if (!(-f $file));
	    }
    }
} else {
    if (-e $file && $zipcut != 0) {
    } else {
	$filezip = $fileroot.$errorlog;
	$file = $fileroot.$errorlog;
	$stop = 1 if (!(-f $file));
    }
}

}


}


### date de la derniere journee du fichier de log

$lastjour_of_year = &nbday($jour);
$ecart = $jour_of_year_end -  $lastjour_of_year;

#print "derniere date du fichier de log : $jour ($lastjour_of_year)\n";

# last day

for ($i=0;$i<=($#stringerror);$i++) {
#   $evolerror{$count_day,$i} += $errorday{$stringerror[$i]};
   $evolerror[$count_day][$i] += $errorday[$stringerror[$i]];
}
#$evolerror{$count_day,$i} += $diversday;
$evolerror[$count_day][$i] += $diversday;

#################################################################
####             sauvegarde des donnees                   #######
#################################################################

if ($firstday ne '') {
    open(OUT,">$path$dirinc$dirsep$incerror") || &error_exit("Error, unable to open $path$dirinc$dirsep$incerror",1);
print OUT "$line\t$size\t$divers\t$diversday\t$firstday\t$oldjour\n";
foreach $val (&reverse_sort_by_value(*error)) {
    print OUT "$val\t$error{$val}\n";
}
close(OUT);    

open(OUT,">$path$dirinc$dirsep$incerrpage") || &error_exit("Error, unable to open $path$dirinc$dirsep$incerrpage",1);
foreach $page (sort keys(%notexistpage)) {
print OUT "$page\t$notexistpage{$page}\t$notexistdate{$page}\t$notexistrefer{$page}\t$notexistrefer{$page}\n";
}
close (OUT);


open(OUT,">$path$dirinc$dirsep$dayerror") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayerror",1);
print OUT "$firstday\n";
for ($j=1;$j<=$count_day;$j++) {
for ($i=0;$i<=($#stringerror+1);$i++) {
#	$evolerror{$j,$i} = 0 if ($evolerror{$j,$i} eq '');
 #       print OUT "$evolerror{$j,$i} ";
	$evolerror[$j][$i] = 0 if ($evolerror[$j][$i] eq '');
        print OUT "$evolerror[$j][$i] ";
}
print OUT "\n";
}
close (OUT);

}

&save_reverse_dns if ($reverse_dns == 1); # sauvegarde de la table de DNS

if ($line == $nbline) {
    $status_script = 1;
    &error_exit("Nothing new scanned...\n",0);
}

if ($firstday eq '') {
    $status_script = 1;
    &error_exit("Nothing have been scanned...\n",0);
}

sub nextlog {

#print "A1 $day - $month - $year\n";
$day++ if ($zipcut == 2);
$day = 1 if ($zipcut == 1);


if ($day > $month_of_year{$month_nb[$monthprev]} && $zipcut == 2) {
$month++;
$monthprev++;
$day = "1";
}

$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

if ($month == 2) {
    if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	$month_of_year{'Feb'} = "29";
	$bisextil = 1;
    } else {
	$month_of_year{'Feb'} = "28";
	$bisextil = 0;
    }
}

$month++ if ($zipcut == 1);
$monthprev = $month-1 if ($zipcut == 1);

#print "O $zipcut - $month - $year \n";
$year++ if ($month == 13);
$month = "1" if ($month == 13);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

$monthprev = 0 if ($month == 1);
$lettermonth = $month_nb[$monthprev];
$prefixlog = $errorlog;
$file = $fileroot;
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallmonth = $month;

$rotate += $rotate_inc if ($zipcut == 3);

    if (length($rotate) == 1 > 0 && length($min_rotate_index) != 1) {
	for ($j=1;$j<length($min_rotate_index);$j++) {
	    $rotate = "0".$rotate;
	}
    }

    if ($rotate < -1) {
	&error_exit("Problem with apache rotating file",1);
    }

if ($real_deb == 0) {
	if ($zipcut != 3) {
	    $file = &Get_LogfileName($fileroot);
	}
	if ($zipcut == 3) {
	    if (($rotate != -1 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate <= $min_rotate_index)) {
		$file = &Get_LogfileName($fileroot);
	    } else {
		$file = $fileroot.$prefixlog;
	    }

	}


#    if (($rotate != -1 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate <= $min_rotate_index)) {
#	$file = &Get_LogfileName($fileroot);
#    }
#    if ($zipcut == 3) {
#	if ($rotate != -1) {
#	    $file = &Get_LogfileName($fileroot);
#	} else {
#	    $file = $fileroot.$errorlog;
#	}
#    }
}

if ($real_deb == 1) {    
#    if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
    if ($struct_compressed_logfile =~ /\%hour/) {

	$abort = 1;
	for ($j=0;$j<=$re;$j++) {
	    $abort = 0 if ($tab_re[$j] eq "$day $month $year");
	}

	$file = $fileroot.$errorlog;
#	if ($re_index == $re || $file eq "$fileroot$errorlog") {
	    $filetmpzip = $file.$zipext;
#	}
	


	if ($abort == 0) {
	    $sec = 60;
	    $min = 59;
	    $hour = 23;
	    for ($k=0;$k<86400;$k++) {

		$file = $fileroot;
		$sec--;
		if ($sec < 0) {
		    $min--;
		    if ($min < 0) {
			$hour--;
			$min = 59;
		    }
		    $sec = 59;
		}
		
		$hour = "0".$hour if (length($hour) == 1);
		$min = "0".$min if (length($min) == 1);
		$sec = "0".$sec if (length($sec) == 1);
	
		$file = &Get_LogfileName($fileroot);
		$filezip = $file.$zipext if ($zip == 1);
		if (-f $file || -f $filezip) {
#		    $re_index++;
		    last;
		}

	    }
	}
    }
}

#print "A - $real_deb - $filetmpzip - $file - $filetmpzip\n";
$filezip = $file.$zipext if ($zip == 1);
$datezip = $year.$month.$day if ($zipcut == 2);
$datezip = $year.$month if ($zipcut == 1);
}

#################################################################
###                    computing maxima                       ###
#################################################################

# tri des $topten error les plus frequentes

$boucle = $topten unless ($unique < $topten);
$boucle = $unique unless ($unique > ($topten-1));

for ($i=0;$i<$boucle;$i++) {
 $maxi = 0;
 for ($j=0;$j<=$#stringerror;$j++) {
 $string = $stringerror[$j];
   if ($error{$string} > $maxi) {
         $maxi = $error{$string};
         $occurerror[$i] = $error{$string};
         $besterror[$i] = $string;
   }
 }
 $error{$besterror[$i]} = 0;
}

#################################################################
#####               error evolution graphs                #######
#################################################################

# check if something have been scan !

if ($ecart > $nbdays && $opt_j eq '' && $line == 0) {
#if ($jour_of_year < $pastjour_of_year && $pastyear == $year && $opt_j eq '' && $nbline == 0) {
#    $increase = $jour_of_year_end - $jour_of_year_first;
#    $increase +=365 if ($increase < 1);
    $msg = "\nLast day recorded in logfile is too old.\n";
#    $msg .= "(Debug : $jour_of_year_end - $jour_of_year_first - $jour_of_year - $pastjour_of_year)\n";
#    $msg .= "Use \"-d $increase\" option to scan all the logfile!\n";
    $msg .= "Use \"-d $ecart\" option to scan all the logfile\n";
    $msg .= "... or nothing will be scanned !\n";
    $status_script = 2;
    &error_exit($msg,0);
}

if ($opt_j ne '' && $toterror == 0) {
    $msg = "$opt_j not found !.\n";
    $msg .= "Log file starting $firstday and ending $jour";
    $status_script = 2;
    &error_exit($msg,1);
}

### recompute array

$start_date = $firstday;

if ($count_day > $nbdays) {
    $initday = $count_day - $nbdays + $ecart;
    $start_date = $pasttoday;
}

for ($i=0;$i<$boucle;$i++) {
    for ($j=0;$j<=$#stringerror;$j++) {
	if ($stringerror[$j] eq $besterror[$i]) {
	    for ($k=$initday;$k<=$count_day;$k++) {
#		$newevolerror{$k-$initday,$i} = $evolerror{$k,$j};
		$newevolerror[$k-$initday][$i] = $evolerror[$k][$j];
		$errortot[$k-$initday] += $evolerror[$k][$j];
	    }
	}
    }
}


# value for divers

for ($k=$initday;$k<=$count_day;$k++) {
#  $newevolerror{$k-$initday,$boucle} = $evolerror{$k,$#stringerror+1};
  $newevolerror[$k-$initday][$boucle] = $evolerror[$k][$#stringerror+1];
  $errortot[$k-$initday] += $evolerror[$k][$#stringerror+1];
}

#for ($j=0;$j<=$count_day;$j++) {
#    $max = 0;
#    for ($i=0;$i<=$#stringerror;$i++) {
#       $max += $evolerror{$initday+$j,$i};
#    }
#    $newevolerror{$j,$boucle} += $max;

#    for ($i=0;$i<$boucle;$i++) {
#       $newevolerror{$j,$boucle} -= $newevolerror{$j,$i};
#    }
#}

### 

#$intervalleday = $jour_of_year_end - $jour_of_year_first;
#$nbdays = $intervalleday if ($intervalleday < $nbdays);
#$toto = ($count_day+$jour_of_year_first);
#$nbdays = $count_day if ($toto < $jour_of_year_end);

$nbdays = $count_day if ($count_day < $nbdays);

### maximum

$maxtot = 0;
for ($j=0;$j<=$nbdays;$j++) {
    $max = 0;
    for ($i=0;$i<=$boucle;$i++) {
#       $max += $newevolerror{$j,$i};
       $max += $newevolerror[$j][$i];
#       print STDOUT "$j $stringerror[$i] $max\n";
    }
    $maxtot = $max if ($max > $maxtot);
}

### compute graph

#if (-x $FLY) {
if ($fly_set == 1) {

$it = length($nbdays)-1;
$div = 10**$it;
$factx = ($div*(int($nbdays/$div)+1))/$grad;
 
$perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

$it = length($maxtot)-1;
$div = 10**$it;
$facty = ($div*(int(($maxtot+$perspec)/$div)+1))/$grad;
 
 $yfirst = $ymax-1;
 $fy = $yfirst-2;

 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
 
 for ($i=0;$i<=$nbdays;$i++) {
 $x1 = ($i+$tridim)*$xstep/$factx;
 $x2 = ($i+1+$tridim)*$xstep/$factx;
 
 $y2 = $ymax;
 $y1 = $ymax;
 $yfinal = $ymax;

 for ($j=0;$j<=$boucle;$j++) {
# $yfinal -= ($ystep/$facty * $newevolerror{$i,$j});
 $yfinal -= ($ystep/$facty * $newevolerror[$i][$j]);
 }

 $x1 = $x1 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);
 $x2 = $x2 - $xstep/$factx if ($x2-$x1 > $xstep && $tridim == 1);

 for ($j=0;$j<=$boucle;$j++) {

 $ji = $j % ($#gcolor+1);
 $ji = 100 if ($j == $boucle);

 if ($bargraph == 1) {
#   $y2 -= ($ystep/$facty * $newevolerror{$i,$j});
#   $y1 -= ($ystep/$facty * $newevolerror{$i,$j-1});
   $y2 -= ($ystep/$facty * $newevolerror[$i][$j]);
   $y1 -= ($ystep/$facty * $newevolerror[$i][$j-1]);
   print FLY "frect $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
   print FLY "rect $x1,$y2,$x2,$y1,0,0,0\n";
   if ($tridim == 1 && ($y1-$y2) > 0) {
        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $y1-$perspec;

        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

        if (int($y2) == int($yfinal)) {
        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
	last;
        }

   }
 }

 if ($linegraph == 1) {
#    $y2 = $ymax - ($ystep/$facty * $newevolerror{$i,$j});
#    $y1 = $ymax - ($ystep/$facty * $newevolerror{$i+1,$j});
    $y2 = $ymax - ($ystep/$facty * $newevolerror[$i][$j]);
    $y1 = $ymax - ($ystep/$facty * $newevolerror[$i+1][$j]);
    print FLY "line $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";

    if ($fillgraph == 1) {
	$ji = ($boucle-$j) % ($#gcolor);
	$ji = 100 if ($j == 0);
	$y2 = $ymax;
	$y1 = $ymax;
	for ($l=0;$l<=($boucle-$j);$l++) {
#	    $y2 -= ($ystep/$facty * $newevolerror{$i,$l});
#	    $y1 -= ($ystep/$facty * $newevolerror{$i+1,$l});
	    $y2 -= ($ystep/$facty * $newevolerror[$i][$l]);
	    $y1 -= ($ystep/$facty * $newevolerror[$i+1][$l]);
	}

	$fx1 = ($x1+$x2)/2;
	$fx1 = $x2 if ($fx1 < ($x1+1.5));
	if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
	    print FLY "line $x1,$ymax,$x1,$y2,$red[$ji],$green[$ji],$blue[$ji]\n";
	    print FLY "line $x2,$ymax,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
 
	    print FLY "line $x1,$yfirst,$x2,$yfirst,$red[$ji],$green[$ji],$blue[$ji]\n";
#	    $fx = ($x1+$x2)/2;
	    print FLY "fill $fx1,$fy,$red[$ji],$green[$ji],$blue[$ji]\n";
	} 
    }
 }
 }
 }

 print FLY "transparent 200,200,200\n";
 close (FLY);

&BuildFly("$tmpfly$vtmp",$errorgraph);

### image pour les abscisses

#$nbdays++; # start at 0 !

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$nbdays days (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";

 }
print FLY "transparent 200,200,200\n";
close (FLY);

&BuildFly("$tmpfly$vtmp",$errorgraphx);
 
### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
 if ($fillgraph == 1 || $bargraph == 1) {
 $posy = $ymax - (($ymax/2)-(length("Total added)")*2));
 print FLY "stringup 0,0,0,5,$posy,medium,Total added\n";
 }
 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);

&BuildFly("$tmpfly$vtmp",$errorgraphy);
}

for ($i=0;$i<=($#stringerror);$i++) {
    $besterror[$i] = "File does not exist" if ($besterror[$i] eq "host:");
    $besterror[$i] = "File does not exist" if ($besterror[$i] eq "No file matching");
}

$ref = 0 if ($cref == 0);

###############################################################
###               creation du fichier HTML                  ###
###############################################################

if ($firstday eq '') {
    $firstday = $jour;
    $ydayfirst = &nbday($firstday);
    $firstday2 = $firstday;
} else {
#if ($firstday ne '') {
    $ydayfirst = &nbday($firstday);
    $firstday2 = $firstday;
}


if ($type_serveur == 1) {
for ($i=0;$i<$boucle;$i++) {
         $besterror[$i] =~ s/;$localhost_protocol:\/\/$localserver//; 
}
}
   
foreach $page (sort keys(%notexistpage)) {
  if ($notexistpage{$page} >= $seuilpage) {
	$yday = &nbday($notexistdate{$page});
	$intervalle = $yday-$ydayfirst;
#	$intervalle += 365 if ($intervalle < 0);
	$tri[$nb_error] = $intervalle;
	$page[$nb_error] = $page;
#	print "$notexistpage{$page} - $seuilpage - $page\n";
	$nb_error++;
	}
}



for ($j=0;$j<$nb_error;$j++) {
	for ($i=0;$i<$nb_error;$i++) {
	if ($tri[$j] > $tri[$i]) {
		$tmp = $tri[$j];
		$tri[$j] = $tri[$i];
		$tri[$i] = $tmp;
		
		$tmp = $page[$j];
		$page[$j] = $page[$i];
		$page[$i] = $tmp;
		}
	}
}

&load_basic_stats;

$firstday = $firstday2;

for ($nblang=0;$nblang<=$#lang;$nblang++) {
$file_to_open = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$tabnameerror;

open(FILEERROR,">$file_to_open") || &error_exit("Error, unable to open $file_to_open",1);
&Error(*FILEERROR, eval($Lang{$lang[$nblang]}));
close(FILEERROR);
}

#################################################################
sub Error {
 local(*FOUT,*L) = @_;

 print FOUT "$doctype\n";
 print FOUT "<HTML><HEAD>\n";
 print FOUT "$charset\n";
 print FOUT "<TITLE>$L{'Stats_about_errors'}</TITLE>\n";
 print FOUT "<!-- Page generated by w3perl - $scriptname $version - $today $hourdate -->\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
 print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";
 print FOUT "$curvy_bottom_jss\n";

 &add_jqplot_js(*FOUT,2);
 &add_css_style(*FOUT,2);

 print FOUT "</HEAD>\n";
 print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
 &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
 print FOUT "<CENTER>\n";

 print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
 print FOUT "<TR>\n";
 print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";

 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";


 print FOUT "<TABLE>\n<TR>\n<TD ALIGN=CENTER>\n";
 print FOUT "<DIV CLASS=\"curly_title\">\n";
 print FOUT "<H1>".uc($L{'Stats_about_errors'})."</H1>\n";
 print FOUT "</DIV>\n";
 print FOUT "</TD>\n</TR>\n</TABLE>\n";


 print FOUT "</TD>\n";
 print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";

 print FOUT "</TD>\n";
 print FOUT "</TR>\n";
 print FOUT "</TABLE>\n";
 print FOUT "</CENTER>\n";

 print FOUT "<HR SIZE=5>\n";
 print FOUT "<CENTER><B>$pasttoday - $jour</B></CENTER>\n" if ($count_day >= $nbdayscf);
 print FOUT "<CENTER><B>$firstday - $jour</B></CENTER>\n" if ($count_day < $nbdayscf);
 print FOUT "<HR SIZE=5><P>\n";

 if ($fly_set == 0) {

     $chart_id = 0;
     $info = "info".$chart_id;
     $ylegend = "$L{'Occurence'}";
     undef @ref_tab;
#     push(@ref_tab,\@newevolerror);
     push(@ref_tab,\@errortot);

     @ref_tab_name = ('error');
     &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,1,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

     undef @ref_tab;
     push(@ref_tab,\@newevolerror);
     @graph_to_display = @besterror;
#     push(@graph_to_display,$dirsep);

     @serie_color = ('#ff5555', '#55ff55', '#5555ff', '#55ffff', '#ff55ff', '#ffff55','#aa0000', '#00aa00', '#0000aa', '#4ad5ac', '#c5d529','#9cb400','#EE9400','#bd8383');
     $serie_color[$#besterror] = "#606060";
#     $xmax_jqplot = $xmax_jqplot*1.2;
     &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,1,"error",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,$menu);

     &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);

 }

 if ($fly_set == 1) {
     if ($nograph != 1) {
	 print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	 print FOUT "<TR>\n";
	 print FOUT "<TD><IMG WIDTH=$xdecal HEIGHT=$ymax SRC=\"$linkerrorgraphy\" ALT=\"y\"></TD>\n";
	 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ymax SRC=\"$linkerrorgraph\" ALT=\"graph\"></TD>\n";
	 print FOUT "</TR><TR><TD></TD>\n";
	 print FOUT "<TD><IMG WIDTH=$xmax HEIGHT=$ydecal SRC=\"$linkerrorgraphx\" ALT=\"x\"></TD>\n";
	 print FOUT "</TR>\n";
	 print FOUT "<TR><TD></TD>\n";
	 print FOUT "<TD ALIGN=CENTER>\n";

	 print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>\n";
	 for ($i=0;$i<$boucle;$i++) {
	     $j = $i % ($#gcolor+1);
	     $couleur = $gcolor[$j];
	     print FOUT "<TR><TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>\n";
	     print FOUT "<TD>&nbsp; $besterror[$i]</TD></TR>\n";
	 }
	 print FOUT "<TR><TD><IMG WIDTH=$square HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\"></TD>\n";
	 print FOUT "<TD>&nbsp; $L{'Others'}</TD>\n";
	 print FOUT "</TR></TABLE>\n";

	 print FOUT "</TD></TR>\n";        
	 print FOUT "</TABLE></CENTER>\n";
     }
 }
 
 print FOUT "<P><CENTER><I>$L{'Evolution_of'} $boucle $L{'most_common_errors'}</I></CENTER>\n";
 print FOUT "<P>\n"; 

 print FOUT "<DIV CLASS=\"item_page\">-&nbsp;$L{'The_Top'} $boucle $L{'most_common_errors'} ($L{'among'} $unique)</DIV><p>\n";

 print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
 print FOUT "<thead>\n";
 print FOUT "<TR>\n";
 print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Error'}&nbsp;</TH>\n";
 print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
 print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Percentage'}&nbsp;</TH>\n";
 print FOUT "</TR>\n";
 print FOUT "</thead>\n";
 print FOUT "<tbody>\n";

# print FOUT "<TABLE CLASS=\"sortable_base\" ID=\"errors\">\n";
# print FOUT "<TR>\n<TH>$L{'Error'}</TH><TH>$L{'Occurence'}</TH>\n<TH>$L{'Percentage'}</TH>\n</TR>\n";

 for ($i=0;$i<=($#stringerror);$i++) {
     if ($occurerror[$i] != 0) {
	 $pourcentage = ($occurerror[$i]*100)/$toterror if ($toterror != 0);
	 $pourcentageint = int($pourcentage);
	 print FOUT "<TR>\n<TD CLASS=\"left\">$besterror[$i]</TD>\n<TD CLASS=\"right\"><B>$occurerror[$i]</B> $L{'times'}</TD>\n<TD CLASS=\"left\">";
	 print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($pourcentageint != 0);
	 print FOUT " <B>";
	 printf FOUT "%.1f",$pourcentage;
	 print FOUT " %</B></TD>\n</TR>\n\n";
     }
 }

 $pourcentage = ($divers*100)/$toterror if ($toterror != 0);
 $pourcentageint = int($pourcentage);
 print FOUT "<TR>\n<TD CLASS=\"left\"><I>$L{'Others'}</I></TD>\n<TD CLASS=\"right\"><B>$divers</B> $L{'times'}</TD><TD CLASS=\"left\">";
 print FOUT "<IMG WIDTH=$pourcentageint HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($pourcentageint != 0);
 print FOUT " <B>";
 printf FOUT "%.1f",$pourcentage;
 print FOUT " %</B></TD>\n</TR>\n\n";
 
 print FOUT "</tbody>\n";
 print FOUT "</TABLE>\n";

 if ($nb_error != 0) {
     print FOUT "<P>\n";

     print FOUT "<DIV CLASS=\"item_page\">-&nbsp;File does not exist";
     print FOUT " ($L{'with_at_least'} $seuilpage $L{'requests'})" if ($seuilpage != 0);
     print FOUT "</DIV><P>\n";

     print FOUT "\n<table class=\"tablesort table-autosort table-autostripe table-stripeclass:alternate\">\n";
     print FOUT "<thead>\n";
     print FOUT "<TR>\n";
     print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'Files'}&nbsp;</TH>\n";
     print FOUT "<TH class=\"table-sortable:numeric\">&nbsp;$L{'Occurence'}&nbsp;</TH>\n";
     print FOUT "<TH class=\"table-sortable:date\">&nbsp;$L{'Last_try'}&nbsp;</TH>\n";
     print FOUT "<TH class=\"table-sortable:default\">&nbsp;$L{'coming_from'}&nbsp;</TH>\n" if ($ref == 1);
     print FOUT "</TR>\n";
     print FOUT "</thead>\n";
     print FOUT "<tbody>\n";

#     print FOUT "<P><TABLE CLASS=\"sortable_base\" ID=\"file_error\">\n";
#     print FOUT "<TR>\n<TH>$L{'Files'}</TH><TH>$L{'Occurence'}</TH><TH>$L{'Last_try'}</TH>";
#     print FOUT "<TH>$L{'coming_from'}</TH>" if ($ref == 1);
#     print FOUT "\n</TR>\n";

     for ($i=0;$i<$nb_error;$i++) {
	 $page = $page[$i];
	 $page =~ s/$pathserver/$dirsepurl/;
	 print FOUT "<TR>\n<TD CLASS=\"left\">$page</TD>\n<TD CLASS=\"right\">$notexistpage{$page[$i]}</TD>\n<TD CLASS=\"right\">$notexistdate{$page[$i]}</TD>\n";
#	 print "UU - $notexistrefer{$page[$i]} - $ref\n";
	 $notexistrefer{$page[$i]} = "&nbsp;" if ($notexistrefer{$page[$i]} eq '' && $ref == 1);
	 print FOUT "<TD CLASS=\"right\">$notexistrefer{$page[$i]}</TD>\n" if ($ref == 1);
	 print FOUT "</TR>\n";
     }
     
     print FOUT "</tbody>\n";
     print FOUT "</TABLE>\n";
 }

 print FOUT "</BODY></HTML>\n";
}

#$yesterday = '';

&update_homepage;

# calculer le temps mis pour le calcul

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
$msg = "Computing took";
$msg .= " $hour h" if ($hour > 0);
$msg .= " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
&output_log($msg);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
    print "</DIV>";
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "ToggleMenu('TOGGLE_$scriptname');\n";
    print "</script>\n";
}

&UpdateCSSMenu('Optional','Errors',$icon_error,"$dirlist$dirsepurl$error",1,0);

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

&StatusCompleted($scriptname,$status_script);

$today =~ s/ /\//g;

open(FILE,">>$history");
#print FILE "cron-error\t$today\t$startrun\t$endrun\t$min:$sec\t$line\n";
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$line;
close(FILE);

__END__

<
