#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                      HEATMAP STATS                             #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 15/05/2013     #####
####                                                                #####
#########################################################################

### TODO
# Option : retrieve external logfiles.
# Incrementale mode
# Daily logfile
# Compression
# Filtering (date,hosts)

$version = "3.18";
$verdate = "15/05/13";

require "libw3perl.pl";

$radius_matrix = 6;
$mode_map = 1; #(1 = clickmap ; 2 = heatmap);

# TODO
# Grouper les points ensemble dans un rayon de 5 pixels ?
# Taille des point => $radius
# Transparency :
# Heatmap/Clickmap
# Group pixel around a radius together
# Create usemap with hostname/date
# changer la map des couleurs noir/A/vert/B/rouge (A=noir+vert,B=vert+rouge)
# Gestion -r -s -d
# Convert to jqplot
# Afficher topten resolution ?

#$fileheatmap = "heatmap".$htmlext;
$scriptname = "cron-heatmap.pl";
$zip = 0;
$cgipagegraph = $w3perlcgiurl.$dirsepurl."pagegraph".$plext;
$extra_size = 10;

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
#$pos = rindex($0,"-");
$vtmp .= $scriptname;
#$vtmp .= substr($0,$pos+1,length($0));
$vtmp =~ s/$plext//g;

# debut de l'initialisation

$starttime = time();

# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";
$startrun2 = (times)[0];

&MakeDirectories;

$linkpath_url = &Extract_WebUrlLink if ($linkpath_url eq '');

#$file = "/var/w3perl/htdocs/w3perl/logs/heatmap_log.20080310";
$radius = 10;
$xmax = 0;
$ymax = 0;

# Load palette
$step = 255/51;
for ($i=0;$i<=51;$i++) {
    $red_pt[$i] = 0;
    $green_pt[$i] = 0;
    $blue_pt[$i] = $step*$i;
#    print "$i - $red_pt[$i] - $green_pt[$i] - $blue_pt[$i]\n";
}
for ($i=52;$i<=102;$i++) {
    $red_pt[$i] = 0;
    $green_pt[$i] = ($i-52)*$step;
    $blue_pt[$i] = 255;
}
for ($i=103;$i<=153;$i++) {
    $red_pt[$i] = 0;
    $green_pt[$i] = 255;
    $blue_pt[$i] = 255-(($i-103)*$step);
}
for ($i=154;$i<=204;$i++) {
    $red_pt[$i] = ($i-154)*$step;
    $green_pt[$i] = 255;
    $blue_pt[$i] = 0;
}
for ($i=205;$i<=255;$i++) {
    $red_pt[$i] = 255;
    $green_pt[$i] = 255-(($i-205)*$step);
    $blue_pt[$i] = 0;
}


#############################################################
# We use daily logfiles
$fileroot = $pathinit."logs/";
$struct_compressed_logfile = "%prefixlog.%year%month%day";
@compressed_logfile_fields = split(/\W+/,$struct_compressed_logfile);
@compressed_sep_fields = split(/\%\w+/,$struct_compressed_logfile);
$zip = 0;
$zipcut = 2;
$prefixlog = "heatmap_log";

for ($i=1;$i<=$#compressed_logfile_fields;$i++) {
    $compressed_logfile_fields[$i] = "%".$compressed_logfile_fields[$i];
    $fields_compressed_logfile{$compressed_logfile_fields[$i]} = $i;
}

###

$countmonth--;
$timesec = time;
($date,$datehour,$datemisc) = &get_time($timesec);

$daytmp = $day;

$monthtmp = $month;
$month = $month_equiv{$month};
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
$lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day if ($zipcut == 2);
$datetmpzip = $year.$month if ($zipcut == 1);
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filetmpzip = &Get_LogfileName($fileroot);
$filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;

$day--;
if ($day < 1) {
    $countmonth--;
     $year-- if ($countmonth < 0);
     $countmonth = 11 if ($countmonth < 0);
     $month = $month_nb[$countmonth];
     $day = $month_of_year{$month};
     }

$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

$yesterday = "$day"."/"."$month"."/"."$year";
$yesterday =~ s/[\/]/ /g;

### number of the current day

#$ydaytoday = &nbday($today);

$ydaystarttoday = 0;
$countmonth = 0;
$month_end = $month_nb[$countmonth];

while ($month_end ne $month) {
     $ydaystarttoday += $month_of_year{$month_end};
     $countmonth++;
     $month_end = $month_nb[$countmonth];
}

#$ydaystarttoday += $day + ($year*365);

# verif que le format est bien en anglais

for ($i=0;$i<=($#month_nb);$i++) {
   $ok = 1 if ($month_nb[$i] eq $month);
}

if ($ok == 0) {
    $msg = "Date format not valid\n. You should use the english date format, set your LANG environnment variable\n ('setenv LANG eng' or 'export LANG=\"eng\"')\n";
    &error_exit($msg);
}

undef $ok;

## variables initialisees

#$nbdays = 1;
$ok = 0;
#loglinesjour = 0;

#$diffmax = 8;
#$diffmax_ini = $diffmax;

$status_script = 0; # 0=OK ; 1=WARNING ; 2=ERROR

###################################################################
if ($zip == 1 || $zipcut != 0) {

    $day = $daytmp;
    $month = $monthindex;
    $monthprev = $month-1;
    $yyear = $year;
    $year = $fyear;
    $tmp = 0;

   # detection du premier mois de log zipe

    while ($out == 0) {
	$tmp++;
        if ($zipcut == 2) {
	    $day++;
	    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	    if ($day > $month_of_year{$month_nb[$monthprev]}) {
		$month++;
		$monthprev++;
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	    }
	}
	$month++ if ($zipcut == 1);
	$monthprev++ if ($zipcut == 1);
	$year++ if ($month == 13);
	$month = "1" if ($month == 13);
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$monthprev = 0 if ($month == 1);       
	$lettermonth =  $month_nb[$monthprev];
	if ((($year ==  $fullyear && $month > $monthindex) || ($year > $fullyear)) && $zipcut != 0) {
	    $msg = "No gziped files found !\n" if ($zip == 1);
	    $msg = "No log files found !\n" if ($zip == 0);
	    &error_exit($msg);
	}
	$smallyear = $year - int($year/100)*100;
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	$smallday = $day;
	$smallmonth = $month;

	$file = &Get_LogfileName($fileroot);
#	print "AA $file\n";

	$out = 1 if (-e $file && !(-z $file) && $real_deb == 0 && $zip == 0);
	$out = 1 if ($file eq $first_logfile && !(-z $first_logfile) && $real_deb == 1 && $zip == 0);
	$filezip = $file.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && !(-z $filezip) && $zip == 1);
	
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No log files found !\n";
	    if ($zip == 1) {
		$msg .= "Are you sure you are using compressed logfile ?\n";
		$msg .= "If not, change the \$zip value in your configuration file using the admin interface\n\n";
	    }
	    &error_exit($msg);
	}
    }

    $lastfile = $file;
    $lastfilezip = $filezip;
    $stop = 0;
    $fyear = $year;
    $year = $yyear;
}



###################################################################
# title

if (!(-e "$path$dirdata$dirsep$fileurl")) {
    $titlename = 0;
}

$count_ip_nb_old = 0;

#if ($reverse_dns == 1 && -f "$path$dirdata$dirsep$ip_table") {
#    &load_reverse_dns;
#    $count_ip_nb = keys(%revdns);
#}

&load_url_map if ($titlename == 1);

###

if ($opt_s ne '' && $opt_i eq '' && $zipcut == 2) {

    ($ds1,$ds2,$ds3) = split('/',$startday);
    $day = $ds1;
    $month = $month_equiv{$ds2};
    $lettermonth = $ds2;
    $year = $ds3;

    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;
    $file = &Get_LogfileName($fileroot);
    $filezip = $file.$zipext if ($zip == 1);
}


#################################################################
###            beginning to scan the log file                 ###
#################################################################

#print "*** Warning *** Reverse dns is on ... it will slow down !\n" if ($reverse_dns == 1);
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET" && $reverse_dns == 1);

while ($stop == 0) {

    if ($ENV{'REQUEST_METHOD'} ne "GET") {
	for ($i=1;$i<=$starnb;$i++) {
	    print "\x08\x08";
	}
    }

    $aff_next_log = "Log file : $file\n";

    if (($zip == 1) && ($file ne $filezip)) {
	if ($zipcut != 3) {
	    &error_open($filezip) if (!(-r $filezip));
	    $line_file = &line_file($filezip);
	    open(FILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip");
	} else {
	    # Apache rotate, trying uncompressed file
	    if (-r $filezip) {
		$line_file = &line_file($filezip);
		open(FILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip");
	    } else {
		&error_open($file) if (!(-r $file));
		$line_file = &line_file($file);
		open(FILE,$file) || &error_exit("Error, unable to open $file");
	    }
	}
    } else {
	&error_open($file) if (!(-r $file));
	$line_file = &line_file($file);
	open(FILE,$file) || &error_exit("Error, unable to open $file");
    }
    
    if ($zip != 1 && $opt_d ne '') {
	seek(FILE,$offset,0);
	$scalar = (<FILE>);
	$scalar = (<FILE>);
    }

    $size = -s $file if (-f $file);
    $size = -s $filezip if (-f $filezip);

    if ($size < 0) {
	$msg = "Problem with logfile size\n";
	$msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
	$msg .= "or split your logfile under the 2 Gb limit\n";
	&error_exit($msg);
    }

    $year = $fyear if ($opt_d eq '' && $fields_logfile{'%date'} eq '' && $mail_format == 0);

    $line_bar_file = 100 if ($reverse_dns == 0);
    $line_bar_file = 1000 if ($reverse_dns == 1);
    $line_file_step = int(($line_file/$line_bar_file)+.5);

    if ($firstday eq '' || $zipcut == 3) {
	print "<BR><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET" && $firstday ne '');
	if ($zipcut != 2 && $firstday ne '') {
	    $msg = "\n\n";
	    &output_log($msg);
	}
	$msg = "$aff_next_log";
	&output_log($msg);
	$aff_next_log_old = $aff_next_log;
	if ($ENV{'REQUEST_METHOD'} eq "GET" && $line_file > $line_bar_file) {
	    $barfiletmp = $file;
	    $barfiletmp =~ s/$fileroot//;
	    $barfiletmp =~ s/\.//g;
	    &InitProgressBar($barfiletmp,$scriptname,$reverse_dns);
	}
    }

    $line_logfile = 0;
    $starnb = 0;
    $msg = "$aff_next_log";
    &output_log($msg);

  BOUCLE:
    while(<FILE>) {
	$line++;
	chop;
if ($line_file > $line_bar_file) {
    if (int($line/$line_file_step) == ($line/$line_file_step)) {
	$line_percent = int(100*($line+1)/$line_file);
	open(FILESTATUS,">$path$incstatus$txtext");
	print FILESTATUS "$scriptname\t$line_percent\t$status_script\n";
	close(FILESTATUS);
	if ($ENV{'REQUEST_METHOD'} eq "GET") {
	    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
	    print "$barfiletmp.setPercentage('+1');\n" if ($reverse_dns == 0);
	    print "$barfiletmp.setPercentage('+0.1');\n" if ($reverse_dns == 1);
	    print "</script>\n";
	} else {
#	    if ($zipcut != 1) {
		$starline++;

		if (($starline == 5 && $reverse_dns == 0) || ($starline == 50 && $reverse_dns == 1)) {

		    $starnb++;
		    $tmp = $starnb*5;
		    print "* $tmp%";

		    print "\x08\x08\x08" if (length($tmp) == 1);
		    print "\x08\x08\x08\x08" if (length($tmp) == 2);
		    print "\x08\x08\x08\x08\x08" if (length($tmp) == 3);

		    $starline = 0;
		}
	    }
#	}

}
}

	($host,$date,$url,$x,$y,$win_x,$win_y,$screenx,$screeny) = split;
	next if ($url =~ /http:\/\//);
	next if ($url =~ /$localdomainename/);
	next if ($host eq '');
	next if ($x < 0 || $y < 0);
	next if ($win_x eq '' || $screenx eq '');

	$url =~ s/#(.*)//;
	if ($screenx eq "-") {
	    $msg = "No screensize detection for $_\n";
	    &output_log($msg);
	}

	next if ($screenx eq "-");
	$url =~ s/$defaulthomepage$//;
	$url =~ s/\#$//;
	$heatmap{$url}++;

	if ($firstday eq '') {
	    ($firstday) = $date =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
	    $firstday =~ s/[\/]/ /g;
	}

	$x = 100*$x/$win_x if ($mode_map == 1);
#	$offsetx = $win_x;

	$url =~ s/\//_/g;
	$url =~ s/\./-/g;

	push(@listscreen,$screenx) unless ($seen{$screenx}++);
	push(@listurl,$url) unless ($seen{$url}++);

	$val = "data_".$screenx.$url;
	$val_offset = "data_".$screenx.$url."_offset";


	$$val{$x,$y}++;
	$$val_offset{$x,$y} = $win_x;

#	$$val{$x,$y,$win_x}++;
#	$$val_offset{$x,$y,$$val{$x,$y}} = $win_x;

	$val_url_max{$url,$screenx} = $$val{$x,$y} if ($val_url_max{$url,$screenx} < $$val{$x,$y});

	unless ($seen{"$url $x $y"}++) {
	    push(@$val,$x);
	    push(@$val,$y);
	}

	$xmax{$url} = $x if ($x > $xmax{$url});
	$ymax{$url} = $y if ($y > $ymax{$url});

    }
    close(FILE);


### Next file

if (($zip == 1 || $zipcut != 0) && $stop == 0) {

    &nextlog;

    if ($zip == 0) {
	if ($zipcut == 2) {
	    if ($real_deb == 0) {
		&nextlog while (!(-f $file) && $datezip lt $datetmpzip);
	    }
	    if ($real_deb == 1) {		
		while ($abort == 1 && $datezip lt $datetmpzip) {
		    &nextlog;
		}
	    }
	    if ($file eq $filetmpzip) {
		$filezip = $fileroot.$prefixlog;
		$file = $fileroot.$prefixlog;
		$stop = 1 if (!(-f $file));
	    }
	}	
    }

    if ($zip == 1) {
	if (-e $filezip) {
	} else {
	    if ($zipcut == 2) {
#		&nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
		&nextlog while ((!(-f $filezip) && !(-f $file)) && $datezip lt $datetmpzip);
		# Found an uncompressed logfile with daily zip logfiles
		if (-f $file && $file !~ /$zipext$/) {
		    $filezip = $file;
		}
		if ($filezip eq $filetmpzip) {
		    $filezip = $fileroot.$prefixlog;
		    $file = $fileroot.$prefixlog;
		    $stop = 1 if (!(-f $file));
		}
	    } else {
		$filezip = $fileroot.$prefixlog;
		$file = $fileroot.$prefixlog;
		$stop = 1 if (!(-f $file));
	    }
	}

    } else {
	if (-e $file && $zipcut != 0) {
	} else {
	    $stop = 1 if (!(-f $file));
	}
    }

    $fyear = $year;
}

}

    if ($ENV{'REQUEST_METHOD'} ne "GET") {
	for ($i=1;$i<=$nb;$i++) {
	    print "\x08\x08\x08";
	}
    }



@listscreen = sort {$b <=> $a} @listscreen;
$heatmap_val = keys(%heatmap);
#$radius2 = $radius/2;

# Group together

if ($tototo == 1) {
for ($p=0;$p<=$#listurl;$p++) {
    $val = "data_".$listurl[$p];
    $max =  $val_url_max{$listurl[$p]};
    $fact = 1;
    $fact = 255/$max if ($max < 255);
    $fact = $max/255 if ($max >= 255);
    $ymax_val = $ymax{$listurl[$p]};
#    print "Page $val\n";

    for ($l=0;$l<scalar(@$val);$l+=2) {
	$x = $$val[$l];
	$y = $$val[$l+1];
	$dist = $x+$y*$ymax_val;
	$val2 = int($fact*$$val{$$val[$l],$$val[$l+1]});	 #pt central
#	print "Point : $x $y $val2\n";
    }
}
}


# Draw map

for ($t=0;$t<=$#listscreen;$t++) {



    $xmax_val = $listscreen[$t];

    for ($p=0;$p<=$#listurl;$p++) {

	$val = "data_".$listscreen[$t].$listurl[$p];

	next if (scalar(@$val)/2 < $seuilpage);

	if ($p == 0) {
	    $msg = "Map for $listscreen[$t] ($#listurl)\n";
	    &output_log($msg);
	}

#	next if (scalar(@$val)/2 < $topen);
	$val_offset = "data_".$listscreen[$t].$listurl[$p]."_offset";

	$heatmap = $path.$dirgraph.$dirsep."heatmap".$listscreen[$t].$listurl[$p].$pngext;

	$ymax_val = $ymax{$listurl[$p]}+$radius*3;
	$max =  $val_url_max{$listurl[$p],$listscreen[$t]};

	$val_url_nb{$listurl[$p],$listscreen[$t]} = scalar(@$val)/2;

	$fact = 1;
	$fact = 255/$max if ($max < 255 && $max != 0);
	$fact = $max/255 if ($max >= 255);

	# Compute map

#	if ($mode_map == 2) {

#	}

	###

	if ($mode_map == 1) {
	    for ($l=0;$l<scalar(@$val);$l+=2) {
		$y = $$val[$l+1];
		$offsetx = $$val_offset{$$val[$l],$$val[$l+1]};
		$off = int(($xmax_val-$offsetx)/2);

		$x = int($offsetx*$$val[$l]/100)+$off;
		$val2 = int($fact*$$val{$$val[$l],$$val[$l+1]});	 #pt central

#		print "$$val[$l],$$val[$l+1] / $x, $y - $val2 - $offsetx\n";
		for ($i=($x-$radius_matrix);$i<=($x+$radius_matrix);$i++) {
		    for ($j=($y-$radius_matrix);$j<=($y+$radius_matrix);$j++) {
			$red_ini = '';
			$blue_ini = '';
			$green_ini = '';
			($red_ini,$green_ini,$blue_ini) = split(/-/,$pixel_val{$i,$j});
			$dist = int(sqrt((($i-$x)*($i-$x))+(($j-$y)*($j-$y))));
			if ($dist <= $radius_matrix) {
			    $red = $red_pt[$val2];
			    $red += int((240-$red_pt[$val2])/($radius_matrix))*$dist;
			    if ($red_ini ne '') {
				$red = $red_ini if ($red_ini < $red);
			    }
			    $red = 255 if ($red > 255);
			    
			    $green = $green_pt[$val2];
			    $green += int((240-$green_pt[$val2])/($radius_matrix))*$dist;
			    if ($green_ini ne '') {
				$green = $green_ini if ($green_ini < $green);
			    }
			    $green = 255 if ($green > 255);
			    
			    $blue = $blue_pt[$val2];
			    $blue += int((240-$blue_pt[$val2])/($radius_matrix))*$dist;
			    if ($blue_ini ne '') {
				$blue = $blue_ini if ($blue_ini < $blue);
			    }
			    $blue = 255 if ($blue > 255);
			    $pixel_val{$i,$j} = "$red-$green-$blue";
			}
		    }
		}
	    }
	}
    
	open(FLY,">$tmpfly$vtmp");
	print FLY "new\n";
	print FLY "size $xmax_val,$ymax_val\n";
	print FLY "frect 0,0,$xmax_val,$ymax_val,200,200,200\n";

	if ($mode_map == 1) {
	    for ($l=0;$l<scalar(@$val);$l+=2) {
		$y = $$val[$l+1];
		$offsetx = $$val_offset{$$val[$l],$$val[$l+1]};
		$off = int(($xmax_val-$offsetx)/2);
		$x = int($offsetx*$$val[$l]/100)+$off;

#	    if ($mode_map == 0) {
#		$val2 = int($fact*$$val{$$val[$l],$$val[$l+1]});	
#		$val3 = int($val2-int($val2*11/100));
#		print FLY "circle $x,$y,$radius,$red_pt[$val3],$green_pt[$val3],$blue_pt[$val3]\n";
#		print FLY "circle $x,$y,$radius2,$red_pt[$val2],$green_pt[$val2],$blue_pt[$val2]\n";
#	    }

		
		for ($i=($x-$radius_matrix);$i<=($x+$radius_matrix);$i++) {
		    for ($j=($y-$radius_matrix);$j<=($y+$radius_matrix);$j++) {
			$dist = int(sqrt((($i-$x)*($i-$x))+(($j-$y)*($j-$y))));
			if ($dist <= $radius_matrix) {
			    ($red,$green,$blue) = split(/-/,$pixel_val{$i,$j});
			    print FLY "setpixel $i,$j,$red,$green,$blue\n";
			}
		    }
		}
	    }
	}

	if ($mode_map == 2) {
	    for ($y=0;$y<$ymax_val;$y++) {
		for ($x=0;$x<$listscreen[$t];$x++) {
		    if ($$val{$x,$y} != 0) {
			$val2 = int($fact*$$val{$x,$y});
			$x2 = $x+$radius_matrix;
			$y2 = $y+$radius_matrix;
			print FLY "frect $x,$y,$x2,$y2,$red_pt[$val2],$green_pt[$val2],$blue_pt[$val2]\n";
#			print FLY "circle $x,$y,20,$red_pt[$val2],$green_pt[$val2],$blue_pt[$val2]\n";
#			print FLY "setpixel $x,$y,$red_pt[$val2],$green_pt[$val2],$blue_pt[$val2]\n";
		    }
		}
	    }
	}

	print FLY "transparent 200,200,200\n";
	close (FLY);

	&BuildFly("$tmpfly$vtmp",$heatmap);
    }
}

for ($nblang=0;$nblang<=$#lang;$nblang++) {
    $file_to_open = "$path$lang[$nblang]$dirsep$dirlist$dirsep$fileheatmap$htmlext";
    open(FILEHEATMAP,">$file_to_open") || &error_exit("Error, unable to open $file_to_open");
    &HeatMap(*FILEHEATMAP, eval($Lang{$lang[$nblang]}),$lang[$nblang],\%val_url_max,\%val_url_nb,\@listscreen);
    close (FILEHEATMAP);
}

# Saving incremental
if ($heatmap_val != 0) {
    open(FILEHEATMAP,">$path$dirinc$dirsep$fileheatmap") || &error_exit("Error, unable to open $path$dirinc$dirsep$fileheatmap");
    foreach $val (&reverse_sort_by_value(*heatmap)) {
#    foreach $val (sort keys %heatmap) {
	print FILEHEATMAP "$val\t$heatmap{$val}\n";
    }
    close(FILEHEATMAP);
}

&load_basic_stats;


&update_homepage;

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

# calculer le temps mis pour le calcul
$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();

if ($debug == 1 || $zipcut == 0 || ($opt_w ne '' && $ENV{'REQUEST_METHOD'} eq "GET")) {
    if ($day_avg_speed != 0) {
	$mean = int($line_avg_speed/$day_avg_speed);
	$msg = "$loglines lines parsed (mean : $mean lines/sec)\n";
	&output_log($msg);
	print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    }
}

$msg =  "Computing took";
$msg .= " $hour h" if ($hour > 0);
$msg .= " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
&output_log($msg);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
    print "</DIV>";
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "ToggleMenu('TOGGLE_$scriptname');\n";
    print "</script>\n";
}

&UpdateCSSMenu('Optional','Heatmap',$icon_heatmap,"$dirlist$dirsepurl$fileheatmap$htmlext",1,0);

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

&StatusCompleted($scriptname,$status_script);

open(FILE,">>$history");
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$loglines;
close(FILE);

sub nextlog {

    $yyear = $year;
    $year = $fyear if ($opt_d eq '' && $mail_format == 0);
    $day++ if ($zipcut == 2);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

    $month++ if ($zipcut == 1);
    $monthprev = $month-1; # if ($zipcut == 1);

    if ($day > $month_of_year{$month_nb[$monthprev]} && $zipcut == 2) {
	$month++;
	$monthprev++;
	$day = "1";
	$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    }

    if ($month == 2) {
	if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	    $month_of_year{'Feb'} = "29";
	    $bisextil = 1;
	} else {
	    $month_of_year{'Feb'} = "28";
	    $bisextil = 0;
	}
    }

    $year++ if ($month == 13);
    $month = "1" if ($month == 13);
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $monthprev = 0 if ($month == 1);
    $lettermonth =  $month_nb[$monthprev];
    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;

    if ($zipcut != 3) {
	$file = &Get_LogfileName($fileroot);
    }
    
    $filezip = $file.$zipext if ($zip == 1);
    $fyear = $year if ($opt_d eq '');
    $datezip = $year.$month.$day;
}

__END__
