<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>W3Perl - Scripts description - Optional</TITLE>
<link rel="stylesheet" media="all" type="text/css" href="../../resources/css/menu.css">
<link rel="stylesheet" media="screen" type="text/css" href="../../resources/css/docs.css">
<!-- insert_curly -->
</head>

<BODY TEXT="#000000" LINK="#0000C0" VLINK="#50508F">

<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
<TR>
<TD COLSPAN=2>
<!-- insert_css_menu -->
</TD>
</TR>
<TR>
<TD WIDTH=130 ALIGN=CENTER VALIGN=TOP BGCOLOR="#39FFFF"></TD>
<TD VALIGN=TOP ALIGN=CENTER>
<H1><FONT COLOR="#209090"><H1>Scripts description</FONT></H1>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP BGCOLOR="#39FFFF">

</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
These scripts allow you to monitor additional informations than the usual
hits and pages statistics. The first three scripts will scan their own
logfiles (or the standard one if you're using an extended logfile format).
<P>
You'll be able to watch out :
<UL>
<LI> which browsers are used when people visits your Web.
<LI> where are they coming from and where do they access your Web.
<LI> which words people are using in search engine to reach your pages.
<LI> deleted pages people are asking for or bad links in your HTML pages.
</UL>
<P>
Two optional scripts will allow you to understand
HOW people are visiting your Web and HOW to optimize your HTML pages.
<P>

<UL>

<LI> Agent, referer and error log
<UL>
<LI><A HREF="#agent">cron-agent.pl</A> <I>(Optional)</I>
<LI><A HREF="#refer">cron-refer.pl</A> <I>(Optional)</I>
<LI><A HREF="#error">cron-error.pl</A> <I>(Optional)</I>
</UL>
<P>
<LI> Session and Documents structures 
<UL>
<LI><A HREF="#session">cron-session.pl</A> <I>(Optional)</I>
<LI><A HREF="#url">cron-url.pl</A> <I>(Optional)</I>
</UL>
</UL>
<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="agent"></A>
<table border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-agent.pl
</th>
</tr>
<tr>
<td valign=top BGCOLOR="#E5E5E5">
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Agent log stats<br>
Compute browsers/OS stats.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
None. You can run the script when you want. I run it once every week or sometimes daily.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
From a few seconds to one or two minutes depending of the size of the log file.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-a</th><td> show all browser</td>
</tr><tr>
<th>-b</th><td> re-initialize everything</td>
</tr><tr>
<th>-c &lt;file&gt;</th><td> load configuration file</td>
</tr><tr>
<th>-d &lt;number&gt;</th><td> number of days to scan (Extended NCSA logfile only)</td>
</tr><tr>
<th>-g &lt;graphics&gt;</th><td> different graphic option available</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td> select language output</td>
</tr><tr>
<th>-i</th><td> input logfile</td>
</tr><tr>
<th>-f</th><td> scan only HTML files (Extended NCSA logfile only)</td>
</tr><tr>
<th>-x</th><td> display default values for flag options</td>
</tr><tr>
<th>-t &lt;toplist&gt;</th><td> display only toplist browsers</td>
</tr><tr>
<th>-z</th><td> use compressed logfiles</td>
</tr><tr>
<th>-v</th><td> display version </td>
</tr></table>

</td>
</tr>

<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan the logfile to extract the most commonly used browser and operating system.
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
Graphic is only produced with a combined logfile (Extended Common Logfile or Extended IIS format). It
show you browsers version versus time. For each browser, you can watch 
percentage of each version.</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="refer"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-refer.pl
</th>
</tr>
<tr>
<td BGCOLOR="#E5E5E5" valign=top>
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Referer log stats<br>
Compute the pages where come most people.<br>
It could be very useful to know which sites have a link to your web site.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
None. You can run the script when you want. I run it once every week.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
From a few seconds to one or two minutes depending of the size of the log file.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-b</th><td> re-initialize everything</td>
</tr><tr>
<th>-c &lt;file&gt;</th><td> load configuration file</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td> select language output</td>
</tr><tr>
<th>-i &lt;file&gt;</th><td> input agent logfile</td>
</tr><tr>
<th>-f</th><td>local references include</td>
</tr><tr>
<th>-p &lt;page&gt;</th><td> referer for this page</td>
</tr><tr>
<th>-t &lt;toplist&gt;</th><td> display only toplist files</td>
</tr><tr>
<th>-x</th><td> display default values for flag options</td>
</tr><tr>
<th>-z</th><td> use compressed logfile</td>
</tr><tr>
<th>-v</th><td> display version </td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan the logfile to extract where come people
accessing your pages. It output the most frequent sites and pages
where people come from and where they arrived in your site. Also the most
common words used in search engine are computed.
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
View how your site have been referenced across the Web and how to improve it
with selected words in your html code.
</td>
</tr>
</table>


<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="error"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-error.pl
</th>
</tr>
<tr>
<td BGCOLOR="#E5E5E5" valign=top>
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Error log stats<br>
It display the most common error from your web server.<br>
A list of error due to files not found is produced also to check
if the files are really missing.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
None. You can run the script when you want. I run it once every week.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
From a few seconds to one or two minutes depending of the size of the error log file.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-r &lt;tildealias&gt;</th><td> substitue ~ by the path alias</td>
</tr><tr>
<th>-b</th><td> re-initialize everything</td>
</tr><tr>
<th>-c &lt;file&gt;</th><td> load configuration file</td>
</tr><tr>
<th>-i &lt;file&gt;</th><td> input error logfile</td>
</tr><tr>
<th>-d &lt;number&gt;</th><td> number of days to scan</td>
</tr><tr>
<th>-j &lt;date&gt;</th><td> stats for this date only</td>
</tr><tr>
<th>-g &lt;graphics&gt;</th><td> select graphics output</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td> select language output</td>
</tr><tr>
<th>-f</th><td> 'file does not exist', HTML files only</td>
</tr><tr>
<th>-q &lt;tri&gt;</th><td> 'file does not exist', matching string only</td>
</tr><tr>
<th>-k</th><td> 'file does not exist', show referer page</td>
</tr><tr>
<th>-s &lt;threshold&gt;</th><td> display threshold for 'file not found'</td>
</tr><tr>
<th>-t &lt;toplist&gt;</th><td> display only toplist most found errors</td>
</tr><tr>
<th>-x</th><td> display default values for flag options</td>
</tr><tr>
<th>-z</th><td> use compressed logfile</td>
</tr><tr>
<th>-v</th><td> display version </td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scan the error log file to extract the most common error server.
It output also the documents your server is unable to futfill.
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
You can add in the code other error message produced by your server.
But be sure, your error message you'll add is not a part of another one.
Graphic is produced showing you the error versus time. <BR>
The page where come the missing file is also printed.<P>
You don't have to wait for error happening to rectify wrong links in your
pages....cron-url.pl is able to scan your documents tree and tell you about
missing files in your links avoiding error log to become too big.<BR>
Windows users can use cron-error if they use redirection files.
</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="session"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-session.pl
</th>
</tr>
<tr>
<td BGCOLOR="#E5E5E5" valign=top>
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Session log stats<br>
It compute how long people stay on your web by scanning the
log file. Full session for each user is shown with other bonus
informations.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
None. You can run the script when you want.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
From a few minutes to a several hours depending of the size of the
log file.<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-a</th><td> include robot session</td>
</tr><tr>
<th>-c &lt;file&gt;</th><td> load configuration file</td>
</tr><tr>
<th>-d &lt;number&gt;</th><td> number of days to scan</td>
</tr><tr>
<th>-g &lt;graphics&gt;</th><td> select graphics output</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td> select language output</td>
</tr><tr>
<th>-i &lt;file&gt;</th><td>input logfile</td>
</tr><tr>
<th>-m</th><td> update only robot detection</td>
</tr><tr>
<th>-t &lt;min&gt;</th><td>session maximum length</td>
</tr><tr>
<th>-j &lt;min&gt;</th><td>maximum time to read a page</td>
</tr><tr>
<th>-q &lt;min&gt;</th><td>display session longer than this value</td>
</tr><tr>
<th>-r &lt;date&gt;</th><td>ending date for stats</td>
</tr><tr>
<th>-s &lt;date&gt;</th><td>starting date for stats</td>
</tr><tr>
<th>-x</th><td> display default values for flag options</td>
</tr><tr>
<th>-z</th><td> use compressed logfile</td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It's very hard to know how long people stay on your web as they
can access a page, going to lunch and have a second access two
hours later. But people usually have a more or less longer look
at your web and only come back another day.<br>
In the script, you have a maximum <I>time limit session</I> variable.
If an access is made within this time, it's still the same session.<BR>
Another way is to select a <I>time limit when reading a page</I>. Usually,
people doesn't need more than one hour to read a HTML page ! <BR>
Accesses from network spider (robots) are removed (well, I try !)
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
If you have a dynamic IP address (Internet provider for example),
different people can come with the same IP address and it become
very hard to know about session users !<BR>
The script will also output the average requests by hour and by the
day of the week.<P>
This script does not yet support incremental mode.
</td>
</tr>
</table>

<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>

<A NAME="url"></A>
<table  border=0>
<tr>
<th align=CENTER colspan=2 BGCOLOR="#FFEECC">
Cron-url.pl
</th>
</tr>
<tr>
<td BGCOLOR="#E5E5E5" valign=top>
Purpose
</td>
<td BGCOLOR="#F5F5F5">
Documents stats<br>
Compute how your web is looking. Do you have a multimedia,
 graphical and heavy web ?<BR>
It will also translate the URL to the TITLE of the file and show
you the most recent html files on your web.<BR>
Also a detailled server tree is output.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Frequency
</td>
<td BGCOLOR="#F5F5F5">
None. You can run the script when you want. I run it once a week.
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Time taken
</td>
<td BGCOLOR="#F5F5F5">
From a few minutes to one hour depending of the size of your web.
<br>
</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Options
</td>
<td BGCOLOR="#F5F5F5">

<table>
<tr>
<th>-c &lt;file&gt;</th><td> load configuration file</td>
</tr><tr>
<th>-d &lt;nbdays&gt;</th><td>show file newest than nbdays days</td>
</tr><tr>
<th>-g &lt;graphics&gt;</th><td> select graphics output</td>
</tr><tr>
<th>-l &lt;language&gt;</th><td> select language output</td>
</tr><tr>
<th>-t &lt;topten&gt;</th><td> show only toplist files</td>
</tr><tr>
<th>-x</th><td> show default values</td>
</tr><tr>
<th>-v</th><td> display version </td>
</tr></table>

</td>
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
How&nbsp;it&nbsp;works
</td>
<td BGCOLOR="#F5F5F5">
It scans your web structure, counting for files, opening each
file. Histograms showing how many links, images per document is
produced and also graphs showing you the documents size
distribution.<BR>
A histogram show the most recent file updated in your web.<BR>
A translation table is made between the URL of a document and
its name (found inside the TITLE tag).<BR>
The structure (tree) of your web is also show with detail about
HTML pages inside each part of the tree.<BR>
It also check every links and report missing files.
</tr>
<tr>
<td BGCOLOR="#E5E5E5">
Notes
</td>
<td BGCOLOR="#F5F5F5">
Could be useful if you want to check every HTML document have
a TITLE tag and is unique.
Could also show you if you have heavy pages !<BR>
People could go directly to new html documents in the tree server or from
the 'new documents' pages.<BR>
</BLOCKQUOTE>
</td>
</tr>
</table>
</TD>
</TR>
</TABLE>
</body>
</html>
