<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML><head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>W3Perl User installation</TITLE>
<link rel="stylesheet" media="all" type="text/css" href="../../resources/css/menu.css">
<link rel="stylesheet" media="screen" type="text/css" href="../../resources/css/docs.css">
<!-- insert_curly -->
</head>

<BODY TEXT="#000000" LINK="#0000C0" VLINK="#50508F">

<TABLE WIDTH="100%" CELLSPACING=0 CELLPADDING=0 BORDER=0>
<TR>
<TD COLSPAN=2>
<!-- insert_css_menu -->
</TD>
</TR>
<TR>
<TD WIDTH=130 ALIGN=CENTER VALIGN=TOP BGCOLOR="#39FFFF"></TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<CENTER>
<H1><FONT COLOR="#209090">User installation</FONT></H1>
<P>

</CENTER>
<P>
<BR>
<BR>
You don't have any access to a cgi-bin directory on your host but
would like to have a stats report. The scripts don't
require to be installed in the cgi-bin directory. Some features like
the administration interface are not available to you. I supposed you have a
ssh access, if not go to the <A HREF="provider.html">Provider Installation</A>
section.
<BR>
<FONT COLOR="#20A0A0">W3Perl installation directory</FONT><BR>
<P>
</BLOCKQUOTE>

</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">

<H3>&nbsp;Without&nbsp;<BR>&nbsp;CGI&nbsp;</H3>

</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
<FONT COLOR="#A020A0"><B>* First STAGE</B></FONT> : <FONT COLOR="#A02020">Install the scripts</FONT>
<P>
- Download the <A HREF="http://www.w3perl.com/download/index.html">W3Perl package</A> on your own host. 
<BR>
- Uncompress the package where you want (best would be in a web server tree) and extract all the files. It will create a
<FONT COLOR="#20A0A0"><I>/w3perl/</I></FONT> directory where all the files are stored.
<P>
<!--
1.3 - Edit the first line of install.pl to reflect the Perl location on your host. 
<BR>Modify $pathw3perl to the location of your <FONT COLOR="#20A0A0"><I>/w3perl/</I></FONT> directory
<BR>$pathcgi should be empty if you don't have cgi.
<P>
1.4 - Launch install.pl.
<P>
-->
<P>
<FONT COLOR="#A020A0"><B>* 2nd STAGE</B></FONT> : <FONT COLOR="#A02020">Building configuration file</FONT>
<P>
- Choose the config file (in /config/ you'll be able to find few examples) which match the kind of stats you want to build and copy this file
to config.pl (which is the default config filename for w3perl). Edit the <A HREF="config.html">config.pl</A> file and customize
it the way you like. The output directory can be whatever you want, it
should only belong to you.
<BR>
- Or you can use the online tool on my website to build your own config file (easier !)
<P>
<FONT COLOR="#A020A0"><B>* 3rd STAGE</B></FONT> : <FONT COLOR="#A02020">Ready</FONT>
<P>
- Launch the script 'cron-w3perl.pl -a' to init your stats.
<P>
- Run your favourite browser :
<P>
<UL>
<LI> Select the 'open file' option to load the main index.html file in the output directory.
<BR>
<LI>  Or just load the index file in your output directory if the index file is located in your web server tree (best).
</UL>
<P>
- If everything is right, add 'cron-w3perl.pl -e ' in your crontab. With the -e flag, cron-w3perl 
will only update stats.
<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>
</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<H3>&nbsp;Without&nbsp;<BR>&nbsp;crontab&nbsp;</H3>

</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
Some sysadmin don't allow you to use a crontab to launch scripts to 
avoid excessive CPU usage.
<BR> 
You could either use the web administration if you have a cgi
directory or manually update the stats with the 'cron-w3perl.pl -e' command.
<P>
<HR ALIGN=CENTER WIDTH="30%">
<P>
</BLOCKQUOTE>
</TD>
</TR>
<TR>
<TD WIDTH=130 VALIGN=TOP ALIGN=CENTER BGCOLOR="#39FFFF">
<H3>&nbsp;Hints&nbsp;</H3>
</TD>
<TD VALIGN=TOP>
<BLOCKQUOTE>
<P>
1 - Read carefully the documentation. Many questions are answered
in the files provided, use also the -h flag for more informations for
each script.
<P>
2 - You can build as many configuration files you need. Just use the
-c flag to load them
</BLOCKQUOTE>
</TD>
</TR>
</TABLE>
</body>
</html>
