#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    domisse@w3perl.com                   version 02/05/2003     #####
####                                                                #####
#########################################################################

%CountrySP = (
"Europe", "Europe",
"Middle-East", "Middle-East",
"South-America", "South-America",
"North-America", "North-America",
"Central-America", "Central-America",
"Africa", "Africa",
"Oceania", "Oceania",
"Asia", "Asia",
"Misc", "Misc",
"Wallis-and-Futuna", "Wallis and Futuna",
"Asia-Pacific", "Asia-Pacific",
"Serbia", "Serbia",
"Montenegro", "Montenegro",
"Somalia", "Somalia",
"East-Timor", "East Timor",
"Aland-Islands", "&Aring;land Islands",
"Nauru", "Nauru",
"Ascension", "Ascension",
"Andorra", "Andorra",
"United-Arab-Emirates", "United-Arab-Emirates", 
"Afghanistan", "Afghanistan",
"Anguilla", "Anguilla",
"Albania", "Albania",
"Antigua-and-Barbuda", "Antigua y Barbuda",
"Armenia", "Armenia",
"Arpa", "Arpanet",
"Argentina", "Argentina",
"Angola", "Angola",
"Antartica", "Antartica",
"Austria", "Austria",
"Australia", "Australia",
"Aruba", "Aruba",
"Azerbaijan", "Azerbaijan",
"Bosnia-Herzegovina", "Bosnia Herzegovina",
"Bangladesh", "Bangladesh",
"Barbados", "Barbados",
"Belgium", "Belgica",
"Burkina-Faso", "Burkina Faso",
"Bulgaria", "Bulgaria",
"Bahrain", "Bahrain",
"Bermuda", "Bermuda",
"Brunei-Darussalam", "Brunei Darussalam",
"Burundi", "Burundi",
"Benin", "Benin",
"Bolivia", "Bolivia",
"Brazil", "Brazil",
"Bahamas", "Bahamas",
"Botswana", "Botswana",
"Belarus", "Belarus",
"Belize", "Belize",
"Buthan", "Buthan",
"British-Indian-Ocean-Territory", "British Indian Ocean Territory",
"Canada", "Canada",
"Central-African-Rep", "Rep Centro-Africana",
"Republic-of-Congo", "Republic of Congo",
"Democratic-Republic-of-the-Congo", "Democratic Republic of the Congo",
"Switzerland", "Suiza",
"Ivory-Coast", "Costa de Marfil",
"Chile", "Chile",
"Cameroon", "Cameron",
"China", "China",
"Colombia", "Colombia",
"Cook-Islands", "Cook Islands",
"Commercial", "Comercial",
"Costa-Rica", "Costa Rica",
"Cuba", "Cuba",
"Cyprus", "Chipre",
"Czech-Republic", "Republica Checa",
"Germany", "Alemania",
"Djibouti", "Djibouti",
"Denmark", "Dinamarca",
"Dominica", "Dominica",
"Dominican-Republic", "Republica Dominicana",
"Algeria", "Algeria",
"Ecuador", "Ecuador",
"US-Educational", "US Educacion",
"Estonia", "Estonia",
"Egypt", "Egipto",
"Spain", "Espana",
"Ethiopia", "Etiopia",
"Finland", "Finlandia",
"Fidji", "Fidji",
"Faroe-Islands", "Islas Faroe",
"France", "Francia",
"Gabon", "Gabon",
"Great-Britain", "Reino Unido",
"French-Guiana", "Guayana Francesa",
"Georgia", "Georgia",
"Ghana", "Ghana",
"Gibraltar", "Gilbraltar",
"US-Government", "US Gobierno",
"Guadeloupe", "Guadeloupe",
"Greece", "Grecia",
"Greenland", "Greolandia",
"Guinea", "Guinea",
"Guyana", "Guyana",
"Guatemala", "Guatemala",
"Guam", "Guam",
"Guinea-Bissau", "Guinea Bissau",
"Hong-Kong", "Hong-Kong", 
"Honduras", "Honduras",
"Croatia", "Croacia",
"Hungary", "Hungria",
"Indonesia", "Indonesia",
"Ireland", "Irlanda",
"Israel", "Israel",
"India", "India",
"International", "Internacional",
"Iceland", "Islandia",
"Iran", "Iran",
"Italy", "Italia",
"Jamaica", "Jamaica",
"Japan", "Japon",
"Jordan", "Jordania",
"Cambodia", "Camboya",
"Comoros", "Comoros",
"South-Korea", "Corea del Sur",
"Kenya", "Kenia",
"Kuwait", "Kuwait",
"Kazachstan", "Kazachstan",
"Kyrgyzstan", "Kyrgyzstan",
"Cayman-Islands", "Islas Cayman",
"Christmas-Island", "Islas Christmas",
"Lebanon", "Lebano",
"Saint-Tome-and-Principe", "Saint Tome and Principe",
"Sainte-Lucia", "Sainte Lucia",
"Saint-Barthelemy", "Saint Barthelemy",
"Saint-Martin", "Saint Martin",
"Lesotho", "Lesotho",
"Liechtenstein", "Liechtenstein",
"Lithuania", "Lithuania",
"Latvia", "Latvia",
"Luxembourg", "Luxemburgo",
"Sri-Lanka", "Sri Lanka",
"US-Military", "US Militar",
"Madagascar", "Madagascar",
"Macau", "Macau",
"Macedonia", "Macedonia",
"Mexico", "Mexico",
"Malaysia", "Malaysia",
"Morocco", "Maruecos",
"Moldova", "Moldovia",
"Marshall-Islands", "Marshall Islands",
"Micronesia", "Micronesia",
"Monaco", "Monaco",
"Maldives", "Maldives",
"Martinique", "Martinique (French)",
"Malta", "Malta",
"Mauritius", "Mauritus",
"Mauritania", "Mauritania",
"Mozambique", "Mozambique",
"Namibia", "Namibia",
"NATO", "NATO",
"New-Caledonia", "New Caledonia", 
"Network", "Network",
"Nicaragua", "Nicaragua",
"Niger", "Niger",
"Nigeria", "Nigeria",
"Netherlands", "Holanda",
"Norway", "Noruega",
"Nepal", "Nepal",
"New-Zealand", "Nueva Zelanda",
"Niue", "Niue",
"Non-Profit", "Organizaciones",
"Oman", "Oman",
"Papua-New-Guinea", "Papua - New Guinea",
"Panama", "Panama",
"Puerto-Rico", "Puerto Rico",
"French-Polynesia", "Polynesia Francesa",
"Pakistan", "Pakistan",
"Paraguay", "Paraguay",
"Peru", "Peru",
"Philippines", "Filipinas",
"Poland", "Polonia",
"Portugal", "Portugal",
"Qatar", "Qatar",
"Romania", "Rumania",
"Russian-Federation", "Federation Rusa",
"Saudi-Arabia", "Arabia Saudita",
"San-Marino", "San Marino",
"Senegal", "Senegal",
"Sierra-Leone", "Sierra Leone",
"Sweden", "Suecia",
"Singapore", "Singapore",
"Slovenia", "Slovenia",
"Slovakia", "Slovakia",
"Swaziland", "Swaziland",
"Soviet-Union", "Union Sovietica",
"El-Savaldor", "El Salvador",
"Chad", "Chad",
"Tanzania", "Tanzania",
"Togo", "Togo",
"Thailand", "Tailandia",
"Tonga", "Tonga",
"Turkey", "Turkia",
"Taiwan", "Taiwan",
"Trinidad-and-Tobago", "Trinidad y Tobago",
"Turkmenistan", "Turkmenistan",
"Tunisia", "Tunez",
"Ukraine", "Ukrania",
"Uganda", "Uganda",
"United-Kingdom", "Reino Unido",
"United-States", "Estados Unidos",
"Uruguay", "Uruguay",
"Uzbekistan", "Uzbekistan",
"Vatican", "Vaticano",
"Venezuela", "Venezuela",
"Vietnam", "Vietnam",
"Virgin-Islands-USA", "Islas Virgenes (EEUU)",
"Virgin-Islands-UK", "Islas Virgenes (British)",
"South-Africa", "Sudafrica",
"Yemen", "Yemen",
"Yugoslavia", "Yugoslavia",
"Zambia", "Zambia",
"Zimbabwe", "Zimbabwe",
"Norfolk-Island", "Norfolk Island",
"Netherlands-Antilles", "Netherlands Antilles",
"American-Samoa", "American Samoa",
"Mongolia", "Mongolia",
"Iraq", "Iraq",
"Vanuatu", "Vanuatu",
"Mali", "Mali",
"Rwanda", "Rwanda",
"Heard-and-McDonald-Islands", "Heard and McDonald Islands",
"Solomon-Islands", "Solomon Islands",
"Cocos-Islands", "Cocos Islands",
"Samoa", "Samoa",
"Mayotte", "Mayotte",
"Turks-and-Caicos-Islands","Turks and Caicos Islands",
"Saint-Pierre-et-Miquelon","Saint Pierre and Miquelon",
"Sierra-Leone", "Sierra Leone",
"South-Georgia-and-South-Sandwich-Islands","South Georgia and South Sandwich Islands",
"Jersey-Channel-Islands", "Jersey (Channel Islands)",
"Eritrea", "Eritrea",
"Tuvalu", "Tuvalu",
"Isle-of-Man", "Isle of Man",
"Laos", "Laos",
"Suriname", "Suriname",
"Montserrat", "Montserrat",
"Seychelles", "Seychelles",
"Grenada", "Grenada",
"Guernsey-Channel-Islands", "Guernsey (Channel Islands)",
"Saint-Helena", "Saint Helena",
"Papua-New-Guinea", "Papua New Guinea",
"Business", "Business",
"Cooperative", "Cooperative",
"Professional", "Professional",
"Name", "Name",
"Aeronautic", "Aeronautic",
"Telephone", "Telephone",
"Travel", "Travel",
"Jobs", "Jobs",
"Info", "Info",
"Museum", "Museum",
"US-Minor-Outlying-Islands", "US Minor Outlying Islands",
"European-Union", "European Union",
"Saint-Kitts-Nevis-Anguilla", "Saint Kitts &amp; Nevis - Anguilla",
"Cape-Verde", "Cape Verde",
"Syria", "Syria",
"Haiti", "Haiti",
"Liberia", "Liberia",
"Libya", "Libya",
"North-Korea", "North Korea",
"Sudan", "Sudan",
"Palestine", "Palestine",
"Tadjikistan", "Tadjikistan",
"Saint-Vincent-Grenadines", "Saint Vincent &amp; Grenadines",
"Gambia", "Gambia",
"Equatorial-Guinea", "Equatorial Guinea",
"Kiribati", "Kiribati",
"Tokelau", "Tokelau",
"Local", "Local Network",
"Satellite", "Satellite",
"Falkland-Islands", "Falkland Islands",
"Myanmar", "Myanmar",
"Northern-Mariana-Islands", "Northern Mariana Islands",
"Malawi", "Malawi",
"Former-Czechoslovakia", "Former Czechoslovakia",
"Invalid", "Invalid",
"Reunion", "Reunion",
"Pitcairn", "Pitcairn",
"Palau", "Palau",
"Mobile", "Mobile",
"Catalan", "Catalan",
"French-Southern-Territories", "French Southern Territories",
"South-Sudan", "South Sudan",
"Private-IP", "Private IP",
"Curacao", "Curacao",
"Sint-Maarten", "Sint-Maarten",
"Caribbean-Netherlands", "Caribbean Netherlands",
"Unknown", "Desconocido"
 );
