#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    Language Script                             #####
####                     (http server)                              #####
####                                                                #####
####    Portuguese Version by:                                      #####
####    {w}izard2010  		                                    #####
####	 version 05/05/2008 (02/05/2003 LD)	      		    #####
####                                                                #####
#########################################################################

# Look for YYY string for new or updated strings

%LangPT = (
"No_enough_data_to_display_graph", "Not enough data to display graph",
"Emails_sent", "Emails sent",
"emails_sent", "emails sent",
"Histogram", "Histogram",
"Mac_address", "Mac address",
"Days_between_same_session", "Days between multiple session",
"Daily_visits", "Daily visits",
"Different_accesses", "Different accesses",
"Unique", "Unique",
"Spam", "Spam",
"spam", "spam",
"Flag", "Flag",
"Spam_rank", "Spam rank",
"documents" , "documentos",
"graph3d", "3D bar",
"graphlinefill", "Filled lines",
"graphline", "Lines",
"barchart", "Barchart",
"Sort", "Sort",
"Alphabetically", "Alphabetically",
"By_size", "By size",
"All" , "Todos",
"Next", "Next",
"Previous", "Previous",
"Last", "Last",
"Weekday", "Weekday",
"Select_an_interval", "Select an interval",
"When", "When",
"Resources", "Resources",
"Optional", "Optional",
"Last_update", "Last update",
"Admin", "Admin",
"Tag", "Tag",
"No_index", "No index",
"Only_users", "Only users",
"Only_cities", "So Cidades",
"Cities", "Cidades",
"Region_name", "Nome da Regiao",
"Heatmap", "Heatmap",
"Click", "Click",
"Most_heavy_files", "Ficheiros mais pesados",
"Selected_pages", "Paginas selecionadas",
"robots", "robos",
"Years", "Anos",
"About_years", "Sobre anos",
"of_years", "de anos",
"Incoming_bandwidth", "Incoming bandwidth",
"Outgoing_bandwidth", "Outgoing bandwidth",
"RSS", "RSS",
"Click_here", "Clique aqui para mais informacoes",
"URL_mapping", "Mapeamento do URL",
"Enabled", "Activo",
"Disabled", "Desactivo",
"Processing", "Processamento",
"No_item_found", "Nao foi encontrado o item",
"Title", "Titulo",
"URL", "URL",
"Threshold", "Limiar",
"Search", "Procurar",
"Search_on", "Procurar em",
"General_ranking", "Ranking geral",
"Emails", "Emails",
"emails", "emails",
"Only_emails", "So emails",
"Full_list", "Lista completa",
"Miscellaneous", "Diversos",
"Screensize", "Screensize",
"Color_depth", "Color depth",
"Java_plugin", "Java plugin",
"Protected_files", "Ficheiros protegidos",
"Parameter","Parametro",
"Exit_occurence", "Ocorrencias de saida",
"Entry_occurence", "Ocorrencias de entrada",
"Unauthorized", "Nao autorizado",
"ReferSpam_excluding", "Spammer excluido",
"Cached_files", "ficheiros em cache",
"Cached_trafic", "Trafego em cache",
"Downloaded_files", "Download de ficheiros",
"Downloaded_trafic", "Transferencia de trafego",
"milliseconds", "ms",
"Stats_about_destinations", "Statistiques about destinations",
"Sorted_destination_servers", "Sorted destination servers",
"Destination", "Destination",
"Incoming_requests_by_status", "Incoming requests by status",
"Outgoing_requests_by_status", "Outgoing requests by status",
"Outgoing_requests_by_destination", "Outgoing requests by destination",
"Average_elapsed_time", "Average elapsed time",
"Proxy", "Proxy",
"Stats_over", "Estatsticas mais",
"updated_every", "atualizados a cada",
"with_an_integration_time_of", "com uma integracao de tempo",
"Real_time","Tempo Real",
"Abort","Abortar",
"Status_code","Status code",
"Size","Tamanho",
"Download_not_completed","Download incompleto",
"Outgoing_traffic", "Outgoing traffic",
"Incoming_traffic", "Incoming traffic",
"Virus", "Virus",
"virus", "virus",
"internal_pages", "YYYinternal pages",
"Internal_pages", "YYYInternal pages",
"Accesses_only", "So acessos",
"accesses", "acessos",
"Gb", "Gb",
"Tb", "Tb",
"most_successful_bookmark", "Favorito mais visitado",
"Bookmarked_page", "Pagina Favorita ",
"Difference", "Diferenca",
"Minimum", "Mnimo",
"Maximum", "Maximo",
"Only_files", "So Ficheiros",
"Filetype", "Tipo de Ficheiros",
"28800_modem", "modem de 28800",
"A_description" , "Descricao",
"About_months" , "Tabela Mensal",
"About_weeks" , "Tabela Semanal", 
"Absolute_links", "Links Absolutos",
"Acces_not_taken_into_account", "Acessos nao considerados",
"Accesses" , "Acessos", 
"All_html_pages_requests", "Todos as paginas HTML solicitadas",
"All_images_requests", "Todos as Imagens solicitadas",
"All_requests" , "Todas as solicitacoes",
"All_sites" , "Todos os Sites",
"At", "Em",
"Average_CPU", "Media de CPU",
"Average", "Media dia",
"Average_is_black", "A Media esta em preto",
"Average_on_hours_and_days", "Media em horas e dias",
"Average_pages_by_session", "Media do numero de paginas visitadas por sessao",
"Average_session_time", "Media de tempo por sessao",
"Average_reading_time_per_page", "Media do tempo de leitura",
"Back", "Recuar",
"Background", "Fundo",
"Bad_links", "Links errados",
"Blue_line_is_average", "A linha azul representa a media",
"Browser" , "Browser",
"Browsers" , "Browser",
"Browsers_used" , "Browsers Usados",
"CPU", "CPU",
"Cgi-bin", "Cgi-bin",
"Conn_Mach" , "Maquinas conectadas", 
"Connection_time", "Tempo de conexao",
"Correct_size_taken_from_image", "Tamanho correto obtido da imagem",
"Countries", "Paises", 
"Data", "Dados",
"Data_traffic_by_weeks" , "Trafego de dados por semana",
"Data_unit_Kb" , "Kilobytes",
"Data_unit_Mb" , "Megabytes",
"Data_unit_octet" , "bytes",
"Date" , "Data",
"Days", "Dias", 
"Decrease_over_the_previous_day","Queda em relacao ao dia anterior",
"Directories" , "Directorias",
"Directories_graphs" , "Grafico de Directorios",
"Docs" , "Docs",
"Documents" , "Documentos",
"DomReq" , "Documentos solicitados", 
"Domain", "Dominios",
"Domain_Hosts" , "Servidores de Dominios",
"Download", "Transferencia", 
"Downloading_time", "Tempo de Transferencia",
"Errors" , "Erros",
"Error", "Erro",
"Evolution_of", "Evolucao de",
"Files", "Ficheiros",
"Forbidden", "Acesso Negado",
"Found_in", "Encontrado em",
"Frames", "Frames",
"Frames_excluding", "Frames excluidas",
"Global_access", "Acesso Global",
"Graphic" , "Grafico",
"Graphs_for" , "Grafico para",
"Graphs_for_dir" , "Grafico para os Directorios",
"HTML_files", "Ficheiros HTML",
"Histogram_about_average_request", "Historico do numero medio de solicitacoes",
"Histogram_sessions", "Historico de solicitacoes",
"Hosts", "Servidores",
"Hosts_excluding", "Servidores excluidos",
"Hosts_from" , "Dos Servidores",
"Hour" , "Hora", 
"Hours" , "Horas", 
"Image", "Imagem", 
"Images", "Imagens",
"Images_histogram", "Historico de Imagens",
"Images_never_used", "Imagens nunca usadas",
"Increase_over_the_previous_day", "Aumento em relacao ao dia anterior",
"Index", "Indice",
"Index_pages", "Indice de paginas",
"Inside" , "Dentro",
"Kb" , "Kb", 
"Kbytes" , "Kilobytes", 
"Keywords", "Palavras Chave",
"Language" , "Portugues PT",
"Last_occurence" , "Ultima ocurrencia",
"Last_try", "Ultima tentativa",
"Legend_in_bracket", "Legenda entre chavetas",
"Level", "Nivel",
"Lines_processed", "Linhas processadas",
"Link", "Link",
"Links", "Links", 
"Links_histogram", "Historico de Links",
"ListOf" , "Lista de",
"ListOfSites" , "Lista de Sites",
"List_of", "Lista de",
"List_of_unresolved_hosts", "Desconhecidos",
"Login", "Login", 
"Longest_external_session", "Maior sess&atilde;o externa",
"Longest_local_session", "Maior sessao local",
"Longest_session", "Maior sessao",
"Mach_Dom" , "maquinas do dominio", 
"Mb" , "Mb",
"Mbytes" , "Megabytes",
"Method", "M&eacute;todo",
"Mhosts" , "servidores",
"Misc", "Misc",
"MonthByMonth" , "meses a meses", 
"Month_of" , "Meses de ", 
"Month" , "Mes", 
"Months" , "Meses", 
"More_Precise" , "mais preciso",
"MostSuccesf" , "mais bem sucedidas",
"Multiple_sessions", "Multiplas sessoes",
"New_country", "Novos Paises",
"New_HTML_files", "Novos ficheiros HTML",
"New_Hosts" , "Novos servidores",
"New_Mach" , "novas maquinas", 
"Newest_pages", "Paginas mais recentes",
"Newest_pages_histogram", "Historico de paginas mais recentes",
"News" , "Novidades",
"NoReq" , "numero de solicitacoes",
"No_Ttl_Req_Mnth" , "numero total de solicitacoes por mes",
"No_Ttl_Req_Week" , "numero total de solicitacoes por semana",
"No_login", "Sem acessos por login",
"No_modification", "Sem modificacoes",
"No_request", "Nenhuma solicitacao foi feita",
"No_robot_session", "Nenhuma sessao de robot encontrada",
"No_title", "Sem titulo",
"Not_found", "Nao encontrado",
"Number" , "Numero",
"Number_of" , "Numero de", 
"Number_of_HTML_files", "Numero de ficheiros HTML",
"Number_of_different_sites" , "Numero de sites diferentes",
"Number_of_different_resolved_countries" , "Numero de paginas diferentes encontrados",
"Number_of_different_pages_used" , "Numero de paginas diferentes utilizadas",
"Number_of_pages_read", "Numero de paginas lidas",
"Number_of_req_by_weeks" , "Numero de solicitacoes por semanas",
"Number_of_requests", "Numero de solicitacoes",
"Number_of_visits", "Numero de visitas",
"OS" , "Sistema",
"OS_used1" , "O",
"OS_used2" , "sistemas operativos usados",
"Occurence" , "Ocorrencias",
"On", "Ligado", 
"Only_directories", "Apenas directorios",
"Only_first", "Apenas o primeiro",
"Only_hosts", "Apenas servidores",
"Only_pages", "Apenas paginas",
"Only_scripts", "Apenas scripts",
"Only_time_session_upper", "Apenas sessoes maiores que",
"Others" , "Outros",
"Outside" , "Fora",
"Page", "Pagina", 
"Page_reading_time_histogram", "Historico do tempo de leitura das paginas HTML",
"Pages", "Paginas",
"Pages_excluding", "Paginas Excluidas", 
"Pages_never_used", "Paginas nunca utilizadas",
"Percentage" , "Percentagem",
"Reading_time", "Tempo de leitura",
"Reading_time_sessions", "Sessoes com tempo de leitura",
"Redirect", "Redirecionamento",
"References_for" , "Referencias para",
"Referer" , "Referencias",
"Referer_about" , "Referencias sobre",
"Referer_on" , "Referencias em",
"Referer_pages2" , "Paginas de referencias",
"Request" , "Solicitacao", 
"Requests" , "Solicitacoes", 
"Robots_excluding", "Robots excluidos",
"Robot_name", "Nome do Robot",
"Robot_session_exclude", "As sessoes de robots foram excluidas",
"Same_over_the_previous_day", "O mesmo que o dia anterior",
"Same_title", "Mesmo titulo",
"Scripts", "Scripts",
"Search_engine", "Motor de Pesquisa",
"Send_me_an", "Envie-me um",
"entry_pages" , "Paginas de entrada",
"exit_pages" , "Paginas de saida",
"Entry_pages" , "Paginas de entrada",
"Exit_pages" , "Paginas de saida",
"Server_tree", "Arvore do Servidor",
"Session", "Sessoes",
"Session_cut1", "se a sessao for maior que um dia, sessao vai ser contada apenas no primeiro dia",
"Session_cut2", "Podem ocorrer erros caso as sessoes durem mais de um dia",
"Session_length", "Titulo da sessao",
"Sessions" , "Sessoes",
"Sessions_from", "Sessoes de",
"Sorted_countries_list", "Lista de paises ordenada",
"Sorted_virtual_server_list", "Lista de servidores virtuais ordenada",
"Speed", "Velocidade",
"Stats_about_CPU", "Estatisticas do CPU",
"Stats" , "Estatisticas", 
"Stats_aboutMnth" , "Estatisticas de",
"Stats_about_HTML_files", "Estatisticas de ficheiros HTML",
"Stats_about_files_weight", "Estatisticas sobre o tamanho dos ficheiros",
"Stats_about_alt", "Estatisticas de ALT",
"Stats_about_errors" , "Estatisticas de erros", 
"Stats_about_host" , "Estatisticas de servidor", 
"Stats_about_hosts", "Estatisticas de servidores",
"Stats_about_images", "Estatisticas de imagens",
"Stats_about_internal_links", "Estatisticas de links internos",
"Stats_about_login", "Estatisticas de login",
"Stats_about_months" , "Estatisticas de meses", 
"Stats_about_robots_sessions", "Estatisticas de sessoes de robots",
"Stats_about_session_length", "Estatisticas sobre o tamanho das sessoes",
"Stats_about_sessions", "Estatisticas de sessoes",
"Stats_about_visits", "Estatisticas de visitas",
"Stats_about_virtual_servers", "Estatisticas de servidores virtuais",
"Stats_about_weeks" , "Estatisticas de semanas", 
"Stats_about_width", "Estatisticas de LARGURA e ALTURA",
"Stats_aboutlastdays1" , "Estatisticas dos ultimos dias",
"Stats_aboutlastdays2" , "dias",
"String", "String",
"Successful_pages" , "Paginas bem sucedidas",
"Summary", "Sumario",
"Symbolic_links", "Links Simbolicos",
"Tab_about_lastdays1" , "Tabela de dados sobre os ultimos dias",
"Tab_about_lastdays2" , "dias",
"Table" , "Tabela", 
"Text" , "Texto",
"Textual_version" , "Versao de texto",
"The_Top", "Os",
"Time", "Tempo",
"Total", "Total",
"Total_HTML_access", "Numero total de acessos HTML",
"Total_data_sent" , "Total de dados enviados",
"Total_number_of_directories", "Numero Total de directorias",
"Total_number_of_html_files", "Numero total de ficheiros HTML",
"Total_number_of_images", "Numero total de imagens",
"Total_number_of_images_in_files", "Numero total de imagens em ficheiros HTML",
"Total_number_of_links", "Numero total de links",
"Total_number_of_requests" , "Numero total de solicitacoes",
"Total_number_of_robot_session", "Numero total de sessoes de robots",
"Total_number_of_scripts", "Numero total de scripts",
"Total_number_sessions", "Numero total de sessoes",
"Total_traffic" , "Trafego total",
"Traffic" , "Trafego", 
"Traffic_about" , "Trafego de",
"Traffic_statistics" , "Estatisticas sobre o trafego",
"Tree", "Arvore",
"Useless_pages", "Paginas menos usadas",
"Users" , "Utilizadores",
"Virtual_servers", "Servidores Virtuais",
"You_should_add", "deveria adicionar",
"Web_size", "Tamanho Web",
"Week" , "Semana", 
"Weeks" , "Semanas", 
"Weight_HTML_files_histogram", "Historico do tamanho de ficheiros HTML",
"Weight_of_files", "Tamanho de paginass",
"With" , "com", 
"about" , "sobre", 
"about_hours_and_days", "sobre horas e dias",
"absolute_links", "links absolutos",
"added_pages", "se pretender adicionar uma das suas paginas aqui",
"all_sites", "todos os sites",
"among" , "entre", 
"and", "e",
"are_shown", "sao mostrados",
"average_HTML_accesses", "media do numero de acessos HTML",
"bad_links", "links em baixo",
"by", "por",
"by_day", "por dia",
"by_hour", "por hora",
"bytes" , "bytes",
"chronological_order", "ordem cronologica", 
"coming_from", "vindo de",
"computed_with", "Processadas por",
"connecting_to", "conectados em",
"connecting_to_the_server", "que se conectaram",
"countries", "paises",
"daily" , "diariamente",
"data_sent_for_dir" , "dados enviados para o directorio",
"day" , "dia",
"days", "dias",
"description", "descricao",
"different_images", "imagens diferentes",
"different_references_found", "diferentes referencias encontradas",
"directories" , "directorios",
"directory" , "directorio",
"domain", "dominio",
"engine_keywords_used", "palavras chaves mais procuradas",
"exceeding", "excedente",
"excluding", "excluidas",
"external" , "externo",
"files", "files",
"files_stored_locally_CD-ROM", "nesses links os seus ficheiros sao gravados localmente ou em CD-ROM",
"for_today" , "para hoje",
"from", "de",
"from_dom" , "do dominio", 
"from domain", "do dominio",
"from_outside", "de fora",
"global", "global",
"hTML_pages", "paginas HTML",
"have", "tem",
"host", "servidor",
"hosts", "servidores",
"hour" , "hora", 
"hours" , "horas", 
"images", "imagens",
"images_found_on_server", "imagens encontradas no servidor",
"in", "em",
"in_this_directory", "nesta directoria",
"in_whole_directory", "em toda a directoria",
"internal", "interno",
"less_than", "menos que",
"links", "links", 
"local", "local",
"maximum", "maximo",
"minimum", "minimo",
"minutes", "minutos",
"minute", "minuto",
"modified_less_than", "modificado menos que",
"monthly", "meses",
"more_than" , "mais que",
"most_common_errors" , "erros mais comuns",
"most_graphic_pages", "paginas com mais imagens",
"most_linky_pages", "paginas com mais links",
"most_succf_browsers_vtime1" , "Evolucao de",
"most_succf_browsers_vtime2" , "browsers mais utilizados",
"most_succf_browsers1" , "Os",
"most_succf_browsers2" , "browsers mais utilizados",
"most_weighty_pages", "paginas maiores",
"no_reference_found", "nenhuma referencia encontrada",
"not_defined", "nao definido",
"not_included", "nao incluido",
"of_different_hosts" , "de servidores diferentes",
"of_months" , "de meses",  
"on", "em",
"only_reading_time_below", "apenas com o tempo de leitura menor que",
"only_session_more_than", "apenas sessoes com mais que",
"optdirsize1" , "(externos e paginas HTML do dominio)",
"optdirsize2" , "(paginas HTML externas)",
"optdirsize3" , "(paginas HTML do dominio)",
"optdirsize4" , "(todas as solicitacoes e dominios externos)",
"optdirsize5" , "(todas as solicitacoes externas)",
"optdirsize6" , "(todas as solicitacoes do dominio)",
"page", "pagina",
"pages" , "paginas",
"pages_found_on_server", "paginas encontradas no servidor",
"percentage" , "percentagem", 
"read_by", "lidas por",
"referer_pages1" , "paginas de referencia",
"request" , "solicitacao", 
"requests" , "solicitacoes", 
"resolved_countries", "paises reconhecidos",
"scripts", "scripts",
"search_engine", "motores de busca",
"seconds", "segundos",
"session", "sessoes",
"sessions", "sessoes",
"since", "desde",
"sites", "sites",
"symbolic_links", "links simbolicos",
"text_only", "somente texto",
"the" , "a", 
"There_are", "Existem",
"times" , "vez(es)",
"to", "para",
"today", "hoje",
"top" , "mais :",
"top_external_sites" , "sites externos",
"top_local_sites" , "sites locais",
"total" , "total",
"total_data_sent_for" , "total de dados enviados para",
"total_for" , "para",
"traffic_in" , "trafego em",
"unknown", "desconhecido",
"unresolved", "nao identificados",
# "used", "usado no servidor",
"used", "consultadas",
"used2", "utilizadas",
"visitors", "visitantes",
"weekly", "semanas",
"weight", "peso",
"weighting", "peso",
"with_at_least", "com pelo menos",
"with_less_than", "com menos que",
"with_most_accesses", "com mais acessos",
"with_the_same_title", "com o mesmo titulo",
"without", "sem",
"without_title", "sem titulo",
"wrong", "errado"
 );
