#!/usr/bin/perl
# <plaintext>  just in case you look at this via a browser

#########################################################################
####                                                                #####
####                    BROWSERS STATS                              #####
####                                                                #####
####                                                                #####
####    domisse@w3perl.com                   version 20/06/2013     #####
####                                                                #####
#########################################################################

$version = "3.18";
$verdate = "20/06/13";

$debug = 0;
$scriptname = "cron-agent.pl";

## valeur a modifier par fixperlpath.pl

require "libw3perl.pl";

## TODO ipad and iphone in Macintosh ?

######### Recuperer $jour_of_year_end depuis la derniere ligne de datafile ?

$status_script = 0;

#if ($logfile_format eq "FTP" || $logfile_format eq "Exim" || $logfile_format eq "Sendmail" || $logfile_format eq "Postfix") {
if ($ftp_format == 1 || $mail_format == 1 || $cups_format == 1) {
    $status_script = 2;
    &error_exit("No agent stats can be done for FTP/Mail or CUPS logfile.\n",1);
}

$fileagentday = $path.$dirinc.$dirsep."agentday";
#$datafile = "time-agent";

$pos = rindex($conf_file,$dirsep);
$vtmp = substr($conf_file,$pos+1,length($conf_file));
#$pos = rindex($0,"-");
#$vtmp .= substr($0,$pos+1,length($0));
$vtmp .= $scriptname; 
$vtmp =~ s/$plext//g;

$listdailyagent = "liste_daily_agent";
$listdailycountries = "liste_daily_country";

if ($opt_y eq '') {
    print "<DIV CLASS=\"launch_script\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    $msg = "Agent stats : $version\n";
    &output_log($msg);
    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}
print "<DIV ID=\"TOGGLE_$scriptname\" STYLE=\"display:inline\">\n" if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '');

# Retrieve external log
&retrieve_external_logfile($fileroot,$remote_host_log) if ($retrieve_external_log == 1 && $opt_w eq '');

$starttime = time();
# calculer le temps mis pour le calcul
$startrun = "$hour:$minute:$second";

### NEWNEW
$separate = 0;
if ($prefixlog ne $agentlog && $agentlog ne '') {
    $separate = 1;
    $requetesize = "-";
    $prefixlog = $agentlog;    
} 

if ($logfile_format eq "Squid-Native" && $agentlog ne '') {
#    $notrafic = 1;
    $struct_logfile = "%host %date %hourshift %agent";
    undef %fields_logfile;
    @logfile_fields = split(/\s+/,$struct_logfile);
    for ($i=0;$i<=$#logfile_fields;$i++) {
	$fields_logfile{$logfile_fields[$i]} = $i;
    }
}

# debut de l'initialisation

if ($logfile_format ne "W3C" && $logfile_format ne "IIS" && $logfile_format ne "Webstar") {
    if ($struct_logfile !~ /\%agent/ && $agentlog eq '') {
	$msg = "The logfile format you have defined ($logfile_format) doesn't have an agent field\n";
	$msg .= "Use a format which includes such data (like ECLF)\n";
	&error_exit($msg,0);
    }
}

#if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
if ($struct_compressed_logfile =~ /\%hour/) {
    $real_deb = 1;
}


#if ($zipcut == 3 || ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/)) {
if ($zipcut == 3 || $struct_compressed_logfile =~ /\%hour/) {
    $filetmpzip = &find_last_log($fileroot,$prefixlog);
    $first_logfile = &find_first_log($fileroot,$prefixlog);

    if ($zipcut == 3) {
	if ($filetmpzip == -1 || $first_logfile == -1) {
	    if (!(-f "$fileroot$prefixlog")) {
		$status_script = 2;
		&error_exit("No file found in $fileroot\n",1);
	    } else {
		$zip = 0;
		$zipcut = 0;
	    }
	} else {
	    $rotate_inc = &find_index_way($filetmpzip,$first_logfile) if ($filetmpzip != -1 && $first_logfile != 1);
	}

	$rotate = $max_rotate_index if ($rotate_inc == -1);

	$zip = 0 if ($zipcut == 3 && $max_rotate_index == 1 && -f $first_logfile);

	if ($zipcut == 3 && $rotate !~ /^\d+$/) {
	    $msg = "Found a logfile I don't understand : $prefixlog$rotate.\nIndex should be a number (found the string '$rotate').\n";
	    $msg .= "Check the compression tool (\$zipext = \"$zipext\" and \$GZIP = \"$GZIP\")\n" if ($zip == 1 && $rotate !~ /$zipext$/);
	    &error_exit($msg,1);
	}
    }
}

#$yesterday = &yesterday_date($day,$countmonth,$year);
$yesterday = &date_intervalle($today,-1);       
$i = 0;
$count_day = 0;
$initday = 0;
$scan = 1;
$jour_of_year = 1;
$pastjour_of_year = 0;
$sizeold = 0;
$add_fields_login = 0;
$paysuniquejour = 0;

#$addit = 0;
$timesec = time;
#&get_time($timesec);
($date,$datehour,$datemisc) = &get_time($timesec);
#($jour_of_year_end) = split(/ /,$datemisc);

if ($struct_compressed_logfile !~ /\%hour/ && $struct_compressed_logfile !~ /\%min/ && $struct_compressed_logfile !~ /\%sec/) {
if ($zipcut == 2 || $zipcut == 1) {
$monthtmp = $month;
#$filetmpzip = $fileroot;
$month = $month_equiv{$month};
#$month++ if ($zipcut == 1);
$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
   $lettermonth = $month_nb[$month-1];
$smallyear = $year - int($year/100)*100;
$smallyear = "0".$smallyear if (length($smallyear) == 1);
$smallday = $day;
$smallday = substr($smallday,1,2) if ($smallday < 10);
$smallmonth = $month;
$datetmpzip = $year.$month.$day if ($zipcut == 2);
$datetmpzip = $year.$month if ($zipcut == 1);
$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
$filetmpzip = &Get_LogfileName($fileroot);
   $filetmpzip_day .= &nbday($date_filename);
$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
$month = $monthtmp;
}
}

	    
@linux_distrib = ('Mandriva','Mandrake','Ubuntu','Fedora','Debian','Red\s*Hat','Suse','Gentoo','Slackware','Knoppix','CentOS');
#@linux_distrib = ('Mandriva','Mandrake','Ubuntu','Fedora','Debian','Red\[ \]*Hat','Suse','Gentoo','Slackware','Knoppix','CentOS');

@main_os = ('Windows','Macintosh','Linux','Unix');
@main_unix_os = ('IRIX','SunOS','Freebsd','OpenBSD','NetBSD','AIX','OSF','VMS','HP-UX');

for ($i=0;$i<=$#main_os;$i++) {
    $main_os_string .= "^$main_os[$i]|";
}
chop($main_os_string);

#

for ($i=0;$i<=$#main_unix_os;$i++) {
    $main_unix_string .= "$main_unix_os[$i]|";
}
chop($main_unix_string);

#

for ($i=0;$i<=$#linux_distrib;$i++) {
    $distrib_string .= "$linux_distrib[$i]|";
}
chop($distrib_string);
@list_distrib = split(/\|/,$distrib_string);

# Load to get paysunique
#open(GENERAL,"$path$dirinc$dirsep$incgeneral") || die &error_exit("Error, unable to open $path$dirinc$dirsep$incgeneral");
#while (<GENERAL>) {
#    @tmp = split;
#    $paysunique = $tmp[23];
#}
#close GENERAL;

$firstjour = &find_first_date($prefixlog) if ($opt_s ne '');
#print "A - $firstjour\n";
#exit;

&init_geoip if ($netgeo == 1);
&init_geoipfree if ($geoip_free == 1);

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
#      print STDOUT "        -a                    : show all browser\n";
      print STDOUT "        -b                    : reset stats\n";
      print STDOUT "        -c <file>             : load configuration file\n";
      print STDOUT "        -d <nbdays>           : number of days to scan (Extended NCSA logifle only)\n"; 
      print STDOUT "        -g <nograph ";
      for ($i=0;$i<$#graphic;$i++) {
      print STDOUT "$graphic[$i] ";
      } 
      print STDOUT "$graphic[$#graphic]";
      print STDOUT "> : graphic output (choose one)\n";
      print STDOUT "        -l <";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      } 
      print STDOUT "$lang[$#lang]";
      print STDOUT ">            : language output (comma split)\n";      
      print STDOUT "        -i <file>             : input logfile\n";
      print STDOUT "        -f                    : scan only HTML files (Extended NCSA logfile only)\n"; 
      print STDOUT "        -s <date>    : starting date (dd/Mmm/yyyy)\n";
      print STDOUT "        -r <date>    : ending date (dd/Mmm/yyyy)\n";
      print STDOUT "        -t <toplist>          : display only toplist browsers\n";
      print STDOUT "        -x                    : show default value for flag options\n";
      print STDOUT "        -v                    : version\n";
      print STDOUT "        -z                    : zip logfiles\n";        
      print STDOUT "\n";
      exit;
}


if ($opt_v == 1) {
      print "$scriptname version $version $verdate\n";
      exit;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
#      print STDOUT "          -a            : ";
#      &id($opt_a);
      print STDOUT "          -b            : ";
      &id($opt_b);
      print STDOUT "          -c            : $configfile\n";
      print STDOUT "          -d <nbdays>   : $nbdays\n"; 
      print STDOUT "          -g <graphic>  : $graphic[0]\n";
      print STDOUT "          -l <language> : ";
      for ($i=0;$i<$#lang;$i++) {
      print STDOUT "$lang[$i],";
      }
      print STDOUT "$lang[$#lang]\n";
      print STDOUT "          -i <file>     : $fileagent\n";
      print STDOUT "          -f            : No\n";
      print STDOUT "          -s <date>     : $firstjour\n";
      print STDOUT "          -r <date>     : $yesterday\n";
      print STDOUT "          -t <toplist>  : $topten\n";
      print STDOUT "          -v            : $version\n";
      print STDOUT "          -z            : ";
      &id($opt_z);       
      exit;
}

# argument cmds line

if ($opt_z ne '') {
$zip = $opt_z;
}

if ($opt_i ne '') {
    $zip = 0;
$fileagent = $opt_i;
}


if ($opt_s) {
    if ($opt_s !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid starting date format (valid format is for example 02/May/1995)\n";
	&error_exit($msg);
    } else {
	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$day = $1;
	$lettermonth = $2;
	$month = $month_equiv{$lettermonth};
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	if ($month < 1 || $month > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	$year = $3;
	$fyear = $3;
	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date \n";
	    &error_exit($msg);
	}


	$smallyear = $year - int($year/100)*100;       
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	$fileagent = &Get_LogfileName($fileroot);
	$filezip = $fileagent.$zipext if ($zip == 1);

	$startday = $opt_s;
	$nbstartday = &nbday($opt_s);

	if ($nbstartday > $ydaytoday) {
	    print "Error ! This date belongs to the futur !\n";
	    &error_exit($msg);
	}

	# En attendant la gestion de $firstjour
	if ($firstjour ne '') {
	    if ($nbstartday < &nbday($firstjour)) {
		$msg = "Error ! Logfile is beginning later !\nI will compute from $firstjour instead\n";
		&output_log($msg);
		$startday = $firstjour;

		($day,$lettermonth,$year) = split(/\//,$firstjour);
		$month = $month_equiv{$lettermonth};
		$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
		
		$smallyear = $year - int($year/100)*100;              
		$smallyear = "0".$smallyear if (length($smallyear) == 1);
		$fileagent = &Get_LogfileName($fileroot);
		$filezip = $fileagent.$zipext if ($zip == 1);
	    }
	} else {
	    if (!(-f $fileagent) && !(-f $filezip)) {
		$msg = "Starting file $file does not exist\n";
		&error_exit($msg);
	    }
	}
    }

    if ($zipcut == 3) {
	$fileagent = &find_index_log($fileroot,$prefixlog,$startday);
	$filezip = $fileagent.$zipext if ($zip == 1);
    }

}

$stopday = $today;

if ($opt_r) {

    if ($opt_r !~ /(\d{2})\/(\w{3})\/(\d{4})/) {
	$msg = "Not a valid ending date format (valid format is  for example 02/May/1995)\n";
	&error_exit($msg);
    } else {

	if ($1 < 1 || $1 > 31) {
	    $msg = "Day should be between 1 and 31 !\n";
	    &error_exit($msg);
	}

	$tmp = $month_equiv{$2};
	$tmp = "0".$tmp if (length($tmp) == 1);
	if ($tmp < 1 || $tmp > 12) {
	    $msg = "Month should be between Jan and Dec !\n";
	    &error_exit($msg);
	}

	if ($fullyear < $3) {
	    $msg = "Year should be less than the current date !\n";
	    &error_exit($msg);
	}

	$stopday = $opt_r;
	$nbstopday = &nbday($opt_r);

	if ($nbstopday > $ydaytoday) {
	    $msg = "Error ! Cannot compute futur !\nI will compute till $yesterday instead\n" ;
	    &output_log($msg);
	    $stopday = $yesterday;
	    $stopday =~ s/ /\//g;
	}
    }

    if ($zipcut == 3) {
	$tmp = $rotate;
	$filetmpzip = &find_index_log($fileroot,$prefixlog,$stopday);
	$filetmpzip = $filetmpzip.$zipext if ($zip == 1);
	$rotate = $tmp;
    }

}


if ($opt_s && $opt_r) {
    if ($nbstopday < $nbstartday) {
	$msg = "Ending date should be later than the starting date !\n";
	&error_exit($msg);
    }
}


if ($opt_t ne '') {
    $topten = $opt_t;
}

if ($opt_d ne '') {
    $nbdays = $opt_d;
    if ($file ne $fileagent) {
	$msg = "Only extended NSCA logfile !!!\nThis switch \"-d\" has no effect.\n";
	&output_log($msg);
    }

}

if ($opt_l ne '') {
  @lang = split(/, /,$opt_l);
  for ($i=0;$i<=$#lang;$i++) {
      $tmp = $dirress.$dirsep."lang".$dirsep.$lang[$i].$plext;
      $tmp = $pathinit.$tmp;
      require "$tmp";
  }
  if ($lang[0] eq '') {
      &error_exit("\nNone of your language choices have been yet translated !\n",1);
      }
}


# switch

if ($opt_g ne '') {
  print STDERR "Only extended NSCA logfile !!!\nThis switch \".$opt_g.\" has no effect.\n" if ($file ne $fileagent);
  if ($opt_g eq "nograph")  {
      $nograph = 1;
  }
  if ($opt_g eq "3d")  {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 1;
  }
  if ($opt_g eq "fill") {
      $bargraph = 0;
      $linegraph = 1;
      $fillgraph = 1;
  }
  if ($opt_g eq "line") {
      $bargraph = 0;
      $linegraph = 1;
  }
  if ($opt_g eq "bar") {
      $bargraph = 1;
      $linegraph = 0;
      $tridim = 0;
  }
}

if ($opt_f == 1 && $file ne $fileagent) {
    print "Only extended NSCA logfile !!!\nThis switch \"-f\" has no effect.\n";
    &output_log($msg);
}

###################################################################

if ($zipcut == 0 && $zip == 0) {
    &error_exit("Agentlog file $fileagent not found\nAre you sure your server produce one ?\n\n",1) unless (-f $fileagent);
}
$nbline = 0;

if ($fly_set == 1) {
    $agentgraph = $path.$dirgraph.$dirsep."agent".$gifext;
    $agentgraphx = $path.$dirgraph.$dirsep."agentx".$gifext;
    $agentgraphy = $path.$dirgraph.$dirsep."agenty".$gifext;

    $linkagentgraph = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agent".$gifext;
    $linkagentgraphx = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agentx".$gifext;
    $linkagentgraphy = "..".$dirsepurl."..".$dirsepurl.$dirgraph.$dirsepurl."agenty".$gifext;
}

$others = "others".$gifext;

#$reverse_dns = 0 if ($nolog eq '');
$w3c_agent = 0;

&MakeDirectories;

$linkpath_url = &Extract_WebUrlLink if ($linkpath_url eq '');

#################################################################
####                   date de ce jour                    #######
#################################################################

if ($file eq $fileagent || $type_serveur == 2) {

    $month_number = $month_equiv{$month};
    $month_number--;

### nombre de jour entre le 1er janvier et $today

    $timesec = time;
#    &get_time($timesec);
    ($date,$datehour,$datemisc) = &get_time($timesec);
    ($jour_of_year_end) = split(/ /,$datemisc);


### date il y a $nbdays jours

    if ($nbdays != 0) {

	$pasttoday = &date_intervalle($today,-$nbdays);
	($pastday,$pastmonth,$pastyear) = split(/ /,$pasttoday);
	$pastmonthnb = $month_equiv{$pastmonth};

	$pastjour_of_year = &nbday($pasttoday);
	print "DATE il y a $nbdays days : $pasttoday ($pastjour_of_year)\n" if ($debug == 1);
    }

    if (($pastyear%4 == 0 && $pastyear%100 != 0) || $pastyear%400 == 0) {
	$pastbisextil = 1;
    }

    $jour_of_year_end++ if ($pastbisextil == 1);
}

$size = -s $fileagent;
if ($size == 0 && -f $fileagent) {
    &error_exit("Your logfile $fileagent is empty !\n",2);
}

if ($size < 0) {
    $msg = "Problem with logfile size\n";
    $msg .= "You should upgrade to the latest Perl version to be able to handle file larger than 2 Gb\n";
    $msg .= "or split your logfile under the 2 Gb limit\n\n";
    &error_exit($msg,1);
}

#############################################################################

&load_reverse_dns if ($reverse_dns == 1); # chargement de la table de DNS

if ($exclude_robot == 1) {
    &LoadRobot($opt_w);
}

if ($exclude_refererspam == 1) {
    if ($opt_w == 1) {
	&LoadReferSpamList;
    } else {
#	&LoadReferSpamByIP;
	&LoadReferSpamByKeyword;
	&LoadReferSpamByDomain;
    }
}

#################################################################
#######        chargement des anciennes valeurs      ############
#################################################################

$opt_b = 1 if (!(-f "$path$dirinc$dirsep$incbrowser"));

if ($opt_b != 1 && $opt_d eq '') {

    if (-f "$path$dirinc$dirsep$incbrowser") {

	open(OUT,"$path$dirinc$dirsep$incbrowser") || &error_exit("Unable to open $path$dirinc$dirsep$incbrowser",1);
	$a = (<OUT>);
	($nbline,$sizeold,$firstday,$oldjour) = split(/\t/,$a);
	chop($oldjour);
#	print "LINE : $nbline - $firstday - $oldjour\n";
	while (<OUT>) {
	    ($browser,$nb) = split(/\t/);
	    chop($nb);
	    $nbre{$browser} = $nb;
	    $unique++;
	    $browser[$unique] = $browser;
	}
	close(OUT);    
	
	($pastday,$pastmonth) = split(/ /,$firstday);
	$jour_of_year = &nbday($firstday);
	$jour_of_year_first = $jour_of_year; 

	open(OUT,"$path$dirinc$dirsep$incos") || &error_exit("Error, unable to open $path$dirinc$dirsep$incos",1);
	$count = (<OUT>);
	chop($count);
	while (<OUT>) {
	    $tmp = ($os,$nb,$tmp2) = split(/\t/);
	    if ($tmp == 2) {
		chop($nb);
		$nbreos{$os} = $nb;
		$uniqueos++;
	    }
	    if ($tmp == 3) {
		chop($tmp2);
		$distrib{$nb} = $tmp2;
	    }
	}
	close(OUT);    

	open(OUT,"$path$dirinc$dirsep$dayagent") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayagent",1);
	while (<OUT>) {
	    (@uni) = split;
	    for ($i=0;$i<=$#uni;$i++) {
		$evolbrowser[$count_day][$i+1] = $uni[$i];
	    }
	    $count_day++;
	}
	close (OUT);
	$count_day--;
	
	for ($i=1;$i<=$unique;$i++) {
	    $nbreday{$browser[$i]} = $evolbrowser[$count_day][$i];
	}
    }
}

# load inc day data

#if (-f $fileagentday && $opt_d eq '' && $opt_b != 1 && $struct_logfile =~ /\%agent/) {
if (-f $fileagentday && $opt_d eq '' && $opt_b != 1) {
#if (-f $fileagentday && $opt_d eq '' && $opt_b != 1 && $agentlog eq $prefixlog) {
#print "Loading daily incremental data : $fileagentday\n";
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

    open(FILEDAYAGENT,"$fileagentday") || &error_exit("Error, unable to open $fileagentday",1);

    $tmp = <FILEDAYAGENT>;
    chop($tmp);

    ($yesterday,$countday) = split(/\t/,$tmp);
    $oldjour = $yesterday;
    $loadinc = 1;
    $nb = 0;

    while (<FILEDAYAGENT>) {
	($tmp,$tmp1,$tmp2) = split(/\t/);
	chop($tmp2);
	
	if ($tmp eq "A") {
	    $nbrebrowserday{$tmp1} = $tmp2;
	    $uniqueday++;
	}
	
	if ($tmp eq "B") {
	    $nbreosday{$tmp1} = $tmp2;
	    $uniqueosday++;
	}

	if ($tmp eq "C") {
	    chop($tmp1);
	    $nb++;
	    $browserday[$nb] = $tmp1;
	}
    }
    close (FILEDAYAGENT);
}

$loadinc = 1 if ($zipcut == 1 || $zipcut == 2);

#print "A - $oldjour - $yesterday - $fileagentday\n";

#################################################################
###                     gzip log file                         ###
#################################################################

#$yeartmp = $year;

if (($zip == 1 || $zipcut != 0) && (($opt_b == 1) || ($nbline == 0))) {

    $day = $daytmp;
    $month = $monthindex;
    $monthprev = $month-1;
#    $yyear = $year;
    $year = $fyear;

   # detection du premier mois de log zipe
    
    while ($out == 0) {
	$tmp++;
	if ($zipcut == 2) {
	    $day++;
	    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
	    if ($day > $month_of_year{$month_nb[$monthprev]}) {
		$month++;
		$monthprev++;
		$day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		$day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
	    }
	}
	$month++ if ($zipcut == 1);
	$monthprev++ if ($zipcut == 1);       
	$year++ if ($month == 13);
	$month = "1" if ($month == 13);
	$month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	$monthprev = 0 if ($month == 1);
	$lettermonth = $month_nb[$monthprev]; 
	if ((($year ==  $fullyear && $month > $monthindex) || ($year > $fullyear)) && $zipcut != 0) {
	            $msg = "No gziped files found !\n\n" if ($zip == 1);
		    $msg = "No log files found !\n\n" if ($zip != 1);
		    &error_exit($msg,1);
	}

	$smallyear = $year - int($year/100)*100;
	$smallyear = "0".$smallyear if (length($smallyear) == 1);
	
	$smallday = $day;
	$smallmonth = $month;
	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
	$fileagent = &Get_LogfileName($fileroot);
#	$real_deb = 1 if ($fileagent eq $file_re);
	$out = 1 if ($fileagent eq $first_logfile && !(-z $first_logfile) && $real_deb == 1 && $zip == 0);
	$out = 1 if (-e $fileagent && !(-z $fileagent) && $real_deb == 0 && $zip == 0);
	$filezip = $fileagent.$zipext if ($zip == 1);
	$out = 1 if (-e $filezip && !(-z $filezip) && $zip == 1);
	if ($zipcut == 3 && $filetmpzip eq $fileagent && $rotate == 0) {
	    $out = 1;
	    $zip = 0;
	    $filezip = $fileagent;
	}
	# if larger then (today-1996)*366 for daily logfiles
	if ($tmp > 5000) {
	    $msg = "No logfile found\n";
	    $msg .= "Are you sure you are using compressed logfile ?\n" if ($zip == 1);
	    &error_exit($msg,1);
	}
    }
#        until (-e $filezip || -e $fileagent);

    $lastfile = $fileagent;
    $lastfilezip = $filezip;
    $stop = 0;
    $fyear = $year;
#    $year = $yyear;
}

#################################################################
#####               computing agent stats                  ######
#################################################################

$line_parsed = 0;
$no_agent = 0;
$agent_found = 0;
($ds1,$ds2,$ds3) = split('/',$startday);                                                                                      
($de1,$de2,$de3) = split('/',$stopday);                                                                                       
$mds2 = $month_equiv{$ds2};                                                                                                   
$mde2 = $month_equiv{$de2};          

if ($opt_s ne '' && $opt_i eq '' && $zipcut == 2) {

    ($ds1,$ds2,$ds3) = split('/',$startday);
    $day = $ds1;
    $month = $month_equiv{$ds2};
    $lettermonth = $ds2;
    $year = $ds3;

    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);

    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;
    $file = &Get_LogfileName($fileroot);
    $filezip = $file.$zipext if ($zip == 1);
}

if (($zip == 1 || $zipcut != 0) && ($opt_b != 1 || $opt_d ne '')) {

    $tmpjour = &date_intervalle($oldjour,1);
    if ($opt_d eq '') {
	if ($zipcut == 1 || $zipcut == 2) {
	    ($day,$month2,$year) = split(' ',$tmpjour);
	} else {
	    ($day,$month2,$year) = split(' ',$oldjour);
	}
    }
    ($day,$month2,$year) = split(' ',$pasttoday) if ($opt_d ne '');	

    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    $month = $month_equiv{$month2};
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $lettermonth = $month2;
    $out = 0 if (!(-f $fileagent));
    while ($out == 0 && (($year <=  $fullyear) || (($year == $fullyear) && $month <= $monthindex))) {
	
	$fyear = $year;
        $smallyear = $year - int($year/100)*100;
        $smallyear = "0".$smallyear if (length($smallyear) == 1);
	$smallday = $day;
	$smallmonth = $month;
	
	$date_filename = $day.$dirsepurl.$lettermonth.$dirsepurl.$year; # Format XX/Mmm/YYYY
#	print "A $year <=  $fullyear - $year == $fullyear && $month <= $monthindex\n";
	$fileagent = &Get_LogfileName($fileroot);
#	print "A $fileagent\n";
	$filezip = $fileagent.$zipext if ((!(-f $fileagent)) && $zip == 1);
	$filezip = $fileagent.$zipext if ($retrieve_external_log == 1 && $zip == 1); # NEW
#	$real_deb = 1 if ($fileagent eq $file_re);
	$out = 1 if (-f $fileagent || -f $filezip);
        if (!(-f $filezip) && !(-f $fileagent)) {
	    if ($zipcut == 2) {
                $day++;
		$day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
                if ($day > $month_of_year{$month_nb[$month-1]}) {
		    $month++;
		    $day = "1" if ($struct_compressed_logfile =~ /\%smallday/);
		    $day = "01" if ($struct_compressed_logfile !~ /\%smallday/);
		}
	    }
	    $month++ if ($zipcut == 1);
	    $year++ if ($month == 13);
	    $month = "1" if ($month == 13);
	    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
	    $lettermonth =  $month_nb[$month-1];
	}
    }
    if ($out == 0 && $opt_d ne '') {
	$msg = "No logfile found - Choose an older date";
	&error_exit($msg,1);
    }
}   


#print "AA1 $zipcut - $pasttoday- $oldjour\n";
#if ($zipcut == 3 && $opt_b eq '' || $real_deb == 1) {
#if ($zipcut == 3 && $opt_d ne '' || $real_deb == 1) {
if ($zipcut == 3 || $real_deb == 1) {
    $fileagent = &find_index_log($fileroot,$prefixlog,$pasttoday) if ($opt_d ne '' && $pasttoday ne '');
    $fileagent = &find_index_log($fileroot,$prefixlog,$oldjour) if ($opt_d eq '' && $oldjour ne '');
#    $fileagent = &find_index_log($fileroot,$prefixlog,$oldjour) if ($opt_d eq '');
#    print "A1 - $fileagent - $pasttoday\n";
#    $filezip = $fileagent;
#    $filezip = $fileagent.$zipext if ($zip == 1 && -f "$fileagent$zipext");
    $filezip = $fileagent.$zipext if ($zip == 1);
}

$fileagent = $fileroot.$prefixlog if (!(-f $filezip) && !(-f $fileagent));

#if ($opt_b != 1 && $opt_d eq '' && $zipcut == 3 && -f "$path$dirinc$dirsep$incbrowser") {
#    $fileagent = $fileroot.$prefixlog;
#    $filezip = $fileagent;
#    $zip = 0;
#}

if ($zipcut != 1 && $zipcut != 2 && $size < $sizeold) {
    $nbline = 0;
    $msg = "Your logfile $fileagent have been cut\n";
    &output_log($msg);
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

if (-f $filezip && -f $fileagent && $retrieve_external_log == 1) {
    unlink($fileagent);
}

#unlink($file) if (-f $filezip && -f $file && $retrieve_external_log == 1);

#&flush(STDOUT);
#$|=1;


while ($stop == 0) {

    $skipl = 0;

    if ($count_day != 0 && $loadinc == 0 && $zipcut != 3) {

	$skipl = 1;

	($tmp4,$tmp2,$tmp3) = split(/ /,$oldjour);
	$jour_listdate = $tmp4." ".$tmp2." ".$tmp3;
	$dirresume = $tmp3."-".$tmp2."-".$tmp4;	

	if ($paysuniquejour == 0) {

	    if (-f "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$dirpays$htmlext") {
		$paysuniquejour = 1;
	    } else {
		
		$pays = "Unknown";
    
		if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
		    $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
		}
		if ($pays eq "Unknown" && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 1) {
		    $pays = &get_geoip($adresse) if ($netgeo == 1);
		    $pays = &get_geoipfree($adresse) if ($geoip_free == 1);
		}
		$paysuniquejour++ if ($pays ne "Unknown" && $pays ne '');
	    }
	}


#	print "Save1 - $jour - $oldjour - $oldoldjour\n";
	if ($struct_logfile =~ /\%agent/) {
	    &save_daily_agent;
	}

	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {	       
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
#		    $bro_ver =~ /(\d)+/;
		    $bro_ver =~ /(\d+\.\d\d*)/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen{"$tmp1 $oldjour"}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
# tri des $topten browser les plus frequents

	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

#

	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};

		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}
	
# OS

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}
	
       ###

	&BuildDailyAgentResume($scriptname,0);

#	push(@listdate,$dirresume);
	push(@listdate,$jour_listdate);
#	print "TI1 - $dirresume\n";
	undef %new_osday;

	for ($i=1;$i<=$unique;$i++) {
	    $evolbrowser[$count_day][$i] = $nbreday{$browser[$i]};
#	    print "A - $nbreday{$browser[$i]} - $browser[$i]\n";
	}

	undef %nbreday;

	###

	for ($i=0;$i<=$unique_new_browserday;$i++) {
	    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
		$browser_versionday{$bestbrowserday[$i],$l} = '';
	    }
	}

	undef %new_browserday;
	undef %nbrebrowserday;
	undef %nbreosday;
	undef %browser_version_nbday;
	undef %browser_versionday;
#	undef $bestbrowserday;
#	undef $occurbrowserday;
	undef @bestbrowserday;
	undef @occurbrowserday;
	
	$unique_new_browserday = 0;
	
	$countday = 0; # if ($nb eq '');
	$uniqueday = 0;
	$uniqueosday = 0;
	$unique_new_osday = 0;	
	$scan = 1;
	$tmp = $month_nb[$month-1];
	$oldjour = $tmp4." ".$tmp." ".$year;
	$oldoldjour = $oldjour;
	$count_day++;
	$nbline = 0;
    }

    $loadinc = 0;

    if ($ENV{'REQUEST_METHOD'} ne "GET") {
	for ($i=1;$i<=$starnb;$i++) {
	    print "\x08 \x08";
	}
}

if ($mode_lb == 0) {
    if (($zip == 1) && (-f $filezip) && ((($fileagent ne $filezip) && ($nbline == 0 || $opt_b == 0)) || ($zipcut == 2))) {
#if (($zip == 1) && ((($fileagent ne $filezip) || ($nbline == 0)) || ($zipcut == 2))) {
	if ($zipcut != 3) {
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    &error_open($filezip) if (!(-r $filezip));
	    $line_file = &line_file($filezip);
	    if ($filezip =~ /$zipext$/) {
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
	    } else {
		open(INFILE,$filezip) || &error_exit("Error, unable to open $filezip",1);
	    }
	    $msg = "Scanning $filezip\n";
	    &output_log($msg);
	} else {
	    # Apache rotate, trying uncompressed file
#	    &retrieve_external_logfile($fileroot,$remote_host_log,$filezip) if ($retrieve_external_log == 1);
	    if (-r $filezip) {
		$line_file = &line_file($filezip);
		open(INFILE, "$GZIP $filezip |") || &error_exit("Error, unable to open $filezip",1);
		$msg = "Scanning $filezip\n";
		&output_log($msg);
	    } else {
#		&retrieve_external_logfile($fileroot,$remote_host_log,$fileagent) if ($retrieve_external_log == 1);
		&error_open($fileagent) if (!(-r $fileagent));
		$line_file = &line_file($fileagent);
		open(INFILE,$fileagent) || &error_exit("Error, unable to open $fileagent",1);
		$msg = "Scanning $fileagent\n";
		&output_log($msg);
	    }
	}

#       print "$filezip file...\n";
#       open(INFILE, "$GZIP $filezip |") || die "Error, unable to open $filezip\n";
    } else {

	if (!(-f $fileagent)) {
	    $msg = "No current logfile $fileagent found\n\n";
	    &output_log($msg,0);
	    exit;
	}
#	&retrieve_external_logfile($fileroot,$remote_host_log,$fileagent) if ($retrieve_external_log == 1);
	&error_open($fileagent) if (!(-r $fileagent) && -s $fileagent);
	$line_file = &line_file($fileagent);
	$msg = "Scanning $fileagent\n";
	&output_log($msg);
	open(INFILE,$fileagent) || &error_exit("Error, unable to open $fileagent",1);
    }
} else {
	    $log_loadbalancing = "";
	    for ($load_iter=0;$load_iter<=$#fileroot;$load_iter++) {
		$file_lb = $fileagent;
		$file_lb .= $zipext if ($zip == 1);
		$file_lb =~ s/$fileroot//;
		$log_loadbalancing .= "$fileroot[$load_iter]$file_lb\n";
	    }
	    chop($log_loadbalancing);
#	    print "DEBUG $logresolvemerge_bin $log_loadbalancing\n";
	    print "Scanning $log_loadbalancing\n";
	    open(INFILE,"$logresolvemerge_bin $log_loadbalancing |");
    }

    $line_bar_file = 100 if ($reverse_dns == 0);
    $line_bar_file = 1000 if ($reverse_dns == 1);
    $line_file_step = int(($line_file/$line_bar_file)+.5);
      
    if ($ENV{'REQUEST_METHOD'} eq "GET" && $line_file > $line_bar_file) {
	$barfiletmp = $fileagent;
	$barfiletmp =~ s/$fileroot//;
	$barfiletmp =~ s/\.//g;
	&InitProgressBar($barfiletmp,$scriptname,$reverse_dns);
    }

    $line = 0;
    $year = $fyear if ($opt_d eq '' && $fields_logfile{'%date'} eq '');
    $starnb = 0;

  BOUCLE:
    while (<INFILE>) {

	$loglines_read++;
	$line++;
	if ($line_file > $line_bar_file) {
	    if (int($line/$line_file_step) == ($line/$line_file_step)) {
		$line_percent = int(100*($line+1)/$line_file);
		# Write status in a file called 'status.txt' => scriptname - $line_percent
		open(FILESTATUS,">$path$incstatus$txtext");
		print FILESTATUS "$scriptname\t$line_percent\t$status_script\n";
		close(FILESTATUS);
		if ($ENV{'REQUEST_METHOD'} eq "GET") {
		    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
		    print "$barfiletmp.setPercentage('+1');\n" if ($reverse_dns == 0);
		    print "$barfiletmp.setPercentage('+0.1');\n" if ($reverse_dns == 1);
		    print "</script>\n";
		} else {
		    if ($zipcut == 2 && $real_deb == 0) {
			$starline++;

			if (($starline == 5 && $reverse_dns == 0) || ($starline == 50 && $reverse_dns == 1)) {

			    $starnb++;
			    $tmp = $starnb*5;
			    print "* $tmp%";

			    print "\x08\x08\x08" if (length($tmp) == 1);
			    print "\x08\x08\x08\x08" if (length($tmp) == 2);
			    print "\x08\x08\x08\x08\x08" if (length($tmp) == 3);
			    
			    $starline = 0;
			}
		    }
		}

	    }
	}

#	print "OO $line - $nbline\n";

	next BOUCLE if (-f "$path$dirinc$dirsep$incbrowser" && $opt_b != 1 && $line <= $nbline && $zipcut != 1 && $zipcut != 2);

#	if ($struct_logfile =~ /\%/ && $agentlog eq '') {
	    
	@line_log = split(/$logfile_sep/);
	chomp($line_log[$#line_log]);
	if ($line_log[$#line_log] =~ /\r\n$/) {
	    $dos_format = 1;
	    chop($line_log[$#line_log]);
	}
	if ($line_log[0] =~ /^\#Fields:/ || $line_log[0] =~ /^\!\!LOG_FORMAT/) {
	    if ($logfile_format eq "IIS") {
		# Error ! This is W3C !
		$msg = "W3C logformat detected\nYour config file show IIS\nChange \$logfile_format to W3C.";
		&error_exit($msg,1);
	    }
	    $struct_logfile = &detect_w3c_logformat($_);
	    open(FILESTATUS,">$path$incstatus$txtext");
	    print FILESTATUS "$scriptname\t100\t$status_script\n";
	    close(FILESTATUS);
	    if ($ENV{'REQUEST_METHOD'} eq "GET") {
		print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
		print "$barfiletmp.setPercentage('99');\n";# if ($reverse_dns == 0);
#		    print "$barfiletmp.setPercentage('+0.1');\n" if ($reverse_dns == 1);
		print "</script>\n";
	    }
	    last BOUCLE if ($struct_logfile !~ /\%agent/);
	    $w3c_agent = 1;
	}
	
	next if ($line_log[0] =~ /^\#/ || $line_log[0] =~ /^\!/);

	if ($struct_logfile =~ /\%/) {
	    $add_fields_login = 0;
	    $add_fields_login = &LoginWithSpace(@line_log) if ($line_log[$fields_logfile{'%login'}] =~ /^\"/);
	    $add_fields_login = &LoginWithSpaceCups(@line_log) if ($cups_format == 1);
	    $date = $line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_login];
	    $date =~ s/\[//;
	    $date = &date_squid($date) if ($date =~ /\d{9}\.\d{3}/);
	    $date = &date_common($line_log[$fields_logfile{'%date'}+$fields_after_login{'%date'}*$add_fields_login],$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_login]) if ($fields_logfile{'%time'} ne '');
	    $date = $date_filename.":".$line_log[$fields_logfile{'%time'}+$fields_after_login{'%time'}*$add_fields_login] if ($fields_logfile{'%date'} eq '');
	    next if ($date !~ m/^((\d+)\/(\w+)\/(\d\d\d\d):)(.*)/);
	    $adresse = $line_log[$fields_logfile{'%host'}+$fields_after_login{'%host'}*$add_fields_login] if ($fields_logfile{'%host'} ne '');
	    $adresse =~ s/^::ffff://; # Ipv6
	    next if ($adresse =~ /:/ && $ipv6_skip == 1);
	    next if ($adresse =~ /[0-9]+$/ && $ipv4_skip == 1);
	    $page = $line_log[$fields_logfile{'%page'}+$fields_after_login{'%page'}*$add_fields_login] if ($fields_logfile{'%page'} ne '');
#	    $page =~ s/$ftpserver// if ($ftpserver ne '' && $ftp_format == 1);
	    $page =~ s/\/\//\// if ($page !~ /^https?:\/\//);
	    $page =~ s/\%3C.*\%3E//gi;

	    $page =~ s/^https?:\/// if ($squid_format == 1 || $virtualCLF == 1);
	    $page =~ s/\/\//\//g;
	    $vserver = '';
	    $vserver = $1 if ($page =~ /^\/([-.0-9a-z]+)\//i && $squid_format == 1);
	    $page =~ s/^$pathserver//i;
	    $page = &remove_empty_dir($page);
	    
	    $method = $line_log[$fields_logfile{'%method'}+$fields_after_login{'%method'}*$add_fields_login] if ($fields_logfile{'%method'} ne '');
	    $query = $line_log[$fields_logfile{'%query'}+$fields_after_login{'%query'}*$add_fields_login] if ($fields_logfile{'%query'} ne '');     
#	    $status = $line_log[$fields_logfile{'%status'}+$add_fields_login] if ($fields_logfile{'%status'} ne '');
	    $status = $line_log[$fields_logfile{'%status'}+$fields_after_login{'%status'}*$add_fields_login] if ($fields_logfile{'%status'} ne '' && $separate == 0);

#	    next if (length($method) > 8);
	    $method =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	    next if ($method =~ /https?:\/\//i);
	    next if ($method =~ /CONNECT/);

	    if ($notrafic == 0 && $separate == 0) {
#	    if ($notrafic == 0) {
		$requetesize = $line_log[$fields_logfile{'%requetesize'}+$fields_after_login{'%requetesize'}*$add_fields_login+$fields_after_agent{'%requetesize'}*$add_fields_agent] if ($mail_format == 0);
		$requetesize = $1+$2 if ($requetesize =~ /(\d+)\+(\d+)/);
		next if ($requetesize !~ /^\d+$/ && $requetesize ne "-" && $ftp_format == 0);
	    }
	    $vserver = $line_log[$fields_logfile{'%virtualhost'}+$fields_after_login{'%virtualhost'}*$add_fields_login] if ($fields_logfile{'%virtualhost'} ne '');
	    $vserver = $line_log[$#line_log] if ($#logfile_fields == $fields_logfile{'%virtualhost'});
	    $vserver = $1 if ($page =~ /^\/([-.0-9a-z]+)\//i && $virtualCLF != 0);
	    $page =~ s/\/\/$virtualfilter// if (($virtualCLF != 0 && $virtualfilter ne '') || ($method =~ /$localserver/));
#	    $page =~ s/^https?:\/// if ($squid_format == 1);

	    next if ($status !~ /^(\d+)$/ && $status ne '');
	    next if ($page =~ /$dirsepurl[_]/ && $fields_logfile{'%page'} ne '' && $type_serveur == 1);

	    $page =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	    $page =~ tr/[A-Z]/[a-z]/ if ($type_serveur == 1);    
	    $page = $page."?".$query if ($query ne '' && $query !~ /^-,*/);

	    next if ($page !~ m#$tri#i && $tri ne '/'); # stats sur une partie du serveur
	    next if ($page =~ m#$tri_exclude#i && $tri_exclude ne ''); # stats sur une partie du serveur
	    next if ($page =~ /$dirsepurl[_]/ && $type_serveur == 1 && $mail_format == 0);
	    next if ($page =~ /$excluderepert/i && $excluderepert ne '');
	    next if ($page !~ /\.(s)?htm(l)?/i && $opt_f == 1);
	    next if (($page =~ /^https?:\/\// || $page eq '') && $mail_format == 0); # (proxy)

	    $reverse_dns = 0 if ($reverse_dns == 1 && $adresse !~ /[0-9]+$/ && $adresse !~ /:/);

#	    $adresse = $nis{$adresse} if ($nis{$adresse} ne '');
#	    $adresse = $revdns{$adresse} if ($reverse_resolv == 1 && $revdns{$adresse} ne '' && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
	    $adresse = $revdns{$adresse} if ($revdns{$adresse} ne '' && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
	    $adresse = &reversedns($adresse) if ($reverse_dns == 1 && $revdns{$adresse} eq '' && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/));
	    $adresse = $adresse.".".$localdomainename if ($adresse !~ /\./ && $localdomainename ne "localhost" && $adresse !~ /:/ && $adresse !~ /[0-9]+$/);
	    $adresse =~ tr/[A-Z]/[a-z]/;

	    next if (($adresse =~ /$localdomaine/o) && ($locallog == 0));
	    next if (($adresse !~ /$localdomaine/o) && ($localonly == 1));
	    next if (($adresse =~ /$nolog/i) && ($nolog ne ''));

#	    if ($squid_format != 1 && $mail_format != 1) {
#		next if ($page =~ /\"$/ && $iis_format != 1); # all format should be %page %protocol
#		next if ($d !~ /^\"/ && $iis_format != 1); # all format should be %page %protocol
#	    }

	    ($tmp) = split(/:/,$date);
	    ($daytoday,$monthtoday,$yeartoday) = split(/\//,$tmp);
	    $yesterday = "$daytoday $monthtoday $yeartoday";
	    next if ($month_equiv{$monthtoday} !~ /(\d+)/);
	    next if (length($yeartoday) != 4);
	    next if ($adresse eq '' || $adresse eq '.');

	    if ($adresse =~ /\//) {
		($tmp,$adresse) = split(/:/,$adresse);
		$msg = "Problem : found $tmp ... fixing done\n";
		&output_log($msg);
	    }
	    
	    $i = $fields_logfile{'%agent'};
	    $f = $line_log[$i+$fields_after_login{'%agent'}*$add_fields_login];

	    $line_parsed++;
	    if ($f =~ /^\d+/ || ($f =~ m/[<>]/) || ($f !~ /^\"/ && $iis_format != 1)) {
		$no_agent++;
		next BOUCLE;
	    }


	    $f = &GetAgentString($f,$i);
#	    $add_fields_agent -= $i;

	    if ($exclude_robot == 1) {
		$foundrobot = 0;

		if ($opt_w eq '') {
		    $foundrobot = &ExcludeRobot($adresse) if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/);
		    $foundrobot = &ExcludeRobot($f) if ($foundrobot == 0);
		} else {

		    if ($robot_list ne '' || $robot_list_ip ne '') {
			if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
			    $foundrobot = 1 if ($adresse =~ /$robot_list/);
			} else {
			    $foundrobot = 1 if ($adresse =~ /$robot_list_ip/);
			}
		    }
		}
		if ($foundrobot == 1) { next BOUCLE; }
	    }

	    if ($exclude_refererspam == 1) {
		if ($spam_list ne '') {
		    $foundreferspam = 0;
		    $foundreferspam = 1 if ($adresse =~ /$spam_list/);
		}
		if ($foundreferspam == 1) { next BOUCLE }
	    }

	    ($browser,$agent1,$agent2) = split(/ \(/,$f) if ($f !~ /\]\(/);
	    ($browser,$agent1) = split(/\]\(/,$f) if ($f =~ /\]\(/);
	    $agent1 = $agent1." ".$agent2 if ($agent2 ne '');
	    

	    $status = $1 if ($query =~ /(\d\d\d);http:\/\// && $type_serveur == 1 && $separate == 0);
#	    $status = $1 if ($query =~ /(\d\d\d);http:\/\// && $type_serveur == 1);
	    if ($squid_format == 0 && $redirect_flag == 0) {
		next if ($status == 304) ; #ote les pages ne contenant rien
		next if ($status == 302) ; #ote les pages ne contenant rien
		next if ($status == 301) ; #redirect automatique
	    }

	    if ($squid_format == 1 && $fields_logfile{'%codestatus'} ne '' && $separate == 0) {
		$codestatus = $line_log[$fields_logfile{'%codestatus'}+$fields_after_login{'%codestatus'}*$add_fields_login+$fields_after_agent{'%codestatus'}*$add_fields_agent];
		if ($codestatus =~ /\//) {
		    ($code_squid,$status) = split(/\//,$codestatus);
		} else {
		    ($code_squid) = split(/:/,$codestatus);
		}
	    }

	    next if (($status >= 400) && ($status < 599));
	    next if ($status =~ /$excludestatuscode/ && $excludestatuscode ne '');

	    next if ($method =~ /$localserver/ && $vserver ne '');
	    next if ($vserver =~ /$excludevirtual/i && $excludevirtual ne '');    
	    next if ($vserver !~ /$virtualfilter/i && $virtualfilter ne '' && $vserver ne '');


#	    print "A $page - $date - $requetesize\n";	    

	    next if ($requetesize == 0 && $requetesize ne "-" && $notrafic == 0 && $redirect_flag == 0) ; #ote les pages ne contenant rien
#		print "A $page - $date - $requetesize - $separate\n";	    	    	    	    


	    if ($opt_s ne '' || $opt_r ne '') {
		($fa) = split(':',$date);
		($fa1,$fa2,$fa3) = split('/',$fa);
		$stop = 1 if ($fa3 > $de3);
		next if ($fa3 < $ds3 || $fa3 > $de3);
		$mequiv = $month_equiv{$fa2};
		$stop = 1 if ($fa3 == $de3 && $mequiv > $mde2);
		next if (($fa3 == $ds3 && $mequiv < $mds2) || ($fa3 == $de3 && $mequiv > $mde2));
		$stop = 1 if ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1);
		next if (($fa3 == $ds3 && $mequiv == $mds2 && $fa1 < $ds1) || ($fa3 == $de3 && $mequiv == $mde2 && $fa1 > $de1));		
	    }             


	    if ($opt_d ne '') {
		($fa) = split(':',$date);	
		($fa1,$fa2,$fa3) = split('/',$fa);
		next if ($fa3 < $pastyear);
		$mequiv = $month_equiv{$fa2};
		next if ($fa3 == $pastyear && $mequiv < $pastmonthnb);
		next if ($fa3 == $pastyear && $mequiv == $pastmonthnb && $fa1 < $pastday);
	    }

	    # We just need to know once if at last one country have been found to activate daily menu country
	    if ($paysuniquejour == 0) {

		($fa) = split(':',$date);	
		($fa1,$fa2,$fa3) = split('/',$fa);
		$jour_listdate = $fa1." ".$fa2." ".$fa3;
		$dirresume = $fa3."-".$fa2."-".$fa1;

#		if (-f "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext") {
		if (-f "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$dirpays$htmlext") {
		    $paysuniquejour = 1;
#		    print "O1 $path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$listdailycountries$txtext\n";
		} else {

		    $pays = "Unknown";

		    if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
			$pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
		    }
		    if ($pays ne "Unknown" && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 1) {
			$pays = &get_geoip($adresse) if ($netgeo == 1);
			$pays = &get_geoipfree($adresse) if ($geoip_free == 1);
		    }
		    $paysuniquejour++ if ($pays ne "Unknown" && $pays ne '');
		}
	    }

	    if ($firstday eq '') {
		($firstday) = $date =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
		$firstday =~ s/[\/]/ /g;
		$jour_of_year = &nbday($firstday);
		$jour_of_year_first = $jour_of_year; 
		$oldjour = $firstday if ($firstday ne '');
	    }
	    
	    ($jour) = split(/:/,$date);
	    $jour =~ s/[\/]/ /g if ($jour ne '');

	    next if ($browser eq '');
	    next if ($agent1 =~ /http/);

	    if ($page !~ /^\//) {
		($os) = split(/_/,$browser); ### REALSERVER
		$browser = "-";
	    }
#		    print "OO $agent1\n" if ($f =~ /Rv/i);
		
	    $page =~ s/$dirsepurl$vserver// if ($virtualCLF == 1);

	    #########
	    if ($page =~ /^\//) {
		if ($agent1 ne '') {
		    $agent1 =~ s/\)\"//g;
		    ($os) = split(/[;(]+/,$agent1); # if ($os eq '');    
			      } else {
				  $os = $agent1;
			      }
		}
		
		if ($os =~ /^[A-Z]+$/) {
		    $os =~ tr/[A-Z]/[a-z]/;
		    $os = ucfirst($os);
		}

		$browser2 = $browser;
#		$os = lc($os);
#		$os = ucfirst($os);

		if ($os eq "Macintosh" || $os eq "Windows") {
		    ($a,$tmp,$tmp1,$tmp2) = split(/[;]/,$agent1);	
		    $tmp1 =~ s/WINDOWS/Windows/;
		    if ($os eq "Macintosh") {
			$os = "Macintosh".$tmp1 if ($tmp =~ /\sU/);
			$os = "Macintosh".$tmp if ($tmp1 =~ /\sU/);
			$tmp = $tmp1 if ($tmp1 =~ /Mac OS X/i);
			if ($tmp =~ /Mac OS X/i) {
			    ($tmp2) = split(/\)/,$tmp);
			    $tmp2 =~ s/_/\./g if ($tmp2 =~ /_/);
			    $tmp2 = substr($tmp2,0,rindex($tmp2,'.')) if (split(/\./,$tmp2) == 3);
			    $os = "Macintosh".$tmp2;
			}

#			print "AA2 $aa $date $os - $tmp - $tmp2\n" if ($os =~ /U/);
			$os =~ s/ Mach-O//;
		    }
		    $os = $tmp1 if ($os eq "Windows");
		}
		
#	    print "Z1 $os\n" if ($f =~ /Rv/i);
		# explorer browser hiding in mozilla !
		if ($agent1 =~ /compatible/i) {
		    ($a,$browser,@tmp) = split(/[;-] /,$agent1);
		    
		    $tmp = '';
		    for ($k=0;$k<=$#tmp;$k++) {
			$tmp .= $tmp[$k];
		    }
		    
		    if ($tmp =~ /DigExt/i) {
			$tmp1 = '';
			for ($k=0;$k<=$#tmp;$k++) {
			    $tmp1 = $tmp[$k];
			    $os = $tmp1 if ($tmp1 =~ /Win/);
			}
		    }
		    
		    if ($tmp !~ /DigExt/i) {
			$os = $tmp[0];
			$os = $tmp[1] if ($tmp[1] =~ /Win/ && $tmp[0] !~ /Win/);
		    }
		    
		    if ($tmp[0] eq '') {
			($browser,$os) = split(/\s+/,$browser2);
		    }
		    
		    $os = "" if ($agent1 !~ /; /);
		    $os = "" if ($browser eq '');
		    $browser = $browser2 if ($agent1 !~ /; /);
		    $tmp = '';
		    $os =~ s/\)(.*)/\)/;
		    $os =~ s/WINDOWS/Windows/;
		}

		if ($agent1 =~ /X11/i) {
		    ($a,$tmp,$tmp1,@tmp) = split(/; /,$agent1);    	
		    ($os) = split(/\s+/,$tmp1);
		    ($os) = split(/\s+/,$tmp) if ($os =~ /Rv\:/i);

		}


		
		if ($agent1 =~ /gecko/i) {
		    ($a,$b,$browser3) = split(/Gecko\)(\s)/,$agent1) if ($agent1 =~ /Gecko\)/);
		    if ($agent1 =~ /Gecko\//) {
			($a,$b,$browser3,$browser4) = split(/Gecko\/(\d{8})/,$agent1);
			$browser3 = $browser4 if ($browser3 eq " ");
			($a,$b,$browser3) = split(/\s+/,$browser3) if ($browser3 =~ /$main_unix_string/i);
		    }


		    
		    if ($agent1 =~ /rv:(.*)\)/) {
			if ($browser3 eq '') {
			    $browser3 = "Gecko/$1";
			}
		    }
		    
		    if ($browser3 eq '') {
			$browser3 = $browser;
		    }
		    $browser3 =~ s/Netscape6/Mozilla/ if ($browser3 =~ "Netscape6");
		    $browser3 =~ s/Netscape/Mozilla/;
		    
		    $browser = $browser3;

		    ($a,$browser,$tmp2,$tmp3) = split(/ /,$browser) if ($browser =~ /\s/);
		    if ($browser eq "Red") {
			$browser = $tmp3;
		    }
		    if ($a =~ /\// && $a !~ /Version/i) {
			$browser = $a;
		    }



		    if ($browser =~ /$distrib_string/i) {
			($a,$tmp3,$browser,$tmp4) = split(/ /,$browser3);
			$browser = $tmp4 if ($tmp4 ne '' && $tmp4 =~ /\//);
			$browser = $browser2 if ($browser eq '');
		    }
		    $browser = $browser2 if ($browser eq '');
		}

#		print "BB - $date - $browser - $f\n";		    

		if ($page =~ /^\//) {
		    ($browser,$tmp) = split(/ \[/,$browser);
		    ($browser,$tmp) = split(/\s+/,$browser);
		    $browser = $browser." ".$tmp if ($tmp ne '');
		    ($browser) = split(/\//,$browser) if ($browser !~ /Chrome/ && $browser !~ /Firefox/ && $browser !~ /Mozilla/ && $browser !~ /gecko/i);
		    ($os) = split(/\//,$os) if ($os !~ /Unknown/);
		    $browser =~ s/\s+$//;
		    $os =~ s/\s+$//;
		    if ($os !~ /Win/i && $os !~ /Macintosh/i) {
			($os,$tmp) = split(/\s+/,$os);
			$os = $os." ".$tmp if ($tmp ne '' && $tmp !~ /\d+/);
		    }

		    if ($browser eq '') {
			$msg = "$fileagent seems to miss agent data !\n";
			$msg .= "or this line :\n$_ is not correctly parsed by this script.\n\n";
			$msg .= "Was not able to extract a browser name from the string : $f\n";
			&warning_msg($msg);
		    }
		}

#		print "OO $browser\n" if ($browser =~ /hrome/i);
	        $browser =~ s/\/(\d+\.\d\d*)\..*/\/$1/;
#		print "AA $browser - $1\n" if ($browser =~ /http/i);
		
		$os = "" if ($os =~ /^\d+$/);
		if ($jour ne $oldjour && $skipl == 0) {
		    if ($zip == 0 && $zipcut != 2) {
			$msg = "$oldjour done\n";
			&output_log($msg);
			print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
		    }
#		    print "$jour - $oldjour\n";
		    $yday = &nbday($jour);
		    $ydayold = &nbday($oldjour);
		    $diff = $yday - $ydayold;
		    
		    $diff++ if ($yday == 0);
		    $jour_of_year += $diff;
		    
		    if ($jour_of_year < $pastjour_of_year && $opt_d ne '') {
			$oldjour = $jour if ($jour ne '');
			$scan = 0;
			next BOUCLE;
		    }
		    
		    ($var1,$var2,$var3) = split(' ',$jour);
		    ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);
		    
		    $skipout = 0;
		    
		    if ($var3 < $oldvar3) {
			unless ($seen_problem_date{$jour}++) {
			    print "<BR><DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
			    $msg = "1 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    &output_log($msg);
			    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }
		    
		    if (($oldvar3 == $var3) && ($month_equiv{$var2} < $month_equiv{$oldvar2}) && $skipout == 0) {
			unless ($seen_problem_date{$jour}++) {
			    print "<BR><DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
			    $msg = "2 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    &output_log($msg);
			    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }
		    
#		    if (($var2 eq $oldvar2) && ($var1 < $oldvar1) && $skipout == 0) {
		    if (($oldvar3 == $var3) && ($month_equiv{$var2} < $month_equiv{$oldvar2}) && ($var1 < $oldvar1) && $skipout == 0) {
			unless ($seen_problem_date{$jour}++) {
			    print "<BR><DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
			    $msg = "3 - Problem found ($date) : $var1$dirsep$var2$dirsep$var3 - should be $oldvar1$dirsep$oldvar2$dirsep$oldvar3 (skipping...)\n";
			    &output_log($msg);
			    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
			}
			$skipout = 1;
			$jour = $oldjour;
			next BOUCLE;
		    }

		    ###

		    if ($skipout == 0) {

			($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
			$jour_listdate = $tmp1." ".$tmp2." ".$tmp3;
			$dirresume = $tmp3."-".$tmp2."-".$tmp1;

#			print "Save2 - $jour - $oldjour - $oldoldjour\n";

			if ($struct_logfile =~ /\%agent/) {
			    &save_daily_agent;
			}

			$unique_new_browserday = 0;
			
			for ($l=1;$l<=$uniqueday;$l++) {
			    
			    for ($j=0;$j<=$#agent;$j++) {
#	    print "AA $browserday[$l] - $agent[$j]\n";
				if ($browserday[$l] =~ /$agent[$j]/) {
				    $tmp = $agent[$j];
				    $tmp1 = $translate_agent{$tmp};
				    $bro_ver = $browserday[$l];
#				    $bro_ver =~ /(\d)+/;
				    $bro_ver =~ /(\d+\.\d\d*)/;
				    $bro_ver = int($1);
				    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
				    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
				    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
				    $browserday[$l] = '';
				    $unique_new_browserday++ if (!($seen{"$tmp1 $oldjour"}++));
				}
			    }
			    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
			    $unique_new_browserday++ if ($browserday[$l] ne '');
			}
			
# tri des $topten browser les plus frequents
			
			for ($i=0;$i<$unique_new_browserday;$i++) {
			    $maxi = 0;
			    foreach $browser (keys(%new_browserday)) {
				if ($new_browserday{$browser} > $maxi) {
				    $maxi = $new_browserday{$browser};
				    $bestbrowserday[$i] = $browser;
				    $occurbrowserday[$i] = $new_browserday{$browser};                 
#	    print "AA $i - $new_browserday[$i] - $tmp - $tmp1\n";

				}
			    }
			    $new_browserday{$bestbrowserday[$i]} = 0;
			}
			
#
			
			for ($i=0;$i<$unique_new_browser;$i++) {
			    for ($j=0;$j<=$#agent;$j++) {
				if ($bestbrowserday[$i] =~ /$agent[$j]/) {
				    $tmp = $agent[$j];
				    $tmp1 = $translate_agent{$tmp};
				}
			    }
			    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
			}

#
			$unique_new_osday = $uniqueosday;
			foreach $osday (keys(%nbreosday)) {
			    $ok = 0;
			    for ($j=0;$j<=$#os;$j++) {
				if ($osday eq $os[$j]) {
				    $tmp = $os[$j];
				    $tmp1 = $translate_os{$tmp};
				    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
				    $ok = 1;
				    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
				}
			    }
			    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
			}
			
			

#			print "Save2b - $jour - $oldjour - $oldoldjour\n";
			&BuildDailyAgentResume($scriptname,0);

			#push(@listdate,$dirresume);
			push(@listdate,$jour_listdate);
#	print "TI2 - $dirresume\n";			
			undef %new_osday;
			
			for ($i=1;$i<=$unique;$i++) {
			    $evolbrowser[$count_day][$i] = $nbreday{$browser[$i]};
			}
			undef %nbreday;
			
			###
			
			for ($i=0;$i<=$unique_new_browserday;$i++) {
			    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
				$browser_versionday{$bestbrowserday[$i],$l} = '';
			    }
			}
			
			undef %new_browserday;
			undef %nbrebrowserday;
			undef %nbreosday;
			undef %browser_version_nbday;
			undef %browser_versionday;
			undef @bestbrowserday;
			undef @occurbrowserday;
#			undef $bestbrowserday;
#			undef $occurbrowserday;
			
			$unique_new_browserday = 0;
			$paysuniquejour = 0;
			$countday = 0;
			$uniqueday = 0;
			$uniqueosday = 0;
			$unique_new_osday = 0;	
			$scan = 1;
			$count_day += $diff;
			$oldoldjour = $oldjour;
			$oldjour = $jour if ($jour ne '');
#			print "KK $jour - $oldjour - $oldoldjour\n";
			$nbline = 0;
		    }
		}
		
	    } # else {

	    if ($page !~ /^\//) {
		###### 2ieme Partie ######

#	    print "AA $f - $_\n";		
		($date,$f) = split(/\"/) if ($_ =~ /\"/);
		$f = $_ if ($_ !~ /\"/);
		chop($f);
		
#	    print "BB $f\n";		
#		if ($separate == 0) {
#		    print "Proxy : $date - $page\n";
#		}

		$f =~ s/\+/ /g if ($f !~ /\s/);
		($browser,$agent1) = split(/ \(/,$f) if ($f !~ /\]\(/);
		($browser,$agent1) = split(/\]\(/,$f) if ($f =~ /\]\(/);
#				print "MM $browser\n"; # if ($browser =~ /hrome/i);
		if ($agent1 ne '') {
		    $agent1 =~ s/\)\"//g;
		    ($os) = split(/[;(]+/,$agent1);    
			      } else {
				  $os = $agent1;
			      }
		    

		if ($os =~ /^[A-Z]+$/) {
		    $os =~ tr/[A-Z]/[a-z]/;
		    $os = ucfirst($os);
		}

		    $browser2 = $browser;

#		$os = lc($os);
#		$os = ucfirst($os);

		if ($os eq "Macintosh" || $os eq "Windows") {
		    ($a,$tmp,$tmp1,$tmp2) = split(/[;]/,$agent1);	
		    $tmp1 =~ s/WINDOWS/Windows/;
		    if ($os eq "Macintosh") {
			$os = "Macintosh".$tmp1 if ($tmp =~ /\sU/);
			$os = "Macintosh".$tmp if ($tmp1 =~ /\sU/);
			$tmp = $tmp1 if ($tmp1 =~ /Mac OS X/i);
			if ($tmp =~ /Mac OS X/i) {
			    ($tmp2) = split(/\)/,$tmp);
			    $tmp2 =~ s/_/\./g if ($tmp2 =~ /_/);
			    $tmp2 = substr($tmp2,0,rindex($tmp2,'.')) if (split(/\./,$tmp2) == 3);
			    $os = "Macintosh".$tmp2;
			}

#			print "AA2 $aa $date $os - $tmp - $tmp2\n" if ($os =~ /U/);
			$os =~ s/ Mach-O//;
		    }
		    $os = $tmp1 if ($os eq "Windows");
		}


#		print "$date $os\n" if ($date =~ /10:51:/);
		    # explorer browser hiding in mozilla !
		    if ($agent1 =~ /compatible/i) {
			($a,$browser,@tmp) = split(/; /,$agent1);
			
			$tmp = '';
			for ($k=0;$k<=$#tmp;$k++) {
			    $tmp .= $tmp[$k];
			}
			
			if ($tmp =~ /DigExt/i) {
			    $tmp1 = '';
			    for ($k=0;$k<=$#tmp;$k++) {
				$tmp1 = $tmp[$k];
				$os = $tmp1 if ($tmp1 =~ /Win/);
			    }
			}

			if ($tmp !~ /DigExt/i) {
			    $os = $tmp[0];
			    $os = $tmp[1] if ($tmp[1] =~ /Win/ && $tmp[0] !~ /Win/);
#	    $os = $tmp[2] if ($os !~ /Win/);
			}
			
			if ($tmp[0] eq '') {
			    ($browser,$os) = split(/\s+/,$browser2);
			}

			$os = "" if ($agent1 !~ /; /);
			$os = "" if ($browser eq '');
			$browser = $browser2 if ($agent1 !~ /; /);
			$tmp = '';
			$os =~ s/\)(.*)/\)/;
			$os =~ s/WINDOWS/Windows/;
		    }
		    
		    if ($agent1 =~ /X11/i) {
			($a,$tmp,$tmp1,@tmp) = split(/; /,$agent1);    	
			($os) = split(/\s+/,$tmp1);
		    }

		    if ($agent1 =~ /gecko/i) {
			($a,$b,$browser3) = split(/Gecko\)(\s)/,$agent1) if ($agent1 =~ /Gecko\)/);
			if ($agent1 =~ /Gecko\//) {
			    ($a,$b,$browser3,$browser4) = split(/Gecko\/(\d{8})/,$agent1);
			    $browser3 = $browser4 if ($browser3 eq " ");
			    ($a,$b,$browser3) = split(/\s+/,$browser3) if ($browser3 =~ /$main_unix_string/i);
			}
			
			if ($agent1 =~ /rv:(.*)\)/) {
			    if ($browser3 eq '') {
				$browser3 = "Gecko/$1";
			    }
			}
			
			if ($browser3 eq '') {
			    $browser3 = $browser if ($browser ne '');
			}
			
			$browser3 =~ s/Netscape6/Mozilla/ if ($browser3 =~ "Netscape6");
			$browser3 =~ s/Netscape/Mozilla/;
			
			$browser = $browser3;
			($a,$browser,$tmp2,$tmp3) = split(/ /,$browser) if ($browser =~ /\s/);
			if ($browser eq "Red") {
			    $browser = $tmp3;
			}
			
			if ($browser =~ /$distrib_string/i) {
			    ($a,$tmp3,$browser,$tmp4) = split(/ /,$browser3);
			    $browser = $tmp4 if ($tmp4 ne '' && $tmp4 =~ /\//);
			    $browser = $browser2 if ($browser eq '');
			}
		    }

		    ($browser,$tmp) = split(/ \[/,$browser);
		    ($browser,$tmp) = split(/\s+/,$browser);
		    $browser = $browser." ".$tmp if ($tmp ne '');
		    ($browser) = split(/\//,$browser) if ($browser !~ /Mozilla/ && $browser !~ /gecko/i);
		    ($os) = split(/\//,$os) if ($os !~ /Unknown/);
		    $browser =~ s/\s+$//;
		    $os =~ s/\s+$//;
		    if ($os !~ /Win/i && $os !~ /Macintosh/i) {
			($os,$tmp) = split(/\s+/,$os);
			$os = $os." ".$tmp if ($tmp ne '' && $tmp !~ /\d+/);
		    }

#		print "AA $browser\n"; # if ($browser =~ /hrome/i);
		    
		    if ($type_serveur == 2) {
			$date =~ s/\[//;
			if ($firstday eq '') {
			    ($firstday) = $date =~ m/^((\d+)\/(\w+)\/(\d+))(.*)/;
			    $firstday =~ s/[\/]/ /g;
			    
			    $jour_of_year  = &nbday($firstday);
			    $jour_of_year_first = $jour_of_year; 
			    $oldjour = $firstday if ($firstday ne '');
			}
			
			($jour) = split(/:/,$date);
			$jour =~ s/[\/]/ /g;
			
			if ($jour ne $oldjour) {
			    
			    $yday = &nbday($jour);
			    $ydayold = &nbday($oldjour);
			    $diff = $yday - $ydayold;
			    $diff++ if ($yday == 0);
			    
			    $jour_of_year += $diff;

			    if ($jour_of_year < $pastjour_of_year && $opt_b eq '') {
				$oldjour = $jour if ($jour ne '');
				$scan = 0;
				next BOUCLE;
			    }
			    
			    ($var1,$var2,$var3) = split(' ',$jour);
			    ($oldvar1,$oldvar2,$oldvar3) = split(' ',$oldjour);
			    
			    $skipout = 0;

			    if ($var3 < $oldvar3) {
				unless ($seen_problem_date{$jour}++) {
				    print "<DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
				    $msg = "1 - Problem found ($date) : $date (skipping...)\n";
				    &output_log($msg);
				    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
				}
				$skipout = 1;
				$jour = $oldjour;
				next BOUCLE;
			    }

			    if (($oldvar3 == $var3) && $month_equiv{$var2} < $month_equiv{$oldvar2}) {
				unless ($seen_problem_date{$jour}++) {
				    print "<DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
				    $msg = "2 - Problem found ($date) : $date (skipping...)\n";
				    &output_log($msg);
				    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
				}
				$skipout = 1;
				$jour = $oldjour;
				next BOUCLE;
			    }

#			    if (($var2 eq $oldvar2) && ($var1 < $oldvar1)) {
			    if (($oldvar3 == $var3) && ($month_equiv{$var2} == $month_equiv{$oldvar2}) && ($var1 < $oldvar1) && $skipout == 0) {
				unless ($seen_problem_date{$jour}++) {
				    print "<DIV CLASS=\"warning_msg\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
				    $msg = "3 - Problem found ($date) : $date (skipping...)\n";
				    &output_log($msg);
				    print "</DIV>" if ($ENV{'REQUEST_METHOD'} eq "GET");
				}
				$skipout = 1;
				$jour = $oldjour if ($jour ne '');
				next BOUCLE;
			    }

			    ###

			    if ($skipout == 0) {  


				($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
				$jour_listdate = $tmp1." ".$tmp2." ".$tmp3;
				$dirresume = $tmp3."-".$tmp2."-".$tmp1;

#				print "Save3 - $jour - $oldjour - $oldoldjour\n";


				if ($paysuniquejour == 0) {

				    if (-f "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$dirpays$htmlext") {
					$paysuniquejour = 1;
				    } else {
					
					$pays = "Unknown";
    
					if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
					    $pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
					}
					if ($pays eq "Unknown" && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 1) {
					    $pays = &get_geoip($adresse) if ($netgeo == 1);
					    $pays = &get_geoipfree($adresse) if ($geoip_free == 1);
					}
					$paysuniquejour++ if ($pays ne "Unknown" && $pays ne '');
				    }
				}


				if ($struct_logfile =~ /\%agent/) {
				    &save_daily_agent;
				}

				$unique_new_browserday = 0;

				for ($l=1;$l<=$uniqueday;$l++) {
	   
				    for ($j=0;$j<=$#agent;$j++) {
					if ($browserday[$l] =~ /$agent[$j]/) {
					    $tmp = $agent[$j];
					    $tmp1 = $translate_agent{$tmp};
					    $bro_ver = $browserday[$l];
					    #$bro_ver =~ /(\d)+/;
					    $bro_ver =~ /(\d+\.\d\d*)/;
					    $bro_ver = int($1);
					    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
					    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
					    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
					    $browserday[$l] = '';
					    $unique_new_browserday++ if (!($seen{$tmp1}++));
					}
				    }
				    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
				    $unique_new_browserday++ if ($browserday[$l] ne '');
				}

# tri des $topten browser les plus frequents

				for ($i=0;$i<$unique_new_browserday;$i++) {
				    $maxi = 0;
				    foreach $browser (keys(%new_browserday)) {
					if ($new_browserday{$browser} > $maxi) {
					    $maxi = $new_browserday{$browser};
					    $bestbrowserday[$i] = $browser;
					    $occurbrowserday[$i] = $new_browserday{$browser};                 
					}
				    }
				    $new_browserday{$bestbrowserday[$i]} = 0;
				}

#
				
				for ($i=0;$i<$unique_new_browser;$i++) {
				    for ($j=0;$j<=$#agent;$j++) {
					if ($bestbrowserday[$i] =~ /$agent[$j]/) {
					    $tmp = $agent[$j];
					    $tmp1 = $translate_agent{$tmp};
					}
				    }
				    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
				}
		   
#

				$unique_new_osday = $uniqueosday;
				foreach $osday (keys(%nbreosday)) {
				    $ok = 0;
				    for ($j=0;$j<=$#os;$j++) {
					if ($osday eq $os[$j]) {
					    $tmp = $os[$j];
					    $tmp1 = $translate_os{$tmp};
					    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
					    $ok = 1;
					    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
					}
				    }
				    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
				}
				
				

#				print "Save3 - $jour - $oldjour - $oldoldjour\n";
				&BuildDailyAgentResume($scriptname,0);

				undef %new_osday;

#				push(@listdate,$dirresume);
				push(@listdate,$jour_listdate);
#	print "TI3 - $dirresume\n";
				###

				for ($i=1;$i<=$unique;$i++) {
				    $evolbrowser{$count_day,$i} = $nbreday{$browser[$i]};
				}
				
				undef %nbreday;

				###

				for ($i=0;$i<=$unique_new_browserday;$i++) {
				    for ($l=$browser_version_nbday{$bestbrowserday[$i]};$l>0;$l--) {
					$browser_versionday{$bestbrowserday[$i],$l} = '';
				    }
				}
		   
				undef %new_browserday;
				undef %nbrebrowserday;
				undef %nbreosday;
				undef %browser_version_nbday;
				undef %browser_versionday;
				undef @bestbrowserday;
				undef @occurbrowserday;
#				undef $bestbrowserday;
#				undef $occurbrowserday;
				
				$unique_new_browserday = 0;
				$paysuniquejour = 0;
				$countday = 0;
				$uniqueday = 0;
				$uniqueosday = 0;
				$unique_new_osday = 0;	
				$scan = 1;
				$count_day += $diff;
				$oldjour = $jour;
				$nbline = 0;
			    }	    
			}
		    }
	    }
		

	$agent_found = 1;

		if ($scan == 1 && (($jour_of_year >= $pastjour_of_year) || $opt_b ne '')) {
#		    print "A1 $os\n" if ($f =~ /Rv/i);

		    $os =~ s/;(.*)//;
		    $os =~ s/\)//;
		    $os =~ s/\s*AppleWebKit//i;
		    $os =~ s/^\s+//;
		    $os = "Unknown" if ($os eq '' || length($os) < 3);

		    $os =~ s/^i?[\d\.]+\s+//;
		    $os = uc(substr($os,0,1)).substr($os,1,length($os)) if ($os =~ /^[a-z]/);
#		    print "A1 $os\n" if ($os =~ /Macintosh/i);		    
		    $browser =~ s/\"//g;
		    $browser = "Unknown" if ($browser eq '' || $browser eq "-");
#		    print "UU $browser\n" if ($browser =~ /chrome/i);
		    $nbre{$browser}++;
		    $nbreday{$browser}++;

#		    print "PP $os\n" if ($os =~ /Macintosh/i);
		    $nbreos{$os}++;

#		    print "A2 - $os - $nbreos{$os} - $f\n" if ($os =~ /AppleWebKit/i);
		    if ($os =~ /Linux/i) {
			for ($i=0;$i<=$#list_distrib;$i++) {
			    if ($f =~ /$list_distrib[$i]/i) {
				$distrib{$list_distrib[$i]}++;
			    }
			}
		    }

		    $nbrebrowserday{$browser}++;
		    $nbreosday{$os}++;
		    
		    $count++;
		    $countday++;
		    
		    $unique++ if ($nbre{$browser} == 1);
		    $uniqueos++ if ($nbreos{$os} == 1);
		    $uniqueday++ if ($nbrebrowserday{$browser} == 1);
		    $uniqueosday++ if ($nbreosday{$os} == 1);
		    
		    $browser[$unique] = $browser if ($nbre{$browser} == 1);
		    $browserday[$uniqueday] = $browser if ($nbreday{$browser} == 1);
		}
	    }

#    $oldoldjour = $oldjour;

	    close (INFILE); 

    $nbline = 0;
#    print "END : A$jour B - $oldjour\n";

#	    if ($line == $no_agent && $line != 0) {
#		print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#		print "\nYour logfile have no data about agent informations\n";
#		print "Check either your logfile format from the web admin or \n";
#		print "rectify your w3perl configuration file by removing the %agent string in \$struct_logfile\n\n";
#		print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#		exit;
#	    }

# last day

#    $oldjour = $jour if ($jour ne '');
    $oldjour = $jour if ($jour =~ m/^((\d+)\s(\w+)\s(\d\d\d\d))/);
#print "END2 : A$jour B - $oldjour\n";

#    print "Save4 - $jour - $oldjour - $oldoldjour\n";
    if ($struct_logfile =~ /\%agent/ && $agent_found == 1) {
	&save_daily_agent;		
    }

# mois gzip suivant

    $stop = 1 if ($zipcut == 1 && $zip == 1 && $datezip eq $datetmpzip);
#    $stop = 1 if (($zip != 1 && $zipcut == 0) || (($zip == 1 || $zipcut == 2) && $fileagent eq $filezip));

    $stop = 1 if (($zip == 0 && $zipcut == 0) || (($zip == 1 || $zipcut == 2) && $filezip eq $file && $fileagent eq $prefixlog) || $opt_i ne '');


    $stop = 1 if (($zipcut == 2 || $zipcut == 1) && $zip == 0 && $fileagent eq "$fileroot$prefixlog");
    $stop = 1 if ($rotate < 0 && $rotate_inc == -1 && $zipcut == 3);
    $stop = 1 if ($rotate > $min_rotate_index && $rotate_inc == 1 && $zipcut == 3);
    $stop = 0 if ($zipcut == 3 && $max_rotate_index == 1 && $rotate == 1 && (-f "$fileroot$prefixlog"));
    $stop = 1 if ($fileagent eq "$fileroot$prefixlog");	    

	    if (($zip == 1 || $zipcut != 0) && $stop == 0) {

		$stop = 1 if ($stopday eq "$day/$lettermonth/$year" && $zipcut != 1);

		$yyear = $year;
		$year = $fyear;
		
		&nextlog;

		if ($rotate == -1 && $zipcut == 3) {
		    $filezip = $fileroot.$prefixlog if ($file eq $fileagent);
		    $fileagent = $fileroot.$prefixlog if ($file eq $fileagent);
		    $filezip = $fileroot.$agentlog if ($file ne $fileagent);
		    $fileagent = $fileroot.$agentlog if ($file ne $fileagent);       
		}
		
		if ($zip == 0) {
		    if ($zipcut == 2) {
			if ($real_deb == 0) {
			    &nextlog while (!(-f $fileagent) && $datezip lt $datetmpzip);
			}
			if ($real_deb == 1) {		
			    while ($abort == 1 && $datezip lt $datetmpzip) {
				&nextlog;
			    }
			}
			if ($fileagent eq $filetmpzip) {
			    $filezip = $fileroot.$prefixlog;
			    $fileagent = $fileroot.$prefixlog;
			    $stop = 1 if (!(-f $fileagent));
			}
#			&nextlog while (!(-f $fileagent) && $datezip lt $datetmpzip);
#			$stop = 1 if ($fileagent eq $filetmpzip);
		    }
		    if ($zipcut == 1) {    
			$fileagent = $fileroot.$prefixlog if (!(-f $fileagent));
		    }
		    if ($zipcut == 3) {
			&nextlog while ((!(-f $fileagent)) && (($rotate >= 0 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate < $min_rotate_index)));
			$stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_inc == -1 && $rotate == -1);
			$stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_inc == 1 && $rotate > $min_rotate_index);
		    }
		}
		
		if ($zip == 1) {
		    if (-e $filezip) {
		    } else {
			if ($zipcut == 2) {
#			    &nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
			    &nextlog while ((!(-f $filezip) && !(-f $fileagent)) && $datezip lt $datetmpzip);
			    # Found an uncompressed logfile with daily zip logfiles
			    if (-f $fileagent && $fileagent !~ /$zipext$/) {
				$filezip = $fileagent;
			    } 
			    $stop = 1 if ($filezip eq $filetmpzip);
			} elsif ($zipcut == 3) {
			    &nextlog while ((!(-f $filezip) && (!(-f $fileagent))) && (($rotate >= 0 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate < $min_rotate_index)));
			    $stop = 1 if ($filezip eq $filetmpzip);		
			    $stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_inc == -1 && $rotate == -1);
			    $stop = 1 if (!(-f "$fileroot$prefixlog") && $rotate_inc == 1 && $rotate > $min_rotate_index);
			} elsif ($zipcut == 1) {
			    &nextlog while (!(-f $filezip) && $datezip lt $datetmpzip);
			    if ($filezip eq $filetmpzip) {
				$month--;
				$fileagent = &Get_LogfileName($fileroot);
				$filezip = $file;
				if (!(-f $fileagent)) {
				    $filezip = $fileroot.$prefixlog;
				    $fileagent = $fileroot.$prefixlog;
				    $stop = 1 if (!(-f $file));
				}
			    }
			} else {
			    $filezip = $fileroot.$prefixlog if ($file eq $fileagent);
			    $fileagent = $fileroot.$prefixlog if ($file eq $fileagent);
			    $filezip = $fileroot.$agentlog if ($file ne $fileagent);
			    $fileagent = $fileroot.$agentlog if ($file ne $fileagent);       
			    $stop = 1 if (!(-f $fileagent));
			}
		    }
		} else {
		    if (-e $fileagent && $zipcut != 0) {
		    } else {
			$stop = 1 if (!(-f $fileagent));
		    }
		}
		
		$fyear = $year;
		$year = $yyear;
	    }
	    
	}# REMETTRE
	    
# last day

if ($agent_found == 1) {

	    if (($file eq $fileagent || $zipcut != 0)) {
		for ($i=1;$i<=$unique;$i++) {
		    $evolbrowser[$count_day][$i] = $nbreday{$browser[$i]};
		}
	    }


### Last day

#         print "Save5 - $jour - $oldjour - $firstday\n";
	    ($tmp1,$tmp2,$tmp3) = split(/ /,$oldjour);
	    $jour_listdate = $tmp1." ".$tmp2." ".$tmp3;
	    $dirresume = $tmp3."-".$tmp2."-".$tmp1;

	    if ($paysuniquejour == 0) {

		if (-f "$path$lang[0]$dirsep$dirdate$dirsep$dirresume$dirsep$dirpays$htmlext") {
		    $paysuniquejour = 1;
		} else {
		    
		    $pays = "Unknown";
    
		    if ($adresse !~ /[0-9]+$/ && $adresse !~ /:/) {
			$pays = substr($adresse,rindex($adresse,'.')+1,length($adresse));
		    }
		    if ($pays eq "Unknown" && ($adresse =~ /[0-9]+$/ || $adresse =~ /:/) && $reverse_geo == 1) {
			$pays = &get_geoip($adresse) if ($netgeo == 1);
			$pays = &get_geoipfree($adresse) if ($geoip_free == 1);
		    }
		    $paysuniquejour++ if ($pays ne "Unknown" && $pays ne '');
		}
	    }


	if ($struct_logfile =~ /\%agent/ && $agent_found == 1) {
	    &save_daily_agent;
	}

	$unique_new_browserday = 0;

	for ($l=1;$l<=$uniqueday;$l++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($browserday[$l] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		    $bro_ver = $browserday[$l];
#		    $bro_ver =~ /(\d)+/;
		    $bro_ver =~ /(\d+\.\d\d*)/;
		    $bro_ver = int($1);
		    $new_browserday{$tmp1} += $nbreday{$browserday[$l]};
		    $browser_versionday{$tmp1,$bro_ver} += $nbreday{$browserday[$l]};
		    $browser_version_nbday{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nbday{$tmp1});
		    $browserday[$l] = '';
		    $unique_new_browserday++ if (!($seen{$tmp1}++));
		}
	    }
	    $new_browserday{$browserday[$l]} += $nbreday{$browserday[$l]} if ($browserday[$l] ne '');
	    $unique_new_browserday++ if ($browserday[$l] ne '');
	}
	
# tri des $topten browser les plus frequents
	
	for ($i=0;$i<$unique_new_browserday;$i++) {
	    $maxi = 0;
	    foreach $browser (keys(%new_browserday)) {
		if ($new_browserday{$browser} > $maxi) {
		    $maxi = $new_browserday{$browser};
		    $bestbrowserday[$i] = $browser;
		    $occurbrowserday[$i] = $new_browserday{$browser};                 
		}
	    }
	    $new_browserday{$bestbrowserday[$i]} = 0;
	}

#
	
	for ($i=0;$i<$unique_new_browser;$i++) {
	    for ($j=0;$j<=$#agent;$j++) {
		if ($bestbrowserday[$i] =~ /$agent[$j]/) {
		    $tmp = $agent[$j];
		    $tmp1 = $translate_agent{$tmp};
		}
	    }
	    $bestbrowserday[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
	}

#

	$unique_new_osday = $uniqueosday;
	foreach $osday (keys(%nbreosday)) {
	    $ok = 0;
	    for ($j=0;$j<=$#os;$j++) {
		if ($osday eq $os[$j]) {
		    $tmp = $os[$j];
		    $tmp1 = $translate_os{$tmp};
		    $new_osday{$tmp1} += $nbreosday{$tmp} if ($ok == 0);
		    $ok = 1;
		    $unique_new_osday-- if ($seen{"$tmp1 $oldjour"}++);
		}
	    }
	    $new_osday{$osday} = $nbreosday{$osday} if ($ok != 1);
	}


#    print "Save4b - $jour - $oldjour - $oldoldjour\n";
if ($jour eq $oldjour) {
    $jour = &date_intervalle($jour,1);
    $jour =~ s/\// /g;
}
	    &BuildDailyAgentResume($scriptname,0);
#	    push(@listdate,$dirresume);	    
	    push(@listdate,$jour_listdate);
	    undef %new_osday;
#	print "TI4 - $dirresume - $oldjour\n";
}

#################################################################
####             sauvegarde des donnees                   #######
#################################################################

$starnb += 10;
if ($ENV{'REQUEST_METHOD'} ne "GET") {
print "     \x08\x08\x08\x08\x08";
    for ($i=1;$i<=($starnb+1);$i++) {
	print "\x08 \x08";
    }
}

print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
$msg = "Saving data\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

open(OUT,">$path$dirinc$dirsep$incbrowser") || &error_exit("Error, unable to open $path$dirinc$dirsep$incbrowser",1);
print OUT "$line\t$size\t$firstday\t$oldjour\n";
#for ($i=1;$i<=$unique;$i++) {
#    print OUT "$browser[$i]\t$nbre{$browser[$i]}\n";
#}
#close(OUT);    
foreach $val (&reverse_sort_by_value(*nbre)) {
    print OUT "$val\t$nbre{$val}\n";
}
close(OUT);    

open(OUT,">$path$dirinc$dirsep$incos") || &error_exit("Error, unable to open $path$dirinc$dirsep$incos",1);
print OUT "$count\n";
#foreach $os (keys(%nbreos)) {
#    print OUT "$os\t$nbreos{$os}\n";
#}
foreach $os (&reverse_sort_by_value(*nbreos)) {
    print OUT "$os\t$nbreos{$os}\n";
}
for ($i=0;$i<=$#list_distrib;$i++) {
    $distrib{$list_distrib[$i]} = 0 if ($distrib{$list_distrib[$i]} eq '');
    print OUT "Linux\t$list_distrib[$i]\t$distrib{$list_distrib[$i]}\n";
}
close(OUT);    


open(OUT,">$path$dirinc$dirsep$dayagent") || &error_exit("Error, unable to open $path$dirinc$dirsep$dayagent",1);
for ($j=0;$j<=$count_day;$j++) {
    undef @sortedtab;
    undef @trireq;
    for ($i=1;$i<=$unique;$i++) {
	$evolbrowser[$j][$i] = 0 if ($evolbrowser[$j][$i] eq '');
	push(@sortedtab,$evolbrowser[$j][$i]);
    }
    @trireq = reverse sort bynumber @sortedtab;
    for ($i=0;$i<=$#trireq;$i++) {
	print OUT "$trireq[$i] ";
    }
    print OUT "\n";
}
close (OUT);

#############################################################################

&save_reverse_dns if ($reverse_dns == 1); # sauvegarde de la table de DNS

if (($w3c_agent == 0 && $logfile_format eq "W3C") || ($line_parsed == $no_agent && $line_parsed != 0) || ($firstday eq '' && $exclude_robot == 1 && ($exclude_robot_nb != $line))) {

#    print "IIII $w3c_agent - $line_parsed == $no_agent - $firstday\n";
    $msg = "\nYour logfile have no data about agent informations\n";
    $msg .= "You can : \n";
    $msg .= " - Check your logfile format contains agent data from the web admin\n";
    $msg .= " - Modify your w3perl configuration file by removing the %agent string in \$struct_logfile\n";
    $msg .= " - Disable running this script from the web interface\n";
    $msg .= "\n";
    $status_script = 2;
    &error_exit($msg,0);
}

if ($agent_found == 0) {
    $status_script = 1;
    &error_exit("All agent string are empty or invalid\n",0);
}

if ($line == $nbline && $opt_b eq '') {
    $status_script = 1;
    &error_exit("Nothing new\n",0);
}

# tri par browser sans version

$unique_new_browser = 0;

for ($l=1;$l<=$unique;$l++) {

	$browser2[$l] = $browser[$l];
	$nbre2{$browser2[$l]} = $nbre{$browser[$l]};	
	for ($j=0;$j<=$#agent;$j++) {
		if ($browser[$l] =~ /$agent[$j]/) {
			$tmp = $agent[$j];
			$tmp1 = $translate_agent{$tmp};
			$bro_ver = $browser[$l];
			$bro_ver =~ /(\d+\.\d\d*)/;
###			$bro_ver = int($1);
			$bro_ver = $1;
			$bro_ver =~ s/00/0/;
#			print "A $bro_ver $browser[$l]\n" if ($browser[$l] =~ /Firefox/);
#			$nb_browser{$tmp1} += $nbre{$browser[$l]};
			$new_browser{$tmp1} += $nbre{$browser[$l]};
			$browser_version{$tmp1,$bro_ver} += $nbre{$browser[$l]};
#			print "QQ $bro_ver - $tmp1 - $browser_version{$tmp1,$bro_ver}\n" if ($bro_ver > 10 && $browser[$l] =~ /Firefox/);
			$pie_browser{"$tmp1 $bro_ver"} += $nbre{$browser[$l]};
#			$a = $pie_browser{"$tmp1 $bro_ver"};
#			print "PP $tmp1 $bro_ver - $a\n";
			$browser_version_nb{$tmp1} = $bro_ver if ($bro_ver > $browser_version_nb{$tmp1});
			$browser[$l] = '';
			$unique_new_browser++ if (!($seen{"$tmp1 priv"}++));
		}
	}
	$new_browser{$browser[$l]} += $nbre{$browser[$l]} if ($browser[$l] ne '');
	$unique_new_browser++ if ($browser[$l] ne '');
}

# tri par os

foreach $os (keys(%nbreos)) {
	$ok = 0;
	for ($j=0;$j<=$#os;$j++) {
		if ($os eq $os[$j]) {
			$tmp = $os[$j];
			$tmp1 = $translate_os{$tmp};
			$new_os{$tmp1} += $nbreos{$tmp} if ($ok == 0);
			$unique_new_os++ if (!($seen{"$tmp1 priv2"}++));
			$ok = 1;
		}
	}
	$new_os{$os} = $nbreos{$os} if ($ok != 1);
	$unique_new_os++ if ($ok != 1);
}

undef %nbreos;

$uniqueos = $unique_new_os;

foreach $os (keys(%new_os)) {
    $nbreos{$os} = $new_os{$os};
}

sub nextlog {

    $day++ if ($zipcut == 2);
    $day = 1 if ($zipcut == 1);

    if ($day > $month_of_year{$month_nb[$monthprev]}) {
	$month++;
	$monthprev++;
	$day = "1";
    } else {
	$month++ if ($zipcut == 1);
	$monthprev = $month-1;
    }

    $year++ if ($month == 13);
    $month = "1" if ($month == 13);
    $day = "0".$day if (length($day) == 1 && $struct_compressed_logfile !~ /\%smallday/);
    $month = "0".$month if (length($month) == 1 && $struct_compressed_logfile !~ /\%smallmonth/);
    $monthprev = 0 if ($month == 1);
    $lettermonth = $month_nb[$monthprev];
    $fileagent = $fileroot;
    $smallyear = $year - int($year/100)*100;
    $smallyear = "0".$smallyear if (length($smallyear) == 1);
    $smallday = $day;
    $smallmonth = $month;

    if ($month == 2) {
	if (($year%4 == 0 && $year%100 != 0) || $year%400 == 0) {
	    $month_of_year{'Feb'} = "29";
	    $bisextil = 1;
	} else {
	    $month_of_year{'Feb'} = "28";
	    $bisextil = 0;
	}
    }

    $rotate += $rotate_inc if ($zipcut == 3);

    if (length($rotate) == 1 > 0 && length($min_rotate_index) != 1) {
	for ($j=1;$j<length($min_rotate_index);$j++) {
	    $rotate = "0".$rotate;
	}
    }

    if ($rotate < -1) {
	$status_script = 2;
	&error_exit("Problem with apache rotating file\n",1);
    }

    if ($real_deb == 0) {
	if ($zipcut != 3) {
	    $fileagent = &Get_LogfileName($fileroot);
	}
	if ($zipcut == 3) {
	    if (($rotate != -1 && $rotate_inc == -1) || ($rotate_inc == 1 && $rotate <= $min_rotate_index)) {
		$fileagent = &Get_LogfileName($fileroot);
	    } else {
#		$filezip = $fileroot.$prefixlog if ($file eq $fileagent);
		$fileagent = $fileroot.$prefixlog if ($file eq $fileagent);
#		$filezip = $fileroot.$agentlog if ($file ne $fileagent);
		$fileagent = $fileroot.$agentlog if ($file ne $fileagent);       
	    }
	}
    }

    if ($real_deb == 1) {    
#	if ($struct_compressed_logfile =~ /\%hour/ && $struct_compressed_logfile =~ /\%min/ && $struct_compressed_logfile =~ /\%sec/) {
	if ($struct_compressed_logfile =~ /\%hour/) {

	    $abort = 1;
	    for ($j=0;$j<=$re;$j++) {
		$abort = 0 if ($tab_re[$j] eq "$day $month $year");
	    }

	    $filetmpzip = $fileagent.$zipext;
	    $fileagent = $fileroot.$prefixlog;

	    if ($abort == 0) {
		$sec = 60;
		$min = 59;
		$hour = 23;
		for ($k=0;$k<86400;$k++) {
		    
#		    $fileagent = $fileroot;
		    $sec--;
		    if ($sec < 0) {
			$min--;
			if ($min < 0) {
			    $hour--;
			    $min = 59;
#			$sec = 59;
			}
			$sec = 59;
		    }
		    
		    $hour = "0".$hour if (length($hour) == 1);
		    $min = "0".$min if (length($min) == 1);
		    $sec = "0".$sec if (length($sec) == 1);
		    
		    $fileagent = &Get_LogfileName($fileroot);
		    $filezip = $fileagent.$zipext if ($zip == 1);
		    if (-f $fileagent || -f $filezip) {
#			$re_index++;
			last;
		    }
		}
	    }
	}
    }
    
    $filezip = $fileagent.$zipext if ($zip == 1);
    $datezip = $year.$month.$day if ($zipcut == 2);
    $datezip = $year.$month if ($zipcut == 1);
}

#################################################################
###                    computing maxima                       ###
#################################################################

$msg = "Sorting data\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# tri de browser2

for ($i=1;$i<=$unique;$i++) {
$maxi = 0;
for ($j=1;$j<=$unique;$j++) {
    if ($nbre{$browser2[$j]} > $maxi) {
         $maxi = $nbre{$browser2[$j]};
         $browser3[$i] = $browser2[$j];
         $nbre3{$browser3[$i]} = $maxi;
         $maxix = $j       
         }
}
$nbre{$browser2[$maxix]} = 0;
}


$boucleall = $topten unless ($unique < $topten);
$boucleall = $unique unless ($unique > ($topten-1));

for ($i=0;$i<$boucleall;$i++) {
$maxi = 0;
foreach $browser (keys(%nbre2)) {
    if ($nbre2{$browser} > $maxi) {
         $maxi = $nbre2{$browser};
         $bestbrowserall[$i] = $browser;
         $occurbrowserall[$i] = $nbre2{$browser};                 
         }
    }
$nbre2{$bestbrowserall[$i]} = 0;
}

#

foreach $os (keys(%nbreos)) {
    ($tmp) = split(/[\s+\-]/,$os);
#    $tmp =~ tr/[A-Z]/[a-z]/;
    $tmp = "Unix" if ($os =~ /$main_unix_string/i);
    $tmp = "Linux" if ($os =~ /$distrib_string/i);
#    $tmp = "Misc" if ($tmp !~ /$main_os_string/);
    $tmp = "Misc" if ($tmp !~ /$main_os_string/i && $os !~ /$main_unix_string/i && $os !~ /$distrib_string/i);
    $main_os{$tmp} += $nbreos{$os};
    $count_main_os{$tmp}++;
#    print "$os - $tmp - $count_main_os{$tmp}\n";
}
#		  print FOUT "$occuros[$i]</TD>\n";

$sum_distrib = 0;
for ($i=0;$i<=$#list_distrib;$i++) {
    $sum_distrib += $distrib{$list_distrib[$i]};
}

#################################################################
#####             browser evolution graphs                #######
#################################################################

#$year = $yeartmp;

$msg = "Generating output\n";
&output_log($msg);
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

if ($struct_logfile =~ /\%agent/ || $type_serveur == 2) {
#if ($prefixlog eq $agentlog || $type_serveur == 2) {

# check if something have been scan !

if ($jour_of_year < $pastjour_of_year && $pastyear == $year && $line == 0) {
    $increase = $jour_of_year_end - $jour_of_year_first;
#$increase +=365 if ($increase < 1);
    $msg = "Last day recorded in logfile is too old.\n";
    $msg .="Use \"-d $increase\" option to scan all the logfile!\n\n";
    $status_script = 1;
    &error_exit($msg,1);
}

if ($count_day == 0 && $unique == 0 && $line == 0) {
    $msg = "Don't seems to be a extended NCSA logfile !\n";
    $msg .= "Check inside your $fileroot directory...\n\n";
    $status_script = 1;
    &error_exit($msg,1);
}

### maximum

if ($count_day < $nbdays) {
    $initday = 0;
    $start_date = $firstday;
} else {
    $initday = $count_day - $nbdays;
    $start_date = &date_intervalle($oldjour,-$nbdays);
}

$maxtot = 0;
for ($j=$initday;$j<=$count_day;$j++) {
    $max = 0;
    for ($i=1;$i<=$unique;$i++) {
       $max += $evolbrowser[$j][$i];
    }
    $newevol[$j-$initday][$boucleall] = $max;
    $maxtot = $max if ($max > $maxtot);
}


### recompute to select the $TOPTEN browsers

for ($j=$initday;$j<=$count_day;$j++) {
  for ($k=0;$k<$boucleall;$k++) {
     for ($i=1;$i<=$unique;$i++) {
       if ($bestbrowserall[$k] eq $browser2[$i]) {
         $newevol[$j-$initday][$k] = $evolbrowser[$j][$i];
       } 
     }
  }
}

for ($i=0;$i<=$nbdays;$i++) {
  for ($k=0;$k<$boucleall;$k++) {
    $newevol[$i][$boucleall] -= $newevol[$i][$k];
    $browser_tot[$i] += $newevol[$i][$k];
  }
}

### 

$count_day++;

#$nbdays = $count_day if (($count_day+$jour_of_year_first) < $jour_of_year_end);
#$nbdays = $count_day if ($count_day > $nbdays);
$nbdays = $count_day if ($count_day < $nbdays);

# Add $start_date to $listdate[0];
$tmp_start_date = &nbday("$start_date");

#($tmp1,$tmp2,$tmp3) = split(/-/,$listdate[0]);
#$tmp4 = "$tmp3 $tmp2 $tmp1";
#$tmp_listdate = &nbday("$tmp4");
$tmp_listdate = &nbday($listdate[0]);

if ($tmp_listdate != $tmp_start_date) {
    for ($i=1;$i<=($tmp_listdate-$tmp_start_date);$i++) {
	# Add
#	$date = &date_intervalle($tmp4,-$i);
	$date = &date_intervalle($listdate[0],-$i);
	($tmp1,$tmp2,$tmp3) = split(/\s+/,$date);
#	$date = "$tmp3-$tmp2-$tmp1";
	$date = "$tmp1-$tmp2-$tmp3";
	unshift(@listdate,$date);
    }
}


if ($fly_set == 1) {

$it = length($nbdays)-1;
$div = 10**$it;
$factx = ($div*(int($nbdays/$div)+1))/$grad;

$perspec = $xstep/$factx if (($perspec > $xstep/$factx) && ($tridim == 1));

$it = length($maxtot)-1;
$div = 10**$it;
$facty = ($div*(int(($maxtot+$perspec)/$div)+1))/$grad;
 
$yfirst = $ymax-1;

# USEMAP
$map = '';
$num = 0;
#$num2 = 0;
$popup_graph_width += 40;


 for ($i=0;$i<=$nbdays;$i++) {
     $x1 = $i*$xstep/$factx;
     $x2 = ($i+1)*$xstep/$factx;

     if ($listdate[$num] ne '') {

#	 ($tmp1,$tmp2,$tmp3) = split(/-/,$listdate[$num]);
	 ($tmp1,$tmp2,$tmp3) = split(/ /,$listdate[$num]);
#	 $tmp = $tmp3."-".$tmp2."-".$tmp1;
	 $tmp = $tmp1."-".$tmp2."-".$tmp3;

#	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$listdate[$num].$dirsepurl.$agent;
#	 $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$listdate[$num].$dirsep.$agent;
	 $linkjour = "..".$dirsepurl.$dirdate.$dirsepurl.$tmp.$dirsepurl.$agent;
	 $fulljour = $path.$lang[0].$dirsep.$dirdate.$dirsep.$tmp.$dirsep.$agent;

	 $wday = $day_of_week[(localtime(&nbday("$tmp")*86400))[6]];
	 
	 $num++;

	 $tmp5 = '';
	 $yfinal = 0;
	 for ($k=0;$k<=$boucleall;$k++) {
	     $yfinal += $newevol[$i][$k];
	 }

	 if ($yfinal != 0) {

	     for ($j=0;$j<3;$j++) {
		 $tmp6 = int((100*$newevol[$i][$j])/$yfinal) if ($yfinal != 0);
		 $tmp5 .= "$bestbrowserall[$j] : $newevol[$i][$j] ($tmp6 %)|" if ($bestbrowserall[$j] ne '');
	     }
	     chop($tmp5);
	     
	     $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$tabnameweek#$num\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp5','','$tabnamedays#$num',1,'','$popup_graph_width')\">\n" if (!(-e $fulljour));
	     $map .= "<AREA SHAPE=\"rect\" COORDS=\"$x1,0,$x2,$ymax\" HREF=\"$linkjour\" ALT=\"$tmp\" onMouseOut=\"hideLayer();overdiv--;\" onMouseOver=\"overdiv++;popLayer('$wday $tmp','$tmp5','','$linkjour',1,'','$popup_graph_width')\">\n" if (-e $fulljour);
	 }
     }
 }


### compute graph

#if (-x $FLY) {


 open(FLY,">$tmpfly$vtmp");
 print FLY "new\n";
 print FLY "size $xmax,$ymax\n";
 print FLY "frect 0,0,$xmax,$ymax,200,200,200\n";
 
 for ($i=0;$i<=$nbdays;$i++) {
 $x1 = $i*$xstep/$factx;
 $x2 = ($i+1)*$xstep/$factx;
 
 $y2 = $ymax;
 $y1 = $ymax;
 $yfinal = $ymax;

 for ($j=0;$j<=$boucleall;$j++) {
 $yfinal -= ($ystep/$facty * $newevol[$i][$j]);
 }

 for ($j=0;$j<=$boucleall;$j++) {

 $ji = $j % ($#gcolor);
 $ji = 100 if ($j == $boucleall);

 if ($bargraph == 1) {
   $y2 -= ($ystep/$facty * $newevol[$i][$j]);
   $y1 -= ($ystep/$facty * $newevol[$i][$j-1]);
   print FLY "frect $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";
   print FLY "rect $x1,$y2,$x2,$y1,0,0,0\n";
   if ($tridim == 1 && ($y1-$y2) > 2) {
        $x1plus = $x1+$perspec;
        $x2plus = $x2+$perspec;
        $y2plus = $y2-$perspec;
        $y1plus = $y1-$perspec;

        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";
        print FLY "poly 0,0,0,$x2,$y1,$x2,$y2,$x2plus,$y2plus,$x2plus,$y1plus\n";

        if ($y2 == $yfinal) {
        print FLY "fpoly $red[$ji],$green[$ji],$blue[$ji],$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        print FLY "poly 0,0,0,$x1,$y2,$x1plus,$y2plus,$x2plus,$y2plus,$x2,$y2\n";
        }
   }
 }

 if ($linegraph == 1) {
    $y2 = $ymax - ($ystep/$facty * $newevol[$i][$j]);
    $y1 = $ymax - ($ystep/$facty * $newevol[$i+1][$j]);
    print FLY "line $x1,$y2,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";

    if ($fillgraph == 1) {
	$ji = ($boucleall-$j) % ($#gcolor);
	$ji = 100 if ($j == 0);
	$y2 = $ymax;
	$y1 = $ymax;
	for ($l=0;$l<=($boucleall-$j);$l++) {
	    $y2 -= ($ystep/$facty * $newevol[$i][$l]);
	    $y1 -= ($ystep/$facty * $newevol[$i+1][$l]);

	}

	$fx1 = ($x1+$x2)/2;
	$fx1 = $x2 if ($fx1 < ($x1+1.5));
	if ($fx1 < $x2 && ($y2 < $fymax || $y1 < $fymax)) {
	    print FLY "line $x1,$ymax,$x1,$y2,$red[$ji],$green[$ji],$blue[$ji]\n";
	    print FLY "line $x2,$ymax,$x2,$y1,$red[$ji],$green[$ji],$blue[$ji]\n";

	    print FLY "line $x1,$yfirst,$x2,$yfirst,$red[$ji],$green[$ji],$blue[$ji]\n";
	    
#	    $fx = ($x1+$x2)/2;
	    $fy = $yfirst-2;

	    print FLY "fill $fx1,$fy,$red[$ji],$green[$ji],$blue[$ji]\n";
	} 
    }
 }
 }
 }

 print FLY "transparent 200,200,200\n";
 close (FLY);

&BuildFly("$tmpfly$vtmp",$agentgraph);

### image pour les abscisses

($startday, $startmonth) = split(/ /,$start_date);

$moischiffre = $month_equiv{$startmonth};
$moischiffre--;
$moisvar = $startmonth;
$valmois = $moischiffre;

$valstep = $startday;
$valstep = "0".$valstep if (length($valstep) == 1);

$xlegend = "$nbdays days (starting $start_date)";

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xmax,$ydecal\n";
 print FLY "frect 0,0,$xmax,$ydecal,200,200,200\n";
 $posx = (($xmax/2)-(length($xlegend)*7/2));
 print FLY "string 0,0,0,$posx,$ydecalm,medium,$xlegend\n";
 for ($i=$xstep;$i<$xmax;$i+=$xstep) {
 $valstep = int(($i/$xmax)*(($xmax*$factx/$xstep)))+$startday;

 $moisvar = $startmonth;
 $valmois = $moischiffre;

 while  ($valstep > $month_of_year{$moisvar}) {
     $valstep = ($valstep - $month_of_year{$moisvar});
     $valmois++;
     $valmois = 0 if ($valmois > 11);
     $moisvar = $month_nb[$valmois];
 }

 $valstep = "0".$valstep if (length($valstep) == 1);
 $val = "$moisvar/$valstep";
 $posx = $i - length($valstep)*10;
 print FLY "line $i,0,$i,5,0,0,0\n";
 print FLY "string 0,0,0,$posx,10,small,$val\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
&BuildFly("$tmpfly$vtmp",$agentgraphx);
 
### image pour les ordonnees

open(FLY,">$tmpfly$vtmp");
print FLY "new\n";
print FLY "size $xdecal,$ymax\n";
 print FLY "frect 0,0,$xdecal,$ymax,200,200,200\n";
 if ($fillgraph == 1 || $bargraph == 1) {
 $posy = $ymax - (($ymax/2)-(length("Total added)")*2));
 print FLY "stringup 0,0,0,5,$posy,medium,Total added\n";
 }
 for ($i=$ystep;$i<$ymax;$i+=$ystep) {
 $valstep = int(($ymax - $i) * ($facty/$ystep));
 print FLY "line $xdecalm,$i,$xdecal,$i,0,0,0\n";
 $pos = ($xdecal - length($valstep)*9);
 $posy = $i-5;
 print FLY "string 0,0,0,$pos,$posy,small,$valstep\n";
 }
print FLY "transparent 200,200,200\n";
close (FLY);
 
&BuildFly("$tmpfly$vtmp",$agentgraphy);

}
}
#}

for ($i=0;$i<$boucle;$i++) {
    for ($j=0;$j<=$#agent;$j++) {
	if ($bestbrowser[$i] =~ /$agent[$j]/) {
	    $tmp = $agent[$j];
	    $tmp1 = $translate_agent{$tmp};
	}
    }
$bestbrowser[$i] =~ s/$tmp/$tmp1/ if ($tmp1 ne '');
$bestbrowser[$i] =~ s/\)//;
$bestbrowser[$i] =~ s/\(//;

}

&load_basic_stats;

for ($nblang=0;$nblang<=$#lang;$nblang++) {

 $file_to_open = $path.$lang[$nblang].$dirsep.$dirlist.$dirsep.$tabnamebrowser;

 open(TABAGENT,">$file_to_open") || &error_exit("Error, unable to open $file_to_open",1);
 &AgentStats(*TABAGENT, eval($Lang{$lang[$nblang]}));
 close(TABAGENT);
}


&update_homepage;

# calculer le temps mis pour le calcul

#$datesyst = &ctime(time);
$datesyst = POSIX::ctime(time);
($dayletter,$month,$day,$hourdate,$a,$year) = split(/[ \t\n\[]+/,$datesyst);
($hour,$minute,$second) = split(/:/,$hourdate);

$endrun = "$hour:$minute:$second";

($hour,$min,$sec) = &timetaken($startrun,$endrun);

$endtime = time();
#printf STDOUT "Computing took %d CPU secondes\n",$endtime - $starttime;
#print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
$msg = "Computing took";
$msg .= " $hour h" if ($hour > 0);
$msg .= " $min min $sec sec\n\n";
print "<P>" if ($ENV{'REQUEST_METHOD'} eq "GET");
&output_log($msg);

if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y ne '') {
    print "</DIV>";
    print "<script language=\"javascript\" type=\"text/JavaScript\">\n";
    print "ToggleMenu('TOGGLE_$scriptname');\n";
    print "</script>\n";
}

&UpdateCSSMenu('Optional','Browsers',$icon_agent,"$dirlist$dirsepurl$agent",1,0);

&admin_goback if ($ENV{'REQUEST_METHOD'} eq "GET" && $opt_y eq '');

&StatusCompleted($scriptname,$status_script);

#$today =~ s/ /\//g;

open(FILE,">>$history");
#print FILE "cron-agent\t$today\t$startrun\t$endrun\t$min:$sec\t$line\n";
printf FILE "$scriptname\t%s\t%s\t%s\t%d:%d:%d\t%d\n",$today,$startrun,$endrun,$hour,$min,$sec,$loglines_read;
close(FILE);


############################################
### creation du fichier pour les browser ###
############################################

##########################################################################
sub AgentStats {
  local(*FOUT,*L) = @_;

  print FOUT "$doctype\n";
  print FOUT "<HTML><HEAD>\n";
  print FOUT "$charset\n";
  print FOUT "<TITLE>$L{'Browsers_used'}</TITLE>\n";
  print FOUT "<!-- Page generated by w3perl - cron-agent.pl $version - $today $hourdate -->\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$helpjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$searchjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$sorttablejs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$cornersjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$style_switcherjs\"></script>\n";
  print FOUT "<script LANGUAGE=\"Javascript\" type=\"text/javascript\" src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$dirjs$dirsepurl$css_menu_iefixjs\"></script>\n";

  print FOUT "$curvy_bottom_jss\n";
  &add_jqplot_js(*FOUT,2);
  &add_css_style(*FOUT,2);

  print FOUT "</HEAD>\n";
  print FOUT "<BODY $backgrd TEXT=\"$custom_text\" LINK=\"$custom_link\" VLINK=\"$custom_vlink\">\n";
  &add_css_menu(*FOUT,*L,$lang[$nblang],$nblang,2);
  &help_div(*FOUT);

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>\n";
  print FOUT "<TD ALIGN=LEFT VALIGN=MIDDLE WIDTH=\"20%\">";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER WIDTH=\"60%\">\n";
  print FOUT "<TABLE>\n<TR>\n<TD ALIGN=CENTER>\n";
  print FOUT "<DIV CLASS=\"curly_title\">\n";
  print FOUT "<H1>".uc(&noaccentinhtml($L{'Browsers_used'}))."</H1><P>\n";
  print FOUT "</DIV>\n";
  print FOUT "</TD>\n</TR>\n</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=RIGHT VALIGN=MIDDLE WIDTH=\"20%\">\n";
  print FOUT "</TD>\n";
  print FOUT "</TR>\n";
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

#  print FOUT "<HR size=5>\n";
#  print FOUT "<CENTER><B>$firstday - $jour</B></CENTER>\n";# if ($file eq $fileagent);
#  print FOUT "<HR size=5>\n"; # if ($file eq $fileagent);
  print FOUT "<P>\n";

  if ($nograph != 1 && $count_day > 1) {
#      if ($bestbrowser[0] ne "Unknown" || $boucle > 1) {

	  if ($struct_logfile =~ /\%agent/ || $type_serveur == 2) {

	      if ($fly_set == 0) {

		  $chart_id = 0;
		  $info = "info".$chart_id;
		  $ylegend = "$L{'Occurence'}";
		  undef @ref_tab;

		  for ($k=0;$k<$boucleall;$k++) {
		      $tmp = "val_reftab".$k;
		      $tmp2 = "nav".$k;
		      $L_temp{$tmp2} = $bestbrowserall[$k];

		      $val_tot = 0;
		      for ($i=0;$i<=$nbdays;$i++) {			  
			  push(@$tmp,$newevol[$i][$k]);
			  $val_tot += $newevol[$i][$k];
		      }
#		      if ($val_tot != 0) {
			  push(@ref_tab_name,$tmp2);
#			  print "SCAL $tmp - $#$tmp\n";
			  push(@ref_tab,\@$tmp);
#		      }
#		      print "A $tmp - $tmp2 - $bestbrowserall[$k] - $val_tot\n";
		  }

#		  print "UU @val_reftab0 \n";
#		  push(@ref_tab,\@browser_tot);
#		  @ref_tab_name = ('browser');

#		  print "@listdate\n";

		  &MakeDailyGraphJqplotInit(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,1,\@ref_tab,\@ref_tab_name,\@listdate,$chart_id);

		  undef @ref_tab;
		  push(@ref_tab,\@newevol);
		  @graph_to_display = @bestbrowserall;

		  @serie_color = ('#ff5555', '#55ff55', '#5555ff', '#55ffff', '#ff55ff', '#ffff55','#aa0000', '#00aa00', '#0000aa', '#4ad5ac', '#c5d529','#9cb400','#EE9400','#bd8383');
		  $serie_color[$#bestbrowserall] = "#606060";
		  &MakeDailyGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,1,\@graph_to_display,\@ref_tab,\@listdate,\@serie_color,1,$unit,$chart_id,1,"",$info,$chart_id,$xlegend,$ylegend,$xmax_jqplot,$menu);

		  &AddJqplotHtml(*FOUT, eval($Lang{$lang[$nblang]}),$I,$chart_id,$info,$xmax_jqplot,$ymax_jqplot,2);
		  $chart_id += $#list_graph_name_jqplot+1;

	      }

	      if ($fly_set == 1) {
		  $map2 = $map;
		  $map2 =~ s/\/\//\/$lang[$nblang]\//g;
		  $map2 =~ s/Requests/$L{'Requests'}/g;
	      
		  print FOUT "<MAP NAME=\"agent\">\n";
		  print FOUT "$map2\n";
		  print FOUT "</MAP>\n";

		  print FOUT "<CENTER><TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
		  print FOUT "<TR>\n";
		  print FOUT "<TD><IMG WIDTH=\"$xdecal\" HEIGHT=\"$ymax\" SRC=\"$linkagentgraphy\" ALT=\"y\"></TD>\n";
		  print FOUT "<TD><IMG WIDTH=\"$xmax\" HEIGHT=\"$ymax\" SRC=\"$linkagentgraph\" ALT=\"graph\" USEMAP=\"#agent\" BORDER=0></TD>\n";
		  print FOUT "</TR>\n<TR><TD></TD>\n";
		  print FOUT "<TD><IMG WIDTH=\"$xmax\" HEIGHT=\"$ydecal\" SRC=\"$linkagentgraphx\" ALT=\"x\"></TD>\n";
		  print FOUT "</TR>\n";
		  print FOUT "<TR>\n<TD></TD>\n";
		  print FOUT "<TD ALIGN=CENTER>\n";
		  
		  print FOUT "<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0><TR>\n";
		  print FOUT "<TD><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$others\" ALT=\"$others\"></TD>\n";
		  print FOUT "<TD CLASS=\"left\">&nbsp; $L{'Others'}</TD>\n</TR>\n";

		  for ($i=9;$i>=0;$i--) {
		      if ($bestbrowserall[$i] ne '') {
			  $j = $i % ($#gcolor);
			  $couleur = $gcolor[$j];
			  $bestbrowserall[$i] =~ s/Mozilla/Netscape/ if ($bestbrowserall[$i] =~ "Mozilla");
			  $bestbrowserall[$i] =~ s/Gecko/Mozilla/ if ($bestbrowserall[$i] =~ "Gecko");
			  print FOUT "<TR>\n<TD><IMG WIDTH=\"$square\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$couleur\" ALT=\"$couleur\"></TD>\n";
			  print FOUT "<TD CLASS=\"left\">&nbsp; $bestbrowserall[$i]</TD>\n</TR>\n";
		      }
		  }
		  print FOUT "</TABLE>\n";

		  print FOUT "</TD></TR>\n";        
		  print FOUT "</TABLE></CENTER>\n";

		  print FOUT "<P><CENTER><I>$L{'most_succf_browsers_vtime1'} $boucle $L{'most_succf_browsers_vtime2'}</I></CENTER>\n";
		  print FOUT "<P><HR><P>\n"; 
	      }
	  }
#      }
  }



  $os_pie = "pie_os".$gifext;
  
  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER>\n";

  if ($fly_set == 0) {
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%pie_browser,\@serie_color,$count,0,1,$unit,$chart_id,0,$info,"","","");
  }

  if ($fly_set == 1) {
      $browser_pie = "pie_browser".$gifext;
      ($line_pie,$map_browser_pie) = &MakePieChart($browser_pie,$count,\%pie_browser,0,0,'',$rayon);
  }

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'Browser'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
      $chart_id++;
  }

  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$browser_pie\" USEMAP=\"#map_browser_graph\" BORDER=0 ALT=\"graph\">\n";
      print FOUT "<P><I>$L{'Occurence'}</I>";
  }
 if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_browser_graph\">\n";
      print FOUT "$map_browser_pie\n";
      print FOUT "</MAP>\n";
  }

  print FOUT "</TD><TD ALIGN=CENTER>\n";

  if ($fly_set == 0) {
      $info = "info".$chart_id;
      $line_pie = &MakePieGraphJqplot(*FOUT, eval($Lang{$lang[$nblang]}),$I,\%nbreos,\@serie_color,$count,0,1,$unit,$chart_id,0,$info,"","","");
  }

  if ($fly_set == 1) {
      ($line_pie,$map_os_pie) = &MakePieChart($os_pie,$count,\%nbreos,0,0,'',$rayon);
  }

  print FOUT "<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=2>\n";
  print FOUT "<TR><TD ALIGN=CENTER VALIGN=MIDDLE>";
  print FOUT "<TABLE BORDER=0>";
  print FOUT "<TR><TH ALIGN=CENTER COLSPAN=3>$L{'OS'}</TH></TR>";
  print FOUT "$line_pie";
  print FOUT "</TABLE>\n";
  print FOUT "</TD>\n";
  print FOUT "<TD ALIGN=CENTER>";

  if ($fly_set == 0) {
      print FOUT "<div id=\"";
      print FOUT "chart".$chart_id;
      print FOUT "\" ";
      print FOUT "style=\"";
      print FOUT "height:".$ymax_jqplot."px; width:".$ymax_jqplot."px;\">";
      print FOUT "</div>\n";
      $chart_id++;
  }
  
  if ($fly_set == 1) {
      print FOUT "<IMG WIDTH=\"$pie_square\" HEIGHT=\"$pie_square\" SRC=\"..$dirsepurl..$dirsepurl$dirgraph$dirsepurl$os_pie\" USEMAP=\"#map_os_graph\" BORDER=0 ALT=\"graph\">\n";
      print FOUT "<P><I>$L{'Occurence'}</I>";
  }


  print FOUT "</TD></TR></TABLE>\n";

  if ($fly_set == 1) {
      print FOUT "<MAP NAME=\"map_os_graph\">\n";
      print FOUT "$map_os_pie\n";
      print FOUT "</MAP>\n";
  }

 if ($fly_set == 0) {
      if ($xmax_jqplot != $xmax_home_jqplot) {
	  print FOUT "<button id=\"show_plotted_image_btn$chart_id\" class=\"jqplot_button\" TITLE=\"View PNG file\">Export</button>\n";
      }
      print FOUT "<div id=\"plotted_image_div$chart_id\" class=\"\" style=\"display: none;\"></div>\n";
  }
  print FOUT "</TD></TR></TABLE><P>\n";


  print FOUT "<TABLE BORDER=0 WIDTH=\"100%\">\n";
  print FOUT "<TR>";

#  $tmp = (&reverse_sort_by_value(*new_browser))[0];
#  if ($bestbrowser[0] ne "Unknown" || $boucle > 1) {
#  if ($tmp ne "Unknown" || $boucle > 1) {
#      print FOUT "<TH ALIGN=CENTER>$L{'most_succf_browsers1'} $boucle $L{'most_succf_browsers2'}</TH>\n";
      print FOUT "<TH ALIGN=CENTER>$L{'most_succf_browsers1'} $topten $L{'most_succf_browsers2'}</TH>\n";
#  }

#  print FOUT "<TH>$L{'OS_used1'} $boucleos $L{'OS_used2'}</TH>\n";
  print FOUT "<TH>$L{'OS_used1'} ".keys(%nbreos)." $L{'OS_used2'}</TH>\n";
  print FOUT "</TR><TR>";

  if ($bestbrowser[0] ne "Unknown" || $boucle > 1) {
      print FOUT "<TD ALIGN=LEFT VALIGN=TOP>\n";
      print FOUT "<CENTER>\n";
      print FOUT "<TABLE>\n";
      print FOUT "<TR>\n<TH COLSPAN=2>&nbsp;$L{'Browser'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";

      $count_idx = 0;
      foreach $browser (&reverse_sort_by_value(*new_browser)) {
	  last if ($count_idx == $topten);
	  $count_idx++;
#      for ($i=0;$i<$boucle;$i++) {
#	  $pourcentage = ($occurbrowser[$i]*100)/$count;
	  $pourcentage = ($new_browser{$browser}*100)/$count;
	  $intpourcentage = int($pourcentage);

#	  $tmp_browser = $bestbrowser[$i];
	  $tmp_browser = $browser;
	  $tmp_browser = "Mozilla" if ($tmp_browser =~ /Gecko/i);
	  ($tmp) = split(/\s+/,$tmp_browser);

	  $tmp =~ tr/[A-Z]/[a-z]/;
	  $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
	  print FOUT "<TR>\n";
	  print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"16\" HEIGHT=\"16\" ALT=\"icon\"></TD>\n";
	  
	  print FOUT "<TD CLASS=\"head_left\">$tmp_browser</TD>\n";
#	  print FOUT "<TD CLASS=\"head_right\"><B>$occurbrowser[$i]</B></TD>\n";
	  print FOUT "<TD CLASS=\"head_right\"><B>$new_browser{$browser}</B></TD>\n";
	  print FOUT "<TD CLASS=\"head_left\">";
	  print FOUT "<IMG WIDTH=$intpourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
	  print FOUT "&nbsp;<B>";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</B></TD>\n</TR>\n";

	  $tmp = 0;
#	  for ($l=int($browser_version_nb{$bestbrowser[$i]}*100);$l>0;$l--) {
	  for ($l=int($browser_version_nb{$browser}*100);$l>0;$l--) {
	      $l2 = $l/100;
#	      $l2 = $l2.".0" if (length($l2) == 1);
	      $l2 = $l2.".0" if (int($l2) == $l2);
#	      $pourcentage = ($browser_version{$bestbrowser[$i],$l2}*100)/$occurbrowser[$i];
	      $pourcentage = ($browser_version{$browser,$l2}*100)/$new_browser{$browser};
	      $intpourcentage = int($pourcentage);
#	      if ($browser_version{$bestbrowser[$i],$l2} ne '' && $intpourcentage >= 1) {
	      if ($browser_version{$browser,$l2} ne '' && $intpourcentage >= 1) {
		  $tmp++;
	      }
	  }

	  $tmp2 = 0;
#	  for ($l=int($browser_version_nb{$bestbrowser[$i]}*100);$l>0;$l--) {
	  for ($l=int($browser_version_nb{$browser}*100);$l>0;$l--) {
	      $l2 = $l/100;
#	      $l2 = $l2.".0" if (length($l2) == 1);
	      $l2 = $l2.".0" if (int($l2) == $l2);
#	      $pourcentage = ($browser_version{$bestbrowser[$i],$l2}*100)/$occurbrowser[$i];
	      $pourcentage = ($browser_version{$browser,$l2}*100)/$new_browser{$browser};
	      $intpourcentage = int($pourcentage);
### display browser more than 1% !

#	      if ($browser_version{$bestbrowser[$i],$l2} ne '' && $intpourcentage >= 1) {
	      if ($browser_version{$browser,$l2} ne '' && $intpourcentage >= 1) {
		  $tmp2++;
		  print FOUT "<TR>\n";
		  print FOUT "<TD ROWSPAN=$tmp>&nbsp;</TD>\n" if ($tmp2 == 1);
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
		  print FOUT ">$tmp_browser&nbsp;$l2</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"right_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"right\"" if (($tmp2/2) == int($tmp2/2));
#		  print FOUT ">$browser_version{$bestbrowser[$i],$l2}</TD>\n";
		  print FOUT ">$browser_version{$browser,$l2}</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left_alter\"" if (($tmp2/2) != int($tmp2/2));
		  print FOUT " CLASS=\"left\"" if (($tmp2/2) == int($tmp2/2));
		  print FOUT ">";
		  print FOUT "<IMG WIDTH=$intpourcentage HEIGHT=$square SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
		  print FOUT "&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n";
		  print FOUT "</TR>\n";
	      }
	  }
      }

      print FOUT "</TABLE>\n";
      print FOUT "</CENTER>\n";
      print FOUT "</TD>\n";
  }

  print FOUT "<TD ALIGN=RIGHT VALIGN=TOP>\n";

  print FOUT "<CENTER>\n";
  print FOUT "<TABLE>\n";
  print FOUT "<TR>\n<TH COLSPAN=2>&nbsp;$L{'OS'}&nbsp;</TH>\n<TH>&nbsp;$L{'Occurence'}&nbsp;</TH>\n<TH>&nbsp;$L{'Percentage'}&nbsp;</TH>\n</TR>\n";
  foreach $os (&reverse_sort_by_value(*main_os)) {
      $pourcentage = ($main_os{$os}*100)/$count;
      $intpourcentage = int($pourcentage);
      $tmp = $os;
      $tmp =~ tr/[A-Z]/[a-z]/;
      $tmp = "Unknown" if ($os =~ /unknown/g);
      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
      print FOUT "<TR>";
      print FOUT "<TD CLASS=\"head\"><IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
      print FOUT "<TD CLASS=\"head_left\">&nbsp;$os&nbsp;</TD><TD CLASS=\"head_right\"><B>$main_os{$os}</B></TD>\n<TD CLASS=\"head_left\">";
      print FOUT "<IMG WIDTH=\"$intpourcentage\" HEIGHT=\"$square\" SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[2]\" ALT=\"$gcolor[2]\">" if ($intpourcentage != 0);
      print FOUT "&nbsp;<B>";
      printf FOUT "%.1f",$pourcentage;
      print FOUT "&nbsp;%</B></TD></TR>\n";

      $tmp4 = 0;
      if ($os ne "Linux") {
#      for ($i=0;$i < $boucleos;$i++) {
	  foreach $os_sub (&reverse_sort_by_value(*nbreos)) {
#	  for ($i=0;$i<$uniqueos;$i++) {
#	      next if ($bestos[$i] =~ /$distrib_string/i);
	      next if ($os_sub =~ /$distrib_string/i);
	      next if ($tmp eq "Unknown" && $os ne "Misc");
	      next if ($nbreos{$os_sub} > $main_os{$os}); # vire les misc
#	      $pourcentage = ($occuros[$i]*100)/$main_os{$os};
	      $pourcentage = ($nbreos{$os_sub}*100)/$main_os{$os};
	      $intpourcentage = int($pourcentage);
#	      ($tmp2) = split(/[\-\s+]/,$bestos[$i]);
	      ($tmp2) = split(/[\-\s+]/,$os_sub);
	      $tmp3 = $tmp2;
#	      $tmp2 = "Unknown" if ($bestos[$i] =~ /unknown/g);
#	      $tmp2 = "Unix" if ($bestos[$i] =~ /$main_unix_string/i);
	      $tmp2 = "Unknown" if ($os_sub =~ /unknown/g);
	      $tmp2 = "Unix" if ($os_sub =~ /$main_unix_string/i);
	      $tmp2 =~ tr/[A-Z]/[a-z]/;
#	      $tmp2 = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp2$gifext"));
	      $tmp2 = "Unknown" if ($tmp2 !~ /$main_os_string/i);
	      $tmp3 = "Misc" if ($tmp2 eq "Unknown");
	      $tmp3 = "Unix" if ($tmp2 eq "unix");
#	  print "A $tmp3 - $count_main_os{$tmp3} - $tmp2 - $tmp - $os - $bestos[$i] - $main_unix_string\n";
	      $tmp_max_boucleos = $count_main_os{$tmp3};
	      $tmp_max_boucleos = $topten if ($topten < $tmp_max_boucleos);

#	      print "OO $tmp2 - $tmp - $os_sub\n";
	      if ($tmp2 eq $tmp) { 
		  $tmp4++;
		  print FOUT "<TR>\n";
#	      print FOUT "<TD ROWSPAN=$count_main_os{$tmp3}></TD>\n" if ($tmp4 == 1);
		  print FOUT "<TD ROWSPAN=\"$tmp_max_boucleos\"></TD>\n" if ($tmp4 == 1);
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
#		  print FOUT "&nbsp;$bestos[$i]</TD>\n";
		  print FOUT "&nbsp;$os_sub</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));
#		  print FOUT "$occuros[$i]</TD>\n";
		  print FOUT "$nbreos{$os_sub}</TD>\n";
		  print FOUT "<TD";
		  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
		  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
		  print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"progress bar\">" if ($intpourcentage != 0);
		  print FOUT "&nbsp;";
		  printf FOUT "%.1f",$pourcentage;
		  print FOUT "&nbsp;%</TD>\n</TR>\n";
		  last if ($tmp4 == $topten);
	      }
	  }
      }

      if ($os eq "Linux") {
	  for ($j=0;$j<=$#list_distrib;$j++) {
	      next if ($distrib{$list_distrib[$j]} == 0);
	      $tmp4++;
	      $pourcentage = ($distrib{$list_distrib[$j]}*100)/$main_os{$os};
	      $intpourcentage = int($pourcentage);
	      $tmp = $list_distrib[$j];
	      $tmp =~ tr/[A-Z]/[a-z]/;
	      $tmp =~ s/\s/_/g;
	      $tmp =~ s/\\s\*//;
	      $tmp = "Unknown" if (!(-f "$pathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext"));
	      print FOUT "<TR>\n";
	      print FOUT "<TD\n";
#	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));	      
	      print FOUT " ALIGN=\"center\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	      $tmp = $list_distrib[$j];
	      $tmp =~ s/\\s\*/&nbsp;/;
	      print FOUT "&nbsp;$tmp</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "$distrib{$list_distrib[$j]}</TD>\n";
	      print FOUT "<TD";
	      print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	      print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	      print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
	      print FOUT "&nbsp;";
	      printf FOUT "%.1f",$pourcentage;
	      print FOUT "&nbsp;%</TD>\n</TR>\n";
	      last if ($tmp4 == $topten);
	  }	  
	  # others
	  $tmp4++;
	  $tmp = "Unknown";
	  print FOUT "<TR>\n";
	  print FOUT "<TD\n";
#	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " ALIGN=\"center\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "<IMG SRC=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$diros$dirsepurl$tmp$gifext\" WIDTH=\"14\" HEIGHT=\"14\" ALT=\"$tmp\"></TD>\n";
	  print FOUT "<TD";
	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "&nbsp;<I>$tmp</I></TD>\n";
	  print FOUT "<TD";
	  print FOUT " CLASS=\"right\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"right_alter\">" if (($tmp4/2) != int($tmp4/2));

	  print FOUT "".($main_os{$os}-$sum_distrib)."</TD>\n";
	  $pourcentage = (($main_os{$os}-$sum_distrib)*100)/$main_os{$os};
	  $intpourcentage = int($pourcentage);
	  print FOUT "<TD";
	  print FOUT " CLASS=\"left\">" if (($tmp4/2) == int($tmp4/2));
	  print FOUT " CLASS=\"left_alter\">" if (($tmp4/2) != int($tmp4/2));
	  print FOUT "<img width=$intpourcentage height=$square src=\"..$dirsepurl..$dirsepurl$linkpathinit$dirress$dirsepurl$gcolor[1]\" ALT=\"$gcolor[1]\">" if ($intpourcentage != 0);
	  print FOUT "&nbsp;";
	  printf FOUT "%.1f",$pourcentage;
	  print FOUT "&nbsp;%</TD>\n</TR>\n";
      }

  }
  print FOUT "</TABLE>\n";
  print FOUT "</CENTER>\n";

  print FOUT "</TD></TR></TABLE>\n";
  print FOUT "<P><BR>\n";
  print FOUT "</BODY></HTML>\n";
}
